#include <cstdio>
#include <cassert>

int main (int argc, char *argv[]) {
	assert (argc == 2);
	FILE *in = fopen (argv[1], "r");

	char c;
	while ((c = getc (in)) != EOF) {
		if (c == '\n') printf ("\\n\n");
		else if (c == ' ') printf ("_");
		else if (c == '\r') printf ("\\r");
		else putchar (c);
	}
	fclose (in);

	return 0;
}
