/*
FROM: BalticOI 1999 day 2
PROB: mobile
KEYW: stl, brute force, full exhaustion
*/

#include <cassert>
#include <cstdlib>

#include <iostream>
#include <vector>
#include <utility>

int N;
std::vector <std::vector <std::pair <int, int> > > dat;
std::vector <std::vector <int> > ans;
std::vector <int> sum;
std::vector <int> bal;
std::vector <bool> used;

void myread (int id) {
	dat.push_back (std::vector <std::pair <int, int> > ());//push an empty vector
	int t;
	char c;
	for (;;) {
		std::cin.get (c);
		if (c == ')') break;
		else if (c != ',') std::cin.putback (c);

		std::cin >> t;
		std::cin.get (c);
		switch (c) {
			case ',': dat[id].push_back (std::make_pair (t, -1));  ++N; break;
			case ')': dat[id].push_back (std::make_pair (t, -1));  ++N; return;
			case '(': dat[id].push_back (std::make_pair (t, dat.size ())); myread (dat.size ()); break;
			default : assert (0);
		}
	}
}

void prnt (int id) {
	std::cout.put ('(');
	for (unsigned i = 0; i < dat[id].size (); ++i) {
		if (dat[id][i].second != -1) prnt (dat[id][i].second);
		else std::cout << ans[id][i];
		if (i != dat[id].size () - 1) std::cout.put (',');
	}
	std::cout.put (')');
	if (id == 0) std::cout << std::endl;
}

void rec (int id, unsigned pos =0u) {
	if (id == -1) {prnt (0); exit (0);}
	if (pos == dat[id].size ())
		if (bal[id]) return;
		else return rec (id-1);

	if (dat[id][pos].second != -1) {
		bal[id] += dat[id][pos].first * sum[dat[id][pos].second];
		sum[id] += sum[dat[id][pos].second];
		rec (id, pos + 1);
		sum[id] -= sum[dat[id][pos].second];
		bal[id] -= dat[id][pos].first * sum[dat[id][pos].second];
		return;
	}

	for (int i = 0; i < N; ++i) {
		if (used[i]) continue;
		used[i] = 1;
		bal[id] += (i + 1) * dat[id][pos].first;
		sum[id] += i + 1;

		ans[id][pos] = i + 1;
		rec (id, pos + 1);
		ans[id][pos] = -1;

		sum[id] -= i + 1;
		bal[id] -= (i + 1) * dat[id][pos].first;
		used[i] = 0;
	}
}

int main () {
	std::cin.get ();//eat the (
	myread (0);

	ans.resize (dat.size ());
	for (unsigned i = 0; i < dat.size (); ++i)
		ans[i].resize (dat[i].size (), -1);

	sum.resize (dat.size ());
	bal.resize (dat.size ());
	used.resize (N);

	rec (dat.size () - 1);

	return 0;
}
