#include <cstdio>
#include <cassert>

const int MAXN = 1 << 16;

int N1, N2, N;
int to[MAXN*2];
int type[MAXN*2];

int main (int argc, char *argv[]) {
	assert (argc == 3);
	FILE *in = fopen (argv[1], "r");
	FILE *out = fopen (argv[2], "r");

	int N1, N2;
	fscanf (in, "%d %d", &N1, &N2);
	N = N1 + N2;

	int i;
	for (i = 0; i < N1; ++i) {
		fscanf (in, "%d", to + i);
		--to[i];
//		to[i] += N1;
	}
	for (i = N1; i < N; ++i) {
		fscanf (in, "%d", to + i);
		--to[i];
	}

	static char line1[MAXN], line2[MAXN];
	fgets (line1, MAXN, out);
	fgets (line2, MAXN, out);
//	printf ("*%s*%s*", line1, line2);

	for (i = 0; i < N1; ++i)
		if (line1[i] == '1') {
//			printf ("line1[%d] --> line2[%d] (%c)\n", i, to[i], line2[to[i]]);
			assert (line2[to[i]] == '0' || line2[to[i]] == 'x');
			line2[to[i]] = 'x';//ok
		}
	for (i = 0; i < N2; ++i)
		if (line2[i] == '1') {
//			printf ("line2[%d] --> line1[%d] (%c)\n", i, to[i+N1], line1[to[i+N1]]);
			assert (line1[to[i+N1]] == '0' || line1[to[i+N1]] == 'x');
			line1[to[i+N1]] = 'x';
		}

	for (i = 0; i < N1; ++i) assert (line1[i] == '1' || line1[i] == 'x');
	for (i = 0; i < N2; ++i) assert (line2[i] == '1' || line2[i] == 'x');

	printf ("OK!\n");

	return 0;
}
