/*
FROM: BalticOI 2001 day 1
PROB: postman
KEYW: euler cycle
*/

#include <cstdio>

const int MAXN = 1 << 8;
const int MAXM = MAXN << 2;//(MAXN * 8) / 2

int N, M;
int ma3x[MAXN][MAXN];
int stk1[MAXM], p1;
int stk2[MAXM], p2;

int main () {
	scanf ("%d %d", &N, &M);

	int i;
	int a, b;
	for (i = 0; i < N; ++i) scanf ("%*d");
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
		++ma3x[a][b];
		++ma3x[b][a];
	}

	stk1[p1++] = 0;
	while (p1) {
		for (i = 0; i < N; ++i)
			if (ma3x[i][stk1[p1-1]]) {
				--ma3x[i][stk1[p1-1]];
				--ma3x[stk1[p1-1]][i];
				stk1[p1++] = i;
				break;
			}
		if (i == N) stk2[p2++] = stk1[--p1];
	}

	printf ("%d\n1", p2 - 1);
	for (i = p2-2; i >= 0; --i) printf (" %d", stk2[i] + 1); printf ("\n");

	return 0;
}
