/*
FROM: BalticOI 2002 day 2
PROB: robots
KEYW: dynamical programming
*/

#include <cstdio>
#include <cstring>
#include <algorithm>

using std::swap;

#define DIF 6

const int MAXN = 10;
const int MAXC = 1 << 7;
const int DIR = 4;
const int B = MAXC, A = B * MAXC;

const int dx[] = {1, 0, -1, 0};
const int dy[] = {0, 1, 0, -1};

int N;
int coor[MAXN][2];
char all[MAXN][DIR][MAXC][MAXC];
char _m1[DIR * MAXC * MAXC], _m2[DIR * MAXC * MAXC];
char *crnt = _m1, *old = _m2;

int main () {
	scanf ("%d\n", &N);
	int d, n;
	int i, j, k;
	char comm;
	for (int rc = 0; rc < N; ++rc) {
		scanf ("%d %d %d %d\n", coor[rc], coor[rc]+1, &d, &n);
		memset (crnt, 51, sizeof (_m1));
		memset (old, 51, sizeof (_m1));
		old[(d / 90) * A + 60 * B + 60] = 0;
		for (int c = 0; c < n; ++c) {
			scanf ("%c", &comm);
			if (comm == 'S') {
				scanf ("\n");
				for (k = 0; k < 4; ++k)
					for (i = 1; i < MAXC-1; ++i)
						for (j = 1; j < MAXC-1; ++j) {
							crnt[k * A + (i+dx[k]) * B + j+dy[k]] <?= old[k * A + i * B + j];
							crnt[k * A + i * B + j] <?= old[k * A + i * B + j] + 1;//stay here
						}
			} else {
				scanf ("%d\n", &d);
				d /= 90;
				for (k = 0; k < 4; ++k)
					for (i = 1; i < MAXC-1; ++i)
						for (j = 1; j < MAXC-1; ++j) {
							crnt[((k+d) & 3) * A + i * B + j] <?= old[k * A + i * B + j];
							crnt[k * A + i * B + j] <?= old[k * A + i * B + j] + 1;//stay here
						}
			}
			std::swap (crnt, old);
			memset (crnt, 51, sizeof (_m1));
		}
		memcpy (all[rc], old, sizeof (_m1));
	}
/*
	for (int rc = 0; rc < N; ++rc) {
		for (j = 60+DIF; j > 60-DIF; --j) {
			for (i = 60-DIF; i < 60+DIF; ++i) {
//				if ((int)all[rc][0][i][j] + all[rc][1][i][j] + all[rc][2][i][j] + all[rc][3][i][j] != 51 * 4)
					printf ("(%2d %2d %2d %2d)(%d %d)", all[rc][0][i][j], all[rc][1][i][j], all[rc][2][i][j], all[rc][3][i][j], i, j);
			}
			printf ("\n");
		}
	}
*/
	int r;
	int bsum = 1 << 30, bx, by;
	int rx, ry, nx, ny;
	int csum, cadd;
	for (i = 0; i < MAXC; ++i)
		for (j = 0; j < MAXC; ++j) {
			csum = 51;
			for (k = 0; k < 4; ++k) csum <?= all[0][k][i][j];
			if (csum == 51) continue;//we cannot be here in ANY position
			rx = i - 60 + coor[0][0];
			ry = j - 60 + coor[0][1];
			for (r = 1; r < N; ++r) {
				nx = rx - coor[r][0] + 60;
				ny = ry - coor[r][1] + 60;
				if (nx >= 0 && nx < MAXC
				 && ny >= 0 && ny < MAXC) {
					for (k = 0, cadd = 51; k < 4; ++k) cadd <?= all[r][k][nx][ny];
					if (cadd == 51) {
//						printf ("%d %d --> %d %d -%d- BREAK\n", i, j, rx, ry, r);
						break;
					}//there is no path to this position for robot r
//					printf ("coor %d %d -Real-> %d %d -new(%d)-> %d %d --> %d\n", i, j, rx, ry, r, nx, ny, cadd);
					csum += cadd;
				}
			}
			if (r == N && bsum > csum) {
				bsum = csum;
				bx = rx;
				by = ry;
			}
		}

	if (bsum == 1 << 30)
		printf ("-1\n");
	else
		printf ("%d\n%d %d\n", bsum, bx, by);

	return 0;
}
