/*
FROM: BalticOI 2003 day 2
PROB: lamps
KEYW: logarithm, lowest bit, xor, ad-hoc
*/

#include <cstdio>

const int MAXN = 1 << 20;

int N, K;
char _v1[MAXN], _v2[MAXN];
char *crnt = _v1, *old = _v2;


int main () {
	scanf ("%d %d", &N, &K);
	
	int i;
	int t;
	for (i = 0; i < N; ++i) {
		scanf ("%d", &t);
		old[i] = t;
	}

	while (K) {
		int lb = K & -K;
		for (i = 0; i < N; ++i)
			crnt[i] = old[i] ^ old[(i+lb) % N];
		char *t = old;
		old = crnt;
		crnt = t;
		K &= (K-1);//remove lowest bit
	}

	for (i = 0; i < N; ++i)
		printf ("%d\n", old[i]);

	return 0;
}
