/*
TASK: coins
LANG: C++

FROM: BaOI 2006 day 1
PROB: coins
KEYW: linear, greedy
*/

#include <cstdio>
#include <cassert>
#include <climits>

const int MAXN = 1 << 19;

int N, K;
int c[MAXN];
bool have[MAXN];

int main () {
	scanf ("%d %d", &N, &K);

	int i;
	int tmp;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", c + i, &tmp);
		have[i] = tmp;
	}
	c[N] = INT_MAX;

	int s = 0, cntr = 0;
	for (i = 0; i < N && s + c[i] < K; ++i) {
		if (have[i] || s + c[i] >= c[i+1]) continue;
		s += c[i];
		++cntr;
	}
	printf ("\n");

	printf ("%d\n%d\n", cntr, K - s);

	return 0;
}
