/*

*/

#include <cstdio>
#include <algorithm>
#include <vector>

int N, K;
std::vector <std::pair <int, bool> > db;

bool eq (const std::pair <int, bool> &a, const std::pair <int, bool> &b) {
	return a.first == b.first;
}

int main (int argc, char *argv[]) {
	assert (argc == 4);
	sscanf (argv[1], "%d", &N);
	sscanf (argv[2], "%d", &K);

	db.resize (N);

	int i;
	for (int i = 0; i < N - 1; ++i) {
		db[i].first = rand () % (K-2) + 2;
		db[i].second = (rand () % 100) < 10;
	}
	db[N-1] = std::make_pair (1, (rand () % 100) < 10);

	printf ("!\n");

	std::sort (db.begin (), db.end ());
	db.resize (std::unique (db.begin (), db.end (), eq) - db.begin ());

	FILE *out = fopen (argv[3], "w");
	fprintf (out, "%u %d\n", db.size (), K);
	for (i = 0; i < (int)db.size (); ++i)
		fprintf (out, "%d %d\n", db[i].first, db[i].second);

	return 0;
}
