/*
TASK: jump
LANG: C++

FROM: BaOI 2006 day 2
PROB: jump
KEYW: dynamical programming, big number addition
*/

#include <cstdio>

const int MAXN = 1 << 7;
const int ALEN = 1 << 4;
const int BASE = 1000000000;

struct big {
	int a[ALEN];
	big () {for (int i = 0; i < ALEN; ++i) a[i] = 0;}
	big& operator += (const big &x) {for (int i = 0; i < ALEN-1; ++i) {a[i] += x.a[i]; a[i+1] += a[i] / BASE; a[i] %= BASE;}return *this;}
	void prnt () {int i; for (i = ALEN-1; i && !a[i]; --i); printf ("%d", a[i]); for (--i; i >= 0; --i) printf ("%09d", a[i]);}
};

int N;
int board[MAXN][MAXN];
//long long dp[MAXN][MAXN];
big dp[MAXN][MAXN];

int main () {
	scanf ("%d", &N);

	int i, j;
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			scanf ("%d", &board[i][j]);

	dp[N-1][N-1].a[0] = 1;
//	dp[N-1][N-1] = 1;
	for (i = N - 1; i >= 0; --i)
		for (j = N - 1; j >= 0; --j) {
			if (!board[i][j]) continue;
			if (i + board[i][j] < N) dp[i][j] += dp[i+board[i][j]][j];
			if (j + board[i][j] < N) dp[i][j] += dp[i][j+board[i][j]];
		}

	dp[0][0].prnt (); puts ("");
//	printf ("%Ld\n", dp[0][0]);

	return 0;
}
