#include <cstdio>
#include <cstring>
#include <utility>
#include <algorithm>

using namespace std;

const int MAXN = 1 << 17;

int N;
pair <double, double> _data[MAXN];
pair <int, int> data[MAXN];
pair <int, int> idx[MAXN * 2];
double coor[MAXN*2];

long long idt[MAXN * 2];
int idts;//index tree size

inline int lb (int a) {return a & -a;}

void add (int pos, int val) {for (++pos; pos <= idts; pos += lb (pos)) idt[pos] += val;}

long long _srch (int pos) {
	static long long res;++pos;
	for (res = 0; pos; pos -= lb (pos))res += idt[pos];
	return res;
}

long long srch (int pos1, int pos2) {return _srch (pos2) - _srch (pos1);}

int main () {
	int T;
	scanf ("%d", &T);

	int i;
	long long res = 0;
	for (int tc = 0; tc < T; ++tc) {
		scanf ("%d", &N);
		for (i = 0; i < N; ++i) {
			scanf ("%lf %lf", &_data[i].first, &_data[i].second);
			coor[i*2  ] = _data[i].first;
			coor[i*2+1] = _data[i].second;
		}
		std::sort (coor, coor + N * 2);
		idts = std::unique (coor, coor + N * 2) - coor;
	
		for (i = 0; i < N; ++i) {
			data[i] = make_pair (lower_bound (coor, coor + idts, _data[i].first) - coor, lower_bound (coor, coor + idts, _data[i].second) - coor);

			idx[i*2] = make_pair (data[i].first, i);
			idx[i*2+1] = make_pair (data[i].second, i);
		}

		std::sort (idx, idx + N * 2);
		memset (idt, 0, sizeof (idt));
		for (i = res = 0; i < N * 2; ++i) {
			if (idx[i].first == data[idx[i].second].first)//add
				add (idx[i].first, 1);
			else {
				res += srch (data[idx[i].second].first, idx[i].first);
				add (data[idx[i].second].first, -1);
			}
		}
		printf ("%Ld\n", res);
	}
	return 0;
}
