# include <cstdio>
# include <vector>
# include <climits>

using namespace std;

const int MAXN = 1 << 10;

int N, K;
int d[MAXN];
int h[MAXN][MAXN];
int best[MAXN];

int c[MAXN][MAXN];

void readf() {
	for ( int i=0 ; i<N ; i++ )
		scanf("%d", d + i);

	for ( int i=0 ; i<N ; i++ )
		for ( int j=0 ; j<N-i ; j++ )
            scanf("%d", h[i] + i + j);
}

int main() {
    while(1) {
        scanf("%d%d", &N, &K);
        if ( N==0 && K==0 ) break;
        readf ();

        for ( int i=0 ; i<N ; i++ ) {
			c[i][i] = h[i][i] * d[i];
			if (c[i][i]) c[i][i] += K;
//			printf ("%d %d %d\n", i, i, c[i][i]);
			for ( int j=i+1 ; j<N ; j++ ) {
				c[i][j] = c[i][j-1] + h[i][j] * d[j];
				if (c[i][j] && !c[i][j-1]) c[i][j] += K;
//				printf ("%d %d %d\n", i, j, c[i][j]);
			}
		}

		best[0] = c[0][0];
		for ( int i = 1 ; i < N ; i++ ) {
			best[i] = c[0][i];
			for (int j = 1; j <= i; ++j)
				best[i] <?= best[j-1] + c[j][i];
		}
        printf("%d\n", best[N-1]);
    }
    return 0;
}
