#include <cstdio>
#include <algorithm>
#include <cstring>

#define MAXN 17

using namespace std;

int a[MAXN], n;
bool adj[MAXN][MAXN];
int v[MAXN][1 << MAXN];

int solve(int i, int mask)
{
	if (v[i][mask]) return v[i][mask];
	v[i][mask] = 1;
	int p = 1;
	for (int j = 0; j < n; j++) {
	if (!(mask & p) && adj[i][j]) {
			int cur = solve(j, mask | p) + 1;
			v[i][mask] = max(cur, v[i][mask]);
		}
		p <<= 1;
	}
	return v[i][mask];
}

int main() {
	int tests;
	scanf("%d", &tests);
	for (int ti = 0; ti < tests; ti++) {
		printf("Case #%d: ", ti + 1);

		memset(v, 0, sizeof(v));

		scanf("%d", &n);

		for (int i = 0; i < n; i++) {
			scanf("%d", &a[i]);
		}

		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				adj[i][j] = (a[i] % a[j] == 0) || (a[j] % a[i] == 0);
			}
		}

		int res = 0;

		int p = 1;
		for (int i = 0; i < n; i++) {
			res = max(solve(i, p), res);
			p <<= 1;
		}
		printf("%d\n", res);
	}
	return 0;
}
