#include <cstdio>
#include <vector>

using namespace std;

#define N (1 << 15)

int n;
long long m;
vector <vector <int> > nei;
long long res[N];
int ld, lv;
int usd[N], u;
int opt[N];
long long ans = 0;

void dfs1(int v, int d)
{
		usd[v] = u;
		if (ld < d)
		{
				ld = d;
				lv = v;
		}
		for (int i = 0; i < (int) nei[v].size(); ++ i)
				if (usd[nei[v][i]] != u)
				{
						dfs1(nei[v][i], d + 1);	
				}
}

int dfs2(int v, int d)
{
		opt[v] = d;
		usd[v] = u;
		for (int i = 0; i < (int) nei[v].size(); ++ i)
				if (usd[nei[v][i]] != u)
				{
						opt[v] = max(dfs2(nei[v][i], d + 1), opt[v]);
				}
		return opt[v];
}

void dfs3(int v, int d)
{
		int cnt = 0, sp = 0;
		usd[v] = u;
		for (int i = 0; i < (int) nei[v].size(); ++ i)
				if (usd[nei[v][i]] != u)
				{
						cnt ++;
						if (opt[nei[v][i]] == opt[v] && !sp)
						{
							sp = 1;	
							dfs3(nei[v][i], d + 1);
						}
						else
						{
							dfs3(nei[v][i], 1);
						}
				}
		if (!cnt)
		{
				ans += res[d];
		}
}

int main()
{
		int tc;
		scanf("%d", &tc);
		for (int t = 0; t < tc; ++ t)
		{
				ans = 0;
				scanf("%d %lld", &n, &m);

				res[0] = 0;
				for (int i = 1; i < N; ++ i)
				{
						res[i] = (res[i - 1] * 2 + 1) % m;
				}
				int a, b;
				nei.clear();
				nei.resize(n);
				for (int i = 0; i < n - 1; ++ i)
				{
						scanf("%d %d", &a, &b);
						-- a; -- b;
						nei[a].push_back(b);
						nei[b].push_back(a);
				}
				ld = -1;
				++ u;
				for (int i = 0; i < n; ++ i)
				{
						if (nei[i].size() == 1)
						{
								dfs1(i, 0);
								break;
						}
				}
				++ u;
				ld = -1;
				dfs1(lv, 0);
				++ u;
				dfs2(lv, 0);
				++ u;
				dfs3(lv, 0);
				printf("Case #%d: %lld\n", t + 1, ans % m);
		}
		return 0;
}
