/*
TASK: c
LANG: C++
*/

#include <iostream>
#include <string>
#include <map>

int main () {
	std::string comm, s1, s2;
	std::map <std::string, std::string> names, tels;
	std::map <std::string, int> comms;
	comms[std::string ("INSERT")] = 0;
	comms[std::string ("DELETE")] = 1;
	comms[std::string ("LOOKUP")] = 2;
	comms[std::string ("LIST")] = 3;
	comms[std::string ("DIE")] = 4;
	
	std::map <std::string, std::string>::iterator ii;
	while (std::cin >> comm)
		switch (comms[comm]) {
			case 0: std::cin >> s1 >> s2; names[s1] = s2; tels[s2] = s1; break;
			case 1: std::cin >> s1; ii = names.find (s1);
					tels.erase (ii->second); names.erase (ii); break;
			case 2: std::cin >> s1; std::cout << (isdigit (s1[0]) ? tels[s1] : names[s1]) << '\n'; break;
			case 3: for (ii = names.begin (); ii != names.end (); ++ii)
						std::cout << ii-> first << ' ' << ii->second << '\n'; break;
			case 4: return 0;
		}

	return 0;
}
