/*
FROM: acm.timus.ru
PROB: 1003 (Parity)
*/

#include <cstdio>
#include <cstring>
#include <utility>
#include <algorithm>

const int MAXN = 1 << 14;
const int MAXM = 1 << 13;

typedef std::pair <int, bool> PT;

int N, M;
int all[MAXN];
PT prev[MAXN];
std::pair <std::pair <int, int>, bool> inp[MAXM];

PT fnd_root (int a) {
	PT res (-1, 0);
	for (; a != prev[a].first; a = prev[a].first)
		res.second ^= prev[a].second;

	res.first = a;
	return res;
}

int main () {
	while (scanf ("%d %d", &N, &M) == 2) {
		int a, b;
		char buf[16];
		int i;
		for (i = 0; i < M; ++i) {
			scanf ("%d %d %s\n", &a, &b, buf);
			--a;
			inp[i].first.first = a;
			inp[i].first.second = b;
			inp[i].second = strcmp (buf, "odd") == 0;
		
			all[i*2] = a;
			all[i*2 + 1] = b;
		}
		std::sort (all, all + M * 2);
		N = std::unique (all, all + M * 2) - all;
//		for (i = 0; i < N; ++i) printf (" %d", all[i]); puts ("");
	
		bool c;
		PT x1, x2;
		for (i = 0; i < N; ++i) prev[i] = PT (i, 0);
		for (i = 0; i < M; ++i) {
			a = std::lower_bound (all, all + N, inp[i].first.first) - all;
			b = std::lower_bound (all, all + N, inp[i].first.second) - all;
			c = inp[i].second;
		
			x1 = fnd_root (a);
			x2 = fnd_root (b);
			if (x1.first != x2.first) {//different trees
//				printf ("add prev %d -- %d %d\n", x1.first, x2.first, c ^ x1.second);
				prev[x1.first] = PT (b, c ^ x1.second);
			} else {
				if ((x1.second ^ x2.second ^ c) == 1) {
					printf ("%d\n", i);
					goto nxt;
				}
			}
		}
		printf ("%d\n", M);
		nxt:;
	}

	return 0;
}
