/*
FROM: acm.timus.ru
PROB: 1007 (Code words)
KEYW: precomputing, full exhaustion
*/

#include <cstdio>
#include <cstring>

const int MAXN = 1 << 10;

int N, N1;
char w[MAXN];
int cnt[MAXN];
int sum[MAXN];

void precomp () {
	int i;
	for (i = 1; i <= N1; ++i) {
		cnt[i] = cnt[i-1] + (w[i] == '1');
		sum[i] = sum[i-1] + (w[i] == '1') * i;
	}
//	for (i = 1; i <= N1; ++i) printf ("(%d %d)", cnt[i], sum[i]); puts ("");
//	cnt[N1+1] = cnt[N1];
//	sum[N1+1] = sum[N1];
}

void ins () {
//	printf ("here!\n");
	int i;
	int pre, post;
	for (i = 0; i <= N1; ++i) {
		pre = sum[i];
		post = (sum[N1] - sum[i]) + (cnt[N1] - cnt[i]);
		
//		printf ("%d -- %d %d(%d %d)\n", i, pre, post, pre + post, pre + post + i + 1);
		if ((pre + post) % (N + 1) == 0) {
			char tmp = w[i + 1];
			w[i + 1] = '\0';
			printf ("%s0", w + 1);
			w[i + 1] = tmp;
			printf ("%s\n", w + i + 1);
			//printf ("%*s0%s\n", i, w + 1, w + 1 + i);
			return;
		} else if ((pre + post + i + 1) % (N + 1) == 0) {
			char tmp = w[i + 1];
			w[i + 1] = '\0';
			printf ("%s1", w + 1);
			w[i + 1] = tmp;
			printf ("%s\n", w + i + 1);
			return;
		}
	}
	while (1);
}

void chg () {
	int i;
	int pre, post;
	if (sum[N1] % (N + 1) == 0) {puts (w + 1); return;}
	for (i = 1; i <= N1; ++i) {
		if (w[i] == '0') continue;
		pre = sum[i-1];
		post = (sum[N1] - sum[i]);
//		printf ("%d -- %d %d\n", i, pre, post);
		if ((pre + post) % (N + 1) == 0) {
//			printf ("put %d to %d\n", 0, i);
			w[i] = '0';
			puts (w + 1);
			return;
		} else if ((pre + post + i) % (N + 1) == 0) {
			w[i] = '1';
			puts (w + 1);
			return;
		}
	}
	while (1);
}

void rem () {
	int i;
	int pre, post;
	for (i = 1; i <= N1; ++i) {
		pre = sum[i-1];
		post = (sum[N1] - sum[i]) - (cnt[N1] - cnt[i]);

		if ((pre + post) % (N + 1) == 0) {
			w[i] = 0;
			printf ("%s%s\n", w+1, w+i+1);
			return;
		}
	}
	while (1);
}

int main () {
	scanf ("%d", &N);

	while (scanf ("%s", w + 1) == 1) {
		N1 = strlen (w + 1);
//		printf ("%d %d\n", N, N1);
//		printf ("--------------\n");
		precomp ();
//		puts (w + 1);
		
		switch (N - N1) {
			case  1: ins (); break;
			case  0: chg (); break;
			case -1: rem (); break;
			default: while (1);
		}
	}

	return 0;
}
