/*
FROM: acm.timus.ru
PROB: 1014 (The Product of Digits)
KEYW: mathematics
*/

#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

int N;
int base[] = {2, 3, 5, 7};
int pows[4];

int main () {
	scanf ("%d", &N);
	if (N == 0) {
		printf ("10\n");
		return 0;
	}
	if (N == 1) {
		printf ("1\n");
		return 0;
	}

	int i;
	for (i = 0; i < 4; ++i)
		while (N % base[i] == 0) {
			++pows[i];
			N /= base[i];
		}

	if (N != 1) {printf ("-1\n"); return 0;}

	vector <int> all;
	while (pows[0] > 2) {all.push_back (8); pows[0] -= 3;}//8
	while (pows[1] > 1) {all.push_back (9); pows[1] -= 2;}//9
	if (pows[0] && pows[1]) {all.push_back (6); --pows[0]; --pows[1];}//6
	while (pows[0] > 1) {all.push_back (4); pows[0] -= 2;}//4
	while (pows[0]) {all.push_back (2); --pows[0];}//2
	while (pows[1]) {all.push_back (3); --pows[1];}//3
	while (pows[2]) {all.push_back (5); --pows[2];}//5
	while (pows[3]) {all.push_back (7); --pows[3];}//7

	sort (all.begin (), all.end ());
	for (i = 0; i < all.size (); ++i) printf ("%d", all[i]); puts ("");

	return 0;
}
