/*
FROM: acm.timus.ru
PROB: 1027 (D++ Again)
KEYW: text processing
*/

#include <cstdio>
#include <cctype>
#include <cstdlib>
#include <cassert>
#include <cstring>

const int MAXL = 1 << 14;

int len;
char text[MAXL];

void ans (bool how) {
	printf ("%s\n", how ? "YES" : "NO");
	exit (0);
}

int main () {
	char *of = text;
	while (fgets (of, text + MAXL - of, stdin)) of += strlen (of);

	len = of - text;
	int i;
/*	for (i = 0; i < len; ++i)
		printf ("(%c_%d)", text[i], (int)text[i]);
	puts ("");
*/

	bool in_expr = 0, in_comment = 0;
	int brk = 0;
	for (i = 0; i < len; ++i) {
		if (in_comment) {
			if (text[i] == '*' && text[i + 1] == ')') {
				in_comment = 0;
				++i;
			}
		} else if (in_expr) {
			assert (brk);
			if (text[i] == '(') {
				if (text[i+1] == '*') {
					++i;
					in_comment = 1;
				} else {
					++brk;
				}
			} else if (text[i] == ')') {
				--brk;
				if (!brk) in_expr = 0;
			} else if (!isdigit (text[i]) && text[i] != '=' && text[i] != '*' && text[i] != '+' && text[i] != '-' && text[i] != '/' && text[i] != '\r' && text[i] != '\n') {
				ans (0);
			}
		} else {
			if (text[i] == '(') {
				if (text[i+1] == '*') {
					in_comment = 1;
					++i;
				} else {
					in_expr = 1;
					assert (brk == 0);
					++brk;
				}
			} else if (text[i] == ')')
				ans (0);
		}
	}

	if (in_expr || in_comment) ans (0);
	ans (1);

	return 0;
}
