/*
FROM: acm.timus.ru
PROB: 1032 (Find a multiple)
KEYW: mathematics
*/

#include <cstdio>
#include <cstring>

const int MAXN = 1 << 14;

int N;
int vec[MAXN];
int sum[MAXN];
int fs[MAXN];

int main () {
	scanf ("%d", &N);

	int i, j;
	for (i = 0; i < N; ++i) scanf ("%d", vec + i);
	
	memset (fs, -1, sizeof (fs));
	fs[sum[0] = (vec[0]) % N] = 0;
	if (sum[0] == 0) {
		printf ("1\n%d\n", vec[0]);
		return 0;
	}
	for (i = 1; i < N; ++i) {
		sum[i] = (sum[i-1] + vec[i]) % N;
		if (fs[sum[i]] != -1) {
			printf ("%d\n", i - fs[sum[i]]);
			for (j = fs[sum[i]] + 1; j <= i; ++j) printf ("%d\n", vec[j]);
			return 0;
		} else {
			if (sum[i] == 0) {
				printf ("%d\n", i + 1);
				for (j = 0; j <= i; ++j) printf ("%d\n", vec[j]);
				return 0;
			}
			fs[sum[i]] = i;
		}
	}
	
	return 0;
}
