/*
FROM: acm.timus.ru
PROB: 1038 (Spell checker)
KEYW: text processing
*/

#include <cstdio>
#include <cctype>
#include <cstring>

const int MAXL = 1 << 16;

int L;
char text[MAXL];

int main () {
	char *tp = text;
	while (fgets (tp, text + MAXL - tp, stdin)) tp += strlen (tp);
	L = tp - text;

	int i;
//	for (i = 0; i < L; ++i) printf ("%c", text[i]);

	bool sent_beg = 1;
	bool word_beg = 0;
	int ans = 0;
	for (i = 0; i < L; ++i) {
		if (isalpha (text[i])) {
			if (isupper (text[i])) {
				if (word_beg)
					++ans;
			} else {
				if (sent_beg)
					++ans;
			}
			sent_beg = 0;
			word_beg = 1;
		} else if (text[i] == '.' || text[i] == '!' || text[i] == '?') {
			word_beg = 0;
			sent_beg = 1;
		} else {
			word_beg = 0;
			//do nothing
		}
	}

	printf ("%d\n", ans);

	return 0;
}
