#include <cstdio>
//#include <cassert>
#include <algorithm>

void assert(bool x) {
	while(!x) ;
}

const int MAXN = 1 << 11;
const int MAXM = 1 << 6;

int n, m;
long double t[MAXN][MAXM];
int price[MAXN];
int id[MAXN];

bool cmp(int a, int b) {
	return price[a] < price[b];
}

int main() {
	scanf("%d %d", &n, &m);

	int sum = 0;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			int xx;
			scanf("%d", &xx);
			t[i][j] = xx;
		}
	}

	for (int i = 0; i < n; i++) {
		scanf("%d", price + i);
	}

	for (int i = 0; i < n; i++) {
		id[i] = i;
	}

	std::stable_sort(id, id + n, cmp);

	//for (int i = 0; i < n; ++i) printf(" %d", id[i]); puts("");

	long double EPS = 1e-14;

	for (int x = 0; x < m; x++) {
		bool found = false;
		for (int i = x; i < n; i++) {
			if (abs(t[id[i]][x]) > EPS) {
				int tmp = id[i];
				for (int j = i; j > x; j--) {
					id[j] = id[j - 1];
				}
				id[x] = tmp;
				sum += price[id[x]];
				found = true;
				break;
			}
		}
		if (found == false) {
			printf("0\n");
			return 0;
		}

		for (int i = x + 1; i < n; i++) {
			if (abs(t[id[i]][x]) < EPS) continue;
			long double c = t[id[i]][x] / t[id[x]][x];
			for (int j = x; j < m; j++) {
				t[id[i]][j] -= c * t[id[x]][j];
			}
			assert (abs(t[id[i]][x]) < EPS);
		}
	}

	printf("%d\n", sum);
	std::sort(id, id + m);
	for (int i = 0; i < m; i++) {
		printf("%d\n", id[i] + 1);
	}

	return 0;
}