/*
FROM: acm.timus.ru
PROB: 1042 (Central heating)
KEYW: binary gauss
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 8;

int N;
bool ma3x[MAXN][MAXN * 2];

int main () {
	scanf ("%d", &N);

	int i, j, k, c;
	for (i = 0; i < N; ++i) {
		while (scanf ("%d", &c), c != -1)
			ma3x[i][--c] = 1;
		ma3x[i][i+N] = 1;
	}
/*
	for (i = 0; i < N; ++i) {
		for (j = 0; j < 2 * N; ++j)
			printf ("%d ", ma3x[i][j]);
		puts ("");
	}
*/
	int cp = 0;
	for (i = 0; i < N; ++i) {
		for (j = cp; j < N; ++j)
			if (ma3x[j][i])
				break;
		if (j == N) continue;
//		printf ("found row %d\n", j);
		if (j != cp)
			for (k = 0; k < 2 * N; ++k)
				std::swap (ma3x[cp][k], ma3x[j][k]);
	
		for (j = 0; j < N; ++j) {
			if (j == cp || !ma3x[j][i]) continue;
//			printf ("xor row %d\n", j);
			for (k = i; k < 2 * N; ++k)
				ma3x[j][k] ^= ma3x[cp][k];
		}
/*		puts ("------");
		for (int i = 0; i < N; ++i) {
			for (int j = 0; j < 2 * N; ++j)
				printf ("%d ", ma3x[i][j]);
			puts ("");
		}
		puts ("------");
*/
		++cp;
	}

/*	for (i = 0; i < cp; ++i) {
		for (j = 0; j < 2 * N; ++j)
			printf ("%d ", ma3x[i][j]);
		puts ("");
	}
*/
	for (i = 0; i < cp; ++i)
		for (k = 0; k < 2 * N; ++k)
			ma3x[N][k] ^= ma3x[i][k];

	for (i = 0; i < N && ma3x[N][i]; ++i);
	if (i == N) {
		bool first = 1;
		for (i = N; i < 2 * N; ++i)
			if (ma3x[N][i]) {
				if (!first) putchar (' ');
				first = 0;
				printf ("%d", i - N + 1);
			}
		puts ("");
	} else
		printf ("No solution\n");

	return 0;
}
