/*
FROM: acm.timus.ru
PROB: 1054 (Hanoi tower)
KEYW: hanoy towers, recursion
*/

#include <cstdio>
#include <cstdlib>

const int MAXN = 1 << 5;

int N;
int dp[MAXN];

void ans_NO () {
	printf ("-1\n");
	exit (0);
}

int f (int n, int fr, int to, int aux) {
//	printf ("%d %d %d %d\n", n, fr, to, aux);
	if (n == -1) return 0;
	if (dp[n] == fr)
		return f (n-1, fr, aux, to);
	else if (dp[n] == to)
		return f (n-1, aux, to, fr) + (1 << n);
	else
		return ans_NO (), -1;
}

int main () {
	scanf ("%d", &N);

	for (int i = 0; i < N; ++i) {
		scanf ("%d", dp + i);
		--dp[i];
	}

	printf ("%d\n", f (N-1, 0, 1, 2));

	return 0;
}
