/*
FROM: acm.timus.ru
PROB: 1064 (Binary Search)
KEYW: binary search :)
*/

#include <cstdio>
#include <cassert>
#include <utility>

const int MAXN = 10000;

int bsrch (int N, int i) {
	int p = 0;
	int q = N-1;
	int m;
	int l = 0;
	while (p <= q) {
		m = (p + q) / 2;
		++l;
		if (m == i) return l;
		if (m > i)
			q = m - 1;
		else
			p = m + 1;
	}
	printf ("%d %d\n", N, i);
	assert (0);
}

bool can[MAXN + 10];

int main () {
	int A, B;
	scanf ("%d %d", &A, &B);
	int i;
	for (i = A+1; i <= MAXN; ++i)
		if (bsrch (i, A) == B)
			can[i] = 1;

	int bi = -1;
	static std::pair <int, int> ans[MAXN];
	int ap = 0;
	for (i = 1; i <= MAXN+1; ++i) {
		if (can[i] && !can[i-1])
			bi = i;
		else if (can[i-1] && !can[i])
			ans[ap++] = std::make_pair (bi, i-1);
	}

	printf ("%d\n", ap);
	for (i = 0; i < ap; ++i)
		printf ("%d %d\n", ans[i].first, ans[i].second);

	return 0;
}
