/*
FROM: acm.timus.ru
PROB: 1074 (A very short problem)
KEYW: parcing input
*/

#include <cassert>
#include <cstdio>
#include <cctype>
#include <cstring>

const int MAXB = 1 << 12;//4000

int ps;
bool sign;
char line[MAXB];
char buf[MAXB];
int cnt;

void myassert (bool b) {
	while (!b);
}

bool read_first (int &pp) {
	sign = 0;//it is positive
	pp = 0;
	if (line[pp] == '-') {
		sign = 1;
		++pp;
	} else if (line[pp] == '+') {
		++pp;
	}

	bool dc = 0;
	int bp = MAXB / 2;
	ps = -1;
	bool rf = 1;
	for (; isdigit (line[pp]) || line[pp] == '.'; ++pp) {
		if (line[pp] == '.') {
			if (dc) return 0;
			dc = 1;
			rf = 0;
//			fprintf (stderr, "ps == %d\n", bp - 1);
			ps = bp - 1;
		} else {
			if (dc == 1) rf = 1;
//			fprintf (stderr, "write to %d -- %c\n", bp, line[pp]);
			buf[bp++] = line[pp];
		}
	}
	if (ps == -1) ps = bp-1;

	if (line[pp] == '\0'
	 || line[pp] == 'e'
	 || line[pp] == 'E')
		return bp != MAXB / 2 && rf;//should have read something after the dot and something at all
	else
		return 0;
}

bool read_sec (int pp) {
//	printf ("we are here!\n");
	if (line[pp] == '\0') {cnt = 0; return 1;}//there is no exponent
	if (line[pp] != 'e' && line[pp] != 'E') return 0;//the exponent does not start with e/E
//	assert (line[pp] == 'e' || line[pp] == 'E');
	++pp;//skip e/E
	bool cs = 0;//positive
	if (line[pp] == '-') {
		cs = 1;//negative
		++pp;
	} else if (line[pp] == '+') {
		++pp;
	}

	cnt = 0;
	bool f = 0;
	for (; isdigit (line[pp]) && cnt < 1000; ++pp) {
		myassert (line[pp] >= '0' && line[pp] <= '9');
		f = 1;
		cnt *= 10;
		cnt += line[pp] - '0';
	}
	
	if (cnt > 1000) cnt = 1000;
	if (cs) cnt *= -1;
//	printf ("fin cnt %d\n", cnt);
	if (f == 0) return 0;//we read only a sing or nothing
	f = 0;
	while (isdigit (line[pp])) {
		myassert (line[pp] >= '0' && line[pp] <= '9');
		f = 1;
		++pp;//skip remaining digits
	}
	if (f == 1) myassert (cnt == 1000 || cnt == -1000);
	if (line[pp] == '\0')
		return 1;//everything fine
	else
		return 0;//bad!
}

int main () {
	char num[16];
	while (gets (line), (line[0] != '#' || line[1] != '\0')) {
		memset (buf, '0', sizeof (buf));
		int n;
		int i;
		gets (num);
		for (i = 0; i < strlen (line); ++i) {
			if (line[i] == ' '
			 || line[i] == '\n'
			 || line[i] == '\r'
			 || line[i] == '\t'
			 || line[i] == '\v'
			 || line[i] == '\f'
			 || line[i] == '\a'
			 || line[i] == '\b') {
				printf ("Not a floating point number\n");
				break;
			}
			if (isspace (line[i])) {
				printf ("Not a floating point number\n");
				break;
			}
		}
		if (i != strlen (line)) continue;

		sscanf (num, "%d", &n);
		myassert (n >= 0 && n <= 100);
		int end;
		if (!read_first (end) || !read_sec (end)) {
			printf ("Not a floating point number\n");
			continue;
		}
		ps += cnt;
//		puts (buf);
		for (i = 0; buf[i] == '0' && i < ps; ++i);
//		fprintf (stderr, "i == %d\n", i);
//		if (sign == 1) putchar ('-');
		bool f = 0;
		static char ans[256];
		int ap = 0;
		for (; i <= ps; ++i) {
			ans[ap++] = buf[i];
			if (buf[i] != '0') f = 1;
			//putchar (buf[i]);
		}
		if (n != 0) {
			ans[ap++] = '.';
			//putchar ('.');
		}
		myassert (!f || cnt != 1000);
		for (int j = 0; j < n; ++j) {
			ans[ap++] = buf[i+j];
			if (buf[i+j] != '0') f = 1;
			//putchar (buf[i+j]);
		}
		ans[ap++] = '\0';
		if (f && sign) putchar ('-');
		puts (ans);
	}

	return 0;
}
