/*
FROM: acm.timus.ru (Winter 2001 A)
PROB: 1081 (Binary Legicographic Sequence)
KEYW: dynamical programming, decoding
*/

#include <cstdio>
#include <cassert>

//typedef long long lli;
const int MAXN = 1 << 6;

int N, K;
int dp[MAXN][2];

int main () {
	scanf ("%d %d", &N, &K);
	--K;

	dp[0][0] = dp[0][1] = 1;
	int i;
	for (i = 1; i <= N; ++i) {
		dp[i][0] = dp[i-1][1];
		dp[i][1] = dp[i-1][1] + dp[i-1][0];
	}

	if (K >= dp[N][1]) {
		printf ("-1\n");
		return 0;
	}

	int cu = 1;//use everything
	for (i = N; i; --i) {
		if (cu == 0) {
			putchar ('0');
			cu = 1;
		} else {
			if (K < dp[i-1][1]) {
				cu = 1;
				putchar ('0');
			} else {
				K -= dp[i-1][1];
				cu = 0;
				putchar ('1');
			}
		}
	}

	assert (K == 0);
	puts ("");

	return 0;
}
