/*
FROM: acm.timus.ru
PROB: 1084 (Goat in the Garden)
KEYW: geometry
*/

#include <cstdio>
#include <cmath>

#ifdef ONLINE_JUDGE
#define PI 3.14159265358979323846264338327950288419
#else
#define PI M_PI
#endif

#define EPS 1e-9

double A, R;

double rad2grad (double ang) {
	return (ang / PI) * 180.;
}

int main () {
	scanf ("%lf %lf", &A, &R);

	double a = A / 2;
	double diag = sqrt (2.) * A / 2;
//	printf ("%lf %lf\n", a, diag);
	
	if (R + EPS > diag) {
		printf ("%.3lf\n", A * A);
		return 0;
	} else if (R - EPS < a) {
		printf ("%.3lf\n", PI * R * R);
		return 0;
	}

	double b = sqrt (R * R - a * a);
	printf ("%.3lf\n", PI * R * R - 4 * (acos (a / R) * R * R - a * b));

	return 0;
}
