/*
FROM: acm.timus.ru
PROB: 1086 (Cryptography)
KEYW: prime numbers
*/

#include <cstdio>

const int MAXN = 1 << 18;

char erat[MAXN];
int prc;
int pr[MAXN];

int main () {
	int i, j;
	for (i = 2; i * i < MAXN; ++i) {
		if (erat[i]) continue;
		pr[prc++] = i;
		for (j = i * i; j < MAXN; j += i)
			erat[j] = 1;
	}
	for (; i < MAXN; ++i)
		if (!erat[i])
			pr[prc++] = i;

	int tc;
	scanf ("%d", &tc);
	while (tc--) {
		scanf ("%d", &i);
		printf ("%d\n", pr[i-1]);
	}

	return 0;
}
