/*
FROM: acm.timus.ru
PROB: 1087 (The time to take stones)
KEYW: combinatorial game, bounded, acyclic
*/

#include <cstdio>
#include <cstdlib>

const int MAXN = 1 << 14;
const int MAXM = 1 << 6;

int N, M;
char g[MAXN];
int k[MAXM];

int main () {
	scanf ("%d %d", &N, &M);

	int i, j;
	for (i = 0; i < M; ++i)
		scanf ("%d", k + i);

	g[0] = 1;//wining
	for (i = 1; i <= N; ++i)
		for (j = 0; j < M; ++j)
			if (k[j] <= i && g[i-k[j]] == 0) {
				g[i] = 1;
				break;
			}

	printf ("%d\n", 2 - g[N]);

	return 0;
}
