/*
FROM: acm.timus.ru
PROB: 1090 (In the army now)
KEYW: lowest bit index tree
*/

#include <cstdio>
#include <cassert>
#include <cstring>

const int MAXN = 10002;

int N, K;
short idt[MAXN];

inline void add (short pos) {
	for (; pos <= N; pos += pos & -pos) ++idt[pos];
}

inline short srch (short pos) {
	static short res;
	for (res = 0; pos; pos &= pos - 1) res += idt[pos];
	return res;
}

int main () {
	scanf ("%d %d", &N, &K);

	int br = -1, brj = -1;
	int i, j;
	int a;
	for (i = 0; i < K; ++i) {
		int crowj = 0;
		memset (idt + 1, 0, sizeof (short) * N);
		for (j = 0; j < N; ++j) {
			scanf ("%d", &a); a = N + 1 - a;
			assert (a >= 1 && a <= N);
			crowj += srch (a);
			add (a);
		}
		if (brj < crowj) {
			brj = crowj;
			br = i + 1;
		}
	}

	printf ("%d\n", br);

	return 0;
}
