/*
FROM: acm.timus.ru
PROB: 1091 (Tmutarakan exams)
KEYW: mathematics, combinations
*/

#include <cstdio>

const int MAXN = 1 << 6;
const int LIMIT = 10000;

int N, S;
int C[MAXN][MAXN];
int pr[128], prc;

int main () {
	scanf ("%d %d", &N, &S);
	C[0][0] = 1;
	int i, j;
	for (i = 1; i <= S; ++i) {
		C[i][0] = 1;
		for (j = 1; j <= i; ++j) {
			C[i][j] = C[i-1][j-1] + C[i-1][j];
			if (C[i][j] > LIMIT)
				C[i][j] = LIMIT;
		}
	}

	pr[prc++] = 2;
	for (i = 3; i < 64; ++i) {
		for (j = 0; j < prc; ++j)
			if (i % pr[j] == 0)
				break;
		if (j == prc)
			pr[prc++] = i;
	}
/*	for (i = 0; i < prc; ++i)
		printf ("%d   %d\n", i, pr[i]);
*/

	int res = 0;
	for (unsigned m = 1; m < (1 << 9); ++m) {
		int bit_cnt = 0;
		int crnt = 1;
		for (j = 0; j <= 8; ++j)
			if ((m >> j) & 1) {
				++bit_cnt;
				crnt *= pr[j];
				if (S / crnt < 2) break;
			}

		if (S / crnt < 2) continue;
//		printf ("%u  %d  %d * %d\n", m, crnt, ((bit_cnt & 1) * 2 - 1), C[S / crnt][N]);
		res += ((bit_cnt & 1) * 2 - 1) * C[S / crnt][N];
		if (res > LIMIT) res = LIMIT;
	}

	printf ("%d\n", res);

	return 0;
}
