/*
FROM: acm.timus.ru
PROB: 1100 (Final Standings)
KEYW: stable sort (stl)
*/

#include <cstdio>
#include <utility>
#include <algorithm>
#include <vector>

const int MAXN = 1 << 18;

bool cmp (const std::pair <std::pair <int, int>, int> &a, const std::pair <std::pair <int, int>, int> &b) {
	return a.first.second != b.first.second ? a.first.second > b.first.second : a.second < b.second;
}

int N;
std::pair <std::pair <int, int>, int> vec[MAXN];

int main () {
	scanf ("%d", &N);

	int i;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", &vec[i].first.first, &vec[i].first.second);
		vec[i].second = i;
	}

	std::sort (vec, vec + N, cmp);
	for (i = 0; i < N; ++i)
		printf ("%d %d\n", vec[i].first.first, vec[i].first.second);

	return 0;
}
