#include<cstdio>

#define MAXN 2

int N;
int idt[130][130][130];

void add (int x, int y, int z, int c) {
	static int i, j, k;
	for (i = x; i <= N; i += i & -i)
		for (j = y; j <= N; j += j & -j)
			for (k = z; k <= N; k += k & -k)
				idt[i][j][k] += c;
}

int query (int x, int y, int z) {
	static int i, j, k, res;
	for (res = 0, i = x; i; i &= i-1)
		for (j = y; j; j &= j-1)
			for (k = z; k; k &= k-1)
				res += idt[i][j][k];

	return res;
}

int main() {
	int m;
	scanf("%d", &N);
	while(1)
	{
		scanf("%d", &m);
		if(m == 1) {
			int x1, y1, z1, c;
			scanf("%d %d %d %d", &x1, &y1, &z1, &c);
			add (++x1, ++y1, ++z1, c);
		} else if (m == 2) {
			int x1, y1, z1, x2, y2, z2;
			scanf("%d %d  %d %d  %d %d", &x1, &y1, &z1, &x2, &y2, &z2);
			++x2; ++y2; ++z2;
//			printf("=> %d\n", query(x2, y2, z2));
			int res = 
			 + query(x2, y2, z2)
			 - query(x1, y2, z2)
			 - query(x2, y1, z2)
			 - query(x2, y2, z1)
			 + query (x1, y1, z2)
			 + query(x1, y2, z1)
			 + query(x2, y1, z1)
			 - query(x1, y1, z1);
			printf("%d\n", res);
		} else
			break;
	}
	return 0;
}
