#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 17;

int N;
int prev[MAXN];
int prevw[MAXN];
bool ns[MAXN];
int dp[MAXN];

int main () {
	scanf ("%d", &N);
	int i;
	for (i = 1; i < N; ++i) {
		scanf ("%d %d", prev + i, prevw + i);
		--prev[i];
		ns[prev[i]] = 1;
	}

	for (i = N-1; i; --i) {
		if (!ns[i]) {
			dp[prev[i]] += prevw[i];
		} else {
			dp[prev[i]] += std::min (prevw[i], dp[i]);
		}
//		printf ("dp[prev[%d]] == dp[%d] == %d\n", i, prev[i], dp[prev[i]]);
	}

	printf ("%.2lf\n", (double)dp[0]);

	return 0;
}
