/*
FROM: acm.timus.ru
PROB: 1500
*/

#include <cstdio>
#include <vector>
#include <utility>

using std::vector;
using std::make_pair;

int N, M, K;
vector <vector <std::pair <char, char> > > vec;

int mask;
int used;
void dfs (unsigned char a) {
	if (used & (1 << a)) return;
	used |= (1 << a);
	for (unsigned char i = 0; i < vec[a].size (); ++i)
		if (mask & (1 << vec[a][i].second))
			dfs (vec[a][i].first);
}

int main () {
	scanf ("%d%d%d", &K, &N, &M);

	int i;
	int j;
	int a, b, c;
	vec.resize (N);
	for (i = 0; i < M; ++i) {
		scanf ("%d%d%d", &a, &b, &c);
		vec[a].push_back (make_pair (b, c));
		vec[b].push_back (make_pair (a, c));
	}

	vector <vector <int> > x (K+1);
	int ub = 1 << K;
	register char pc;
	for (i = 0; i < ub; ++i) {
		pc = 0;
		for (j = 0; j < K; ++j)
			if (i & (1 << j)) ++pc;
		x[pc].push_back (i);
	}

	for (i = 1;; ++i) {
		for (j = 0; j < (int)x[i].size (); ++j) {
			mask = x[i][j];
			used = 0;
			dfs (0);
			if (used & 2) goto end;
		}
	}

	end:;
	printf ("%d\n", i);
	int k;
	for (k = 0; k < K; ++k)
		if (x[i][j] & (1 << k)) {
			printf ("%d", k);
			break;
		}
	for (++k; k < K; ++k)
		if (x[i][j] & (1 << k)) {
			printf (" %d", k);
		}

	printf ("\n");

	return 0;
}
