/*
FROM: acm.timus.ru
PROB: 1501
*/

#include <cstdio>

const int MAXN = 3002;

int N;
short nn1[MAXN], nn2[MAXN];
char dp[MAXN][MAXN];
char line[2][MAXN];

char dpf (short ii, short jj) {
	if (dp[ii][jj]) return dp[ii][jj];
	if ((ii + jj) & 1) {
		if ((nn1[ii] + nn2[jj]) * 2 > ii + jj) {
			if (line[0][ii] == '1' && dpf (ii+1, jj) > 0) return dp[ii][jj] = 1;
			if (line[1][jj] == '1' && dpf (ii, jj+1) > 0) return dp[ii][jj] = 2;
			return dp[ii][jj] = -1;//no solution
		} else {
			if (line[0][ii] == '0' && dpf (ii+1, jj) > 0) return dp[ii][jj] = 1;
			if (line[1][jj] == '0' && dpf (ii, jj+1) > 0) return dp[ii][jj] = 2;
			return dp[ii][jj] = -1;//no solution
		}
	} else {
		if (dpf (ii+1, jj) > 0) return dp[ii][jj] = 1;
		if (dpf (ii, jj+1) > 0) return dp[ii][jj] = 2;
		return dp[ii][jj] = -1;
	}
}

int main () {
	scanf ("%d\n", &N);

	int i;
	gets (line[0]);
	short c = 0;
	for (i = 0; i < N; ++i)
		nn1[i + 1] = c += line[0][i] == '0';

	gets (line[1]);
	c = 0;
	for (i = 0; i < N; ++i)
		nn2[i + 1] = c += line[1][i] == '0';
/*
	for (i = 0; i <= N; ++i)
		printf ("%d %d\n", nn1[i], nn2[i]);
*/
	dp[N][N] = 3;//it is terminal
	dpf (0, 0);
	if (dp[0][0] == -1) printf ("Impossible");
	else {
		int ii = 0, jj = 0;
		while (ii != N || jj != N) {
			putchar (dp[ii][jj] + '0');
//			printf ("(%d %d)", ii, jj);
			if (dp[ii][jj] == 1) ++ii; else ++jj;
		}
	}
	printf ("\n");

	return 0;
}
