/*
FROM: acm.timus.ru
PROB: 1507
*/

#include <cstdio>
#include <cstring>

int N;
struct ma3x {
	bool m[50][50];
//	ma3x () {memset (m, 0, sizeof (m));}
	ma3x () {}
	ma3x (const ma3x &a) {memcpy (m, a.m, sizeof (m));}
	void operator = (const ma3x &a) {memcpy (m, a.m, sizeof (m));}
};

void mul (ma3x &a, const ma3x &b, const ma3x &c) {
	static unsigned char i, j, k;
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			for (k = 0; k < N; ++k)
				if (b.m[i][k] && c.m[k][j]) {
					a.m[i][j] = 1;
					break;
				} else
					a.m[i][j] = 0;
}

void add (ma3x &a, const ma3x &b) {
	static unsigned char i, j;
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			a.m[i][j] = a.m[i][j] || b.m[i][j];
}

ma3x base;
ma3x Ret;
void mypow (int st) {
	static ma3x tmp;
	if (st == 1) {Ret = base; return;}
	if (st & 1) {
		mypow (st - 1);
		mul (tmp, Ret, base);
		Ret = tmp;
	} else {
		mypow (st / 2);
		mul (tmp, Ret, Ret);
		Ret = tmp;
	}
}

int main () {
	scanf ("%d", &N);
	unsigned char i, j;
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j) {
			int tmp;
			scanf ("%d", &tmp);
			base.m[i][j] = tmp;
		}

	mypow (N * (N-1));

//	printf ("calculated!\n");

	ma3x tmp, sum = Ret;
	for (int i = N*(N-1) + 1; i <= N*(N+1); ++i) {
//		printf ("%d %d %d\n", N*(N-1) + 1, i, N*(N+1));
//		printf ("Add\n");
		mul (tmp, Ret, base);
		add (sum, tmp);
		Ret = tmp;
	}

	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			if (!sum.m[i][j]) {
				printf ("No\n");
				return 0;
			}

	printf ("Yes\n");

	return 0;
}
