#include <cstdio>
#include <algorithm>
#include <utility>
#include <cassert>
#include <cstdlib>

const int MAXN = 1 << 6;

int N, M;
std::pair <int, int> buf[MAXN * MAXN];

int main (int argc, char *argv[]) {
	assert (argc == 4);
	
	sscanf (argv[1], "%d", &N);
	sscanf (argv[2], "%d", &M);
	FILE *out = fopen (argv[3], "w");
	fprintf (out, "%d %d\n", N, M);
	int i, j, a, b, bp = 0;
	for (i = 0; i < N; ++i)
		for (j = i + 1; j < N; ++j)
			buf[bp++] = std::make_pair (i, j);

	assert (bp >= M);
	std::random_shuffle (buf, buf + bp);

	for (i = 0; i < M; ++i)
		fprintf (out, "%d %d\n", buf[i].first + 1, buf[i].second + 1);
	fclose (out);

	return 0;
}
