#include <cstdio>
#include <map>
#include <cctype>

using namespace std;

typedef long long ll;

struct Order
{
	ll cnt, last, pr, num;
	bool operator<(const Order &o) const
	{
		return (pr == o.pr) ? (cnt > o.cnt) : (pr < o.pr);
	}
};

ll n, m;
//map <long long, Order> mpi;
Order mpi[1 << 16];
int used[1 << 16];
char name[128][1024];
ll fl[128];
ll pr[128];

int main()
{
	Order o1, o2;
	o1.pr = 0;
	o1.cnt = 0;
	o1.last = -1;
	o1.num = 0;
	mpi[0] = o1;
	used[0] = 1;
	char ch;
	scanf("%I64d %I64d", &n, &m);
	m *= 1000;
	//printf("IO\n");
	for (int i = 0; i < n; ++ i)
	{
		scanf("%s", name[i]);
		scanf("%I64d", pr + i);
		scanf("%I64d", fl + i);
		//printf("%lld\n", fl[i]);
		int u  = 0;
		while(u < 3 && scanf("%c", &ch))
		{
			//printf("%c", ch);	
			if (ch == '.') continue;
			if (!isdigit(ch)) break;
			++ u;
			fl[i] = fl[i] * 10 + ch - '0';
		}
		for (; u < 3; ++ u) fl[i] *= 10;
		//printf("%s %lld %lld\n", name[i], pr[i], fl[i]);
		ll x;
		//for (map <long long, Order>::iterator it = mpi.end(); it-- != mpi.begin();)
		//for (map <long long, Order>::iterator it = mpi.begin(); it != mpi.end(); ++ it)
	//printf("IO\n");
		for (int j = 0; j < m; ++ j)
		if (used[j])
		{
			//printf("%lld\n", i);
			x = j;
			o1 = mpi[j];
			//if (x >= m) break;
			o2.last = i;
			o2.pr = o1.pr + pr[i];
			if (o1.last == i)
			{
				o2.cnt = o1.cnt;
				o2.num = o1.num + 1;
			}
			else
			{
				o2.cnt = o1.cnt + 1;
				o2.num = 1;
			}
			//if (x + fl[i] >= m) printf("%lld\n", x + fl[i]);
			//printf("IO2\n");
			x += fl[i];
			if (!used[x])
			{
				used[x] = 1;
				mpi[x] = o2;
			}
			else
			{
				if (o2 < mpi[x]) mpi[x] = o2;
			}
			/*for (int j = 1; x < m; ++ j)
			{
				x += fl[i];
				o2.pr = j * pr[i] + o1.pr;
				o2.last = i;
				o2.cnt = o1.cnt + 1;
				o2.num = j;
				if (!mpi.count(x))
				{
					mpi[x] = o2;
				}
				else
				{
					if (o2 < mpi[x]) mpi[x] = o2;
				}
			}*/
		} 
	}
	o2.pr = 2000000000000000ll;
	ll x;
	//for (map <long long, Order>::iterator it = mpi.begin(); it != mpi.end(); ++ it)
	for (int i = m; i <= 2 * m; ++ i)
	if (used[i])
	{
		if (mpi[i] < o2)
		{
			x = i;
			o2 = mpi[i];
		}
	}
	//printf("%lld\n", x);
	printf("%I64d\n", o2.pr);
	while (x)
	{
		printf("%s %I64d\n", name[o2.last], o2.num);
		x -= o2.num * fl[o2.last];
		o2 = mpi[x];
	}
	return 0;
}
