/* @JUDGE_ID: 63966HA 100  C++  "Dynamic Programming"*/
/*
NAME: The 3n + 1 problem
ID: 100
SITE: acm.uva.es
*/

#include <cstdio>
#include <cstdlib>
#include <algorithm>

/*
const int MAXN = 1000001;
typedef unsigned short ushort;
*/
/*
ushort *opt = new ushort [MAXN];
ushort **fsrch;

unsigned rec (unsigned a) {
    if (a < MAXN)
        if(opt[a])
            return opt[a];
        else if (a & 1)
            return opt[a] = rec (3 * a + 1) + 1;
        else
            return opt[a] = rec (a >> 1) + 1;
    else if (a & 1)
            return rec (3 * a + 1) + 1;
    else
            return rec (a >> 1) + 1;
}
*/
typedef unsigned uint;

int rec_ (uint a) {
//	printf (" %u", a);
    if (a == 1)
        return 1;

    if (a & 1u)
        return rec_ (a * 3u + 1u) + 1;
    else
        return rec_ (a >> 1) + 1;
}

/*
void fillopt () {
    int i=0, p2=1;
    opt[1] = 1;
    for (i = 2; i < MAXN; ++i)
        opt[i] = 0;

    int *queue = new int [MAXN];
    queue[0] = 1;

    int a;
    for (i = 0; i < p2; ++i) {
        a = (queue[i] << 1);
        if (a < MAXN && !opt[a]) {
            queue[p2++] = a;
            opt[a] = opt[queue[i]] + 1;
        }
        a = (queue[i] / 3);
        if ((queue[i] % 3) == 1 && (a & 1) && !opt[a]) {
            queue[p2++] = a;
            opt[a] = opt[queue[i]] + 1;
        }
    }

    delete [] queue;

    for (i = 1; i < MAXN; ++i)
        if (!opt[i])
            rec (i);

    for (i = 1; i <= 10; ++i)
        printf ("%u ", opt[i]);
    printf ("\n*******\n");

}
*/
/*
void genall () {
#define NN (20)
    fsrch = new ushort* [NN];
    int i,j;
    for (i = 0; i < NN; ++i)
        fsrch[i] = new ushort [MAXN-(1<<i)+1];

    for (i = 1; i < MAXN; ++i)
        fsrch[0][i] = opt[i];

    for (i = 1; i <= 10; ++i)
        printf ("%u ", opt[i]);
    printf ("*******\n");

    delete [] opt;

#define _max_(A,B) (((A) > (B)) ? (A) : (B))

    for (i = 1; i < NN; ++i)
        for (int ub=MAXN-(1<<i)+1, j = 1; j < ub; ++j)
            fsrch[i][j] = _max_ (fsrch[i-1][j], fsrch[i-1][j+(1<<(i-1))]);
//#undef _max_
//#undef NN
}
*/
/*
ushort srch (int a, int b) {
    int dif = (b - a), i;
    for (i = 1; i <= NN; ++i)
        if ((1 << i) > dif)
            break;

    --i;
//    printf ("stepen - %d, kletki ([%d], [%d])\n", i, a, b-(1<<i)+1);
    return _max_ (fsrch[i][a], fsrch[i][b-(1<<i)+1]);
}
*/

int main () {
/*
    fillopt ();
    genall ();
*/
    int i;
/*
    for (i = 0; i <= 3; ++i) {
        for (int ub = 10-(1<<i)+1, j = 1; j < ub; ++j)
            printf ("%d ", fsrch[i][j]);
        printf ("\n");
    }
*/
	int opt[1000000];
	for (int i = 1; i < 1000000; ++i) {
		opt[i] = rec_ (i);
//		printf ("\n");
	}

    int a, b;
    int max;
//    uint tmp;
	while (scanf ("%d %d", &a, &b) != -1) {
//        max = srch (a, b);
		max = 0;
		if (a <= b) {
			for (i = a; i <= b; ++i)
				if (opt[i] > max)
					max = opt[i];
		} else {
			for (i = b; i <= a; ++i)
				if (opt[i] > max)
					max = opt[i];
		}
		printf ("%d %d %d\n", a, b, max);
    }

/*
    for (i = 0; i < NN; ++i)
        delete [] fsrch[i];
    delete [] fsrch;
*/
    return 0;
}
