/*
NAME: The Blocks Problem
ID: 101
SITE: acm.uva.es
*/

#include <cstdio>
#include <cstring>

const int MAXN = 32;
typedef void (*funk) (const int, const int);

int N;

int ma3x[MAXN][MAXN];
int szs[MAXN];

void test () {
    int i,j;
    for (i = 0; i < N; ++i) {
        printf ("%d:", i);
        for (j = 0; j < szs[i]; ++j)
            printf (" %d", ma3x[i][j]);
        printf ("\n");
    }
}

void pile (int i1, int j1, int i2) {
    for (int j = j1; j < szs[i1]; ++j)
        ma3x[i2][szs[i2]++] = ma3x[i1][j];
    szs[i1] = j1;
}


void srch (int a, int &i, int &j) {
    for (i = 0; i < N; ++i)
        for (j = 0; j < szs[i]; ++j)
            if (ma3x[i][j] == a)
                return;
}

void clean (int i, int j) {
    for (int jj = ++j; jj < szs[i]; ++jj) {
        ma3x[ma3x[i][jj]][0] = ma3x[i][jj];
        szs[ma3x[i][jj]] = 1;
    }
    szs[i] = j;
}

void _00 (const int a, const int b) {
    int i1,j1, i2, j2;
    srch (a, i1, j1);
    srch (b, i2, j2);
    if (i1 == i2)
        return;

    clean (i1, j1);
    clean (i2, j2);
/*
    ma3x[i2][szs[i2]++] = a;
    --szs[i1];
*/
    pile (i1, j1, i2);
}

void _01 (const int a, const int b) {
    int i1,j1, i2, j2;
    srch (a, i1, j1);
    srch (b, i2, j2);
    if (i1 == i2)
        return;


    clean (i1, j1);
/*
    ma3x[i2][szs[i2]++] = a;
    --szs[i1];
*/
    pile (i1, j1, i2);
}

void _10 (const int a, const int b) {
    int i1,j1, i2, j2;
    srch (a, i1, j1);
    srch (b, i2, j2);
    if (i1 == i2)
        return;

    clean (i2, j2);
    pile (i1,j1,i2);
}

void _11 (const int a, const int b) {
    int i1,j1, i2, j2;
    srch (a, i1, j1);
    srch (b, i2, j2);
    if (i1 == i2)
        return;

    pile (i1,j1,i2);
}


funk f[2][2] = {{&_00, &_01}, {&_10, &_11}};

int main () {
    scanf ("%d", &N);

    int i;
    for (i = 0; i < N; ++i) {
        ma3x[i][0] = i;
        szs[i] = 1;
    }

    char command[10];
    int fc, sc, fn, sn;
	for (;;) {
		scanf ("%s %d", command, &fn);
		if (!strcmp (command, "quit"))
			break;
		if (!strcmp (command, "move"))
			fc = 0;
		else
			fc = 1;
		scanf ("%s %d", command, &sn);
		if (!strcmp (command, "onto"))
			sc = 0;
		else
			sc = 1;
		f[fc][sc] (fn, sn);
    }

	test ();

    return 0;
}
