/*
NAME: The Skyline Problem
ID: 105
SITE: acm.uva.es
*/

#include <cstdio>

const int MAXX = 1 << 14;

int vec[MAXX];

int main () {
	int l, h, r;
	int i;
	while (scanf ("%d%d%d", &l, &h, &r) != -1) {
		for (i = l; i < r; ++i)
			vec[i] = (vec[i] > h ? vec[i] : h);
	}
	for (i = 0; i < MAXX && !vec[i]; ++i);
	
	printf ("%d %d", i, vec[i]);
	
	for (++i; i < MAXX; ++i)
		if (vec[i] != vec[i-1])
			printf (" %d %d", i, vec[i]);
	printf ("\n");

	return 0;
}
