/*
NAME: Meta-Loopless Sorts
ID: 110
SITE: acm.uva.es
*/

#include <cstdio>

const int MAXN = 1 << 3;

int N;
char vec[MAXN];

void all () {
	printf ("%c", vec[0]); for (int i = 1; i < N; ++i) printf (",%c", vec[i]);
}

void init () {
	for (int i = 0; i < N; ++i)
		vec[i] = 'a' + i;
	printf ("program sort(input,output);\n"
			"var\n");
	all ();
	printf (" : integer;\n");
	printf ("begin\n"
			"  readln(");
	all ();
	printf (");\n");
}

void fin () {
	printf ("end.\n");
}

void swp (int a, int b) {char tmp = vec[a]; vec[a] = vec[b]; vec[b] = tmp;}

int idnt = 1;
void ident () {for (int i = 0; i < idnt; ++i) printf ("  ");}

void solve (int i, int j) {
//	printf ("<%d %d>\n", i, j);
	if (j == -1) return solve (i+1, i);
	if (i == N) {ident (); printf ("writeln("); all (); printf (")\n"); return;}
	ident (); printf ("if %c < %c then\n", vec[j+1], vec[j]);
	swp (j, j + 1);
	++idnt;
	solve (i, j-1);
	swp (j, j + 1);
	--idnt;
	ident (); printf ("else\n");
	++idnt;
	solve (i+1, i);
	--idnt;
}

int main () {
	int Ntc;
	scanf ("%d", &Ntc);

	for (int i = 0; i < Ntc; ++i) {
		if (i) printf ("\n");
		scanf ("%d", &N);
		init ();
		solve (1, 0);
		fin ();
	}

	return 0;
}
