/*
NAME: History Grading
ID: 111
SITE: acm.uva.es
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 21;

int N;
int ref[MAXN];
int row[MAXN];
int tmp[MAXN];

void do_it () {
	int i;
	for (i = 1; i < MAXN; ++i) tmp[i] = INT_MAX;
	tmp[0] = INT_MIN;
//	for (i = 0; i < N; ++i) printf (" %d", row[i]); printf ("\n");
	for (i = 0; i < N; ++i)
		*std::lower_bound (tmp + 1, tmp + N, row[i]) = row[i];
	for (i = MAXN-1; tmp[i] == INT_MAX; --i);
	printf ("%d\n", i);
}

int main () {
	scanf ("%d", &N);

	int t, i;
	for (i = 0; i < N; ++i) {
		scanf ("%d", &t);
		ref[i] = t - 1;
	}
//	for (i = 0; i < N; ++i) printf ("%d ", ref[i]); printf ("\n");

	for (;;) {
		for (i = 0; i < N; ++i) {
			if (scanf ("%d", &t) != 1) return 0;
			--t;
			row[t] = ref[i];
		}
//		printf ("yo!\n");
		do_it ();
	}

	return 0;
}
