/*
NAME: Tree Summing
ID: 112
SITE: acm.uva.es
*/

#include <cstdio>
#include <cassert>
#include <cctype>

struct node {
	long long n;
	node *left, *right;
	node (long long _n, node *_left, node *_right) : n (_n), left (_left), right (_right) {}
};

node *head;

node *readtree () {
	static long long n;
	static char tmp;
	while (isspace (getchar ()));
	while (isspace (tmp = getchar ()));
	if (tmp == ')')
		return 0;
	else {
		ungetc (tmp, stdin);
		scanf ("%Ld", &n);
		node *t = new node (n, 0, 0);
		t->left = readtree ();
		t->right = readtree ();
		while (isspace (getchar ()));
		return t;
	}
}

long long srch;
bool fnd (node *x, long long S) {
	if ((!x->left) && (!x->right))
		return S + x->n == srch;
	else
		return (x->left ? fnd (x->left, S + x->n) : 0) || (x->right ? fnd (x->right, S + x->n) : 0);
}

int idnt;
void prnt (node *x) {
	if (!x) return;
	++idnt;
	for (int i = 0; i < idnt; ++i) printf ("  ");
	printf ("%Ld\n", x->n);
	prnt (x->left);
	prnt (x->right);
	--idnt;
}

int main () {
	while (scanf ("%Ld", &srch) == 1) {
		head = readtree ();
		printf ("%s\n", head && fnd (head, 0) ? "yes" : "no");
	}

	return 0;
}
