/*
NAME: Stacks of Flapjacks
ID: 120
SITE: acm.uva.es
*/

#include <cstdio>
#include <iostream>
#include <algorithm>
#include <sstream>
#include <string>

const int MAXN = 1 << 5;

int N;
int vec[MAXN];

void flip (int a) {
	std::reverse (vec, vec + a + 1);
	std::cout << N - a << ' ';//printf ("%d ", N - a);
}

int main () {
	std::string line;

	while (std::getline (std::cin, line), line.size ()) {
		std::istringstream in (line);
		//printf ("%s\n", line.c_str ());
		std::cout << line << std::endl;
		N = 0;
		while (in >> vec[N++]);
		--N;
//		for (int i = 0; i < N; ++i) printf ("%d ", vec[i]); printf ("\n\n");
		for (int bottom = N - 1; bottom; --bottom) {
			int maxi = bottom;
			for (int i = bottom - 1; i >= 0; --i)
				if (vec[maxi] < vec[i])
					maxi = i;
			if (maxi == bottom) continue;
			if (maxi	)
				flip (maxi);
			flip (bottom);
		}
		std::cout << 0 << std::endl;//printf ("0\n");
	}

	return 0;
}
