/*
NAME: Trees on the level
ID: 122
SITE: acm.uva.es
*/

#include <cstdio>
#include <map>
#include <iostream>
#include <sstream>
#include <string>
#include <utility>

class nsc {
	public:
	bool operator () (const std::string &a, const std::string &b) const {return a.size () != b.size () ? a.size () < b.size () : a < b;}
};

int main () {
	std::string tmp;
	std::map <std::string, int, nsc> nodes;
	bool bf = 0;
	int d;
	std::string s;
	while (std::cin >> tmp) {
		if (tmp == "()") {
			if (bf) goto nxt;
			for (std::map <std::string, int>::const_iterator i = nodes.begin (); i != nodes.end (); ++i) {
//				printf ("look at - %s\n", i->first.c_str ());
				for (int j = i->first.size () - 1; j >= 0; --j) {
//					printf ("srch for _%s_\n", i->first.substr (0, j).c_str ());
					if (nodes.find (i->first.substr (0, j)) == nodes.end ()) {
						printf ("not complete\n");
						goto nxt;
					}
				}
			}

			for (std::map <std::string, int>::const_iterator i = nodes.begin (); i != nodes.end (); ++i) {
				if (i != nodes.begin ()) printf (" ");
				printf ("%d", i->second);
			}
			printf ("\n");
			nxt:;
			bf = 0;
			nodes.clear ();
		} else {
			if (bf) continue;
			std::istringstream in (tmp.substr (1, tmp.size () - 2));
			in >> d >> s;
			s = s.substr (1);
			if (nodes.find (s) == nodes.end ()) nodes[s] = d;
			else {printf ("not complete\n"); bf = 1;}
		}
	}

	return 0;
}
