/*
NAME: The Errant Physicist
ID: 126
SITE: acm.uva.es
*/

#include <cstdio>
#include <cassert>
#include <cstdlib>
#include <cctype>
#include <cstring>
#include <cmath>

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <utility>
#include <map>
#include <set>
#include <queue>

struct el {
	int coef;
	int val[2];//0 is x 1 is y
	el (int _coef =0, int _val0 =0, int _val1 =0) {coef = _coef; val[0] = _val0; val[1] = _val1;}
	el & operator = (const el& x) {coef = x.coef; val[0] = x.val[0]; val[1] = x.val[1]; return *this;}
	bool operator < (const el &a) const {return val[0] != a.val[0] ? val[0] > a.val[0] : val[1] < a.val[1];}
};

el read_el (const std::string &s) {
	el ret;
	unsigned i, j;
	int tmp = 0;
	for (i = 1; i < s.size () && s[i] != 'x' && s[i] != 'y'; ++i) {
		tmp *= 10;
		tmp += s[i] - '0';
	}
	if (i == 1) tmp = 1;
	ret.coef = tmp * (s[0] == '-' ? -1 : 1);
	if (i == s.size ()) return ret;

	for (int k = 0; k < 2; ++k) {
		tmp = 0;
		for (j = i + 1; j < s.size () && s[j] != 'x' && s[j] != 'y'; ++j) {
			tmp *= 10;
			tmp += s[j] - '0';
		}
		if (j == i + 1) tmp = 1;
		ret.val[s[i] - 'x'] = tmp;

		if (j == s.size ()) return ret;
		i = j;
	}
	assert (0);
}

std::vector <el> expr[2];
std::vector <el> res;

std::string ans[2];
void pans (int a, int b) {
	std::string tmp, tmp2;
	while (b) {
		tmp = (char)('0' + b % 10) + tmp;
		b /= 10;
		tmp2 += " ";
	}
	ans[a] += tmp;
	ans[!a] += tmp2;
}
void qprnt (el a) {
//	printf ("%d %d %d\n", a.coef, a.val[0], a.val[1]);
	ans[0] += "   ";//3 space
	ans[1] += a.coef < 0 ? " - " : " + ";
//	printf ("%d %d %d\n", abs (a.coef != 1), a.val[0] == 0, a.val[1] == 0);
	if (abs (a.coef) != 1 || (a.val[0] == 0 && a.val[1] == 0))
		pans (1, abs (a.coef));
	for (int k = 0; k < 2; ++k) {
		if (a.val[k]) {
			ans[0] += " ";
			ans[1] += ('x' + k);
		}
		if (a.val[k] > 1)
			pans (0, a.val[k]);
	}
}


int main () {
	std::string line;
	std::cin >> line;
	while (line != "#") {
		for (int k = 0; k < 2; ++k) {
			if (line[0] != '-') line = '+' + line;

			int beg = 0;
			el to_push;
			expr[k].clear ();
			for (unsigned i = 1; i <= line.size (); ++i)
				if (i == line.size () || line[i] == '+' || line[i] == '-') {
					to_push = read_el (line.substr (beg, i - beg));
					expr[k].push_back (to_push);
//					printf ("%d %d %d\n", to_push.coef, to_push.val[0], to_push.val[1]);
					beg = i;
				}
			std::cin >> line;
		}
/*
		for (unsigned i = 0; i < expr[0].size (); ++i) printf ("%d %d %d\n", expr[0][i].coef, expr[0][i].val[0], expr[0][i].val[1]);
		printf ("--\n");
		for (unsigned i = 0; i < expr[1].size (); ++i) printf ("%d %d %d\n", expr[1][i].coef, expr[1][i].val[0], expr[1][i].val[1]);
*/

		res.clear ();
		res.reserve (expr[0].size () * expr[1].size ());
		unsigned i, j;
		for (i = 0; i < expr[0].size (); ++i)
			for (j = 0; j < expr[1].size (); ++j)
				res.push_back (
				el (expr[0][i].coef * expr[1][j].coef,
					expr[0][i].val[0] + expr[1][j].val[0],
					expr[0][i].val[1] + expr[1][j].val[1]));

//		printf ("res - %d\n", res.end () - res.begin ());
		sort (res.begin (), res.end ());

//		for (i = 0; i < res.size (); ++i) printf ("%d %d %d\n", res[i].coef, res[i].val[0], res[i].val[1]); printf ("---\n");

		ans[0].clear ();
		ans[1].clear ();
		el tmp = res[0];
		for (i = 1; i <= res.size (); ++i)
			if (i < res.size () && tmp.val[0] == res[i].val[0] && tmp.val[1] == res[i].val[1])
				tmp.coef += res[i].coef;
			else if (tmp.coef) {
				qprnt (tmp);
				if (i < res.size ()) tmp = res[i];
			}
		int ofset;
		if (ans[1][1] == '-') {ans[1][2] = '-'; ofset = 2;} else ofset = 3;
		printf ("%s\n%s\n", ans[0].c_str () + ofset, ans[1].c_str () + ofset);
		//std::cout << ans[0] << std::endl << ans[1] << std::endl;
	}

	return 0;
}
