#include <cstdio>
#include <cmath>

using namespace std;

typedef long long ll;

ll x, y;

bool find(ll a, ll t)
{
	ll disc = 12ll * t - 3ll * a * a, sq;
	if (disc < 0) return false;
	sq = (ll) sqrt(disc);
	if (sq * sq == disc)
	{
		disc = -3ll * a + sq;
		if (disc < 0) return false;
		if (disc % (6ll) == 0)
		{
			y = disc / (6ll);
			x = y + a;
			return true;
		}
	}
	return false;
}

int main()
{
	ll n;
	while (scanf("%lld", &n), n)
	{
		bool found = false;
		for (ll a = 1, t; (t = a * a * a) <= n; ++ a)
		{
			if (n % a == 0)
			{
					found = find(a, n / a);	
					if (found)
					{
						printf("%lld %lld\n", x, y);
						break;
					}
			}
		}
		if (!found)
			printf("No solution\n");

	}
	return 0;
}

