#include<cstdio>

using namespace std;

#define MAXN 65536
#define MAXK 1024
#define INF 2000000000

int a[MAXN], f[MAXN], n, k;

bool test(int d)
{
	int sum = 0, tmp = k;
	for(int i = 0; i < n; i++)
	{
		if(sum + a[i] <= d)
		{
			sum += a[i];
		}
		else if(tmp > 0 && a[i] <= d)
		{
			sum = a[i];
			tmp --;
		}
		else return 0;
	}
	return 1;
}

int main()
{
	while(scanf("%d%d", &n, &k) != -1)
	{
		if(n == 0)
		{
			printf("%d %d\n", 0, 1);
			continue;
		}
		int sum = 0;
		for(int i = 0; i < n; i++)
		{
			scanf("%d", &a[i]);
			sum += a[i];
		}
		int l = 0, r = sum, res = INF;
		while(l <= r)
		{
			int mid = (l + r) / 2;
			if(test(mid))
			{
				res = mid;
				r = mid - 1;
			}
			else l = mid + 1;
		}
		f[n] = 1;
		int diff = 0;
		for(int i = 0; i < n; i++)
		{
			if(sum - diff <= res) f[i] = 1;
			else f[i] = 0;
			diff += a[i];
		}
		for(int j = 1; j <= k; j++)
		{
			int t = 0, tmp = 0, ans = 0;
			while(t < n && tmp + a[t] <= res) { tmp += a[t]; ans += f[t+1]; ans %= 10007; t++; }
			f[0] = ans;
			for(int i = 1; i < n; i++)
			{
				tmp -= a[i - 1];
				ans -= f[i];
				if(ans < 0)
				{
					ans += 10007;
				}
				while(t < n && tmp + a[t] <= res) { tmp += a[t]; ans += f[t+1]; ans %= 10007; t++; }
				f[i] = ans;
			}
		}
		printf("%d %d\n", res, f[0]);
	}
	return 0;
}
