#include<cstdio>
#include<algorithm>

long double sum(long double n)
{
	return n * (n + 1) / 2;
}

long double sum2(long double n)
{
	return n * (n + 1) * (2 * n + 1) / 6;
}

long double sum3(long double n)
{
	return sum(n) * sum(n);
}

long double calc(int a, int b)
{
	long double res = 0;
	for(int k = 2; k <= a + b; k++)
	{
		int a1 = a + 1, b1 = b + 1 - k;
		int left = std::max(0, k - b - 1), right = std::min(a, k - 1);
		long double x1 = sum(right) - sum(left);
		long double x2 = sum2(right) - sum2(left);
		long double x3 = sum3(right) - sum3(left);
		long double tmp = a1 * b1 * x1 + a1 * x2 - b1 * x2 - x3;
		res += tmp / k;
	}
	return res;
}

int main()
{
	int c = 1;
	while(1)
	{
		int x1, y1, x2, y2, h;
		scanf("%d%d%d%d%d", &x1, &y1, &x2, &y2, &h);
		if(x1 == 0 && y1 == 0 && x2 == 0 && y2 == 0 && h == 0) break;
		int a = y1 - x1;
		int b = y2 - x2;
		long double res = 4 * h * calc(a, b);
		res /= (long double)(a + 1) * a * (b + 1) * b;
		printf("Case %d: %Lf\n", c, res);
		c++;
	}
	return 0;
}
