/*NOTE: this plays a game of turning cons form H to T ...
there are N coins, you can turn 1, 2 or 3 coins but the rightmost should be H. everyting T is losing. -> strategy*/
#include <cstdio>

const int MAXN = 1 << 10;

const int N = 20;
int dp[MAXN] = {0, 1, 2};
char used[MAXN * MAXN];

int main () {
	dp[0] = 0;
	used[0] = used[1] = used[2] = used[3] = 1;//because 0 1 and 2 are up
	int i, ii;
	for (i = 3; i <= N; ++i) {
		for (ii = 0; used[ii]; ++ii);
		dp[i] = ii;
		used[ii] = 1;
		for (ii = 1; ii < i; ++ii)
			used[dp[ii] ^ dp[i]] = 1;
	}

	for (i = 0; i <= N; ++i) printf ("%d -> %d (%x --> %x)\n", i, dp[i], i, dp[i]);

	return 0;
}
