#include <cstdio>
#include <cstring>
#include <ctime>
#include <cstdlib>

#include "module_tnc.h"

namespace {
	const int MAXK = 1 << 7;
	int K;
	int vec[MAXK];
	int __init_sum;
	int sum;
	int current_picked;
	int _total_questions;
};

static void pick_nut () {
	if (sum == 0) {
		printf ("EVERYTHING OK - %d (average %lf)\n", _total_questions, (double)_total_questions / __init_sum);
		exit (0);
	}
	int pick = rand () % sum;
	for (int i = 0; i < K; ++i)
		if (pick < vec[i]) {
			current_picked = i;
			break;
		} else
			pick -= vec[i];

	--vec[current_picked];
	--sum;
}

void init (int _K, int *_vec, int _sum) {
	srand (time (0));
	K = _K;
	memcpy (vec, _vec, sizeof (int) * K);
	__init_sum = sum = _sum;
//	printf ("%d__\n", __init_sum);

	pick_nut ();
}

bool ask (int sz, int *ask_vec) {
	++_total_questions;
	for (int i = 0; i < sz; ++i)
		if (ask_vec[i] == current_picked) return 1;
	return 0;
}

void ans (int x) {
	if (x == current_picked)
		pick_nut ();
	else {
		printf ("WRONG GUESS!\n");
		exit (-1);
	}
}
