/*
FROM: Balkan Olympiad in Informatics (BOI) 2000 day 1
PROB: market
KEYW: dynamical programming
*/

#include <cstdio>

const int MAXW = 1 << 10;
const int MAXN = 1 << 9;
const int MAXTW = MAXW * MAXN;

int N;
bool can[MAXTW] = {1};

int main () {
	scanf ("%d", &N);
	
	int i, j;
	int a, sum = 0;
	for (i = 0; i < N; ++i) {
		scanf ("%d", &a);
		for (j = sum; j >= 0; --j)
			if (can[j]) can[j+a] = 1;
		sum += a;
	}

	int res = 0;
	for (j = sum; j; --j)
		res += can[j];

	printf ("%d\n", res);

	return 0;
}
