/*
FROM: Balkan Olympiad in Informatics (BOI) 2001 day 1
PROB: secret
KEYW: module
*/

#include <cassert>
#include <cstring>
#include <cstdio>

static int real, nguesses;

void showfit (int guess, int *kr, int *bk) {
	static int first_time = 1;
	static int cnt[16];
	if (first_time) {
		first_time = 0;
		scanf ("%d", &real);
	}
	++nguesses;

	memset (cnt, 0, sizeof (cnt));
	*kr = *bk = 0;

	++cnt[real % 10];
	++cnt[real / 10 % 10];
	++cnt[real / 100 % 10];
	++cnt[real / 1000];

	if (cnt[guess % 10]) --cnt[guess % 10], ++*kr;
	if (cnt[guess / 10 % 10]) --cnt[guess / 10 % 10], ++*kr;
	if (cnt[guess / 100 % 10]) --cnt[guess / 100 % 10], ++*kr;
	if (cnt[guess / 1000]) --cnt[guess / 1000], ++*kr;

	if (real % 10 == guess % 10) --*kr, ++*bk;
	if (real / 10 % 10 == guess / 10 % 10) --*kr, ++*bk;
	if (real / 100 % 10 == guess / 100 % 10) --*kr, ++*bk;
	if (real / 1000 == guess / 1000) --*kr, ++*bk;
}

void ans (int a) {
	assert (a == real);
	assert (nguesses <= 10);
	printf ("%d guesses\n", nguesses);
}
