/*
FROM: Balkan Olympiad in Informatics (BOI) 2001 day 2
PROB: schedule
KEYW: dynamical programming
*/

#include <cstdio>

int N;
int dp[2][4];

int main () {
	scanf ("%d", &N);

	dp[1][0] = 0; dp[1][1] = 1; dp[1][2] = 1;
	for (int i = 2; i <= N; ++i) {
		dp[i & 1][0] = dp[i - 1 & 1][2];
		dp[i & 1][1] = dp[i - 1 & 1][0] + dp[i - 1 & 1][1];
		dp[i & 1][2] = dp[i - 1 & 1][0] + dp[i - 1 & 1][1];
	}

	printf ("%d\n", dp[N & 1][0] + dp[N & 1][1]);
	return 0;
}
