#include <cstdio>
#include <algorithm>
#include <ext/hash_map>

typedef __gnu_cxx::hash_map <int, int> htype;
typedef htype::iterator htit;

int N, M;
int K, L;
htype _dp_1[3], _dp_2[3], *o = _dp_1, *n = _dp_2;

int app (int a, int b) {
	return a /= std::__gcd (a, b);
}

void clear (htype *x) {
	x[0] = htype ();
	x[1] = htype ();
	x[2] = htype ();
}

int main () {
	freopen ("dream.in", "r", stdin);
	freopen ("dream.out", "w", stdout);

	scanf ("%d %d", &N, &M);
	scanf ("%d %d", &K, &L);

	int i, j;
	htit it;
	int crnt;
	o[2][K] = 1;
	int _pid;
	int go;
	for (i = 0; i < N; ++i) {
		//j == 0
		clear (n);
		j = 0;
		_pid = (i == 1 ? 1 : 2);
		scanf ("%d", &crnt);
		for (it = o[_pid].begin (); it != o[_pid].end(); ++it) {
			go = app (it->first, crnt);
			n[0][it->first] += it->second; n[0][it->first] %= L;
			n[1][go] += it->second; n[1][go] %= L;
			n[2][go] += it->second; n[2][go] %= L;
		}
		std::swap (n, o);

/*		printf ("%d %d -->\n", i, j);
		for (int p = 0; p < 3; ++p) {
			for (it = o[p].begin (); it != o[p].end (); ++it) {
				printf ("\t%d %d --> %d\n", p, it->first, it->second);
			}
		}
*/
		for (j = 1; j < M; ++j) {
			scanf ("%d", &crnt);

			clear (n);

			for (it = o[0].begin (); it != o[0].end (); ++it) {
				go = app(it->first, crnt);
				n[0][it->first] += it->second; n[0][it->first] %= L;
				n[1][go] += it->second; n[1][go] %= L;
				n[2][go] += it->second; n[2][go] %= L;
			}
			for (it = o[1].begin (); it != o[1].end (); ++it) {
				go = app (it->first, crnt);
				n[1][it->first] += it->second; n[1][it->first] %= L;
				n[2][go] += 2 * it->second; n[2][go] %= L;
			}
			for (it = o[2].begin (); it != o[2].end (); ++it) {
				n[2][it->first] += it->second; n[2][it->first] %= L;
			}
			std::swap (n, o);
/*			printf ("%d %d -->\n", i, j);
			for (int p = 0; p < 3; ++p) {
				for (it = o[p].begin (); it != o[p].end (); ++it) {
					printf ("\t%d %d --> %d\n", p, it->first, it->second);
				}
			}
*/
		}
	}

	printf ("%d\n", o[1][1]);

	return 0;
}
