/*
TASK:chandelier
LANG:C++
*/

#include <cstdio>
#include <climits>
#include <algorithm>
#include <vector>

const int MAXN = 1 << 14;

int cp = 1;
std::vector <int> ch[MAXN];
int ss[MAXN];
int stack[MAXN], sp;
char line[MAXN];

int _sz;
inline int id (int a) {return a < _sz ? a : a - _sz;}

int main () {
	fgets (line, MAXN, stdin);

	int i, j, k;
	for (i = 0; isdigit (line[i]) || line[i] == 'a'; ++i) {
		if (line[i] == 'a')
			stack[sp++] = 0;
		else {
			ch[cp].reserve (line[i]);
			for (j = 0; j < line[i] - '0'; ++j)
				ch[cp].push_back (stack[--sp]);
			std::reverse (ch[cp].begin (), ch[cp].end ());
			stack[sp++] = cp++;
		}
	}
	ss[0] = 1;
	int cmax;
	for (i = 1; i < cp; ++i) {
		ss[i] = INT_MAX;
		_sz = ch[i].size ();
		for (j = 0; j < _sz; ++j) {
			for (k = cmax = 0; k < _sz; ++k)
				cmax >?= ss[ch[i][id (j + k)]] + k;
			ss[i] <?= cmax;
		}
	}

	printf ("%d\n", ss[cp-1]);

	return 0;
}
