/*
TASK:heapsort
LANG:C++
*/

#include <cstdio>
#include <cassert>
#include <algorithm>
#include <climits>

const int MAXN = 1 << 16;
int N;
int vec[MAXN];
int vp = 0;

int main () {
	scanf ("%d", &N);
	int i, j;
	vec[0] = 1;
	vp = 1;
	for (i = 2; i <= N; ++i) {
		assert (vec[vp-1] == 1);
		vec[vp-1] = INT_MAX;
		std::push_heap (vec, vec + vp);
		vec[0] = i;
		vec[vp++] = 1;
	}
	for (j = 0; j < vp; ++j) printf ("%d ", vec[j]); printf ("\n");

	return 0;
}
