/*
TASK:joke
LANG:C++
*/

#include <vector>
#include <utility>

const int MAXN = 1 << 10;

int N;
int dp[MAXN];
std::vector < std::pair <int, int> > prev[MAXN];

void add (int a, int b) {
	static unsigned i;
	for (i = 0; i < prev[b].size (); ++i)
		if (prev[b][i].first == a) {
			++prev[b][i].second;
			if (prev[b][i].second > b - prev[b][i].first)
				prev[b][i].second = b - prev[b][i].first;
//			printf ("%d %d ++\n", b, prev[b][i].first);
			return;
		}

//	printf ("pb %d %d\n", b, a);
	prev[b].push_back (std::make_pair (a, 1));
}

int main () {
	scanf ("%d", &N);

	int i;
	int a, b;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d\n", &a, &b);
		if (a + b < N) add (a, N - b);
	}

	unsigned j;
	dp[0] = 0;
	for (i = 1; i <= N; ++i) {
		dp[i] = dp[i-1];
		for (j = 0; j < prev[i].size (); ++j) {
//			printf ("upd dp[%d] >?= %d(%d) + %d\n", i, dp[prev[i][j].first], prev[i][j].first, prev[i][j].second);
			dp[i] >?= dp[prev[i][j].first] + prev[i][j].second;
		}
//		printf ("dp[%d] = %d\n", i, dp[i]);
	}

	printf ("%d\n", N - dp[N]);

	return 0;
}
