/*
FROM: BOOI 4
TASK: fibtree
KEYW: dynamical programming
LANG: C++
*/

#include <cstdio>

const int MAXN = 1 << 9 + 1;
const int MAXK = 1 << 9 + 1;

const int BASE = 1000000000;
int bigN = 100;

struct big {
	int a[100];
	big () {for (int i = 0; i < bigN; ++i) a[i] = 0;}
	big operator = (int a) {for (int i = 0; i < bigN; ++i) a[i] = 0; a[0] = a;}
	big operator = (const big &b) {for (int i = 0; i < bigN; ++i) a[i] = b.a[i];}
	big operator += (const big &b) {for (int i = 0; i < bifN; ++i) {a[i] += b.a[i]; a[i+1] += a[i] / BASE; a[i] %= BASE;}}
	void prnt () {for (i = bigN-1; i >= 0 && a[i]; --i); if (i == -1) printf ("0"); else {printf ("%d", a[i]); for (--i; i >= 0; --i) printf ("%9d", a[i]);}}
};

int N, K;
big opt[MAXN][MAXK];

int main () {
	scanf ("%d %d", &N, &K);

	int i, j;
	opt[1][1] = 1;
	for (i = 2; i <= N; ++i) {
		opt[i][1] = 1;
		for (j = 2; j <= i; ++j) {
			opt[i][j] = opt[i-1][j-1];
			opt += opt[i-2][j-1];
		}
	}
/*
	for (i = 1; i <= N; ++i) {
		for (j = 1; j <= i; ++j)
			printf ("%Ld ", opt[i][j]);
		printf ("\n");
	}
*/

	opt[N][K].prnt ();

	return 0;
}
