/*
FROM: BOOI 4
TASK: fibtree
KEYW: dynamical programming
LANG: C++
*/

#include <cstdio>

const int MAXN = 1 << 9 + 1;
const int MAXK = 1 << 9 + 1;

int N, K;
long long opt[MAXN][MAXK];

int main () {
	scanf ("%d %d", &N, &K);

	int i, j;
	opt[1][1] = 1;
	for (i = 2; i <= N; ++i) {
		opt[i][1] = 1;
		for (j = 2; j <= i; ++j)
			opt[i][j] = opt[i-1][j-1] + opt[i-2][j-1];
	}
/*
	for (i = 1; i <= N; ++i) {
		for (j = 1; j <= i; ++j)
			printf ("%Ld ", opt[i][j]);
		printf ("\n");
	}
*/
	printf ("%Ld\n", opt[N][K]);

	return 0;
}
