/*
TASK: garden
LANG: C++
*/
#include<stdio.h>
#include<math.h>
#include<stdlib.h>
#include<sstream>
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
using namespace std;

#define LL long long
#define VI vector < int >
#define VS vector < string >
#define pb push_back
#define cs c_str()
#define sz size()
#define ALL(a) (a).begin(),(a).end()
///////////////////////////////////////////
#define mx 16384
#define type long long
#define in stdin;//fopen("c:\\tp\\tests\\booi4\\garden.02.in","r")
FILE*fn;

struct point
{long long x,y;
point(){x=y=0;}
point(long long a,long long b){x=a;y=b;}
};

type det22(int a,int b,int c,int d)
  {return (type)a*(type)d-(type)b*(type)c;}

long long det2(const point&a,const point&b,const point&c)
  {type c1=det22(b.x-a.x,b.y-a.y,c.x-a.x,c.y-a.y);
  if(c1<0)return -1;
  if(c1>0)return 1;
  return 0;}

point operator-(const point&a,const point&b){return point(a.x-b.x,a.y-b.y);}
point operator+(const point&a,const point&b){return point(a.x*b.x,a.y*b.y);}
bool operator>(const point&a,const point&b){return a.y>b.y||(a.y==b.y&&a.x>b.x);}
bool operator<(const point&a,const point&b){return det2(point(0,0),a,b)>0;}
bool operator!=(const point&a,const point&b){return a.x!=b.x||a.y!=b.y;}

int sumdiv(int a)
  {long long q1,q2,c1,c2;
  vector < pair <int ,int > > divs;
  if(a==1)return 1;
  for(q1=2;q1*q1<=a;q1++)if(a%q1==0)
    {divs.pb(make_pair(q1,0));
    while(a%q1==0)
      {divs[divs.sz-1].second++;
      a/=q1;}}
  if(a!=1)divs.pb(make_pair(a,1));

  c1=1;
  for(q1=0;q1<divs.sz;q1++)
    {
    c2=1;
    for(q2=0;q2<=divs[q1].second;q2++)c2=c2*divs[q1].first;
    c2=(c2-1)/(divs[q1].first-1);
    c1=c1*c2;
    }
  return (int)c1;}

vector < point > ss,stack;

int c,m,q1,q2,q3,c1,c2,c3,c4;
point p1,p2,p3;

int main()
  {fn=in;
  fscanf(fn,"%d %d",&c,&m);
  for(q1=0;q1<c;q1++)
    {fscanf(fn,"%d",&c1);
    ss.pb(point(c1%m,sumdiv(c1)%m));}
  fclose(fn);
  if(c<=2)
    {printf("0.000000\n");
    return 0;}
  c1=0;
  for(q1=1;q1<c;q1++)if(ss[c1]>ss[q1])c1=q1;
  swap(ss[0],ss[c1]);
  p1=ss[0];
  for(q1=0;q1<c;q1++)ss[q1]=ss[q1]-p1;
  sort(ss.begin()+1,ss.end());
  for(q1=c1=1;q1<ss.sz;q1++)if(ss[q1]!=ss[c1-1])ss[c1++]=ss[q1];
  ss.resize(c1);
  stack.pb(ss[0]);
  stack.pb(ss[1]);
  stack.pb(ss[2]);
  c=ss.sz;
  for(q1=3;q1<c;q1++)
    {while(det2(stack[stack.sz-2],stack[stack.sz-1],ss[q1])<=0) stack.pop_back();
    stack.pb(ss[q1]);}
  double ans=0.0;
  stack.pb(stack[0]);
//  for (int i = 0; i < stack.size (); ++i) printf ("%Ld ")
  for(q1=1;q1<stack.sz;q1++)
    ans+=sqrt((double)(stack[q1].x-stack[q1-1].x)*(double)(stack[q1].x-stack[q1-1].x)+(double)(stack[q1].y-stack[q1-1].y)*(double)(stack[q1].y-stack[q1-1].y));
  printf("%.6lf\n",ans);
  return 0;}
