/*
FROM: Central European Olympiad in Informatics (CEOI) 2001 day 1
PROB: chaing
KEYW: test case generator
*/

#include <cstdio>
#include <cassert>
#include <cstdlib>
#include <ctime>

#include <algorithm>
#include <ext/numeric>

const int MAXN = 1 << 14;

int N;
int tmp[MAXN];

int main (int argc, char *argv[]) {
	srand (time (0));

	assert (argc == 3);
	FILE *in = fopen (argv[1], "w");
	sscanf (argv[2], "%d", &N);

	__gnu_cxx::iota (tmp, tmp + N, 0);
	std::random_shuffle (tmp, tmp + N);

	fprintf (in, "%d\n%d", N, tmp[0] + 1);
	for (int i = 1; i < N; ++i)
		fprintf (in, " %d", tmp[i] + 1);
	fprintf (in, "\n");

	return 0;
}
