#include "necklace.h"

#include <vector>
#include <list>

std::vector <std::list <int> > db;

void init (void) {
	db.resize (1, std::list <int> ());
	/* Insert your initialization code here.  */
}

int pearl (int neck_id, int on_left) {
	if (on_left)
		return db[neck_id].front ();
	else
		return db[neck_id].back ();
/* Insert your code for the pearl function here.  */
}

void create (int from, char operation, int on_left, int param) {
	/* Insert your code for the create function here.  */
	db.push_back (db[from]);
	if (operation == 'R') {
		if (on_left) {
			db.back ().pop_front ();
		} else {
			db.back ().pop_back ();
		}
	} else {
		if (on_left) {
			db.back ().push_front (param);
		} else {
			db.back ().push_back (param);
		}
	}
}
