/*
FROM: Champion 2005 round 4 Large
PROB: tree
KEYW: dynamical programming on tree, tele like
*/

#include <cstdio>
#include <cstring>

typedef unsigned char uchar;

const int MAXN = 152;

struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};

int N, P;
uchar dp[MAXN][MAXN];
uchar sz[MAXN];

int vec[MAXN];
el buf[MAXN];

int ans = 0xff;
void dpf (int a) {
	dp[a][0] = 1;
	dp[a][1] = 0;
	sz[a] = 1;

	uchar i, b;
	int ii, jj;
	for (i = vec[a]; i != 0xff; i = buf[i].next) {
		b = buf[i].to;
		dpf (b);

		for (ii = sz[a]; ii; --ii) {
			for (jj = sz[b]; jj; --jj)
				dp[a][ii+jj] <?= dp[a][ii] + dp[b][jj];
			dp[a][ii] += dp[a][0];//dp[x][0] must be 1 for everyone
		}
		sz[a] += sz[b];
	}
	ans <?= dp[a][P];
}

int main () {
	scanf ("%d %d", &N, &P);

	int i;
	int a, b;
	for (i = 0; i < N; ++i) vec[i] = 0xff;
	for (i = 0; i < N-1; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
		buf[i] = el (b, vec[a]);
		vec[a] = i;
	}

	memset (dp, 0xff, sizeof (dp));
	dpf (0);
	printf ("%d\n", ans);

	return 0;
}
