/*
FROM: ROMANIA 2005/2006 ROUND 6 L
PROB: grazing
KEYW: dynamical programming??
*/

#include <cstdio>

const int MAXN = 1 << 9;

int N;
int sc;
long long opt[MAXN][MAXN];

int main () {
	scanf ("%d", &N);

	int i, j;
	for (i = 1; i <= N; ++i)
		opt[i][1] = opt[i][i] = 1;

	for (i = 3; i <= N; ++i)
		for (j = 2; j < N; ++j) {
			for (k = 1; k * j <= i; ++k)
				opt[i][j] += opt[i-k*j][j-1] * f (i, j, k);
		}

	long long res =0;
	for (i = 1; i <= N; ++i)
		res += opt[N][i];

	printf ("%Ld\n", res);

	return 0;
}
