/*
FROM: Campion 2005/2006 round 9 Large
PROB: program
KEYW: dynamical programming
NOTE: N^3
*/

#include <cstdio>
#include <cstring>

const int MAXN = 1 << 9;
const int MOD = 9731;

int N;
char row[MAXN];
int dp[MAXN][MAXN];

int main () {
	gets (row);
	N = strlen (row);

	int i, j, d;
	for (i = 0; i <= N; ++i) dp[i][i] = 1;
	for (d = 1; d <= N; ++d)
		for (i = 0; i + d <= N; ++i) {
			if (row[i] == ')') {dp[i][i+d] = 0; continue;}
			for (j = i + 1; j <= i + d; ++j)
				if (row[j] == '(')
					dp[i][i+d] += (dp[i+1][j-(row[j-1] == ')')] * dp[j][i+d]) % MOD;
			dp[i][i+d] %= MOD;
		}

	printf ("%Ld\n", dp[0][N]);

	return 0;
}
