/*
FROM: Campion 2005/2006 round 7 Large
PROB: scoici
KEYW: map
*/

#include <cstdio>
#include <map>
#include <vector>

const int MAXN = 1 << 17;
const int MAXC = 1 << 4;

int N, C;
int vec[MAXN];

std::map <std::vector <int>, int> seen;

int main () {
	scanf ("%d %d", &N, &C);

	int i;
	int ccol, zc = C;//current color, zero count
	std::map <std::vector <int>, int> :: iterator it;
	std::vector <int> crnt (C);
	seen[crnt] = -1;
	int len = 0, beg = -1;
	for (i = 0; i < N; ++i) {
		scanf ("%d", &ccol);
		--ccol;
		zc -= !crnt[ccol];
		++crnt[ccol];
		if (!zc) for (size_t j = 0; j < crnt.size (); ++j) zc += !(--crnt[j]);
		if ((it = seen.find (crnt)) != seen.end ()) {
			if (len < i - it -> second) {
				len = i - it -> second;
				beg = it -> second + 2;
			}
		} else
			seen[crnt] = i;
	}

	printf ("%d %d\n", beg, len);

	return 0;
}
