/*
FROM: Champion 2006 round 2 Large
PROB: perm
KEYW: dynamical programming
*/

#include <cstdio>

const int MAXN = 3002;
const int MAXK = 3002;
const int MOD = 666013;

int N, K;
int dp[MAXN][MAXK];

int main () {
//	FILE *in = fopen ("perm.in", "r");
//	FILE *out = fopen ("perm.out", "w");
	FILE *in = stdin;
	FILE *out = stdout;

	fscanf (in, "%d %d", &N, &K);

	int i, j;
	dp[1][0] = 1;
	for (i = 2; i <= N; ++i) {
		dp[i][0] = (i - 1) * dp[i-1][0] % MOD
					+ dp[i-1][1];
		dp[i][0] %= MOD;
//		printf ("dp[%d][%d] = %d\n", i, 0, dp[i][0]);
		for (j = 1; j <= N; ++j) {
			dp[i][j] = (i - 1 - j) * dp[i-1][j] % MOD
					 + dp[i-1][j-1]
					 + (j + 1) * dp[i-1][j+1] % MOD;
			dp[i][j] %= MOD;
//			printf ("dp[%d][%d] = %d (%d * %d + %d + %d * %d)\n", i, j, dp[i][j], i - 1 - j, dp[i-1][j], dp[i-1][j-1], j + 1, dp[i-1][j+1]);
		}
	}

	fprintf (out, "%d\n", dp[N][K]);

	return 0;
}
