#include <cstdio>
#include <cmath>
#include <vector>
#include <utility>
#include <algorithm>

const int MAXN = 1 << 10;
const int MAXM = 1 << 10;

int N, M;
bool dp[MAXN][MAXM];

int main () {
	scanf ("%d %d", &N, &M);

	int i, j, k;
	for (j = 1; j <= M; ++j) dp[0][j] = 1;

	for (i = 1; i <= N; ++i) {
		dp[i][0] = 1;
		for (j = 1; j <= M; ++j)
			for (k = 1; k <= (i >? j); ++k) {
				if (k <= i && !dp[i-k][j]) {dp[i][j] = 1; break;}
				if (k <= j && !dp[i][j-k]) {dp[i][j] = 1; break;}
				if (k <= i && k <= j && !dp[i-k][j-k]) {dp[i][j] = 1; break;}
			}
	}
/*	for (i = 0; i <= N; ++i) {
		for (j = 0; j <= M; ++j)
			putchar (dp[i][j] ? '#' : '.');
		puts ("");
	}
*/
	FILE *out = fopen ("x1", "w");
	for (i = 0; i <= N; ++i)
		for (j = 0; j <= M; ++j)
			if (!dp[i][j]) fprintf (out, "%d %d\n", i, j);
	fclose (out);
	out = fopen ("x2", "w");
	
//	printf ("-----------\n");
	double fi = (sqrt (5) + 1.) / 2.;
	std::vector <std::pair <int, int> > vec;
	vec.push_back (std::make_pair (0, 0));
	for (i = 1; i <= N; ++i) {
		vec.push_back (std::make_pair ((int)(fi * i), (int)((fi + 1) * i)));
		vec.push_back (std::make_pair (vec.back ().second, vec.back ().first));
	}

	std::sort (vec.begin (), vec.end ());
	for (i = 0; i < (int)vec.size (); ++i)
		fprintf (out, "%d %d\n", vec[i].first, vec[i].second);
	fclose (out);

	return 0;
}
