/*
FROM: Champion 2006 round 3 Large
PROB: xor
KEYW: linear equations
*/

#include <cstdio>

typedef unsigned long long ull;
const int MAXN = 5002;
const unsigned MOD = 666777;

int N;
ull vec[MAXN];

int main () {
	FILE *in = fopen ("xor.in", "r");
	FILE *out = fopen ("xor.out", "w");

	fscanf (in, "%d", &N);

	int i;
	for (i = 0; i < N; ++i)
		fscanf (in, "%Lu", vec + i);
	fclose (in);

	int cp = 0;
	ull tmp;
	for (ull bit = 1LLU << 63; bit;	bit >>= 1) {
		if (vec[i = cp] & bit)
			goto scnd;
		for (++i; i < N; ++i)
			if (vec[i] & bit) {
				tmp = vec[i];
				vec[i] = vec[cp];
				vec[cp] = tmp;
				break;
			}

		if (i == N) continue;
		scnd:;
		for (++i; i < N; ++i)
			if (vec[i] & bit)
				vec[i] ^= vec[cp];

		for (i = 0; i < cp; ++i)
			if (vec[i] & bit)
				vec[i] ^= vec[cp];

		if (++cp == N) break;
	}

	ull res = 0;
	unsigned ways = 1;
	for (i = 0; i < cp; ++i)
		res ^= vec[i];

	for (i = cp; i < N; ++i) {
		ways *= 2;
		if (ways >= MOD) ways -= MOD;
	}

	fprintf (out, "%Lu\n%u\n", res, ways);
	fclose (out);
	
	return 0;
}
