/*
FROM: Champion 2006 round 4 Large
PROB: bilete
KEYW: dynamical programming
*/

#include <cstdio>
#include <cassert>
#include <algorithm>

const int MAXN = 1 << 7;
const int ALPHA = 1 << 5;//26

int N;
const int A = 26;
char vec[MAXN];
int dp[MAXN][MAXN][ALPHA];

int main () {
//	FILE *in = fopen ("bilete.in", "r");
//	FILE *out = fopen ("bilete.out", "w");
	FILE *in = stdin;
	FILE *out = stdout;

	fgets (vec, MAXN, in);

	N = std::unique (vec, vec + MAXN) - vec - 2;//eats the '\n' and the '\0'
	for (int i = 0; i < N; ++i) vec[i] -= 'A';

	int d, l, r, c, i;

	for (d = 1; d <= N; ++d)
		for (l = 0, r = d; r <= N; ++l, ++r)
			for (c = 0; c < A; ++c)
				if (c == vec[l]) {
					dp[l][r][c] = dp[l+1][r][c];
				} else {
					dp[l][r][c] = 1 + dp[l+1][r][c];
					for (i = l+2; i <= r; ++i)
						if (vec[i-1] == vec[l])
							dp[l][r][c] <?= 1 + dp[l+1][i][vec[l]] + dp[i][r][c];
				}

	fprintf (out, "%d\n", dp[0][N][vec[0]] + 1);

	return 0;
}
