/*
FROM: Champion 2006 round 4 Large
PROB: vector
KEYW: game theory, SG theorem
*/

#include <cstdio>

const int MAXN = 1 << 17;

int N;
unsigned vec[MAXN];

int main () {
	scanf ("%d", &N);
	--N;

	int i;
	for (i = 0; i < N; ++i)
		scanf ("%u", vec + i);

	unsigned xr = 0;
	for (i = 0; i < N; i += 2)
		xr ^= vec[i];

	if (xr == 0) {
		printf ("0\n");
		return 0;
	}

	printf ("1\n");
	unsigned targ;
	for (i = 0; i < N; i += 2) {
		targ = xr ^ vec[i];
		if (targ < vec[i]) {
			printf ("%d %d\n", i + 1, vec[i] - targ);
			return 0;
		} else if (targ - vec[i] <= vec[i+1]) {
			printf ("%d %d\n", i + 2, targ - vec[i]);
			return 0;
		}
	}

	return 0;
}
