/*
FROM: Champion 2006 round 6 Large
PROB: flood
KEYW: linking problem
*/

#include <cstdio>
#include <utility>
#include <algorithm>

const int MAXN = 1 << 14;
const int MAXP = 1 << 18;

int N, M, P;
int a[MAXN];
int sz[MAXN];
std::pair <int, std::pair <int, int> > edges[MAXP];

int main () {
//    FILE *in = fopen ("flood.in", "r");
//    FILE *out = fopen ("flood.out", "w");
    FILE *in = stdin;
    FILE *out = stdout;
    
    
    int i;
    fscanf (in, "%d", &N);
    for (i = 0; i < N; ++i) {a[i] = i; sz[i] = 1;}

    fscanf (in, "%d", &M);
    int p, q;
    int to_join = N - 1;
    for (i = 0; i < M; ++i) {
        fscanf (in, "%d %d", &p, &q);
        --p; --q;
        for (; a[p] != p; p = a[p]) a[p] = a[a[p]];
        for (; a[q] != q; q = a[q]) a[q] = a[a[q]];
        if (p != q) {
            --to_join;
            if (sz[p] > sz[q]) {
                a[q] = p;
                sz[p] += sz[q];
            } else {
                a[p] = q;
                sz[q] += sz[p];
            }
        }
    }
    fscanf (in, "%d", &P);
    for (i = 0; i < P; ++i) {
        fscanf (in, "%d %d %d", &edges[i].second.first, &edges[i].second.second, &edges[i].first);
        --edges[i].second.first;
        --edges[i].second.second;
    }
    fclose (in);

    fprintf (out, "%d\n", to_join);

    std::sort (edges, edges + P);
    static int ans[MAXN], ap = 0;
    int total_cost = 0;
    for (i = 0; to_join; ++i) {
        for (p = edges[i].second.first ; a[p] != p; p = a[p]) a[p] = a[a[p]];
        for (q = edges[i].second.second; a[q] != q; q = a[q]) a[q] = a[a[q]];
        if (p != q) {
            --to_join;
            total_cost += edges[i].first;
            ans[ap++] = i;
            if (sz[p] > sz[q]) {
                a[q] = p;
                sz[p] += sz[q];
            } else {
                a[p] = q;
                sz[q] += sz[p];
            }
        }
    }

    fprintf (out, "%d\n", total_cost);
    for (i = 0; i < ap; ++i)
        fprintf (out, "%d %d %d\n", edges[ans[i]].second.first + 1, edges[ans[i]].second.second + 1, edges[ans[i]].first);
    fclose (out);

    return 0;
}
