#include <iostream>
#include <vector>

using namespace std;

#define Sets(T) vector < vector < T > >

template <class T>
Sets(T) cartesian(Sets(T) ss)  {
  Sets(T) rs,t1,t2;
  int m,n,p,i,j,k;
  rs.resize(p=1);
  rs[0].resize(0);
  m = ss.size();
  for (i=m-1; i>=0; --i,rs=t2,p*=n)
    for (n=ss[i].size(),t2.resize(0),j=n-1; j>=0; --j)
      for (t1=rs,k=0; k<p; ++k)  {
        t1[k].push_back(ss[i][j]);
        t2.push_back(t1[k]);
      }
  reverse(rs.begin(),rs.end());
  for (n=rs.size(),i=0; i<n; ++i)
    reverse(rs[i].begin(),rs[i].end());
  return rs;
}

template <class T>
void printcp(Sets(T) cp)  {
  int m = cp.size();
  int n = cp[0].size();
  for (int i=0; i<m; ++i)  {
    cout << "[ ";
    for (int j=0; j<n; ++j)
      cout << cp[i][j] << ' ';
    cout << "]  ";
  }
  cout << endl;
}

void setset(Sets(char) & ss)  {
  ss.resize(3);
  ss[0].resize(0);  ss[0].push_back('a');  ss[0].push_back('b');  ss[0].push_back('c');
  ss[1].resize(0);  ss[1].push_back('d');
  ss[2].resize(0);  ss[2].push_back('e');  ss[2].push_back('f');
}

int main ()  {
  vector < vector < char > > sets;
  setset(sets);
  printcp(cartesian(sets));
  return 0;
}
