#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cstdlib>

const int ROW = 1 << 4;
const int COL = 1 << 4;

struct rc {
	unsigned char a[ROW][COL];
    rc () {for (int i = 0; i < ROW; ++i) for (int j = 0; j < COL; ++j) a[i][j] = '0';}
};

rc base;
rc targ;

int cor[6][2] = {{0, 3}, {3, 0}, {3, 3}, {3, 6}, {3, 9}, {6, 3}};

int vec[] = {'A', 'B', 'C', 'D', 'E', 'F'};

void type (rc);

void input () {
	int i, j, k;
    int tmp[1 << 8] = {0};
    int tp = 'A';

	for (i = 0; i < 9; ++i)
		gets ((char *)base.a[i]);

    for (k = 0; k < 6; ++k)
		for (i = 0; i < 3; ++i)
    		for (j = 0; j < 3; ++j)
				if (tmp[(int)base.a[cor[k][0] + i][cor[k][1] + j]] == 0) {
                    tmp[(int)base.a[cor[k][0] + i][cor[k][1] + j]] = tp++;
                    base.a[cor[k][0] + i][cor[k][1] + j] = tp - 1;
                } else {
                    base.a[cor[k][0] + i][cor[k][1] + j] =
                    tmp[(int)base.a[cor[k][0] + i][cor[k][1] + j]];
                }

    memset (tmp, 0, sizeof (int) * (1 << 8));
    tp = 'A';

	for (i = 0; i < 9; ++i)
		gets ((char *)targ.a[i]);

    for (k = 0; k < 6; ++k)
		for (i = 0; i < 3; ++i)
    		for (j = 0; j < 3; ++j)
				if (tmp[(int)targ.a[cor[k][0] + i][cor[k][1] + j]] == 0) {
                    tmp[(int)targ.a[cor[k][0] + i][cor[k][1] + j]] = tp++;
                    targ.a[cor[k][0] + i][cor[k][1] + j] = tp - 1;
                } else {
                    targ.a[cor[k][0] + i][cor[k][1] + j] =
                    tmp[(int)targ.a[cor[k][0] + i][cor[k][1] + j]];
                }

}


void rotcl (rc &b, rc &t, int bs, int ts) {
	int bx = cor[bs][0], by = cor[bs][1];
    int tx = cor[ts][0], ty = cor[ts][1];
	for (int i = 0; i < 3; ++i)
    	for (int j = 0; j < 3; ++j)
        	t.a[tx + j][ty + 2 - i] = b.a[bx + i][by + j];
}


void rotccl (rc &b, rc &t, int bs, int ts) {
	int bx = cor[bs][0], by = cor[bs][1];
    int tx = cor[ts][0], ty = cor[ts][1];
	for (int i = 0; i < 3; ++i)
    	for (int j = 0; j < 3; ++j)
        	t.a[tx + 2 - j][ty + i] = b.a[bx + i][by + j];
}

void copy (rc &b, rc &t, int bs, int ts) {
	int bx = cor[bs][0], by = cor[bs][1];
    int tx = cor[ts][0], ty = cor[ts][1];
	for (int i = 0; i < 3; ++i)
    	for (int j = 0; j < 3; ++j)
        	t.a[tx + i][ty + j] = b.a[bx + i][by + j];
}

void type (rc a) {
	for (int i = 0; i < 9; ++i) {
    	for (int j = 0; j < 12; ++j)
        	printf ("%c", vec[a.a[i][j] - 'A']);
        printf ("\n");
    }
    printf ("\n");
}

void rotbase (rc &b, rc &t) {
	rotcl (b, t, 0, 3);
	rotcl (b, t, 1, 0);
	rotcl (b, t, 2, 2);
	rotcl (b, t, 3, 5);
	rotccl (b, t, 4, 4);
	rotcl (b, t, 5, 1);
}

void movebase (rc &b, rc &t) {
    rotcl (b, t, 0, 0);
	copy (b, t, 1, 4);
	copy (b, t, 2, 1);
	copy (b, t, 3, 2);
	copy (b, t, 4, 3);
    rotccl (b, t, 5, 5);
}

void copyall (rc &a, rc &b) {
	for (int i = 0; i < 6; ++i)
    	copy (a, b, i, i);
}

void _tryeq (rc a) {
	int i, j, k;
	for (k = 0; k < 6; ++k)
    	for (i = 0; i < 3; ++i)
        	for (j = 0; j < 3; ++j)
            	if (vec[a.a[cor[k][0] + i][cor[k][1] + j] - 'A'] !=
                	targ.a[cor[k][0] + i][cor[k][1] + j])
                    goto end;
    end:
    if (j == 3) {printf ("YEP!\n"); exit (0);}
}

void doall () {
	rc a, b;
    copyall (base, b);
	_tryeq (b);//without movement

    int i, j;
    for (i = 0; i < 4; ++i) {
    	rotbase (b, a);
        _tryeq (a);
    	rotbase (a, b);
        _tryeq (b);
        rotbase (b, a);
        _tryeq (a);
        rotbase (a, b);

        movebase (b, a);
        _tryeq (a);
        copyall (a, b);
    }
	rotbase (b, a);
    movebase (a, b);
    _tryeq (b);

    rotbase (b, a);
    _tryeq (a);
    rotbase (a, b);
    _tryeq (b);
    rotbase (b, a);
    _tryeq (a);
    rotbase (a, b);

	movebase (b, a);
    movebase (a, b);


   	rotbase (b, a);
    _tryeq (a);
	rotbase (a, b);
    _tryeq (b);
    rotbase (b, a);
    _tryeq (a);
    rotbase (a, b);
}

int main () {
	input ();

	rc a;

    do
	  	doall ();
    while (std::next_permutation (vec, vec + 6));

    printf ("NOP!\n");

	return 0;
}

