#include <iostream>
#include <sstream>
#include <stack>
#include <string>

#define OPER(B) {double t = stk.top (); stk.pop (); stk.top () B##= t; break;}

using namespace std;

int main () {
	string line, tok;
	stack <double> stk;
	while (getline (cin, line)) try {
		stk = stack<double> ();
		istringstream in (line);
		while (in >> tok) {
			if (tok.size () == 1u && tok.find_first_not_of ("+-*/") == string::npos) {
				if (stk.size () < 2u) throw 0;
				switch (tok[0]) {
					case '+': OPER (+)
					case '-': OPER (-)
					case '*': OPER (*)
					case '/': OPER (/)
				}
			} else {
				istringstream inn (tok);
				double t;
				inn >> t;
				if (inn.eof () && !inn.fail ()) stk.push (t); else throw 2;
			}
		}
		if (stk.size () > 1u) throw 3;
		else if (stk.size () == 1u) cout << stk.top () << endl;
	} catch (...) {
		cout << "Error" << endl;
	}

	return 0;
}
