/*
TASK:pas
LANG:C++

FROM: POI 2000 r1
PROB: stripes
KEYW: sum of games, SG theory
*/

#include <cstdio>

const int MAXN = 1 << 10;

int N;
int query[MAXN];

int sg[MAXN];
int used[MAXN * 2];

int str[4];

int main () {
	scanf ("%d %d %d", str, str+1, str+2);

	scanf ("%d", &N);

	int max = 0;
	int i, j, k;
	for (i = 0; i < N; ++i) {
		scanf ("%d", query + i);
		max >?= query[i];
	}

	sg[0] = 0;//losing
	for (i = 1; i <= max; ++i) {
		for (j = 0; j < MAXN * 2; ++j) used[j] = 0;

		for (j = 0; j < 3; ++j) {
			if (str[j] > i) continue;
			for (k = 0; k <= (i - str[j]) / 2; ++k)
				used[sg[k] ^ sg[i-str[j]-k]] = 1;
		}

		for (j = 0; used[j]; ++j);
		sg[i] = j;
	}

	for (i = 0; i < N; ++i)
		printf ("%d\n", 1 + !sg[query[i]]);

	return 0;
}
