/*
FROM: SPRING 2001 A
PROB: coins
NOTE: tester
*/

#include <cstdio>
#include <cstdlib>

int b[4];
int ex;

int main (int argc, char *argv[]) {
	if (argc != 4) {printf ("0\nerror(argc)\n"); exit (-1);}
	FILE *in = fopen (argv[1], "r");
	FILE *out = fopen (argv[2], "r");
	if (!in || !out) {printf ("0\nerror(files)\n"); exit (-1);}

	fscanf (in, "%d %d %d %d", b + 1, b + 2, b + 3, &ex);
	fclose (in);

	int N;
	int x, y;
	if (fscanf (out, "%d", &N) != 1) {printf ("0\nerror(output)\n"); exit (0);}
	for (int i = 0; i < N; ++i) {
		if (fscanf (out, "%d %d", &x, &y) != 2) {printf ("0\nerror(output)\n"); exit (0);}
		if (b[x] < b[y]) {printf ("0\nerror(move)\n"); exit (0);}
		b[x] -= b[y];
		b[y] <<= 1;
	}
	if (!b[1] || !b[2] || !b[3]) printf ("%d\nOK!\n", N > 3 * ex ? 0 : N <= ex ? 10 : (15 * ex - 5 * N) / ex);
	else {printf ("0\nerror(no empty)\n"); exit (0);}

	return 0;
}
