/*
FROM: GCJ 2008 Round 1B
PROB: B Number Sets
KEYW: mathematics, prime numbers
NOTE: does not work
*/

#include <cstdio>
#include <cassert>
#include <ext/numeric>
#include <vector>

namespace std {
	using namespace __gnu_cxx;
}

typedef long long ll;

const int MAXPR = 1 << 17;
const int PRUB = 1 << 20;

int apc;
int all_pr[MAXPR];

void populate_pr() {
	std::vector<bool> eseed(PRUB);

	int i;
	for (i = 2; i * i <= PRUB; ++i) {
		if (!eseed[i]) {
			all_pr[apc++] = i;
			for (int j = i * i; j < PRUB; j += i) {
				eseed[j] = 1;
			}
		}
	}
	printf ("%d\n", i);
	for (; i < PRUB; ++i)
		if (!eseed[i])
			all_pr[apc++] = i;

/*
	for (int i = 0; i < 20; ++i)
		printf (" %d", all_pr[i]);
	puts("");
	printf ("%d\n", apc);
*/
}

int pc;
int pr[MAXPR];

int nxt[MAXPR];
int sz[MAXPR];
//

ll A, B;

inline void build_bnd(ll d, ll &lb, ll &ub) {
	lb = (A + d - 1) / d;
	ub = (B + d - 1) / d;
}

void build_list(ll a, ll b, ll p) {
	pc = 0;
	ll lb, ub;
	for (int i = 0; i < apc; ++i) {
		if (all_pr[i] < p) continue;

		build_bnd(all_pr[i], lb, ub);
		if (ub - lb < 2) continue;

		pr[pc] = all_pr[i];
		nxt[pc] = pc;
		sz[pc] = ub - lb;
		++pc;
	}
}

ll go_wild(ll a, ll b) {
	int ii, jj;
	ll lb, ub;
	for (int i = 0; i < pc; ++i)
		for (int j = i+1; j < pc; ++j) {
			ii = top(i);
			jj = top(j);

			if (ii == jj) continue;
			build_bnd((ll)pr[i] * pr[j], lb, ub);

			if (ub > lb)
				same_top(i, ii);
				same_top(j, jj);
				sz[ii] += sz[jj] - ;
		}
}

int main () {
	int tc;
	scanf ("%d", &tc);

	populate_pr();


	for (int ctc = 1; ctc <= tc; ++ctc) {
		ll p;
		scanf ("%Ld %Ld %Ld", &A, &B, &p);

		build_list(p);
		printf ("Case #%d: %Ld\n", ctc, go_wild());
	}

	return 0;
}
