/*
FROM: Croatia Final Competition in Informatics 2001 day 1
PROB: wedding
KEYW: writing, lists
*/

#include <cstdio>
#include <algorithm>
#include <list>

const int MAXN = 1 << 14;
typedef std::list <std::pair <int, int> > list_t;
typedef list_t :: iterator list_it_t;

list_t train;
list_t min_list, max_list;
int N, K;//not of Slavko's family
int h[MAXN];
int idx[MAXN];

bool cmp (int a, int b) {
	return h[a] < h[b];
}

bool can_put (list_it_t it, std::pair <int, int> to_put) {
	list_it_t nxt = it;
	++nxt;
	return (to_put.first - it->first) * (nxt->first - to_put.first) >= 0;
}

int trav (list_it_t beg, list_it_t end, int id, int step) {
	while (beg != end && id >= 0 && id < N) {
		if (can_put (beg, std::make_pair (h[idx[id]], idx[id] + K))) {
			beg = train.insert (++beg, std::make_pair (h[idx[id]], idx[id] + K));
			--beg;
			id += step;
		} else
			++beg;
	}
	return id;
}

int main () {
	scanf ("%d %d", &N, &K);

	int i, j;
	int c;
	for (i = 0; i < K; ++i) {
		scanf ("%d", &c);
		train.push_back (std::make_pair (c, i));
	}

	N -= K;
	for (i = 0; i < N; ++i) {
		scanf ("%d", h + i);
		idx[i] = i;
	}
	std::sort (idx, idx + N, cmp);

	list_it_t min_h = train.begin (), max_h = train.begin ();

	bool min_last = 0;
	for (list_it_t it = ++train.begin (); it != train.end (); ++it) {
		if (*it < *min_h) {min_h = it; min_last = 1;}
		if (*it > *max_h) {max_h = it; min_last = 0;}
	}

	if (!min_last) {
		for (i = 0; i < N && h[idx[i]] < min_h->first; ++i)
			min_list.push_back (std::make_pair (h[idx[i]], idx[i] + K));
		j = trav (min_h, max_h, i, +1);
		for (int k = j; k < N; ++k) max_list.push_back (std::make_pair (h[idx[k]], idx[k] + K));
		--i;
	} else {
		printf ("t2\n");
		for (i = N-1; i >= 0 && h[idx[i]] > max_h->first; --i)
			max_list.push_front (std::make_pair (h[idx[i]], idx[i] + K));
		j = trav (max_h, min_h, i, -1);
		++i;
		std::swap (i, j);
		for (int k = 0; k <= i; ++k) min_list.push_back (std::make_pair (h[idx[k]], idx[k] + K));
	}
	//[0, i] & [j, N)

	printf ("%d %d  %d\n", i, j, N);
	for (list_it_t it = train.begin (); it != train.end (); ++it) printf ("(%d %d)", it->first, it->second); puts ("");
	for (list_it_t it = min_list.begin (); it != min_list.end (); ++it) printf ("(%d %d)", it->first, it->second); puts ("  min");
	for (list_it_t it = max_list.begin (); it != max_list.end (); ++it) printf ("(%d %d)", it->first, it->second); puts ("  max");

	int abs_min, abs_max;
	int train_beg = train.begin ()->first;
	int train_end = (--train.end ())->first;
	if (!min_list.empty ())
		abs_min = min_list.begin ()->first;
	if (!max_list.empty ())
		abs_max = (--max_list.end ())->first;

	if (min_list.empty () && max_list.empty ())
		prnt ();
	if (min_list.empty ()) {
		int best_cost = (abs_max - train_beg) <? ((abs_max - max_h->first) * 2) <? (abs_max - train_end);
		if (beg_cost == (abs_max - train_beg)) {
			std::reverse (min)
		}
	}
	if (max_list.empty ()) {
	
	}
	
	return 0;
}
