/*
FROM: Croatia 2005 National Junior 2nd day
PROB: ribari
KEYW: binary search
*/

#include <cstdio>

const int MAXN = 1 << 17;
const int MAXADOPT = 1 << 30;

int N;
int pos[MAXN];
int fish[MAXN];

bool ok (int a) {
	long long have = 0;

	int i;
	for (i = 0; i < N; ++i) {
		have = have + fish[i] - a;
		if (have >= 0 && (pos[i+1] - pos[i]) >= have) have = 0;//if we have more and is CAN NOT reach the next town - it is 0
		else have -= (pos[i+1] - pos[i]);//if we have more than tha transportation cost or we have less we substract
	}

	return have >= 0;
}

int main () {
	scanf ("%d", &N);

	int i;
	for (i = 0; i < N; ++i)
		scanf ("%d %d", pos + i, fish + i);
	pos[N] = pos[N-1];

	int l = 0, r = MAXADOPT, m;

	while (l + 1 < r) {
		m = (l + r) >> 1;

		if (ok (m))
			l = m;
		else
			r = m;
	}

	printf ("%d\n", l);

	return 0;
}
