/*
FROM: Croatia 2005 regional senior
PROB: kviz
KEYW: strings, parsing
*/

#include <cstdio>
#include <cctype>

const int MAXLEN = 1 << 7;

char line[MAXLEN];

bool vowel (char a) {
	if (!isalpha (a)) return 0;
	a = tolower (a);
	return a == 'a' || a == 'e' || a == 'i' || a == 'o' || a == 'u';
}

int main () {
	gets (line);

	char buf[MAXLEN];

	int i;
	int cnt = 0;
	for (i = 0; line[i]; ++i) {
		if (isalpha (line[i]))
			++cnt;

		buf[i] = isalpha (line[i]) ? '.' : line[i];
	}
	if (!cnt) {
		puts (line);
		puts (line);
		puts (line);
		return 0;
	}


	buf[i] = 0;
	puts (buf);

	int ub = cnt / 3 + (cnt % 3 == 2);
	int k =0;
	int look_here = -1;
//	printf ("%d %d\n", cnt, ub);
	for (i = 0; line[i]; ++i) {
		if (isalpha (line[i]))
			if (k++ < ub)
				buf[i] = line[i];
			else {
				look_here = look_here == -1 ? i : look_here;
				buf[i] = '.';
			}
		else
			buf[i] = line[i];
	}
	puts (buf);

	for (i = look_here; line[i] && !vowel (line[i]); ++i);
	if (line[i]) {//there are vowels
		for (; line[i]; ++i)
			buf[i] = !isalpha (line[i]) || vowel (line[i]) ? line[i] : '.';
	} else {
		k = 0;
		ub = (2 * cnt) / 3 + ((2 * cnt) % 3 == 2);
		for (i = 0; line[i]; ++i) {
			if (isalpha (line[i]))
				if (k++ < ub)
					buf[i] = line[i];
				else {
					buf[i] = '.';
				}
			else
				buf[i] = line[i];
		}
	}
	puts (buf);

	return 0;
}
