#include <cstdio>
#include <algorithm>
#include <ext/numeric>

const int MAXN = 1 << 14;
const int MAXK = 1 << 7;

int N, K;
char data[MAXN][MAXK * 2];

struct cmp {
	int pos;
	cmp (int _pos) : pos (_pos) {}
	bool operator () (const int a, const int b) {return data[a][pos] < data[b][pos];}
};

int idx[MAXN];
int res;
void solve (int pos, int l, int r) {
	std::sort (idx + l, idx + r, cmp (pos));

	int mid = l;
	for (int i = l + 1; i <= r; ++i)
		if (data[idx[i-1]][pos] != data[idx[i]][pos] || i == r) {
			++res;
			if (pos != K && pos != K-1)
				solve (pos < K ? pos + 1 : pos - 1, mid, i);
			mid = i;
		}
}

int main () {
	scanf ("%d %d\n", &N, &K);

	for (int i = 0; i < N; ++i)	gets (data[i]);
	__gnu_cxx::iota (idx, idx + N, 0);
	solve (0, 0, N);
	__gnu_cxx::iota (idx, idx + N, 0);
	solve (2 * K - 1, 0, N);

	printf ("%d\n", res);

	return 0;
}
