/*
FROM: Croatia Olympiad in Informatics 2006
PROB: super95
KEYW: hardcode, full exhaustion
*/

#include <cstdio>
#include <cassert>
#include <cmath>
#include <utility>
#include <string>

#define MP make_pair
#define c first
#define cnt second

using std::pair;
using std::make_pair;

char to100[128];
pair <char, long long> vec[512];
std::string sd[512];
int vp;


int main () {
	int i, j;
	to100[1] = 'J';
	to100[2] = 'D';
	to100[3] = 'T';
	to100[4] = 'X';
	to100[5] = 'P';
	to100[6] = 'X';
	to100[7] = 'S';
	to100[8] = 'O';
	to100[9] = 'D';
	to100[10] = 'D';
	for (i = 1; i < 10; ++i)
		to100[i+10] = to100[i];
	for (j = 20; j < 100; ++j)
		to100[j] = to100[j / 10];

	char spec[] = "STDSMDSMDS";
	long long start = 100;
	for (i = 0; i < 10; ++i) {
		if (spec[i] != 'D') {
			vec[vp] = MP (spec[i], start);//1xx..
			sd[vp++] = std::string ("1");
		} else {
			for (j = 0; j < 10; ++j) {
				vec[vp] = MP (to100[j+10], start / 10);
				sd[vp] = std::string ("1");
				sd[vp++] += (char)(j + '0');
			}
		}
		for (j = 2; j < 10; ++j) {
			vec[vp] = MP (to100[j], start);//jxx..
			sd[vp++] += (char)(j + '0');
		}
		start *= 10;
	}

	char t = getchar ();
	long long N;
	scanf ("%Ld", &N);
	--N;

	for (i = 1; i < 100; ++i)
		if (to100[i] == t)
			if (!N) {printf ("%d\n", i); return 0;}
			else --N;

	for (j = 0; j < vp; ++j)
		if (vec[j].c == t && (N -= vec[j].cnt) < 0)
			break;
	assert (j != vp);

	N += vec[j].cnt;
	int x = (int)log10 (vec[j].cnt);
	char tt[10];
	int tp;
	tp = 0;
	while (N) {
		tt[tp++] = N % 10 + '0';
		N /= 10;
	}
	for (; tp < x; ++tp) tt[tp] = '0';

	printf ("%s", sd[j].c_str ());
	for (i = x-1; i >= 0; --i) putchar (tt[i]);
	putchar ('\n');

	return 0;
}
