/*
FROM: Croatia 2006 Regional
PROB: matches
KEYW: binary operations
*/

#include <cstdio>

int sq[1 << 4] =
				{
					0x02003009,
					0x02006012,
					0x0200C024,
					0x02030048,
					0x02060090,
					0x020C0120,
					0x02300240,
					0x02600480,
					0x02C00900,
					0x020770DB,
					0x020EE1B6,
					0x027706D8,
					0x02EE0DB0,
					0x02999E07,
				};
char type[1 << 4][1 << 4] =
{
"+--+--+--+",
"|..|..|..|",
"|..|..|..|",
"+--+--+--+",
"|..|..|..|",
"|..|..|..|",
"+--+--+--+",
"|..|..|..|",
"|..|..|..|",
"+--+--+--+"
};

int which[1 << 4][1 << 4] = {
{	25,	0,	0,	25,	1,	1,	25,	2,	2,	25},
{	12,	25,	25,	13,	25,	25,	14,	25,	25,	15},
{	12,	25,	25,	13,	25,	25,	14,	25,	25,	15},

{	25,	3,	3,	25,	4,	4,	25,	5,	5,	25},
{	16,	25,	25,	17,	25,	25,	18,	25,	25,	19},
{	16,	25,	25,	17,	25,	25,	18,	25,	25,	19},

{	25,	6,	6,	25,	7,	7,	25,	8,	8,	25},
{	20,	25,	25,	21,	25,	25,	22,	25,	25,	23},
{	20,	25,	25,	21,	25,	25,	22,	25,	25,	23},

{	25,	9,	9,	25,	10,	10,	25,	11,	11,	25}
};

int N, K;

void prnt (int a) {
	for (int i = 0; i < 10; ++i) {
		for (int j = 0; j < 10; ++j)
			if (a & (1 << which[i][j]))
				printf ("%c", type[i][j]);
			else
				printf (".");
		printf ("\n");
	}
}

int main () {
	scanf ("%d %d", &K, &N);

	int i, j;
/*
	for (i = 0; i < 14; ++i) {
		prnt (sq[i]);
		printf ("\n\n");
	}
*/
	int CASEN = 1 << 24;
	int ii, cnt;
	for (i = 0; i < CASEN; ++i) {
//		i = sq[0];
		ii = i;
		cnt = 0;
		while (ii) {cnt += (ii & 1); ii >>= 1;}
		if ((24 - cnt) != K) continue;
//		printf ("cnt == %d\n", cnt);

		int res = 0;
		cnt = 0;
		ii = i | (1 << 25);
		for (j = 0; j < 14; ++j)
			if ((ii & sq[j]) == sq[j]) {
//				printf ("sq %d is in\n", j);
				++cnt;
				res |= sq[j];
			}
//		printf ("res == %x, cnt = %d\n", res, cnt);
		if (cnt == N && res == ii) {
			prnt (ii);
			return 0;
		}
	}

	return 0;
}
