/*
FROM: COCI (Croatia Open Competition in Informatics) 2006 contest 3
PROB: npuzzle
KEYW: manhattan distance
*/

#include <cstdio>
#include <cstdlib>

char inp[8][8];

int dst (int x, int y, int a) {
	return abs (x - a / 4) + abs (y - a % 4);
}

int main () {
	gets (inp[0]);
	gets (inp[1]);
	gets (inp[2]);
	gets (inp[3]);

	int i, j;
	int sum = 0;
	for (i = 0; i < 4; ++i)
		for (j = 0; j < 4; ++j) {
			if (inp[i][j] == '.') continue;
			sum += dst (i, j, inp[i][j] - 'A');
		}

	printf ("%d\n", sum);

	return 0;
}
