/*
FROM: COCI (Croatia Open Competition in Informatics) 2006 contest 4
PROB: JOGURT
KEYW: recursion, divide and conquer
*/

#include <cstdio>

int id[1 << 16], N;

int rec (int *xx, int n) {
	if (n == 1) {*xx = 1; return 1;}
	else if (n == 2) {*xx = 1; xx[1] = 2; xx[2] = 3; return 3;}
	int tmp = rec (xx + 1, n - 1), i;
	for (i = 1; i <= tmp; ++i)
		xx[i] *= 2;
	for (; i <= tmp * 2; ++i)
		xx[i] = xx[i - tmp] + 1;
	*xx = xx[tmp + 1];
	xx[tmp + 1] = 1;
	return tmp * 2 + 1;
}

int main () {
	scanf ("%d", &N);
	int sz = rec (id, N);
	printf ("%d", id[0]);
	for (int i = 1; i < sz; ++i)
		printf (" %d", id[i]);
	puts ("");

	return 0;
}
