/*
FROM: COCI (Croatia Open Competition in Informatics) 2007 contest 6
PROB: maraton
KEYW: easy
*/

#include <cstdio>
#include <cstring>

const int MAXN = 32;

int N;
char brd[MAXN][MAXN];

int main () {
	scanf ("%d\n", &N);

	int i, j;
	memset (brd, '.', sizeof (brd));
	for (i = 0; i < N; ++i) {
		for (j = 0; j < N; ++j)
			brd[i][j] = getchar ();
		getchar ();
	}

	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j) {
			if (brd[i][j] == '.') continue;
			if (brd[i][j] == brd[i+1][j] && brd[i][j] == brd[i+2][j]
			 || brd[i][j] == brd[i][j+1] && brd[i][j] == brd[i][j+2]
			 || brd[i][j] == brd[i+1][j+1] && brd[i][j] == brd[i+2][j+2]) {
				printf ("%c\n", brd[i][j]);
				return 0;
			}
		}
	printf ("ongoing\n");
	return 0;
}
