#include <cstdio>
#include <cassert>

const int MAXN = 1 << 10;

int N, M;
int K;
int N1, M1;
int NS, MS;
int idt[MAXN][MAXN];

int _srch (int x1, int y1) {
//	printf ("%d %d srch\n", x1, y1);
	static int i, j, res;
	res = 0;
	for (i = x1; i; i &= i - 1)
		for (j = y1; j; j &= j - 1) {
			assert (i && j);
//			printf ("add to srch %d %d\n", i, j);
			res += idt[i][j];
		}
	return res;
}

int srch (int x1, int y1, int x2, int y2) {
	return _srch (x1, y1) + _srch (x2, y2) - _srch (x1, y2) - _srch (x2, y1);
}

void add (int x, int y, int val) {
//	printf ("%d %d add %d\n", x, y, val);
	for (int i = x; i <= N; i += i & -i)
		for (int j = y; j <= M; j += j & -j) {
//			printf ("%d %d\n", i, j);
			idt[i][j] += val;
		}
}


int main () {
	scanf ("%d %d", &N, &M);
	scanf ("%d %d", &N1, &M1);
	NS = N1 * 2 - 1;
	MS = M1 * 2 - 1;

	scanf ("%d", &K);

	int tx, ty, bx, by;
	int res = 0;
	int i, j;
	int crnt;
	for (i = 1; i + N1 <= N + 1; ++i) {
		for (j = 1; j + M1 <= M + 1; ++j) {
			scanf ("%d", &crnt);
			tx = (i - N1) >? 0;
			ty = (j - M1) >? 0;
//			printf ("%d %d -- %d %d %d %d\n", i, j, tx, ty, i, j);
//			printf ("\t%d\n", srch (tx, ty, i, j));
			crnt += srch (tx, ty, i, j);
			add (i, j, K - crnt % K);
			res += (K - crnt % K) % K;
		}
		for (; j <= M; ++j) {
			scanf ("%d", &crnt);
			tx = (i - N1) >? 0;
			ty = (j - M1) >? 0;
//			printf ("%d %d -- %d %d %d %d\n", i, j, tx, ty, i, j);
//			printf ("\t%d\n", srch (tx, ty, i, j));
			crnt += srch (tx, ty, i, j);
			if (crnt % K != 0) {
				printf ("impossible\n");
				return 0;
			}
		}
	}
	for (; i <= N; ++i) {
		for (j = 1; j <= M; ++j) {
			scanf ("%d", &crnt);
			tx = (i - N1) >? 0;
			ty = (j - M1) >? 0;
//			printf ("%d %d -- %d %d %d %d\n", i, j, tx, ty, i, j);
//			printf ("\t%d\n", srch (tx, ty, i, j));
			crnt += srch (tx, ty, i, j);
			if (crnt % K != 0) {
				printf ("impossible\n");
				return 0;
			}
		}
	}

	printf ("%d\n", res);

	return 0;
}
