/*
FROM: NOI 1999 round 4
PROB: fruits
KEYW: dynamical programming
*/

#include <cstdio>

const int MAXN = 1 << 10;

int N;
bool opt[MAXN] = {1};
int prev[MAXN];

int main () {
	scanf ("%d", &N);
	int c;
	for (int i = 0; i < N; ++i) {
		scanf ("%d", &c);
		for (int j = 1000 - c; j >= 0; --j)
			if (opt[j] && !opt[j+c]) {
				opt[j+c] = 1;
				prev[j+c] = c;
			}
	}
	if (!opt[1000])
		printf ("NO\n");
	else
		for (int i = 1000; i != 0; i -= prev[i]) printf ("%d\n", prev[i]);

	return 0;
}
