/*
FROM: NOI 1999 round 4
PROB: sqr
KEYW: dynamical programming, full exhaustion
*/

#include <cstdio>
#include <climits>

const int MAXN = 1 << 6;

int N;
int map[MAXN][MAXN];
int sum[MAXN][MAXN];

int main () {
	scanf ("%d", &N);

	int i, j, k;
	for (i = 1; i <= N; ++i)
		for (j = 1; j <= N; ++j)
			scanf ("%d", &map[i][j]);

	for (i = 1; i <= N; ++i)
		for (j = 1; j <= N; ++j)
			sum[i][j] = sum[i-1][j] + sum[i][j-1] - sum[i-1][j-1] + map[i][j];

	int best = INT_MIN;
	for (i = 1; i <= N; ++i)
		for (j = 1; j <= N; ++j)
			for (k = 1; k <= (i <? j); ++k)
				best >?= sum[i][j] + sum[i-k][j-k] - sum[i-k][j] - sum[i][j-k];

	printf ("%d\n", best);

	return 0;
}
