#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define MAX 100

float g[MAX+1][MAX+1];
int n;
float arr[MAX+1];
int prev[MAX+1];
char used[MAX+1];

void readIt() {
  int a,b;
  float ff;
  FILE *f = fopen("TICKETS.INP", "rt");
  fscanf(f, "%d", &n);
  for (int i=0; i<(n*(n-1)/2); i++) {
    fscanf(f, "%d%d%f", &a, &b, &ff);
    g[a][b] = ff;
  }
  fclose(f);
}


void checkIt() {
  FILE *fout = fopen("TICKETS.OUT", "rt");

  if (fout == NULL) {
    printf("ERROR!!!.  no tickets.out\n");
    exit(0);
  }

  int m, a, b, tmp;
  char usedN;


/*  int prev1, prev2;

  prev1 = prev[n];
  prev2 = n;

  while (prev1 != 0) {
    printf("%d %d\n", prev1, prev2);
    prev2 = prev1;
    prev1 = prev[prev2];
  }
*/

  float sum = 0;
  fscanf(fout, "%d", &m);

  for (int i=1; i<= n; i++) used[i] = 0;
  usedN = 0;
  for (i=0; i<m; i++) {
    fscanf(fout, "%d%d", &a, &b);

    if (a == b || a > n || b > n) {
      printf("ERROR!!!.  equal numbers || number > n\n");
      exit(0);
    }

    if (a > b) {
      tmp = a;
      a = b;
      b = tmp;
    }

    for (int j=a; j<b; j++) {
      if (used[j]) {
        printf("ERROR!!!.  Overlapping\n");
        exit(0);
      } else {
        used[j] = 1;
      }
    }

    if (b==n) {
      if (used[n]) {
        printf("ERROR!!!.  Overlapping\n");
        exit(0);
      } else {
        used[n] = 1;
      }
    }

    sum += g[a][b];
  }

  if (usedN) used[n] = 1;

  for (i=1; i<=n; i++) {
    if (!used[i]) {
      printf("ERROR!!!.  Not all!!!\n");
      exit(0);
    }
  }

  if (fabs(sum-arr[n]) > 0.00001) {
    printf("ERROR!!!.  Diffrent sum.  Judge=%.2f  Student=%.2f\n", arr[n], sum);
    exit(0);
  }

  fclose(fout);
}

void solve() {
  float min;
  int minPrev;
  arr[1] = 0;
  prev[1] = 0;

  for (int i=2; i<=n; i++) {
    min = 10e30;

    for (int j=1; j<i; j++) {
      if (min > arr[j] + g[j][i]) {
        min = arr[j] + g[j][i];
        minPrev = j;
      }
    }

    arr[i] = min;
    prev[i] = minPrev;
  }

  checkIt();
}

int main() {
  readIt();
  printf("\n");
  solve();
  printf("OK! OK! OK! OK!\n");
}