/*
FROM: NOI 2000 round 4
PROB: tickets
KEYW: dynamical programming
*/

#include <cstdio>
#include <climits>

const int MAXN = 1 << 7;

int N;
int ma3x[MAXN][MAXN];
int opt[MAXN];
int prev[MAXN];
int cnt[MAXN];

void get2 (int *d1, int *d2) {
	char tmp = getchar ();
	*d1 = 0;
	if (tmp != '.') {
		ungetc (tmp, stdin);
		scanf ("%d.", d1);
	}
	scanf ("%d\n", d2);
}

int main () {
	scanf ("%d\n", &N);
	int m = N * (N - 1) / 2;

	int i, j;
	int a, b, d1, d2;
	for (i = 0; i < m; ++i) {
		scanf ("%d %d ", &a, &b);
		--a; --b;
		get2 (&d1, &d2);
		ma3x[a][b] = ma3x[b][a] = d1 * 100 + d2;
	}

	opt[N-1] = 0;
	prev[N-1] = -1;
	cnt[N-1] = 0;
	for (i = N-2; i >= 0; --i) {
		opt[i] = INT_MAX;
		for (j = i + 1; j < N; ++j) {
			if (opt[i] > opt[j] + ma3x[i][j]) {
				opt[i] = opt[j] + ma3x[i][j];
				prev[i] = j;
				cnt[i] = cnt[j] + 1;
			}
		}
	}

//	printf ("%d.%d\n", opt[0] / 100, opt[0] % 100);
	printf ("%d\n", cnt[0]);
	for (i = 0; prev[i] != -1; i = prev[i])
		printf ("%d %d\n", i + 1, prev[i] + 1);

	return 0;
}
