/*
FROM: 2001 k1
PROB: boat
KEYW: brute force
*/

#include <cstdio>
#include <cstdlib>
#include <algorithm>

const int MAXN = 1 << 7;
const int MAXM = 1 << 4;

int N, M;
int vec[MAXN];
int row[MAXM];
int idx[MAXM];
bool used[MAXN];
int layout[MAXM][MAXN];
int layoutc[MAXM];

void prnt () {
	for (int i = 0; i < M; ++i) {
		printf ("%d\n%d", layoutc[i], layout[i][0]);
		for (int j = 1; j < layoutc[i]; ++j)
			printf (" %d", layout[i][j]);
		printf ("\n");
	}
	exit (0);
}

void gen (int m, int left, int pos) {
	if (m == M) prnt ();
	if (!left) {gen (m+1, row[idx[m+1]], 0); return;}
	for (int i = 0; i < N; ++i)
		if (!used[i] && vec[i] <= left) {
			used[i] = 1;
			layout[idx[m]][layoutc[idx[m]]++] = vec[i];
			gen (m, left - vec[i], pos + 1);
			--layoutc[idx[m]];
			used[i] = 0;
		}
}

bool cmpidx (int a, int b) {return row[a] < row[b];}

int main () {
	scanf ("%d %d\n", &N, &M);

	int i;
	for (i = 0; i < N; ++i)
		scanf ("%d", vec + i);
	for (i = 0; i < M; ++i)
		scanf ("%d", row + i), idx[i] = i;

//	std::sort (vec, vec + N);
	std::sort (idx, idx + M, cmpidx);
	gen (0, row[idx[0]], 0);

	return 0;
}
