/*
FROM: 2001 k1
PROB: boxes
KEYW: dynamical programming
*/

#include <cstdio>

const int MAXA = 1 << 4;
const int MAXN = 1 << 5;

int A, B, N;
unsigned opt[MAXA][MAXN];

int main () {
	scanf ("%d %d %d", &N, &A, &B);
	int AB = A >? B;

	int i, j, k;
	i = 0;
	for (j = 0; j <= AB; ++j) opt[j][i] = 1;
	for (i = 1; i <= N; ++i)
		for (j = 0; j <= AB; ++j)
			for (k = 0; k <= j; ++k)
				opt[j][i] += opt[k][i-1];
/*
	for (i = 0; i <= N; ++i) {
		for (j = 0; j <= AB; ++j)
			printf ("%u ", opt[j][i]);
		printf ("\n");
	}
*/
	printf ("%Lu\n", (unsigned long long)opt[A][N] * (unsigned long long)opt[B][N]);

	return 0;
}
