/*
FROM: NOI 2001 round 3
PROB: cover
KEYW: dynamical programming
*/

#include <cstdio>
#include <vector>

const int LEN = 1 << 11;

int N;
std::vector <std::vector <int> > nxt (LEN);
int opt[LEN];

int main () {
	scanf ("%d", &N);

	int i;
	int a, b;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", &a, &b);
		a += 1 << 10; b += 1 << 10;
		if (a > b) a ^= b ^= a ^= b;
		nxt[a].push_back (b);
	}

	opt[LEN-1] = 0;
	for (i = LEN-2; i >= 0; --i) {
		opt[i] = opt[i+1];
		for (int j = 0; j < (int)nxt[i].size (); ++j)
			opt[i] >?= opt[nxt[i][j]] + 1;
	}

	printf ("%d\n", opt[0]);
	for (i = 0; i < LEN; ++i)
		for (int j = 0; j < (int)nxt[i].size (); ++j)
			if (opt[nxt[i][j]] + 1 == opt[i]) {
				printf ("%d %d\n", i - (1 << 10), nxt[i][j] - (1 << 10));
				i = nxt[i][j] - 1;
				break;
			}

	return 0;
}
