/*
FROM: NOI 2001 round 3
PROB: power
KEYW: fast power
*/

#include <cstdio>

int N, M, Y;

int sq (int a) {return a * a;}

int pow (int x, int p) {
	if (x == 0 || p == 0) return 1;
	if (p == 1) return x;
	return p & 1 ? (pow (x, p - 1) * x) % M : sq (pow (x, p - 1)) % M;
}

int main () {
	scanf ("%d %d %d", &N, &M, &Y);
	int ans[1 << 10];
	int ap = 0;

	int i;
	for (i = 0; i < M; ++i)
		if (pow (i, N) == Y)
			ans[ap++] = i;

	if (ap) {
		printf ("%d", ans[0]);
		for (i = 1; i < ap; ++i)
			printf (" %d", ans[i]);\
		printf ("\n");
	} else
		printf ("-1\n");

	return 0;
}
