/*
FROM: 2002 k2
PROB: shsh
KEYW: dynamical programming
*/

#include <cstdio>
#include <cstring>

const int MAXN = 20;
const int MAXVOTE = 2000;

int N;
int V;
long long opt[MAXN][MAXVOTE];
long long fact[MAXN] = {1};
int p[MAXN];

long double calc (int id) {
	static int i, j, k;
	memset (opt, 0, sizeof (opt));
	opt[0][0] = 1;
	for (i = 0; i < N; ++i) {
		if (i == id) continue;
		for (j = N-1; j >= 0; --j)
			for (k = V - p[i] - 1; k >= 0; --k)
				opt[j+1][k+p[i]] += opt[j][k];
	}

	long long res = 0;
	for (i = 0; i < N; ++i)
		for (j = V-p[id]; j < V; ++j)
			res += fact[i] * fact[N-1-i] * opt[i][j];

	return (long double)res / fact[N];
}

int main () {
	for (int i = 1; i < 20; ++i) fact[i] = fact[i-1] * i;
	int tkn = 0;
	while (scanf ("%d", &N), N) {
		if (tkn++) putchar ('\n');
		scanf ("%d", &V);
		for (int i = 0; i < N; ++i) scanf ("%d", &p[i]);
		for (int i = 0; i < N; ++i) printf ("%.1Lf\n", calc (i) * 100.0);
	}
	printf ("0\n");

	return 0;
}
