/*
FROM: 2002 k3
PROB: FAX
KEYW: stack sort
*/

#include <cstdio>

const int MAXN = 1 << 5;

int N;
long long K;
long long opt[MAXN][MAXN];
int used[MAXN];

void prnt (int a) {
	static int ft = 1;
	if (!ft) putchar (' ');
	else ft = 0;

	for (int i = N; i >= 0; --i)
		if (!used[i] && (a--) == 0) {
				printf ("%d", i);
				used[i] = 1;
				return;
			}
}

int main () {
	scanf ("%d%Ld", &N, &K);
	int i, j;
	opt[0][0] = 1;
	for (i = 1; i < MAXN; ++i) {
		opt[i][0] = 1;
		for (j = 1; j < i; ++j)
			opt[i][j] = opt[i][j-1] + opt[i-1][j];
	}
	--K;

	long long res = 0;
	for (j = 0; j <= N; ++j) res += opt[N][j];
	printf ("%Ld\n", res);
/*	res = 0;
	for (i = 0; i < 20; ++i) {
		for (j = res = 0; j < 20; ++j) {
			printf ("%d ", opt[i][j]);
			res += opt[i][j];
		}
		printf ("(%d)\n", res);
	}
*/

	i = N; j = N;
	for (i = N; i > 0; --i) {
		for (; (K -= opt[i][j]) >= 0; --j);
		K += opt[i][j];
		prnt (j);
	}
	puts ("");
	return 0;
}
