/*
FROM: NOI 2002 round 3
PROB: work
KEYW: ford belman, negative edges, linear unequations
*/

#include <cstdio>

const int MAXN = 1 << 10;
const int MAXM = 1 << 13;

int N, M;

int d[MAXN];
int fe[MAXM];
int se[MAXM];
int w[MAXM];

int main () {
	scanf ("%d %d", &N, &M);

	int i, j;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d %d", se + i, fe + i, w + i);
		--fe[i]; --se[i];
	}

	for (i = 0; i < N - 1; ++i)
		for (j = 0; j < M; ++j)
			if (d[se[j]] > d[fe[j]] + w[j])
				d[se[j]] = d[fe[j]] + w[j];

	for (j = 0; j < M; ++j)
		if (d[se[j]] > d[fe[j]] + w[j]) {
			printf ("NO SOLUTION\n");
			return 0;
		}

	int min = 0;
	for (i = 0; i < N; ++i)
		min <?= d[i];
	for (i = 0; i < N; ++i)
		printf ("%d\n", d[i] - min);

	return 0;
}
