/*
FROM: 2003 k1
PROB: part
KEYW:
*/

#include <cstdio>
#include <cstdlib>
#include <algorithm>

const int MAXN = 1 << 7;

int S, K;
int _row[MAXN], _n;

int opt[MAXN][MAXN];

void input () {
	_n = -1;
	while (scanf ("%d", _row + ++_n) == 1);
	K = _row[--_n];
	std::sort (_row, _row + _n);
	std::reverse (_row, _row + _n);
	for (int i = 0; i < _n; ++i) S += _row[i];
}

int code (int *vec) {
	int s = S;
	int res = 0;
	int max = S;
	for (int i = 0; s; ++i) {
		for (int j = max; j > vec[i]; --j)
			res += opt[s][j];
		s -= vec[i];
		max = vec[i] <? s;
	}
	return res;
}

void decode (int a) {
	int s = S;
	int max= S;

	for (int i = 0, j; s; ++i) {
		for (j = max; (a -= opt[s][j]) >= 0; --j);
		a += opt[s][j];
		if (i) putchar (' '); printf ("%d", j);
		max = j <? (s -= j);
	}
	printf ("\n");
}

int main () {
	input ();

	int i, j, k;
	opt[0][0] = 1;
	for (i = 1; i <= S; ++i)
		for (j = 1; j <= i; ++j)
			for (k = 0; k <= (j <? i - j); ++k)
				opt[i][j] += opt[i-j][k];

	int tmp = code (_row), tmp2;
	for (int i = 0; i < S; ++i) _row[i] = 1;
	if (tmp + K > (tmp2 = code (_row))) {printf ("%d\n", tmp2 - tmp); exit (0);}
	decode (tmp + K);

	return 0;
}
