/*
FROM: 2003 k2
PROB: mountain
KEYW: heap
*/

#include "mountain.h"


//#include <cstdio>
//#include <cstdlib>
#include <queue>

struct pos {
	int x, y;
	pos () {}
	pos (int _x, int _y) : x (_x), y (_y) {}
};

struct heap {
	pos l, r;
	heap () {}
	heap (pos _l, pos _r) : l (_l), r (_r) {}
	bool operator < (const heap &a) const {return (-l.x + l.y + r.x + r.y) / 2 > (-a.l.x + a.l.y + a.r.x + a.r.y) / 2;}//inverted
};

pos f (heap a) {
	pos ret;
	ret.y = (-a.l.x + a.l.y + a.r.x + a.r.y) / 2;
	ret.x = ret.y - a.l.y + a.l.x;
	return ret;
}

int N;
std::priority_queue <heap> h;

int ask (int a) {
/*	printf ("%d\n", a);
	fflush (stdout);
	int ans;
	scanf ("%d", &ans);
	return ans;
*/
	return look (a);
}
/*
void answer (pos ans) {
//	printf ("-1 %d %d\n", ans.x, ans.y);
//	exit (0);

	answer (ans.x, ans.y);
}
*/
int main () {
//	scanf ("%d", &N);
	N = init ();

	h.push (heap (pos (0, 0), pos (N, 0)));

	heap crnt;
	pos crntp;
	int ans;
	while (!h.empty ()) {
		crnt = h.top (); h.pop ();
		crntp = f (crnt);
		printf ("expect %d\n", crntp.y);
		if ((ans = ask (crntp.x)) == crntp.y)
			answer (crntp.x, crntp.y);
		crntp.y = ans;
		printf ("%d %d   %d %d\n%d %d  %d %d\n", crnt.l.x, crnt.l.y, crntp.x, crntp.y,
		crntp.x, crntp.y, crnt.r.x, crnt.r.y);
		h.push (heap (crnt.l, crntp));
		h.push (heap (crntp, crnt.r));
	}

	return 0;
}
