/*
FROM: NOI 2003 round 3
PROB: cube
KEYW: full exhaustion
*/

#include <cstdio>
#include <cstring>
#include <cassert>

#include <algorithm>
#include <vector>

const int NN = 1 << 4;
const int MAXM = 1 << 3;
const int N = 12;

int M;
int all_cnt;
int CH, ZN;
int cnt[MAXM];
int _cnt[MAXM];
int __vec1[NN], __vec2[NN];
int *vec = __vec1, *vec2 = __vec2;
int fact[NN];

int plf [] = {1,2,3,0,5,6,7,4,9,10,11,8};
int plb [] = {8,5,0,4,11,9,1,3,10,6,2,7};

//std::vector <bool> used;
bool used[8000000];

int _c_;
inline int P () {
	static int zn, ch, i;
	for (i = 0, ch = 0, zn = 1; i < M; ++i) {
		++_c_;
		zn *= fact[_cnt[i]];
		ch += _cnt[i];
	}
	ch = fact[ch];
	CH = ch, ZN = zn;//all

	return ch / zn;
}

void input () {
	int ce = 0, prev, tmp;
	scanf ("%d", &prev);
	++cnt[ce];
	for (int i = 1; i < N; ++i) {
		scanf ("%d", &tmp);
		if (tmp != prev) {
			prev = tmp;
			++ce;
		}
		++cnt[ce];
	}

	M = ce + 1;
	memcpy (_cnt, cnt, sizeof (cnt));
	all_cnt = P ();
//	used.resize (all_cnt);
}

int ___cntr;
inline void decode (int a) {
	static int i, j, tmp, ch, zn;
	memcpy (_cnt, cnt, sizeof (cnt));
	ch = CH, zn = ZN;
	for (i = 0; i < N; ++i) {
		ch /= N - i;
		for (j = 0; j < M; ++j) {
			++___cntr;
			if (!_cnt[j]) continue;
			tmp = ch * _cnt[j] / zn;
			if (a < tmp) {
				zn /= _cnt[j];
				--_cnt[j];
				vec[i] = j;
				break;
			} else
				a -= tmp;
		}
	}
}

inline int code () {
	static int i, j, res, ch, zn;
	memcpy (_cnt, cnt, sizeof (cnt));
	ch = CH, zn = ZN;
	for (i = 0, res = 0; i < N; ++i) {
		ch /= N - i;
		for (j = 0; j < vec[i]; ++j) {
			++___cntr;
			if (_cnt[j])
				res += ch * _cnt[j] / zn;
		}
		++___cntr;

		zn /= _cnt[vec[i]];
		--_cnt[vec[i]];
	}

	return res;
}

inline void rotf () {
	static int i;
	for (i = 0; i < N; ++i) {
		vec2[plf[i]] = vec[i];
		++___cntr;
	}
	std::swap (vec, vec2);
}

inline void rotb () {
	static int i;
	for (i = 0; i < N; ++i) {
		vec2[plb[i]] = vec[i];
		++___cntr;
	}
	std::swap (vec, vec2);
}

void rot_all () {
	for (int i = 0; i < 4; ++i) {
		for (int j = 0; j < 4; ++j) {
			used[code ()] = 1;
			rotf ();
		}
		rotb ();
	}
	rotf ();
	rotb ();
	for (int i = 0; i < 2; ++i) {
		for (int j = 0; j < 4; ++j) {
			used[code ()] = 1;
			rotf ();
		}
		rotb ();
		rotb ();
	}
}

int main () {
	fact[0] = 1; for (int i = 1; i <= N; ++i) fact[i] = fact[i-1] * i;

	input ();

	int res = 0;
	for (int i = 0; i < all_cnt; ++i) {
		if (used[i]) continue;
		++res;
		decode (i);
		rot_all ();
	}

	printf ("%d\n", res);
	printf ("%d %d\n", ___cntr, _c_);

	return 0;
}
