/*
FROM: NOI 2003 round 3
PROB: fill
KEYW: dynamical programming, recursion
*/

#include <cstdio>

const int MAX = 1 << 8;

struct el {
	int d;
	int l;
	el () {}
	el (int _d, int _l) : d (_d), l (_l) {}
	bool operator < (const el &a) const {return d != a.d ? d > a.d : l < a.l;}
	el operator <?= (const el &a) {if (a < *this) *this = a; return *this;}
	el operator + (int a) const {el ret = *this; ret.l += a; return ret;}
};

int A, B, C, D;
el opt[MAX][MAX][MAX];

int trnk (int a, int b) {
	return a > b ? b : a < 0 ? 0 : a;
}

int pr (int a, int b, int bb) {
	return a + b <= bb ? a : bb - b;
}

el rec (int a, int b, int c) {
//	printf ("in rec %d %d %d\n", a, b, c);
	if (opt[a][b][c].d != 0) return opt[a][b][c];
	el &crnt = opt[a][b][c];
	crnt.d >?= (a <= D ? a : crnt.d);
	crnt.d >?= (b <= D ? b : crnt.d);
	crnt.d >?= (c <= D ? c : crnt.d);
	if (!crnt.d) {crnt.d = 1; crnt.l = 1000000000;}//very bad
//	printf ("(%d %d)\n", crnt.d, crnt.l);

	if (a > 0 && b < B) {crnt <?= rec (trnk (a - B + b, A), trnk (b + a, B), c) + pr (a, b, B);}
	if (a > 0 && c < C) {crnt <?= rec (trnk (a - C + c, A), b, trnk (c + a, C)) + pr (a, c, C);}

	if (b > 0 && a < A) {crnt <?= rec (trnk (a + b, A), trnk (b - A + a, B), c) + pr (b, a, A);}
	if (b > 0 && c < C) {crnt <?= rec (a, trnk (b - C + c, B), trnk (c + b, C)) + pr (b, c, C);}

	if (c > 0 && a < A) {crnt <?= rec (trnk (a + c, A), b, trnk (c - A + a, C)) + pr (c, a, A);}
	if (c > 0 && b < B) {crnt <?= rec (a, trnk (b + c, B), trnk (c - B + b, C)) + pr (c, b, B);}

//	printf ("ret(%d %d %d) -- %d %d\n", a, b, c, crnt.d, crnt.l);
	return crnt;
}

int main () {
	scanf ("%d %d %d %d", &A, &B, &C, &D);

//	set_opt ();
	rec (0, 0, C);
	printf ("%d %d\n", opt[0][0][C].l, opt[0][0][C].d);

	return 0;
}
