/*
FROM: NOI 2003 round 3
PROB: friend
KEYW: bfs
*/

#include <cstdio>
#include <vector>
#include <queue>

const int MAXN = 1 << 15;

int N, M;
std::vector <std::vector <int> > vec;
bool used[MAXN];

int max_in_group;
void bfs (int start) {
	std::queue <int> q;
	q.push (start);
	used[start] = 1;
	int in_gr = 0;

	while (!q.empty ()) {
		int crnt = q.front (); q.pop ();
		++in_gr;
		for (int i = 0; i < (int)vec[crnt].size (); ++i)
			if (!used[vec[crnt][i]]) {
				used[vec[crnt][i]] = 1;
				q.push (vec[crnt][i]);
			}
	}

	max_in_group >?= in_gr;
}

int main () {
	scanf ("%d %d", &N, &M);
	vec.resize (N);

	int a, b;
	for (int i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
		vec[a].push_back (b);
		vec[b].push_back (a);
	}

	for (int i = 0; i < N; ++i)
		if (!used[i]) bfs (i);

	printf ("%d\n", max_in_group);

	return 0;
}
