/*
FROM: NOI 2003 round 3
PROB: sork
KEYW: heap, sort
*/

#include "srv.h"

#include <cstdio>
#include <queue>

int K;
struct el {
	int num;
	int row;
	bool operator < (const el &a) const {return num > a.num;}
};

std::priority_queue <el> heap;

int main () {
	srv (0, 0, &K);
//	printf ("K == %d\n", K);
	int tmp;
	el topush;
	for (int i = 0; i < K; ++i) {
		srv (1, i + 1, &tmp);
//		printf ("%d -- %d\n", i, tmp);
		if (tmp != -1) {
			topush = (el) {tmp, i};
			heap.push (topush);
		}
	}
	el crnt;
	while (!heap.empty ()) {
		crnt = heap.top (); heap.pop ();
//		printf ("poped %d %d\n", crnt.num, crnt.row);
		srv (2, crnt.num, &tmp);
		srv (1, crnt.row + 1, &tmp);
		if (tmp != -1) {
//			printf ("push %d %d\n", tmp, crnt.row);
			heap.push ((el) {tmp, crnt.row});
		}
	}
	srv (3, 0, &tmp);

	return 0;
}
