#include "srv.h"

#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>

namespace {
	std::vector <std::vector <int> > rows;
	std::vector <std::vector <int>::const_iterator> cpos;
	std::vector <bool> finished;
	int last_said;
	int cntr;
}

static void init () {
//	printf ("in here!\n");
	srand (time (0));
	rows.resize (rand () % 200 + 1);
//	printf ("wow!--%u\n", rows.size ());
	int all_sum = 0;
	for (int i = 0; i < (int)rows.size (); ++i) {
		rows[i].resize (rand () % 100000);

//		printf ("%d - %u\n", i, rows[i].size ());
		for (int j = 0; j < (int)rows[i].size (); ++j)
			rows[i][j] = rand ();
		std::sort (rows[i].begin (), rows[i].end ());
		cpos.push_back (rows[i].begin ());
		finished.push_back (0);
		all_sum += (int)rows[i].size ();
	}
	last_said = -1;
	cntr = 0;
	assert (cpos.size () == rows.size ());
	printf ("%u --- %d\n", rows.size (), all_sum);
}

void srv (int code, int val, int *answer) {
//	printf ("where!%d %d\n", code, val);
	if (cntr >= 250000) {printf ("too many asking, too little answers!\n"); exit (-1);}
	switch (code) {
		case 0: //printf ("0\n");
				init ();
				*answer = (int)rows.size();
				break;
		case 1: //printf ("1 -- %d-----------\n", val);
				if (finished[val-1]) {
					printf ("asking for a finished sequence!\n");
					exit (-1);
				}
				if (cpos[val-1] == rows[val-1].end ()) {
					*answer = -1;
					finished[val-1] = 1;
				} else
					*answer = *cpos[val-1]++;
				++cntr;
				break;
		case 2: //printf ("2\n");
				if (val >= last_said) last_said = val; else {printf ("wrong sort!\n"); exit (-1);} --cntr; break;
		case 3: //printf ("3\n");
				int i;
				for (i = 0; i < (int)rows.size () && finished[i]; ++i);
				if (i != (int)rows.size ()) {
					printf ("not everything has finished!\n");
					exit (-1);
				}
				printf ("OK!\n");
				break;
		default: printf ("def-kvooo!\n");
	}
}
