/*
FROM: 2004 k1
PROB: trav
KEYW: full exhaustion with optimizations
*/

#include <cstdio>
#include <climits>

const int MAXN = 1 << 4;
const int MAXM = 1 << 6;

int N, M;
int vec[MAXN][MAXM];

int t[MAXN][MAXM];

int best;
int bseq[MAXN];

bool used[MAXN];
int seq[MAXN];

void save () {
	for (int i = 0; i < N; ++i) bseq[i] = seq[i];
/*
	for (int i = 0; i < N; ++i) printf ("%d ", bseq[i] + 1); printf ("\n");

	for (int i = 1; i <= N; ++i) {
		for (int j = 0; j < M; ++j)
			printf ("%d ", t[i][j]);
		printf ("\n");
	}
*/
}

int calct (int v, int a) {
	int ct = 0;
	for (int i = 0; i < M; ++i)
		if ((ct += vec[a][i]) < t[v-1][i])
			t[v][i] = ct = t[v-1][i];
		else
			t[v][i] = ct;
	return ct;
}

void rec (int v, int cs) {
	if (v == N) {best = cs; save (); return;}

	for (int i = 0; i < N; ++i) {
		if (used[i]) continue;
		used[i] = 1;
		seq[v] = i;
		int last = calct (v + 1, i);
		if (cs + (N - v) * last < best)
			rec (v + 1, cs + last);
		used[i] = 0;
	}
}

int main () {
	scanf ("%d %d", &N, &M);

	int i, j;
	for (i = 0; i < N; ++i)
		for (j = 0; j < M; ++j)
			scanf ("%d", &vec[i][j]);

	best = INT_MAX;
	rec (0, 0);
//	printf ("%d\n", best);
	printf ("%d", bseq[0] + 1); for (i = 1; i < N; ++i) printf (" %d", bseq[i] + 1); printf ("\n");

	return 0;
}
