/*
FROM: NOI 2004 ROUND 2 A
PROG: perm
KEYW: dynamical programming
*/

#include <cstdio>

const int MAXN = 1 << 4;
const int MAXK = 1 << 4;

int N, K;
long long opt[MAXN][MAXK];

int main () {
	scanf ("%d %d", &N, &K);

	int i, j;
	for (i = 1; i <= N; ++i) opt[i][i - 1] = opt[i][0] = 1;

	for (i = 2; i <= N; ++i)
		for (j = 1; j < i - 1; ++j)
			opt[i][j] = (j + 1) * opt[i - 1][j] + (i - j) * opt[i - 1][j - 1];

	printf ("%Ld\n", opt[N][K]);

	return 0;
}
