#include <cstdio>

const int MAXN = 1 << 4;
const int MAXSUM = 1 << 7;

int N, K, P;

long long opt[MAXN][MAXSUM];

int main () {
	scanf ("%d %d %d", &N, &P, &K);

	opt[0][0] = 1;
	int i, j;
	for (i = 1; i <= N; ++i) {
		opt[i][0] = 1;
		for (j = 1; j < P + 1; ++j)
			opt[i][j] = opt[i][j-1] + opt[i-1][j];
		for (; j < MAXSUM; ++j)
			opt[i][j] = opt[i][j-1] + opt[i-1][j] - opt[i-1][j-P-1];
	}

	for (i = 0; i <= N; ++i) {
		for (j = 0; j < MAXSUM; ++j)
			printf ("%Ld ", opt[i][j]);
		printf ("\n");
	}

	long long res = 0;
	for (i = 0; i + K < MAXSUM; ++i)
		res += opt[N][i] * opt[N][i+K];

	printf ("%Ld\n", res);

	return 0;
}
