#include "module.h"

#include <cstdio>
#include <cstdlib>

namespace {
	const int MAXN = 1 << 7;
	const int MAXTRIES = 830;
	int sz;
	int N;
	int bx[MAXN];
	int by[MAXN];
	bool answered[MAXN];
	int ntries;
	int nguessed;
}

#ifdef  __cplusplus
extern "C" {
#endif

short getSize () {
	scanf ("%d %d", &sz, &N);
	for (int i = 0; i < N; ++i)
		scanf ("%d %d", bx + i, by + i);

	return sz;
}

short ask (short x1, short x2, short y1, short y2) {
	if (ntries++ > MAXTRIES) {printf ("you made more than %d tries!\n", MAXTRIES); exit (-1);}
	short res = 0;
	for (int i = 0; i < N; ++i)
		if (x1 <= bx[i] && bx[i] <= x2 &&
			y1 <= by[i] && by[i] <= y2)
			++res;
	printf ("ask (%hd, %hd, %hd, %hd) -> %hd\n", x1, x2, y1, y2, res);
	return res;
}

void answer (short x, short y) {
	int i;
	for (i = 0; i < N && !(bx[i] == x && by[i] == y); ++i);
	if (i == N) {printf ("not any bacteria at %hd %hd!\n", x, y); exit (-1);}
	else if (answered[i]) {printf ("already guessed %hd %hd!\n", x, y); exit (-1);}
	else answered[i] = 1;
	if (++nguessed == N) {printf ("everything is all right! %d tries!\n", ntries); exit (0);}
}

#ifdef  __cplusplus
}
#endif
