/*
FROM: 2005 k1
PROB: toto
KEYW: ad-hoc
*/

#include "totolib.h"

#include <cstdio>

int s[1 << 4];
int tr[1 << 4];

int z[1 << 3], zp;
int fnd (int a, int st) {
	static int k1, k2;
	k1 = post_comb (z[0], z[1], z[2], z[3], z[4], st);
	k2 = post_comb (z[0], z[1], z[2], z[3], z[4], st+1);
	if (a)
		return k1 && k2 ? st + 2 : !k1 ? st : st + 1;
	else
		return k1 ? st : k2 ? st + 1 : st + 2;
}

int ans[1 << 3], ap;

int main () {
	int i, j;

	for (i = 0; i < 15; ++i)
		s[i] = post_comb (i * 3 + 1, i * 3 + 2, i * 3 + 3, i * 3 + 4, i * 3 + 5, i * 3 + 6);

	for (j = 0; s[j]; ++j);
	for (i = j * 3 + 1; i < j * 3 + 6; ++i) z[zp++] = i;

	tr[j] = tr[j+1] = 0;
	for (i = j-1; i >= 0; --i)
		tr[i] = s[i] - tr[i+1];
	for (i = j + 2; i < 16; ++i)
		tr[i] = s[i-1] - tr[i-1];

//	for (i = 0; i < 8; ++i) printf ("(%d %d) ", tr[i*2], tr[i*2 + 1]); printf ("\n");

	int k;
	for (i = 0; i < 16; ++i)
		if (tr[i] == 3) {
//			printf ("f3 -- %d\n", i * 3 + 1);
			for (j = 1; j <= 3; ++j) ans[ap++] = i * 3 + j;
		} else if (tr[i] == 2) {
//			printf ("f2 -- %d\n", i * 3 + 1);
			k = fnd (1, i * 3 + 1);
			for (j = 1; j <= 3; ++j) if (i * 3 + j != k) ans[ap++] = i * 3 + j;
		} else if (tr[i] == 1) {
//			printf ("f1 -- %d\n", i * 3 + 1);
			ans[ap++] = fnd (0, i * 3 + 1);
		}

	if (ap == 5)
		ans[ap++] = 49;

	post_comb (ans[0], ans[1], ans[2], ans[3], ans[4], ans[5]);

	return 0;
}
