/**/

#include "totolib.h"

#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <algorithm>

namespace {
	const int MAXTRIES = 28;
	int ntries;
	int vec[6];
}

void init () {
	srand (time (0));
	if (scanf ("%d", vec) != 1) {
		int q[50];
		int pos;
		for (int i = 1; i < 50; ++i) q[i-1] = i;
		for (int i = 0; i < 6; ++i) {
			pos = rand () % (49 - i);
			vec[i] = q[pos];
			q[pos] = q[49-i-1];
		}
	} else
		scanf ("%d %d %d %d %d", vec + 1, vec + 2, vec + 3, vec + 4, vec + 5);

	std::sort (vec, vec + 6);
//	for (int i = 0; i < 6; ++i) printf ("%d ", vec[i]); printf ("\n");
	ntries = 0;
}

int post_comb (int a, int b, int c, int d, int e, int f) {
	static int ft = 1;
	if (ft) {init (); ft = 0;}
	if (ntries++ == MAXTRIES) {printf ("MORE!\n"); exit (-1);}

//	printf ("ask %d %d %d %d %d %d -- ", a, b, c, d, e, f);

	int res = 0;
	for (int i = 0; i < 6; ++i) {
		if (vec[i] == a) ++res;
		if (vec[i] == b) ++res;
		if (vec[i] == c) ++res;
		if (vec[i] == d) ++res;
		if (vec[i] == e) ++res;
		if (vec[i] == f) ++res;
	}
	if (res == 6) {printf ("Correct - %d tr%s!\n", ntries, ntries == 1 ? "y" : "ies"); exit (0);}

//	printf ("%d\n", res);
	return res;
}
