/*
FROM: 2005 k3
PROB: burn
KEYW: floid
*/

#include <cstdio>
#include <cstdlib>

const int MAXN = 1 << 7;
const int _infinity = 1 << 29;

int N, M;
int ma3x[MAXN * 2][MAXN * 2];
int p[MAXN];
int lma3x[MAXN][MAXN];//the longest one

double f (int f, int s, int m) {
	return (f >? s) + (((m - abs (f - s)) / 2.) >? 0);
}

int main () {
	scanf ("%d %d", &N, &M);
	int N2 = N * 2;

	int i, j, k;
	int a, b, l;
	for (i = 0; i < N2; ++i) for (j = 0; j < N2; ++j) ma3x[i][j] = _infinity;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d %d", &a, &b, &l);
		--a; --b;
		++p[a]; ++p[b];
		ma3x[a + N][b] <?= l;
		ma3x[b + N][a] <?= l;
		lma3x[a][b] = (lma3x[b][a] >?= l);
	}

	for (i = 0; i < N; ++i) {ma3x[i][i + N] = p[i]; ma3x[i][i] = ma3x[i+N][i+N] = 0;}

	for (k = 0; k < N2; ++k)
		for (i = 0; i < N2; ++i)
			for (j = 0; j < N2; ++j)
				ma3x[i][j] <?= ma3x[i][k] + ma3x[k][j];

	double min = _infinity, cmax;
	for (k = 0; k < N; ++k) {
		cmax = 0.;
		for (i = 0; i < N; ++i)
			for (j = i + 1; j < N; ++j) {
				cmax >?= f (ma3x[k][i+N], ma3x[k][j+N], lma3x[i][j]);
//				printf ("from %d to %d %d (%d %d %d) -- %lf\n", k, i, j, ma3x[k][i+N], ma3x[k][j+N], lma3x[i][j],\
				f (ma3x[k][i+N], ma3x[k][j+N], lma3x[i][j]));
			}
		min <?= cmax;
//		printf ("--\n");
	}

	printf ("%.1lf\n", min);
	return 0;
}
