#include <stdio.h>

#define MAXL 1000000000
#define MAXN 101
#define MAXM 6001
int g[MAXN][MAXN],e[MAXM][3],d[MAXN];

int main()
{
	int N,M,i,j,k,l,f,s;
	double min=2000000000.0,lmax,llmax;
    
	scanf("%d %d",&N,&M);
	for(i=1;i<=N;i++)
	{
	   d[i]=0;
	   for(j=1;j<=N;j++)
		   g[i][j]=(i==j?0:MAXL);
	}

	for(i=1;i<=M;i++)
	{
       scanf("%d %d %d",&e[i][0],&e[i][1],&e[i][2]);
	   d[e[i][0]]++;d[e[i][1]]++;
	   if(g[e[i][0]][e[i][1]]>e[i][2])
	      g[e[i][0]][e[i][1]]=g[e[i][1]][e[i][0]]=e[i][2];
	}
	// Floyd
	for(i=1;i<=N;i++)
        for(j=1;j<=N;j++)
		   if(i==j) g[i][i]=d[i];
		   else g[i][j]=g[i][j]+d[i]+d[j];
	for(k=1;k<=N;k++)
	   for(i=1;i<=N;i++)
		   for(j=1;j<=N;j++)
		   {
		      if(i!=j&&g[i][k]-g[k][k]+g[k][j]<g[i][j])
			     g[i][j]=g[i][k]-g[k][k]+g[k][j];
		   }
        int p=0;
	for(i=1;i<=N;i++) //start in i;
	{
	   lmax=0.0;
	   for(j=1;j<=N;j++) 
		   if(g[i][j]>lmax)lmax=g[i][j];
       for(j=1;j<=M;j++) // for each edge
	   {
		f=e[j][0];s=e[j][1];l=e[j][2];
		if(g[i][f]>g[i][s]){int t=f;f=s;s=t;}
		if(l<=g[i][s]-g[i][f])llmax=l+g[i][f];
		else llmax=(g[i][s]+l+g[i][f])/2.;
                if(llmax>lmax) lmax=llmax;
	   }
	   if(lmax<min){min=lmax;p=i;}
	}
	printf("%.1lf\n",min);
    return 0;
}
