/*
TASK:traverse
LANG:C++
*/

#include <cstdio>

const int MAXN = 1 << 10;
const int MAXT = 1 << 8;
const int MAX = 1 << 5;
const int BASE = 1000000000;

struct num {
	int a[MAX];
	num () {}
	num (int b) {a[0] = b; for (int i = 1; i < MAX; ++i) a[i] = 0;}
	bool operator >= (const num &b) const {int i; for (i = MAX-1; i > 0 && a[i] == b.a[i]; --i); return (a[i] >= b.a[i]);}
	num& operator = (const num &b) {for (int i = 0; i < MAX; ++i) a[i] = b.a[i]; return *this;}
	num& operator = (int b) {a[0] = b; for (int i = 1; i < MAX; ++i) a[i] = 0; return *this;}
	bool operator == (int b) {int i; for (i = 1; i < MAX && a[i] == 0; ++i); return a[0] == b && i == MAX; }
	num operator + (const num &b) const {
//		printf ("in op +:\n");
//		prnt ();
//		b.prnt ();
		num ret = *this;
		int pr = 0;
		for (int i = 0; i < MAX-1; ++i) {
			ret.a[i] += b.a[i] + pr;
			pr = ret.a[i] / BASE;
			ret.a[i] %= BASE;
		}
//		ret.prnt ();
		return ret;
	}
	//more
	num& operator -= (const num &b) {
		for (int i = 0; i < MAX-1; ++i) {
			if (a[i] < b.a[i]) {
				a[i] += BASE;
				a[i+1] -= 1;
			}
			a[i] -= b.a[i];
		}
		return *this;
	}
	num operator - (const num &b) const {
		num ret = *this;
		ret -= b;
		return ret;
	}
	void prnt () const {
		int i;
		for (i = MAX-1; i > 0 && !a[i]; --i);
		printf ("%d", a[i]);
		for (--i; i >= 0; --i) printf ("%09d", a[i]);
		printf ("\n");
	};
	void scan () {
		char buf[MAX*9];
		fgets (buf, sizeof (buf), stdin);
		int len = strlen (buf) - 1;
		int fid = len / 9;
		for (int i = 0; i < MAX; ++i) a[i] = 0;
		for (int i = 0; i < len; ++i) {
			if (!((len - i) % 9)) --fid;
			a[fid] *= 10;
			a[fid] += buf[i] - '0';
		}
	}
};

int N, K;
num opt[MAXN][MAXT][2];
num pow2[MAXN];

num f (int n, int t, int b, num s) {
	printf ("---%d %d %d ", n, t, b); s.prnt ();
//	getchar ();
	if (t == 0 && b == 0 && s == 0) return pow2[n-1];

	if (t == 0 && b == 0)
		return f (n-1, t, b, s - num(1)) + pow2[n - 1];

	if (b == 0) {
		if (s >= opt[n-1][t-1][1]) {
			s -= opt[n-1][t-1][1];
			return f (n - 1, t, b, s) + pow2[n - 1];
		} else
			return pow2[n-1] - f (n-1, t-1, 1, s);
	} else {
		if (s >= opt[n-1][t][b]) {
			s -= opt[n-1][t][b];
			return pow2[n-1] - f (n - 1, t, 0, s);
		} else
			return f (n - 1, t, b, s) + pow2[n-1];
	}
}

int main () {
	scanf ("%d", &N);

	int i, j, k;
	opt[1][0][0] = 1;
	for (i = 2; i <= N; ++i)
		for (j = 0;; ++j) {
			opt[i][j][0] = (j ? opt[i-1][j-1][1] : num (1)) + opt[i-1][j][0];
			opt[i][j][1] = opt[i-1][j][1] + opt[i-1][j][0];
//			printf ("%d %d %d (%d %d %d   %d %d %d)-- ", i, j, 0, i-1, j-1, 1, i-1, j, 0); opt[i][j][0].prnt ();
//			printf ("%d %d %d (%d %d %d   %d %d %d)-- ", i, j, 1, i-1, j, 1, i-1, j, 0); opt[i][j][1].prnt ();
//			printf ("%d %d %d -- ", i, j, 0); opt[i][j][0].prnt ();
//			printf ("%d %d %d -- ", i, j, 1); opt[i][j][1].prnt ();
			if (opt[i][j][1] == 0) break;
		}



	pow2[0] = 1;
	for (i = 1; i <= N; ++i)
		pow2[i] = pow2[i-1] + pow2[i-1];

	num crnt;
	scanf ("%d\n", &K);
	for (i = 0; i < K; ++i) {
		crnt.scan ();
		for (j = 0;; ++j)
			for (k = 0; k < 2; ++k)
				if (crnt >= opt[N][j][k]) {
					crnt -= opt[N][j][k];
					printf ("extract %d %d %d, left ", N, j, k); crnt.prnt ();
				} else {
//					printf ("calling %d %d %d\n", N, j, k);
//					getchar ();
					f (N, j, k, crnt).prnt ();
					goto nxti;
				}
		nxti:;
	}

	return 0;
}
