/*
FROM: NOI round 3 day 1
PROB: water
KEYW: backtrack, full exhaustion
*/

#include <cstdio>
#include <cassert>
#include <algorithm>
#include <vector>
#include <utility>

const int MAXV = 1 << 8;

typedef unsigned char uchar;
uchar sep[3][4];

int K;
std::vector <std::pair <uchar, uchar> > gr[MAXV][MAXV];
bool term[MAXV][MAXV];
bool used[MAXV][MAXV];

void calc_moves (int from[], int id1, int id2) {
	static int i, to[3], difs[8], bnd[2][2];

	memcpy (to, from, sizeof (to));
	for (i = 0; i < 4; ++i)	difs[i] = sep[id1][i] - from[id1];
	bnd[0][0] = sep[id1][0] - from[id1];
	bnd[0][1] = sep[id1][3] - from[id1];

	for (i = 0; i < 4; ++i) difs[i+4] = from[id2] - sep[id2][i];
	bnd[1][0] = from[id2] - sep[id2][3];
	bnd[1][1] = from[id2] - sep[id2][0];

	std::sort (difs, difs + 8);
	int dc = std::unique (difs, difs + 8) - difs;
	for (i = 0; i < dc; ++i)
		if (difs[i] >= bnd[0][0] && difs[i] >= bnd[1][0]
		 && difs[i] <= bnd[0][1] && difs[i] <= bnd[1][1]
		 && difs[i]) {
			to[id1] = from[id1] + difs[i];
			to[id2] = from[id2] - difs[i];
			gr[from[0]][from[1]].push_back (std::make_pair ((uchar)to[0], (uchar)to[1]));
		}
}

int _lvl, res;
std::pair <uchar, uchar> __path[100];

/*void __pp (std::pair <uchar, uchar> x) {
	printf ("VVVV\n");
	__path[_lvl + 1] = x;
	for (int i = 0; i <= _lvl + 1; ++i)
		printf ("%d %d %d\n", __path[i].first, __path[i].second, sep[0][3] - __path[i].first - __path[i].second);
	printf ("-->><\n");
}
*/
void rec (uchar a, uchar b) {
//	printf ("%d %d -- %d\n", (int)a, (int)b, _lvl);
	if (_lvl == K) return;
	for (size_t i = 0; i < gr[a][b].size (); ++i)
		if (term[gr[a][b][i].first][gr[a][b][i].second]){
			++res;
//			__pp (gr[a][b][i]);
			assert (!used[gr[a][b][i].first][gr[a][b][i].second]);
		}
		else if (!used[gr[a][b][i].first][gr[a][b][i].second]) {
			used[gr[a][b][i].first][gr[a][b][i].second] = 1;
			++_lvl;
			__path[_lvl] = std::make_pair (gr[a][b][i].first, gr[a][b][i].second);
			rec (gr[a][b][i].first, gr[a][b][i].second);
			--_lvl;
			used[gr[a][b][i].first][gr[a][b][i].second] = 0;
		}
//	printf ("<--\n");
}

int main () {
	int V;
	scanf ("%d %d", &V, &K);
	int i, j;
	int tmp[2];
	for (i = 0; i < 3; ++i) {
		for (j = 0; j < 2; ++j)
			scanf ("%d", tmp + j);
		if (tmp[0] > tmp[1]) std::swap (tmp[0], tmp[1]);
		sep[i][1] = tmp[0];
		sep[i][2] = tmp[1];
		sep[i][3] = V;
	}
/*
	for (i = 0; i < 3; ++i) {
		for (j = 0; j < 4; ++j)
			printf ("%d ", sep[i][j]);
		printf ("\n");
	}
*/
	int from[3];
	for (from[0] = 0; from[0] <= V; ++from[0])
		for (from[1] = 0; from[0] + from[1] <= V; ++from[1]) {
			from[2] = V - from[0] - from[1];
			if (from[0] == 1 || from[1] == 1 || from[2] == 1)
				term[from[0]][from[1]] = 1;
			else {
				calc_moves (from, 0, 1);
				calc_moves (from, 0, 2);
				calc_moves (from, 1, 2);
//				printf ("------\n");
			}
		}

	used[V][0] = 1;
	__path[0] = std::make_pair (V, 0);
	rec (V, 0);
	printf ("%d\n", res);

	return 0;
}
