/*
FROM: NOI 2007 r1
PROB: expres
KEYW: reverse polish notation
NOTE: correct but slow (very)
*/

#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <cassert>
#include <string>

const int MAXN = 128 * 2;
const int MAXL = 256 * 2;
const long long INF = 1ll << 60;

long long val_stk[MAXN];
int sig_stk[MAXN];
int vsp, ssp;
long long ccost;
long long best = INF;

int state_stk[MAXN], stsp;
int best_states[MAXN], bsp;

int L, N;
int k[3];
char expr[MAXL];
int digs[MAXN];
int signs[MAXN];

int nd (long long a) {//number of digits
	return a ? (int)log10 (llabs (a)) + 1 : 1;
}

long long calc_res_cost (long long o1, long long o2, int op) {
	switch (op) {
		case 0: ccost += (nd (o1) + nd (o2)) * k[0]; return o1 + o2;
		case 1: ccost += (nd (o1) + nd (o2)) * k[1]; return o1 - o2;
		case 2: ccost += (nd (o1) * nd (o2)) * k[2]; return o1 * o2;
		default: assert (("sth bad!", 0));
	}
}

void rpn_bt (int pos) {
//	for (int i = 0; i < vsp; ++i) {printf ("%Ld ", val_stk[i]); if (i != vsp - 1) printf ("%c ", "+-*"[sig_stk[i]]);} puts ("");
//	for (int i = 0; i < stsp; ++i) printf ("%d ", state_stk[i]); puts ("states");
	if (ccost >= best) return;
	if (pos == N && vsp == 1) {
//		printf ("%Ld__\n", ccost);
		best = ccost;
//		for (int i = 0; i < stsp; ++i) printf ("%d ", state_stk[i]); puts ("");
		for (int i = 0; i < stsp; ++i) best_states[i] = state_stk[i];
		bsp = stsp;
		return;
	}

	if (vsp > 1) {
		long long o1 = val_stk[vsp-2];
		long long o2 = val_stk[vsp-1];
		vsp -= 2;
		int op = sig_stk[ssp-1];
		--ssp;
		long long old_cost = ccost;
		state_stk[stsp++] = 0;
		val_stk[vsp++] = calc_res_cost (o1, o2, op);
		rpn_bt (pos);
		--stsp;
		--vsp;
		ccost = old_cost;
		val_stk[vsp++] = o1;
		val_stk[vsp++] = o2;
		sig_stk[ssp++] = op;
	}
	if (pos != N) {
		val_stk[vsp++] = digs[pos];
		sig_stk[ssp++] = signs[pos-1];
		state_stk[stsp++] = 1;
		rpn_bt (pos + 1);
		--stsp;
		--vsp;
		--ssp;
	}
}

int tosign (char a) {
	switch (a) {
		case '+': return 0;
		case '-': return 1;
		case '*': return 2;
		default : assert (("bad input", 0));//there must be a problem with the input
	}
}

std::string make_str (int a) {
	return std::string (1, a + '0');
}
std::string make_str_sig (int a) {
	return std::string (1, "+-*"[a]);
}


void prnt () {
	static std::string stk[MAXN];
	static int dstk[MAXN], dsp;
	int stp = 0, cdp = 1;
	stk[stp++] = make_str (digs[0]);
	for (int i = 0; i < bsp; ++i) {
		if (best_states[i] == 0) {
			stk[stp-2] = std::string ("(") + stk[stp-2] + make_str_sig (dstk[dsp-1]);
			stk[stp-2] += stk[stp-1] + std::string (")");
			--stp;
			--dsp;
//			printf ("%s\n", stk[stp-1].c_str ());
		} else {
			stk[stp++] = make_str (digs[cdp]);
			dstk[dsp++] = signs[cdp-1];
			++cdp;
		}
	}
	assert (stp == 1);
	printf ("%s\n", stk[0].substr (1, stk[0].size () - 2).c_str ());
}

int main () {
	gets (expr); L = strlen (expr);
	int i;
	for (i = 0; i < 3; ++i) scanf ("%d", k + i);

	for (i = 0; i < L; i += 2)
		digs[i/2] = expr[i] - '0';
	for (i = 1; i < L; i += 2)
		signs[i/2] = tosign (expr[i]);
	N = L/2 + 1;//the number of digits

	val_stk[vsp++] = digs[0];
	rpn_bt (1);

	printf ("%Ld\n", best);
//	for (i = 0; i < bsp; ++i) printf ("%d ", best_states[i]); puts ("");
	prnt ();

	return 0;
}
