/*
FROM: NOI 2007 r1
PROB: expres
KEYW: dynamical programming
NOTE: wrong (author) solution
*/

#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <cstring>

const long long MAX = 1000000000000000;
const int MAXN = 128 * 2;
const int MAXL = 256 * 2;
const long long INF = 1ll << 60;

int N;
long long min[MAXN][MAXN];
long long max[MAXN][MAXN];

int L;
int k[3];
char expr[MAXL];
int digs[MAXN];
int signs[MAXN];

int tosign (char a) {
	switch (a) {
		case '+': return 0;
		case '-': return 1;
		case '*': return 2;
		default : printf ("__%c__\n", a); assert (("bad input", 0));//there must be a problem with the input
	}
}

int main (int argc, char *argv[]) {
	assert (argc == 2);
	freopen (argv[1], "r", stdin);
	gets (expr); L = strlen (expr);
	int i, j, d;
	for (i = 0; i < 3; ++i) scanf ("%d", k + i);

	for (i = 0; i < L; i += 2) {
		digs[i/2] = expr[i] - '0';
		printf ("pos %d -- _%c_\n", i, expr[i]);
	}
	for (i = 1; i < L; i += 2) {
		printf ("poss %d -- _%c_\n", i, expr[i]);
		signs[i/2] = tosign (expr[i]);
	}
	N = L/2 + 1;//the number of digits

	for (i = 0; i < N; ++i)
		min[i][i+1] = max[i][i+1] = digs[i];
	long long v1, v2, v3, v4;
	for (d = 2; d <= N; ++d)
		for (i = 0; i + d <= N; ++i) {//the interval we are calculating is [i, i + d) (digits)
			min[i][i+d] = INF;
			max[i][i+d] = -INF;
			for (j = i + 1; j < i + d; ++j) {//j shows the position of the sign which will split up the two parts [i,j) and [j;d)
				switch (signs[j-1]) {
					case 0: min[i][i+d] <?= min[i][j] + min[j][i+d]; max[i][i+d] >?= max[i][j] + max[j][i+d]; break;
					case 1: min[i][i+d] <?= min[i][j] - max[j][i+d]; max[i][i+d] >?= max[i][j] - min[j][i+d]; break;
					case 2: v1 = min[i][j] * min[j][i+d];
							v2 = min[i][j] * max[j][i+d];
							v3 = max[i][j] * min[j][i+d];
							v4 = max[i][j] * max[j][i+d];
							min[i][i+d] <?= v1 <? v2 <? v3 <? v4;
							max[i][i+d] >?= v1 >? v2 >? v3 >? v4;
				}
			}
			if (llabs (min[i][i+d]) > MAX || llabs (max[i][i+d]) > MAX) {
				printf ("min[%d][%d] == %Ld\n", i, i+d, min[i][i+d]);
				printf ("max[%d][%d] == %Ld\n", i, i+d, max[i][i+d]);
				assert (0);
			}
		}
	printf ("SEEMS CORRECT!\n");

	return 0;
}
