#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<climits>
using namespace std;
char s[256];
int k01, k02, k03;
long long int v[256][256][256];//[][][0] -- how many values does it 'remember', with the best "cost"
long long int e[256][256];//total payment
char t[256][256];//traversed (used)
int len;

int cif(long long int a)
{
 if(a==0) return 1;
 int v=0;
 a=abs(a);
 while(a>0) {v++;a=a/10;}
 return v;   
}

bool exist(int i1, int i2, long long int c)
{
 for(int k=1; k<=v[i1][i2][0]; k++)
  if(v[i1][i2][k]==c) return true;
 return false; 
}

void calc(int i1, int i2)
{ 
  if(t[i1][i2]) return;
  if(i1==i2)
   {
     v[i1][i2][0]=1;
     v[i1][i2][1]= (int)s[i1]-(int)'0';
     e[i1][i2]=0;
     t[i1][i2]=true; 
     return;
   }

  long long int m=INT_MAX; m=m*m;

  for(int i=i1+1;i<=i2-1;i+=2)
     {calc(i1,i-1); calc(i+1,i2); 
      for(int k1=1;k1<=v[i1][i-1][0];k1++)
      for(int k2=1;k2<=v[i+1][i2][0];k2++)
      {  
       long long int a,b,c,ca,cb,cc;
       a=v[i1][i-1][k1];
       b=v[i+1][i2][k2];
       ca=e[i1][i-1];
       cb=e[i+1][i2];
       switch (s[i])
       { 
         case '+' : c=a+b; cc=k01*(cif(a)+cif(b))+ca+cb; break;
         case '-' : c=a-b; cc=k02*(cif(a)+cif(b))+ca+cb; break;
         case '*' : c=a*b; cc=k03*(cif(a)*cif(b))+ca+cb; break;    
       }
      if(m>cc){m=cc;}
      }
     }  
  
  e[i1][i2]=m;
   
  for(int i=i1+1;i<=i2-1;i+=2)
     { 
      for(int k1=1;k1<=v[i1][i-1][0];k1++)
      for(int k2=1;k2<=v[i+1][i2][0];k2++)
      {  
       long long int a,b,c,ca,cb,cc;
       a=v[i1][i-1][k1];
       b=v[i+1][i2][k2];
       ca=e[i1][i-1];
       cb=e[i+1][i2];
       switch (s[i])
       { 
         case '+' : c=a+b; cc=k01*(cif(a)+cif(b))+ca+cb; break;
         case '-' : c=a-b; cc=k02*(cif(a)+cif(b))+ca+cb; break;
         case '*' : c=a*b; cc=k03*(cif(a)*cif(b))+ca+cb; break;    
       }
       if(cc==m)
        if(!exist(i1,i2,c))
         {v[i1][i2][0]++;
          if(v[i1][i2][0]>254) printf("error overflow!\n");
          v[i1][i2][v[i1][i2][0]]=c;
         }
      } 
     } 
   t[i1][i2]=true;       
} 
int main()
{ scanf("%s",s); 
  scanf("%d%d%d",&k01, &k02, &k03);
  len=strlen(s)-1;
//  printf("%s\n",s);
  calc(0, len); 
  printf("%d\n",e[0][len]); 
/*
  for(int i1=0;i1<=len;i1+=2)
  {
    for(int i2=0;i2<=len;i2+=2)
     if(i2<i1) printf("    ");
     else printf("%3d ",e[i1][i2]);
    printf("\n");
  }
 for(int i1=0;i1<=len;i1+=2)
  {
    for(int i2=0;i2<=len;i2+=2)
     if(i2<i1) printf("    ");
     else printf("%3d ",v[i1][i2][1]);
    printf("\n");
  }
 for(int i1=0;i1<=len;i1+=2)
  {
    for(int i2=0;i2<=len;i2+=2)
     if(i2<i1) printf("    ");
     else printf("%3d ",v[i1][i2][2]);
    printf("\n");
  }
*/
}
