#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 14;

struct p {
	int a, b;
};

int N;

p vec[MAXN];

bool cmp (const p &a, const p &b) {
	return (a.a == b.a ? a.b < b.b : a.a < b.a);
}

int main (int argc, char *argv[]) {
	int i;
	for (i = 0; scanf ("%d %d", &vec[i].a, &vec[i].b) != EOF; ++i);
	N = i;

	std::sort (vec, vec + N, cmp);
	for (i = 0; i < N; ++i)
		printf ("%d %d\n", vec[i].a, vec[i].b);

	return 0;
}
