/*
FROM: SPRING 2006 A
PROB: streets
KEYW: dynamical programming, combinations, HARD
*/

#include <cstdio>

const int MAXN = 1 << 10;
const int MOD = 4999999;

long long pow2[MAXN * MAXN];

int N;
long long all[MAXN];
long long res[MAXN];
long long ost[MAXN];

long long C[MAXN][MAXN];

int main () {
	scanf ("%d", &N);

	pow2[0] = 1;
	for (int i = 1, NN = N * N; i < NN; ++i) pow2[i] = (pow2[i-1] << 1) % MOD;

	for (int i = 0; i <= N; ++i) {
		C[i][0] = 1;
		for (int j = 1; j <= i; ++j)
			C[i][j] = (C[i-1][j-1] + C[i-1][j]) % MOD;
	}

	all[0] = all[1] = 1;
	ost[1] = 0;
	res[0] = res[1] = 1;
	for (int i = 2; i <= N; ++i) {
		for (int j = 1; j < i; ++j) {
			ost[i] += ((((C[i-1][j-1] * res[j]) % MOD) * all[i-j]) % MOD);
			ost[i] %= MOD;
		}

		all[i] = pow2[i * (i - 1) >> 1];

		res[i] = (all[i] - ost[i] + MOD) % MOD;
	}

	printf ("%Ld\n", res[N]);

	return 0;
}
