#include <vector>
#include <string>
#include <cmath>

using namespace std;

struct point {
	int x;
	int y;
};

double S (const point &a, const point &b, const point &c) {
/*	double aa = hypot (a.x - b.x, a.y - b.y);
	double bb = hypot (a.x - c.x, a.y - c.y);
	double cc = hypot (b.x - c.x, b.y - c.y);
	double p = (aa + bb + cc) / 2;
	return sqrt (p * (p-aa) * (p-bb) * (p-cc));
*/
	return abs ((b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x)) / 2.0;
}

point vec[1 << 6];
class BestTriangulation {
	public:
	double maxArea (vector <string> veci) {
		int N = veci.size ();
		int i, j, k;
		for (i = 0; i < N; ++i) {
			for (j = 0; j < veci[i].size () && veci[i][j] != ' '; ++j) {
				vec[i].x *= 10;
				vec[i].x += veci[i][j] - '0';
			}
			for (++j; j < veci[i].size (); ++j) {
				vec[i].y *= 10;
				vec[i].y += veci[i][j] - '0';
			}
//			printf ("%d %d\n", vec[i].x, vec[i].y);
		}
		double tmp;
		double best = 0;
		for (i = 0; i < N - 2; ++i)
			for (j = i + 1; j < N - 1; ++j)
				for (k = j + 1; k < N; ++k)
					if ((tmp = S (vec[i], vec[j], vec[k])) > best)
						best = tmp;
		return best;
	}
};