#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>

using namespace std;

int N;
int w[1 << 6];
int K;

bool can (int m) {
	int clen =0;
	int kleft = K;
	for (int i = 0; i < N; ++i) {
		if (w[i] > m) return 0;
		if ((clen += w[i] + 1) > m + 1)
			if ((--kleft) < 0)
				return 0;
			else
				clen = w[i] + 1;
	}
	return 1;
}

class SentenceSplitting {
	public:
	int split(string sentence, int _K) {
		K = _K;
		int i = 0, j =0;
		while (j != string::npos) {
			j = sentence.find (' ', i);
			if (j != string::npos) {
				w[N++] = j - i;
			} else
				w[N++] = sentence.size () - i;
			i = j + 1;
		}
		for (int i = 0; i < N; ++i) printf ("%d ", w[i]); printf ("\n");

		int l = 0, r = 1000, m;
		while (l + 1 < r) {
			m = (l + r) / 2;
			if (can (m))
				r = m;
			else
				l = m;

		}
		return r;
	}

	public:
};
