#include <cstdio>

const int MAXN = 300001;

int P[1000];
int opt[MAXN];

class CannonBalls {
	public:
	int fewestPiles (int n) {
		P[0] = 1;
		int tmp = 1;

		int i, j, k;
		for (i = 1;; ++i) {
			tmp += i + 1;
			P[i] = P[i-1] + tmp;
			if (P[i] > n) break;
//			printf ("%d\n", P[i]);
		}
		int N = i;

		for (i = 0; i < N; ++i) {
			opt[P[i]] = 1;
			if (P[i] == n) return 1;
		}

		for (k = 2;; ++k)
			for (i = n; i >= 0; --i)
				for (j = 0; j < N; ++j)
					if (opt[i] == k-1 && i + P[j] <= n) {
						opt[i + P[j]] = k;
						if (i + P[j] == n) return k;
					}
		return -1;
	}
};
