#include <cstdio>
#include <string>
#include <vector>
#include <queue>

using namespace std;

struct state {
	int x, y;
	int h;
	int p;
	state () {}
	state (int _x, int _y, int _h, int _p) : x (_x), y (_y), h (_h), p (_p) {}
};

queue <state> q;

int dx[] = {-1, 0, 1, 0, 0};
int dy[] = {0, 1, 0, -1, 0};

bool used[50][50][101][11];

int mytime = 0;


class ShrinkingPills {
	public:
	int escape (int pc, int ps, int ds, int dh, vector <string> lab) {
		int i, j =0;
		for (i = 0; i < lab.size (); ++i)
			for (j = 0; j < lab[i].size (); ++j)
				if (lab[i][j] == '@')
					goto lbl1;
		lbl1:;

		q.push (state (i, j, 100, pc));
		int cc =1, nc =0;
		state c;
		state css;
		used[i][j][100][pc] = 1;

		while (cc && mytime < 1200) {
			for (i = 0; i < cc; ++i) {
				c = q.front (); q.pop ();
//				printf ("%d %d %d %d\n", c.x, c.y, c.h, c.p);

				if (lab[c.x][c.y] == 'E') return mytime;

				for (j = 0; j < 5; ++j) {
					if (lab[c.x + dx[j]][c.y + dy[j]] == '#') continue;

					if (c.p && c.h == 100 && (lab[c.x + dx[j]][c.y + dy[j]] != 'X' || dh - (mytime + 1) * ds >= c.h - ps)) {
						css = state (c.x + dx[j], c.y + dy[j], c.h - ps, c.p - 1);
						if (!used[css.x][css.y][css.h][css.p]) {
							used[css.x][css.y][css.h][css.p] = 1;
							q.push (css);
							++nc;
						}
					}

					if (lab[c.x + dx[j]][c.y + dy[j]] != 'X' || dh - (mytime + 1) * ds >= ((c.h == 100 || c.h - ps <= 0) ? 100 : c.h - ps)) {
						css = state (c.x + dx[j], c.y + dy[j], ((c.h == 100 || c.h - ps <= 0) ? 100 : c.h - ps), c.p);
						if (!used[css.x][css.y][css.h][css.p]) {
							used[css.x][css.y][css.h][css.p] = 1;
							q.push (css);
							++nc;
						}
					}
				}
			}
			++mytime;
//			printf ("***** %d *****\n", mytime);
			cc = nc;
			nc = 0;
		}
		printf ("%d\n", mytime);
		return -1;
	}
};