#include <cstdio>
#include <vector>
#include <string>

using namespace std;

int difx [] = {1, 0, -1, 0};
int dify [] = {0, 1, 0, -1};

bool used[64][64];
vector <string> maze;

int res;
int N, M;
void dfs (int x, int y) {
	if (x < 0 || x >= N || y < 0 || y >= M) return;
	if (maze[x][y] == '#') {++res; return;}
	if (used[x][y]) return;
	used[x][y] = 1;
	for (int i = 0; i < 4; ++i)
		dfs (x + difx[i], y + dify[i]);
}

class TroytownKeeper {
	public:
	int limeLiters(vector <string> _maze) {
		maze = _maze;
		N = maze.size ();
		M =  maze[0].size ();
		for (int i = 0; i < N; ++i) {
			dfs (i, 0);
			dfs (i, M - 1);
		}
		for (int i = 0; i < M; ++i) {
			dfs (0, i);
			dfs (N-1, i);
		}
		return res;
	}

};

int main () {
	TroytownKeeper k;
	vector <string> vv(4);
	vv[0] = string ("#.#.#.#");
	vv[1] = string (".#.#.#.");
	vv[2] = string ("#.#.#.#");
	vv[3] = string (".#.#.#.");
	printf ("%d\n", k.limeLiters (vv));
}
