#include <cstdio>
#include <algorithm>
#include <cassert>
#include <cstring>

using std::swap;

long long dp[64][64][128];
const long long MOD = 1000001;

long long dpf (int n, int m, int k) {
	if (n > m) swap (n, m);
	if (dp[n][m][k] != -1) {
//		printf ("%Ld\n", dp[n][m][k]);
		return dp[n][m][k];
	}
//	printf ("dfp  %d %d %d --- ", n, m, k);

	if (k == 0) {
//		printf ("1 x\n");
		return dp[n][m][k] = 1;
	}
	if (n == 0 || m == 0) {
//		printf ("0 xx\n");
		return dp[n][m][k] = 0;
	}

	if (k == 1) {
//		printf ("%d xxx\n", n * m);
		return dp[n][m][k] = n * m;
	}
	if (n == 1) {
		if (k > 2 || k > m) {
//			printf ("0 y\n");
			return dp[n][m][k] = 0;
		}
		if (k == 1) {
//			printf ("%d yy\n", m);
			return dp[n][m][k] = m;
		}
//		printf ("%d yyy\n", m * (m-1) / 2);
		return dp[n][m][k] = m * (m-1) / 2;
	}
	assert (n > 1 && m > 1);

	dp[n][m][k]
	      =	dpf (n-1, m, k)
		  + dpf (n-1, m-2, k-2) * m * (m - 1) / 2
		  + dpf (n-1, m-1, k-1) * m
		  + dpf (n-2, m-1, k-2) * (n - 1) * m;

//	printf ("%Ld XX\n", dp[n][m][k]);
	return dp[n][m][k] %= MOD;
}

class RooksPlacement {
	public:
	int countPlacements(int N, int M, int K) {
		memset (dp, -1, sizeof (dp));
		if (N > M) swap (N, M);
//		dpf (N, M, K);
		int i, j, k;
/*
		for (i = 0; i <= N; ++i)
			for (j = i; j <= M; ++j)
				for (k = 0; k <= K; ++k)
					dpf (i, j, k);
*/	
//		dpf (2, 3, 2);
/*
		for (i = 0; i <= 5; ++i) {
			for (j = 0; j < i; ++j)
				printf ("(--- ---)");
			for (j = i; j <= 5; ++j)
				printf ("(%3Ld %3Ld)", dp[i][j][1], dp[i][j][2]);
			puts ("");
		}*/
		dpf (N, M, K);
		return dp[N][M][K];
	}
};


int main () {
	RooksPlacement x;
	printf ("%d\n", x.countPlacements (23, 37, 39));
	return 0;
}
