#include <cstdio>
#include <vector>
#include <string>

using namespace std;

const int MAXN = 1 << 4;
vector <string> w;

int ma3x[MAXN][MAXN];
bool in[MAXN][MAXN];

int N;
string opt[1<<12][12];

string CMP (string a, string b) {
	return a.size () != b.size () ?
			a.size () < b.size () ?
			a : b
	 	:
	 		a < b ? a : b;
}

string f (int a, int b) {
	if (a == (1 << N) - 1) return w[b];
	else if (opt[a][b] != string ()) return opt[a][b];

	string best(1000, 'Z');
	for (int i = 0; i < N; ++i)
		if (!(a & (1 << i)))
			best = CMP (f (a | (1 << i), i).substr (ma3x[b][i]), best);

	return opt[a][b] = w[b] + best;
}

class JoinedString {
	public:
	string joinWords(vector <string> _words) {
		int i, j, k;
		bool nok[MAXN] = {0};
		std::sort (_words.begin (), _words.end ());
		_words.resize (std::unique (_words.begin (), _words.end ()) - _words.begin ());
		N = (int)_words.size ();

		for (i = 0; i < N; ++i)
			for (j = 0; j < N; ++j)
				if (i != j && _words[i].find (_words[j]) != -1u)
					nok[j] = 1;

		for (i = 0; i < N; ++i)
			if (!nok[i])
				w.push_back (_words[i]);

		N = w.size ();
		for (i = 0; i < N; ++i)
			for (j = 0; j < N; ++j) {
				if (i == j) continue;
				for (k = w[j].size () <? w[i].size (); k >= 0; --k)
					if (w[i].substr (w[i].size () - k) == w[j].substr (0, k)) {
						ma3x[i][j] = k;
						break;
					}
			}

		string best(1000, 'Z');
		for (i = 0; i < N; ++i)
			best = CMP (f (1 << i, i), best);

		return best;
	}
};

///END
vector <string> inp;

int main () {
	inp.push_back (string ("OFG"));
	inp.push_back (string ("SDOFGJTILM"));
	inp.push_back ( string ("KBWNF"));
	inp.push_back (string ("YAAPO"));
	inp.push_back (string ("AWX"));
	inp.push_back (string ("VSEAWX"));
	inp.push_back (string ("DOFGJTIL"));
	inp.push_back (string ("YAA"));

	JoinedString a;
	printf ("%s\n", a.joinWords (inp).c_str ());

	return 0;
}
