/*
TASK:crazy
LANG:C++
*/

#include <vector>
#include <cstring>

#include "crazy.h"

using namespace std;

int dp[601][601], mov[601][601][2];
vector<short> e[601];

void buildGraph(void)
{
  int i, j, k;
  for(i=2; i<=600; ++i)
    for(j=1; i*j<=600; ++j)
      for(k=j+1; i*k<=600; ++k)
      {
        e[i*k].push_back(i*j);
        //printf("%ld %ld\n",i*k, i*j);
      }
}

void calcDP(void)
{
  int s, i, j, t, c;
  for(s=4; s<=1000; ++s)
    for(i=2; i<=600; ++i)
    {
      j=s-i;
      if(j<2 || j>600)
        continue;
      dp[i][j]=0x7FFFFFFD;
      for(c=0; c<(int)e[j].size(); ++c)
      {
        t=dp[i+1][e[j][c]];
        if(t%2 && (t<dp[i][j] || dp[i][j]%2))
        {
          dp[i][j]=t+1;
          mov[i][j][0]=i+1;
          mov[i][j][1]=e[j][c];
        }
        if(t%2==0 && dp[i][j]%2 && t<dp[i][j])
        {
          dp[i][j]=t+1;
          mov[i][j][0]=i+1;
          mov[i][j][1]=e[j][c];
        }
      }
      for(c=0; c<(int)e[i].size(); ++c)
      {
        t=dp[e[i][c]][j+1];
        if(t%2 && (t<dp[i][j] || dp[i][j]%2))
        {
          dp[i][j]=t+1;
          mov[i][j][0]=e[i][c];
          mov[i][j][1]=j+1;
        }
        if(t%2==0 && dp[i][j]%2 && t<dp[i][j])
        {
          dp[i][j]=t+1;
          mov[i][j][0]=e[i][c];
          mov[i][j][1]=j+1;
        }
      }
      if(dp[i][j]==0x7FFFFFFD)
        dp[i][j]=1;
    }
}

int main(void)
{
  int x, y;
  buildGraph();
  memset(dp, -1, sizeof dp);
  calcDP();
  while(1)
  {
    getnum(&x, &y);
    setnum(mov[x][y][0], mov[x][y][1]);
  }
  return 0;
}

