#include <cstdio>
#include <queue>

const int MAXN = 800;
const int MAXM = 4000;
const int MAXK = 40;

struct el {
	int to;
	int dist;
	int next;
	el () {}
	el (int _to, int _dist, int _next) : to (_to), dist (_dist), next (_next) {}
};

struct heap {
	int id;
	int dist;
	heap () {}
	heap (int _id, int _dist) : id (_id), dist (_dist) {}
	bool operator < (const heap &a) const {return dist > a.dist;}//inverted
};

int K, N, M;

int vec[MAXN];
el buf[MAXM * 2];

int res;

int in_h[MAXN][MAXK];
int in_hc[MAXN];

bool can_put (int el, int val) {
	return 1;
	if (in_hc[el] == 0) {in_h[el][in_hc[el]++] = val; return 1;}

	int i;
	if (in_hc[el] < K) {
		i = in_hc[el] - 1;
		goto putit;
	}

	if (in_h[el][K - 1] <= val) return 0;
	i = K-2;
	putit:;
	for (; i >= 0 && in_h[el][i] > val; --i)
		in_h[el][i + 1] = in_h[el][i];

	in_h[el][i + 1] = val;
	return 1;
}

void dijkstra () {
	std::priority_queue <heap> h;
	int needed = K;

	h.push (heap (0, 0));
	in_h[0][in_hc[0]++] = 0;

	unsigned maxsize =0, heap_pops =0, heap_pushs =0;
	FILE *out = fopen ("log", "w");

	int popedcnt[MAXN] = {0};

	heap crnt;
	while (needed) {
		crnt = h.top (); h.pop ();
		++heap_pops;

		if (++popedcnt[crnt.id] > K) continue;
//		fprintf (out, "%d ", crnt.id);
		if (h.size () > maxsize) maxsize = h.size ();
		if (crnt.id == N - 1) {//gone to the destination
			res += crnt.dist;
			--needed;
		} else
			for (int i = vec[crnt.id]; i != -1; i = buf[i].next)
				if (can_put (buf[i].to, buf[i].dist + crnt.dist)) {
					h.push (heap (buf[i].to, crnt.dist + buf[i].dist));
					++heap_pushs;
				}
	}
	fprintf (out, "\n%d %d %d -> %u %u %u\n", N, M, K, heap_pushs, heap_pops, maxsize);
	fclose (out);
}

int main () {
	scanf ("%d %d %d", &K, &N, &M);

	int i;
	int a, b, d;
	int bp =0;
	for (i = 0; i < N; ++i) vec[i] = -1;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d %d", &a, &b, &d);
		--a; --b;

		buf[bp] = el (b, d, vec[a]);
		vec[a] = bp++;

		buf[bp] = el (a, d, vec[b]);
		vec[b] = bp++;
	}

	dijkstra ();

	printf ("%d\n", res);

	return 0;
}
