/*
FROM: USACO 2002 FEBRUARY GREEN
PROB: fiber
KEYW: graph, full exhaustion
*/

#include <cstdio>

const int MAXN = 1 << 10;
const int MAXM = 1 << 15;

struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};

int N, M;

int vec[MAXN * 2];
el buf[MAXM];

int trf (int a, int b) {
	if (a > b) return a;
	else {
		while ((a += N) < b);
		return a;
	}
}

int main () {
//	FILE *in = fopen ("fiber.in", "r");
	FILE *in = stdin;
	fscanf (in, "%d %d", &N, &M);

	int bp =0;
	int a, b;
	int i;
	for (i = 0; i < N; ++i) vec[i] = -1;
	for (i = 0; i < M; ++i) {
		fscanf (in, "%d %d", &a, &b);
		--a; --b;

		buf[bp] = el (b, vec[a]);
		vec[a] = bp++;

		buf[bp] = el (a, vec[b]);
		vec[b] = bp++;
	}
	fclose (in);
/*
	for (i = 0; i < N; ++i) {
		printf ("%d ->", i);
		for (int j = vec[i]; j != -1; j = buf[j].next)
			printf (" %d", buf[j].to);
		printf ("\n");
	}
*/
	for (i = N; i < 2 * N; ++i)
		vec[i] = vec[i - N];

	int farmost, beg;
	int ccnt;
	int best = MAXN;
	int j, k;
	int trfed;
	for (i = 0; i < N; ++i) {
		ccnt = 0;
		farmost = i;
		beg = i;
//		printf ("--%d\n", i);
		for (;;) {
//			printf ("\tbeg == %d\n", beg);
			for (j = beg; j <= farmost; ++j)
				for (k = vec[j]; k != -1; k = buf[k].next)
					if ((trfed = trf (buf[k].to, j)) > farmost && trfed < i + N) {
//						printf ("\tfrom %d extended to %d\n", j, trfed);
						farmost = trfed;
					}/* else {
						printf ("\t%d -- %d\n", j, trfed);
					}*/
//			printf ("\tend == %d\n", farmost);
			ccnt += farmost - beg;
			beg = farmost + 1;
			farmost = beg;
			if (beg >= i + N) break;
		}
		if (beg > i + N) printf ("wowow! %d %d\n", beg, i + N);
//		printf ("ccnt = %d\n", ccnt);
		if (ccnt < best)
			best = ccnt;
	}

	printf ("%d\n", best);

	return 0;
}
