/*
FROM: USACO 2002 JANUARY GREEN
PROB: pasture
KEYW: full exhaustion
*/

#include <cstdio>
#include <cstdlib>

const int MAXN = 1 << 12;

int N;
int sum[MAXN];

int main () {
//	FILE *in = fopen ("pasture.in", "r");
	FILE *in = stdin;
	fscanf (in, "%d", &N);

	int i, j;
	for (i = 1; i <= N; ++i) {
		fscanf (in, "%d", sum + i);
		sum[i] += sum[i - 1];
	}
	fclose (in);

	int min = 1 << 22;
	int mini, minj;
	int tmp;
	for (i = N; i >= 1; --i)
		for (j = i; j <= N; ++j)
			if (min > (tmp = abs (sum[j] - sum[i - 1])) || min == tmp && minj - mini < j - i) {
				min = tmp;
				mini = i;
				minj = j;
			}

//	FILE *out = fopen ("pasture.out", "w");
	FILE *out = stdout;
	fprintf (out, "%d %d %d\n", mini, minj, min);

//	printf ("%d %d\n", abs (sum[25] - sum[1]), abs (sum[434] - sum[110]));
	fclose (out);

	return 0;
}
