/*
FROM: USACO 2002 OPEN GREEN
PROB: majesty
KEYW: sort and linear
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 17;

struct el {
	int l;
	int r;
	el () {}
	el (int _l, int _r) : l (_l), r (_r) {}
};

int N;
el vec[MAXN];

bool cmp (const el &a, const el &b) {
	return a.l < b.l;
}

int sqr (int a) {
	return a * a;
}

int S (int a) {
	return sqr (vec[a].r - vec[a].l);
}

int S (int l, int r) {
	return sqr (r - l);
}

int main () {
	scanf ("%d", &N);

	int i;
	for (i = 0; i < N; ++i)
		scanf ("%d %d", &vec[i].l, &vec[i].r);

	std::sort (vec, vec + N, cmp);

	int cs = S (0);
	int pr = vec[0].r;
	for (i = 1; i < N; ++i)
		if (vec[i].r > pr) {
			if (vec[i].l < pr)
				cs -= S (vec[i].l, pr);
			cs += S (i);
			pr = vec[i].r;
		}
	printf ("%d\n", cs);

	return 0;
}
