/*
FROM: USACO 2006 FEBRUARY GOLD
ID: iskren81
PROB: bdsum
LANG: C++
KEYW: full exhaustion
*/

#include <cstdio>
#include <cstdlib>
#include <algorithm>

const int MAXN = 1 << 4;//16;

int N;
int TARG;
int bc[MAXN];
int vec[MAXN];

inline void try_vec () {
	static int i;
	static int sum; sum = 0;
	for (i = 0; i < N; ++i)
		sum += vec[i] * bc[i];
	if (sum == TARG) {
		FILE *out = fopen ("bdsum.out", "w");
		fprintf (out, "%d", vec[0]);
		for (i = 1; i < N; ++i)
			fprintf (out, " %d", vec[i]);
		fprintf (out, "\n");
		exit (0);
	}
}

int main () {
	FILE *in = fopen ("bdsum.in", "r");
//	FILE *in = stdin;
	fscanf (in, "%d %d", &N, &TARG);
	fclose (in);

	bc[1] = 0;
	bc[0] = 1;
	int i, j;
	for (i = 2; i <= N; ++i)
		for (j = i; j > 0; --j)
			bc[j] += bc[j-1];

	for (i = 0; i < N; ++i)
		vec[i] = i + 1;

	do
		try_vec ();
	while (std::next_permutation (vec, vec + N));

	return 0;
}
