/*
FROM: USACO 2006 MARCH GOLD
PROB: skilift
KEYW: bfs
ID: iskren81
LANG: C++
*/

#include <cstdio>
#include <vector>

const int MAXN = 1 << 13;

int N, K;
int h[MAXN];
std::vector <std::vector <int> > vec;

int main () {
	freopen ("skilift.in", "r", stdin);
	freopen ("skilift.out", "w", stdout);

	scanf ("%d %d", &N, &K);

	int i, j;
	for (i = 0; i < N; ++i)
		scanf ("%d", h + i);

	int x, y;
	vec.resize (N);
	for (i = 0; i < N; ++i) {
		vec[i].push_back (i + 1);//you can always go to the next one
		x = 1; y = h[i + 1] - h[i];
		for (j = 2; j <= K && i + j < N; ++j) {
			if ((long long)x * (long long)(h[i + j] - h[i]) >= (long long)y * (long long)j) {
				vec[i].push_back (i + j);
				y = h[i + j] - h[i];
				x = j;
			}
		}
	}
/*
	for (i = 0; i < N; ++i) {
		printf ("%d ->", i);
		for (j = 0; j < (int)vec[i].size (); ++j)
			printf ("%d ", vec[i][j]);
		printf ("\n");
	}
*/
	int queue[MAXN];
	int p1 =0, p2 =1, p3 =0, lvl =1;
	int crnt;
	queue[p3++] = 0;
	bool used[MAXN] = {0};
	used[0] = 1;

	while (p1 != p2) {
		for (i = p1; i < p2; ++i) {
			crnt = queue[i];
//			printf ("%d (%d)(%d)\n", crnt, lvl, N);
			if (crnt == N - 1) goto end;
			for (j = 0; j < (int)vec[crnt].size (); ++j) {
//				printf ("try %d\n", vec[crnt][j]);
				if (!used[vec[crnt][j]]) {
//					printf ("add %d\n", vec[crnt][j]);
					used[vec[crnt][j]] = 1;
					queue[p3++] = vec[crnt][j];
				}
			}
		}
		p1 = p2;
		p2 = p3;
		++lvl;
	}

	end:;
	printf ("%d\n", lvl);

	return 0;
}
