/*
FROM: USACO 2006 November Gold
TASK: cowfood
LANG: C++
ID: iskren81
KEYW: dynamical programming with mask
*/

#include <cstdio>
#include <cassert>
#include <algorithm>

const int MAXN = 1 << 4;
const int MAXMASK = 1 << 12;
const int MOD = 100000000;

int N, M;
bool board[MAXN][MAXN];
int _dp[2][MAXMASK];
int *old = _dp[0], *crnt = _dp[1];

int main () {
	FILE *in = fopen ("cowfood.in", "r");
	FILE *out = fopen ("cowfood.out", "w");

	fscanf (in, "%d%d", &N, &M);

	register int i, j, k, UB = 1 << N;
	for (i = 0; i < N; ++i)
		for (j = 0; j < M; ++j) {
			fscanf (in, "%d", &board[i][j]);
		}

	for (k = 0; k < UB; ++k) old[k] = 1;
	for (j = M-1; j >= 0; --j)
		for (i = N-1; i >= 0; --i) {
			for (k = 0; k < UB; ++k) {
				crnt[k] = old[k & ~(1 << i)];
				if (board[i][j] && !(k & 1 << i || i && k & 1 << i-1))
					crnt[k] += old[k | 1 << i];
				if (crnt[k] >= MOD) crnt[k] -= MOD;
			}
			std::swap (old, crnt);
		}

	fprintf (out, "%d\n", old[0]);
	return 0;
}
