/*
ID: iskren81
LANG: C++

FROM: USACO 2007 FEBRUARY
PROB: csort
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 14;

int N;
int row[MAXN];
int _idx[MAXN];
int idx[MAXN];
bool used[MAXN];

bool cmp (int a, int b) {
	return row[a] < row[b];
}

int main () {
	freopen ("csort.in", "r", stdin);
	freopen ("csort.out", "w", stdout);

	scanf ("%d", &N);

	int i, j;
	for (i = 0; i < N; ++i) {
		scanf ("%d", row + i);
		_idx[i] = i;
	}

	std::sort (_idx, _idx + N, cmp);

	int overall_min = row[_idx[0]];
	for (i = 0; i < N; ++i) idx[_idx[i]] = i;
//	for (i = 0; i < N; ++i) printf (" %d", idx[i]); printf ("\n");

	int res = 0;
	int sum, min, k;
	for (i = 0; i < N; ++i) {
		if (used[i] || idx[i] == i) continue;

		sum = k = 0; min = 1 << 20;
		for (j = i; !used[j]; j = idx[j]) {
			used[j] = 1;
			sum += row[j];
			min <?= row[j];
			++k;
		}
//		printf ("%d %d %d -- %d %d\n", sum, min, overall_min, (sum + min * (k - 2)), (sum + overall_min * (k + 1) + min));
		res += (sum + min * (k - 2)) <? (sum + overall_min * (k + 1) + min);
	}

	printf ("%d\n", res);

	return 0;
}
