/*
TASK:storage
LANG:C++
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 8;

struct box {
	int w;
	int h;
};

int Wid, Stc;
box data[MAXN];
int H[MAXN];

int ma3x[MAXN][MAXN];

bool cmp (const box &a, const box &b) {
	return a.h < b.h;
}

int main () {
	scanf ("%d %d", &Stc, &Wid);

	int i;
	for (i = 0; i < Stc; ++i)
		scanf ("%d %d", &data[i].w, &data[i].h);


	for (i = 0; i < Wid; ++i)
		scanf ("%d", H + i);

	std::sort (data, data + Stc, cmp);

	int diff;
	int j;
	int S;
	for (i = 0; i < Stc; ++i) {
		S = data[i].h * data[i].w;
//		printf ("now %d %d\n", data[i].h, data[i].w);
		for (diff = data[i].w; diff <= Wid; ++diff)
			for (j = 0; j + diff <= Wid; ++j) {
//				printf ("-%d %d\n", j, j + diff);
				//put <--
				if (H[j] >= data[i].h && H[j + data[i].w - 1] >= data[i].h) {
					ma3x[j + data[i].w][j + diff] >?= ma3x[j][j+diff] + S;
//					printf ("-->%d %d(%d)\n", j + data[i].w, j + diff, ma3x[j + data[i].w][j + diff]);
				}

				//put -->
				if (H[j + diff - 1] >= data[i].h && H[j + diff - data[i].w] >= data[i].h) {
					ma3x[j][j + diff - data[i].w] >?= ma3x[j][j+diff] + S;
//					printf ("-->%d %d(%d)\n", j, j + diff - data[i].w, ma3x[j][j + diff - data[i].w]);
				}
			}
	}

	int res = -1;
	for (diff = 0; diff <= Wid; ++diff)
		for (j = 0; j + diff <= Wid; ++j)
			res >?= ma3x[j][j+diff];

	printf ("%d\n", res);
	return 0;
}
