/*
ID: iskren81
PROB: heritage
LANG: C++
*/

#include <cstdio>
#include <cstdlib>
#include <cstring>

const int MAXLEN = 1 << 5;

char iorder[MAXLEN];
char porder[MAXLEN];

struct node {
	char k;
	node *left;
	node *right;
	node () {}
	node (char kk, node *ll, node *rr) : k (kk), left (ll), right (rr) {}
};

node* constr (int il, int ir, int pl, int pr) {
//	printf ("%d %d %d %d\n", il, ir, pl, pr);

	if (il == ir)
		return 0;
	else if (il + 1 == ir)
		return new node (iorder[il], 0, 0);
	
	int i;
	for (i = il; i < ir; ++i)
		if (iorder[i] == porder[pl])
			break;
	if (i == ir) {printf ("wow!\n"); exit (-1);}
//	printf ("\t%d %d %d %d  %d %d %d %d\n", il, i, pl + 1, pl + 1 + (i - il), i + 1, ir, pl + 1 + (i-il), pr);
	return new node (porder[pl], constr (il, i, pl + 1, pl + 1 + (i - il)), constr (i + 1, ir, pl + 1 + (i-il), pr));
}

void postdfs (node *a) {
	if (!a) return;
	postdfs (a->left);
	postdfs (a->right);
	printf ("%c", a->k);
}

int main () {
	FILE *in = fopen ("heritage.in", "r");

	fgets (iorder, MAXLEN, in);
	fgets (porder, MAXLEN, in);
	fclose (in);

	int n = strlen (iorder) - 1;

	node *head = constr (0, n, 0, n);
	freopen ("heritage.out", "w", stdout);
	postdfs (head);
	printf ("\n");

	return 0;
}
