/*
FROM: BalticOI 1997 day 1
PROB: basket
KEYW: sorting
*/

#include <iostream>
#include <string>
#include <map>

const int MAXN = 1 << 9;
const int MAXLEN = 1 << 10;

int N, NN;
int srt[MAXN];
int wins[MAXN];
int mwins[MAXN];
int dif[MAXN];
int tot[MAXN];
int score[MAXN][MAXN];
std::string xx[MAXN];

bool cmp1 (int a, int b) {
	return wins[a] > wins[b];
}

bool cmp2 (int a, int b) {
	return 	mwins[a] != mwins[b] ?
				mwins[a] > mwins[b] :
				dif[a] != dif[b] ?
					dif[a] > dif[b] :
					tot[a] > tot[b];
}

void get_info (std::string &s1, std::string &s2, int &r1, int &r2) {
	static char line[MAXLEN];
	fgets (line, MAXLEN, stdin);
/*	p = strtok (line, "-");
	printf ("_%s_\n", p); fflush (stdout);
	p = strtok (0, " ");
	printf ("_%s_\n", p); fflush (stdout);*/
	s1 = std::string (strtok (line, "-"));
	s2 = std::string (strtok (0, " "));
	sscanf (strtok (0, ""), "%d:%d", &r1, &r2);
//	printf ("%s .. %s  %d  %d\n", s1.c_str (), s2.c_str (), r1, r2);
}

int main () {
	std::string s1, s2;
	int r1, r2;
	std::map <std::string, int> db;
	int id1, id2;
	static int i, cN = 0;
	scanf ("%d\n", &N);
	NN = N * (N - 1) / 2;
	for (i = 0; i < NN; ++i) {
		get_info (s1, s2, r1, r2);
		if (db.find (s1) == db.end ()) {db[s1] = cN, xx[cN++] = s1;}
		if (db.find (s2) == db.end ()) {db[s2] = cN, xx[cN++] = s2;}
		id1 = db[s1];
		id2 = db[s2];
		score[id1][id2] = r1;
		score[id2][id1] = r2;
		++wins[r1 < r2 ? id2 : id1];
	}
	for (i = 0; i < N; ++i) srt[i] = i;
	std::sort (srt, srt + N, cmp1);

	int beg = 0;
	static int buf[MAXN], bp = 0;
	buf[bp++] = srt[0];
	srt[N] = N+1;
	wins[N+1] = -1;//beat this ;)
	for (i = 1; i <= N; ++i) {
		if (wins[srt[beg]] == wins[srt[i]])
			buf[bp++] = srt[i];
		else {
			if (bp == 1) goto set;
			static int ii, jj;
			for (ii = 0; ii < bp; ++ii)
				for (jj = ii + 1; jj < bp; ++jj) {
					++mwins[score[buf[ii]][buf[jj]] > score[buf[jj]][buf[ii]] ? buf[ii] : buf[jj]];
					dif[buf[ii]] += score[buf[ii]][buf[jj]] - score[buf[jj]][buf[ii]];
					dif[buf[jj]] += score[buf[jj]][buf[ii]] - score[buf[ii]][buf[jj]];
					tot[buf[ii]] += score[buf[ii]][buf[jj]];
					tot[buf[jj]] += score[buf[jj]][buf[ii]];
				}
			std::sort (srt + beg, srt + i, cmp2);
			set:;
			beg = i;
			bp = 0;
			buf[bp++] = srt[i];
		}
	}

	for (i = 0; i < N; ++i)
		std::cout << xx[srt[i]] << std::endl;

	return 0;
}
