/*
FROM: BalticOI 1998 day 2
PROB: baltic codes (baltco)
KEYW: coding
*/

#include <cstdio>

const int LINE_SIZE = 16;
const int LINES_PER_LETTER = 16;
const int LETTERS = 1;

const int LINES_CNT = LETTERS * LINES_PER_LETTER;
const int MAXCH = LINES_CNT * LINE_SIZE;

int vec[MAXCH], vp;

int main () {
	int i, j;
	int c = 0;
	int cbit;
	for (i = 0; i < LINES_CNT; ++i) {
		for (j = 0; j < LINE_SIZE; ++j) {
			cbit = getchar () - '0';
			if (cbit == c)
				++vec[vp];
			else {
				++vec[++vp];
				c = cbit;
			}
		}
		getchar ();//eats '\n'
	}
	++vp;

	int _big = 0;
	for (i = 0; i < vp; ++i) {
		printf ("%d ", vec[i]);
		if (vec[i] >= 10) ++_big;

	}
	printf ("\n%d %d\n", vp, _big);


	for (i = 0; i < vp; ++i) {
		if (vec[i] < 100)
			printf ("%02d", vec[i]);
		else if (vec[i] < 200) {
			if (vec[i] < 105) {
				printf ("99");
				if (i == vp - 1)
					vec[vp++] = vec[i] - 99;
				else
					vec[i+1] = vec[i] - 99;
			} else
				printf ("9901%02d", vec[i] - 100);
		} else {
			if (vec[i] < 204)
				printf ("99%02d99", vec[i] - 198);
			else
				printf ("99019901%02d", vec[i] - 200);
		}
	}
	printf ("\n");

	return 0;
}
