/*
FROM: BalticOI 1999 day 2
PROB: delivery
KEYW: dynamical programming, ad hoc
*/

#include <cstdio>

const int MAXDL = 1 << 10;
const int MAXS = 1 << 9;
const int MAXL = 1 << 9;

int DL;
int S;
int L;

int sp[MAXS];
int lp[MAXL];
int ll[MAXDL];
short dp[MAXDL][MAXDL];

short f (int v, int l, int pos) {
	if (dp[v][l] != -1) return dp[v][l];
	if (pos != S) {
		if (v + sp[pos] <= DL) dp[v][l] >?= f (v + sp[pos], l, pos + 1);
		if (l + sp[pos] <= DL) dp[v][l] >?= f (v, l + sp[pos], pos + 1);
	}

	return dp[v][l] >?= pos + ll[DL-l];
}

int main () {
	scanf ("%d", &DL);
	scanf ("%d", &S);
	int i;
	for (i = 0; i < S; ++i)
		scanf ("%d", sp + i);
	scanf ("%d", &L);
	for (i = 0; i < L; ++i)
		scanf ("%d", lp + i);
	lp[L] = MAXDL;//sure will overflow

	int csum = lp[0];
	int cp = 1;
	ll[0] = 0;
	for (i = 1; i <= DL; ++i)
		if (i == csum) {
			ll[i] = ll[i-1] + 1;
			csum += lp[cp++];
		} else
			ll[i] = ll[i-1];

	for (i = 0; i <= DL; ++i)
		for (int j = 0; j <= DL; ++j)
			dp[i][j] = -1;

	f (0, 0, 0);

	printf ("%d\n", (int)dp[0][0]);

	return 0;
}
