/*
FROM: BalticOI 1999 day 1
PROB: expression
KEYW: dynamical programming
*/

#include <cstdio>
#include <cstring>

const int MAXD = 1 << 5;//19

int L, D;
long long dp[2][MAXD];

int fdp (int D) {
	int i, j;
	memset (dp, 0, sizeof (dp));
	dp[L & 1][0] = 1;
	for (i = L-1; i >= 0; --i)
		for (j = 0; j <= D; ++j) {
			dp[i & 1][j] = 0;
			if (L - i > j && j < D)
				dp[i & 1][j] += dp[!(i & 1)][j+1];//open
			if (j)
				dp[i & 1][j] += dp[!(i & 1)][j-1];//close
		}
	return dp[0][0];
}

int main () {
	scanf ("%d %d", &L, &D);

	long long ub = fdp (D);
	long long lb = fdp (D-1);
	printf ("%Ld\n", ub - lb);

	return 0;
}
