/*
FROM: BalticOI 2001 day 1
PROB: box of mirrors
KEYW: strategy
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 7;
const int MAXM = 1 << 7;

int N, M;
bool brd[MAXN][MAXM];
int lm[MAXM];

void f (int cr, int cc, int tr) {
	for (; cr != tr; ++cc)
		if (lm[cc] != -2) {
			brd[cr][cc] = 1;
			std::swap (lm[cc], cr);
		}
}

int main () {
	scanf ("%d %d", &N, &M);

	int i, a;
	for (i = 0; i < M; ++i) lm[i] = -2;
	for (i = 0; i < N; ++i) {
		scanf ("%d", &a);
		if (a - N - M <= N)
			f (i, 0, 2 * N + M - a);
		else
			f (i, 0, lm[2 * M + 2 * N - a] = -1);
	}

	for (i = 0; i < M; ++i) {
		scanf ("%d", &a);
		if (a - N - M <= N)
			f (lm[i], i+1, 2 * N + M - a);
		else if (i != 2 * N + 2 * M - a)
			f (lm[i], i+1, lm[2 * N + 2 * M - a] = -1);
	}

	for (i = 0; i < N; ++i) {printf ("%d", brd[i][0]); for (int j = 1; j < M; ++j) printf (" %d", brd[i][j]); printf ("\n");}

	return 0;
}
