#include <cstdio>
#include <cassert>
#include <vector>
#include <algorithm>

const int MAXN = 1 << 10;
const int MAX = 1 << 4;

int N;
int deg[MAXN];
int deg2[MAXN];
std::vector <int> ans1[MAXN], ans2[MAXN];

int main (int argc, char *argv[]) {
	assert (argc == 4);
	FILE *in = fopen (argv[1], "r");
	FILE *out = fopen (argv[2], "r");
	FILE *sol = fopen (argv[3], "r");

	assert (in && out && sol);

	fscanf (in, "%d", &N);
	int i, j, a;
	for (i = 0; i < N; ++i) {
		fscanf (in, "%d", deg + i);
		deg2[i] = deg[i];
	}
	fclose (in);


	static char messout[MAX], messsol[MAX];
	fgets (messout, MAX, out);
	fgets (messsol, MAX, sol);
	if (strcmp (messout, "SCHEDULE\n") == 0) {
		for (i = 0; i < N; ++i)
			for (j = 0; j < deg[i]; ++j) {
				fscanf (out, "%d", &a);
				--a;
				ans1[i].push_back (a);
				ans2[a].push_back (i);
				--deg2[a];
			}

		for (i = 0; i < N; ++i) {
			std::sort (ans2[i].begin (), ans2[i].end ());
			assert (ans1[i] == ans2[i]);
			assert (!deg2[i]);
		}
		assert (strcmp (messsol, "SOLUTION\r\n") == 0);
	}

	return 0;
}
