/*
FROM: some kind of ACM
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 4;
const int MAXOPTLEN = 1 << 18;//2 ^ 17 is enough but just in case
const unsigned long long START = 18000000000000000000llu;

int N;
int vec[MAXN];
int max;
int mask;
bool opt[MAXOPTLEN];
int used[MAXOPTLEN];

int main () {
	scanf ("%d", &N);
	for (int i = 0; i < N; ++i)
		scanf ("%d", vec + i);
	std::sort (vec, vec + N);
	max = vec[N-1];
	mask = ((1 << (max + 1)) - 1);

	for (int i = 0; i <= max; ++i) {
		for (int j = 0; j < N && vec[j] <= i; ++j)
			if (!opt[i-vec[j]])	{
				opt[i] = 1;
				break;
			}
	}

	int templ = 0;
	for (int i = 0; i <= max; ++i) {
		templ <<= 1;
		templ |= opt[i];
	}
	for (int i = 0; i < MAXOPTLEN; ++i)
		used[i] = -1;

	int beg1, beg2;
	used[templ] = 0;
	for (int i = max+1;; ++i) {
		for (int j = 0; j < N; ++j)
			if (!opt[i-vec[j]]) {
				opt[i] = 1;
				break;
			}

		templ <<= 1;
		templ |= opt[i];
		templ &= mask;
		if (used[templ] != -1) {
			beg1 = used[templ];
			beg2 = i - max;
			break;
		} else
			used[templ] = i - max;
	}

	printf ("%d\n", opt[beg1 + (START - beg1) % (beg2 - beg1)]);

	return 0;
}
