/*
FROM: 2002 k3
PROB: toto (decode)
KEYW: decoding, combinations
*/

#include <cstdio>
#include <iostream>

const int MAXN = 1 << 6;
const int MAXM = 1 << 6;

int N, M;
long long opt[MAXN][MAXM];
int vec[MAXM];

int main () {
	int T;
	int i, j;
	long long a = 0;

	for (i = 0; i < MAXN; ++i)
		for (j = opt[i][0] = 1; j <= MAXM-1 <? i; ++j)
			opt[i][j] = opt[i-1][j-1] + opt[i-1][j];

/*	for (i = 0; i < MAXN; ++i) {
		for (j = 0; j < MAXM; ++j)
			printf (" %Ld", opt[i][j]);
		printf ("\n");
	}*/

//	scanf ("%d", &T);
	std::cin >> T;
	for (int tc = 0; tc < T; ++tc) {
//		scanf ("%d %d %Ld", &N, &M, &a);
		std::cin >> N >> M >> a;
		--a;

		if (a >= opt[N][M]) {
			printf ("%d", N - M + 1);
			for (i = N - M + 1; i < N; ++i)
				printf (" %d", i + 1);
			printf ("\n");
			continue;
		}

		for (i = j = 0; i < M; ++i) {
			for (++j; (a -= opt[N-j][(M-1)-i]) >= 0; ++j);
			a += opt[N-j][(M-1)-i];
			vec[i] = j;
		}

		std::cout << vec[0];//printf ("%d", vec[0]);
		for (i = 1; i < M; ++i) std::cout << ' ' << vec[i];//printf (" %d", vec[i]); puts ("");
		std::cout << '\n';
	}

	return 0;
}
