#include <cstdio>
#include <cstring>
#include <utility>
#include <algorithm>

using namespace std;

const int MAXN = 1 << 17;

int N;
pair <double, double> _data[MAXN];
pair <int, int> data[MAXN];
pair <int, pair <int, int> > idx[MAXN * 2];
double coor[MAXN*2];

long long idt[MAXN * 2];
int idts;//index tree size

inline int lb (int a) {return a & -a;}

void add (int pos, int val) {
	++pos;
	for (; pos <= idts; pos += lb (pos)) {
//		printf ("\tadded in %d %d\n", pos, val);
		idt[pos] += val;
	}
}

long long _srch (int pos) {
	static long long res;
	++pos;
//	printf ("_srch %d -", pos);
	for (res = 0; pos; pos -= lb (pos)) {
//		printf ("\t_srch in %d\n", pos);
		res += idt[pos];
	}
//	printf (" %Ld\n", res);
	return res;
}

long long srch (int pos1, int pos2) {
	return _srch (pos2) - _srch (pos1);
}

int main () {
	int T;
	scanf ("%d", &T);

	int i;
	long long res = 0;
	for (int tc = 0; tc < T; ++tc) {
		scanf ("%d", &N);
		for (i = 0; i < N; ++i) {
			scanf ("%lf %lf", &_data[i].first, &_data[i].second);
			coor[i*2  ] = _data[i].first;
			coor[i*2+1] = _data[i].second;
		}
		std::sort (coor, coor + N * 2);
		idts = std::unique (coor, coor + N * 2) - coor;
	
		for (i = 0; i < N; ++i) {
			data[i] = make_pair (lower_bound (coor, coor + idts, _data[i].first) - coor,
								 lower_bound (coor, coor + idts, _data[i].second) - coor);
			idx[i*2 + 0] = make_pair (data[i].first, make_pair (0, i));//begin
			idx[i*2 + 1] = make_pair (data[i].second, make_pair (1, i));//end -> to put it befor begin if id is same
		}
		std::sort (idx, idx + N * 2);
/*
		for (i = 0; i < N; ++i) {
			printf ("%d %d (%lf %lf)\n", data[i].first, data[i].second, _data[i].first, _data[i].second);
		}
		for (i = 0; i < N * 2; ++i) {
			printf ("%d %d %d\n", idx[i].first, idx[i].second.first, idx[i].second.second);
		}
		printf ("--------\n");
*/
		res = 0;
		memset (idt, 0, sizeof (idt));
		for (i = 0; i < N * 2; ++i) {
			if (idx[i].second.first == 0) {//add
				add (idx[i].first, 1);
			} else {
				res += srch (data[idx[i].second.second].first, idx[i].first);
				add (data[idx[i].second.second].first, -1);
			}
//			printf ("---\n");
		}
		printf ("%Ld\n", res);
	}

	return 0;
}
