# include <cstdio>
# include <vector>
# include <climits>

using namespace std;

int n,k;
vector <int> d;
vector <vector <int> > h;
vector <int> best;

int c[1024][1024];

void readf() {
    d.resize(0);
    h.resize(n+2);
    best.resize(n+2);
    int x;
    for ( int i=0 ; i<n ; i++ ) {
        scanf("%d", &x);
        d.push_back(x);
    }
    for ( int i=0 ; i<n ; i++ ) {
        h[i].resize(n+1);
        for ( int j=0 ; j<n-i ; j++ ) {
            scanf("%d",&x);
            h[i][j+i] = x;
        }
    }
}

int main() {
    while(true) {
        scanf("%d %d", &n, &k);
        if ( n==0 && k==0 ) break;
        readf();
        best[0] = 0;
        
        for ( int i=0 ; i<n ; i++ ) {
            c[i][i] = h[i][i]*d[i];
            for ( int j=i+1 ; j<n ; j++ ) {
                c[i][j] = c[i][j-1]+h[i][j]*d[j];                
//                printf("%d %d %d\n",i,j,c[i][j]);
            }
        }
        for ( int i=1 ; i<=n ; i++ ) {
            best[i] = INT_MAX;           
            for ( int j=i-1 ; j>=0 ; j-- ) {
                if ( best[i] >  k+c[j][i]+best[j] ) {
                    best[i] = k+c[j][i]+best[j];
                }
            }
  //          printf("%d %d\n", i, best[i]);
        }
        printf("%d\n",best[n-1]);
    }
    return 0;
}
