/**/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 21;
long long cube[1 << 21];

int vecsz;
int vec[1 << 5];

inline void fill_vec (long long a) {
	int i;
	for (i = 0; a; ++i) {
		vec[i] = a % 10;
		a /= 10;
	}
	vecsz = i;
}

inline bool is_cube () {
	long long res =0;
	for (int i = 0; i < vecsz; ++i) {
		res *= 10;
		res += vec[i];
	}
//	printf ("\t %Ld\n", res);
	return (*std::lower_bound (cube, cube + MAXN-1, res) == res);
}

void prnt_vec () {
	for (int i = vecsz - 1; i >= 0; --i) printf ("%d ", vec[i]); printf ("\n");
}

int main () {
	int i, j;
	for (i = 0; i < MAXN; ++i)
		cube[i] = (long long)i * i * i;

	int cntr;
//	i = std::lower_bound (cube, cube + MAXN-1, 1006012008) - cube;
	for (i = 1;; ++i) {
		printf ("%d\r", i);
		fill_vec (cube[i]);
		std::reverse (vec, vec + vecsz);
//		getc (stdin);
//		for (j = 0; j < vecsz; ++j) printf ("%d ", vec[j]); printf ("\n");
		cntr = 1;
		while (std::next_permutation (vec, vec + vecsz)) {
//			printf ("\t");
//			for (j = 0; j < vecsz; ++j) printf ("%d ", vec[j]); printf ("\n");
			if (is_cube ()) ++cntr;
		}
		if (cntr == 5) break;
//		printf ("**************\n");
	}
	printf ("%Ld\n", cube[i]);
	return 0;
}
