/**/

#include <cstdio>
#include <algorithm>
#include <cmath>

const int MAXN = 1 << 17;

int pr[MAXN], prc;
long long sum[MAXN];

inline bool is_prime (long long k) {
	if (k >= 1000000) return 0;
	return (*std::lower_bound (pr, pr + prc, (int)k) == (int)k);
}

const long long BIG = 1000000000000000000ll;

int main () {
	freopen ("7.out", "r", stdin);

	int i, j;
	for (;; ++prc) {
		scanf ("%d", pr + prc);
		if (pr[prc] > 1000000) break;
	}
	printf ("prc == %d\n", prc);
	pr[prc] = 1000000000;
	int maxd = 21;
	int si =0;

	sum[0] = pr[0];
	for (i = 1; i < prc; ++i) {
		sum[i] = sum[i-1] + pr[i];
		if (is_prime (sum[i]))
			maxd >?= i + 1;
		if (sum[i] > BIG) printf ("wow!\n");
	}

	int __prime, __id;
	for (i = 1; i < prc; ++i)
		for (j = i - maxd - 1; j >= 0; --j)
			if (is_prime (sum[i] - sum[j])) {
				maxd = i - j;
				si = i;
				__prime = sum[i] - sum[j];
				__id = std::lower_bound (pr, pr + prc, (int)(sum[i] - sum[j])) - pr;
			}

	printf ("%d %d(%d %d)\n", maxd, si, __prime, __id);
/*
	maxd = 543;
	si = 545;
	int tmp;
	for (j = si - maxd + 1; j <= si; ++j)
		tmp += pr[j];
	printf ("%d\n", tmp);
*/
	return 0;
}
