#include <cstdio>
#include <cstring>
#include <vector>
//#include <algorithm>

const int MAXN = 64;

int N, K;
std::vector <int> gr[MAXN];

int main () {
	freopen ("cherry.in", "r", stdin);
	freopen ("cherry.out", "w", stdout);
	scanf ("%d %d", &N, &K);
	--K;

	int i;
	int a, b;
	for (i = 1; i < N; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;

		gr[a].push_back (b);
		gr[b].push_back (a);
	}

	double prob[2][MAXN] = {{1.,},};
	int _o = 0, _n = 1;
/*
	for (int ii = 0; ii < N; ++ii)
		printf (" %lf", prob[_o][ii]);
	puts ("");
	for (int ii = 0; ii < N; ++ii)
		printf (" %lf", prob[_n][ii]);
	puts ("");
*/
	double res = 0;
	for (i = 1; i < 10000; ++i) {
		memset (prob[_n], 0, sizeof (prob) / 2);
		for (int ii = 0; ii < N; ++ii)
			if (ii != K)
				for (size_t jj = 0; jj < gr[ii].size (); ++jj)
					prob[_n][gr[ii][jj]] += prob[_o][ii] / gr[ii].size ();
/*		for (int ii = 0; ii < N; ++ii)
			printf (" %lf", prob[_n][ii]);
		puts ("");*/
		res += prob[_n][K] * i;
		_o = _n;
		_n = !_n;
	}

	printf ("%.4lf\n", res);

	return 0;
}
