/*
FROM: acm.timus.ru
PROB: 1005 (Stone pile)
KEYW: full exhaustion (bit)
*/

#include <cstdio>
#include <cstdlib>

const int MAXN = 1 << 5;

int N;
int vec[MAXN];

int min (int a, int b) {
	return a < b ? a : b;
}

int main () {
	scanf ("%d", &N);

	int i, j;
	int allw = 0;
	for (i = 0; i < N; ++i) {
		scanf ("%d", vec + i);
		allw += vec[i];
	}

	int ub = 1 << N;
	int m;
	int cw;
	int ans = allw;
	for (m = 0; m < ub; ++m) {
		cw = 0;
		for (j = 0; j < N; ++j)
			if ((m >> j) & 1)
				cw += vec[j];
		ans = min (ans, abs (cw * 2 - allw));
	}
	
	printf ("%d\n", ans);

	return 0;
}
