/*
FROM: acm.timus.ru
PROB: 1009 (K-based numbers)
KEYW: dynamical programming
*/

#include <cstdio>

int N, K;
long long dp[32][2];

int main () {
	scanf ("%d %d", &N, &K);

	dp[0][0] = dp[0][1] = 1;
	int i;
	for (i = 1; i <= N; ++i) {
		dp[i][0] = (K - 1) * dp[i-1][1];
		dp[i][1] = (K - 1) * dp[i-1][1] + dp[i-1][0];
	}

	
#ifdef ONLINE_JUDGE
	printf ("%I64d\n", dp[N][0]);
#endif
#ifndef ONLINE_JUDGE
	printf ("%Ld\n", dp[N][0]);
#endif

	return 0;
}
