/*
FROM: acm.timus.ru
PROB: 1010
KEYW: linear
*/

#include <cstdio>
#include <cstdlib>
#include <climits>

const int MAXN = 1 << 17;

int N;
long long f[MAXN];

long long myabs (long long a) {
	return a * ((a > 0) - (a < 0));
}

int main () {
	scanf ("%d", &N);
	
	int i;
	for (i = 0; i < N; ++i)
#ifdef ONLINE_JUDGE
		scanf ("%I64d", f + i);
#endif
#ifndef ONLINE_JUDGE
		scanf ("%Ld", f + i);
#endif

	int bi = 0;
	for (i = 1; i + 1 < N; ++i)
		if (myabs (f[bi+1] - f[bi]) < myabs (f[i+1] - f[i]))
			bi = i;

	printf ("%d %d\n", bi + 1, bi + 2);

	return 0;
}
