/*
FROM: acm.timus.ru
PROB: 1019 (A Line painting)
KEYW: map
*/

#include <cstdio>
#include <map>

#define WHITE true
#define BLACK false

int N;
std::map <int, bool> line;

void prnt (std::map <int, bool> :: iterator &x) {
	if (x == line.end ()) printf ("END\n");
	else printf ("%d %d\n", x->first, x->second);
}

std::map <int, bool> :: iterator nxt (const std::map <int, bool> :: iterator &x) {
	std::map <int, bool> :: iterator ret (x);
	return ++ret;
}

int main () {
	line[0] = WHITE;
	line[1000000000] = BLACK;

	scanf ("%d", &N);
	int i;
	int a, b;
	char _c;
	bool c;
	std::map <int, bool> :: iterator it1, it2, le, re;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d %c", &a, &b, &_c);
		c = (_c == 'w');
	
		it1 = line.lower_bound (a);
//		printf ("scanned %d %d %d\n", a, b, c);
//		printf ("%d %d\n", it1->first, it1->second);
		if (it1->first == a) {//on
			if (it1->second == c) {//same
				le = it1;
				++le;
			} else {//diff
				le = it1;
			}
		} else {//between
			if (it1->second == c) {
				le = it1;
				--it1;
				line[a] = c;
			} else {
				le = it1;
			}
		}
	
		it2 = line.lower_bound (b);
//		printf ("%d %d\n", it2->first, it2->second);
		if (it2->first == b) {//on
			if (it2->second == c) {
				re = it2;
				++re;
			} else {
				re = it2;
			}
		} else {//between
			if (it2->second == c) {
				re = line.insert (std::make_pair (b, !c)).first;
			} else {
				re = it2;
			}
		}
//		prnt (le);
//		prnt (re);
//		printf ("bef erase: "); for (it1 = line.begin (); it1 != line.end (); ++it1) printf ("(%d %d)", it1->first, it1->second); puts ("");
		if (le->first < re->first)
			line.erase (le, re);
//		printf ("aft erase: "); for (it1 = line.begin (); it1 != line.end (); ++it1) printf ("(%d %d)", it1->first, it1->second); puts ("");

	}
/*
	for (it1 = line.begin (); it1 != line.end (); ++it1)
		printf ("%d %d\n", it1->first, it1->second);
*/
	int ans = 0;
	int start = -1;
	for (it1 = line.begin (); it1 != line.end (); ++it1)
		if (it1->second == WHITE)
			if (ans < nxt (it1)->first - it1->first) {
				ans = nxt (it1)->first - it1->first;
				start = it1->first;
			}
	printf ("%d %d\n", start, start + ans);

	return 0;
}
