/*
FROM: acm.timus.ru
PROB: 1020
KEYW: geometry, distance
*/

#include <cstdio>
#include <utility>
#include <cmath>

#define x first
#define y second

int N;
double R;

int main () {
	scanf ("%d %lf", &N, &R);

	std::pair <double, double> first, prev, now;
	scanf ("%lf %lf", &first.x, &first.y);
	prev = first;
	double res = 2. * R * acos (-1.);
	for (int i = 1; i < N; ++i) {
		scanf ("%lf %lf", &now.x, &now.y);
		res += hypot (prev.x - now.x, prev.y - now.y);
		prev = now;
	}

	res += hypot (prev.x - first.x, prev.y - first.y);
	printf ("%.2lf\n", res);

	return 0;
}
