/*
FROM: acm.timus.ru
PROB: 1021 (Sacrament of the sum)
KEYW: linear search (triangular idea)
*/

#include <cstdio>

const int MAXN = 1 << 16;

int n[2];
int vec[2][MAXN];

int main () {
	int i, k;
	for (k = 0; k < 2; ++k) {
		scanf ("%d", n + k);
		for (i = 0; i < n[k]; ++i)
			scanf ("%d", vec[k] + i);
	}

	int p1 = 0, p2 = 0;

	while (p1 < n[0] && p2 < n[1] && vec[0][p1] + vec[1][p2] != 10000) {
		((vec[0][p1] + vec[1][p2] > 10000) ? ++p2 : ++p1);
	}

	printf ("%s\n", p1 != n[0] && p2 != n[1] ? "YES" : "NO");

	return 0;
}
