/*
FROM: acm.timus.ru
PROB: 1024 (Permutations)
KEYW: order of a permutation, gcd
*/

#include <cstdio>

const int MAXN = 1 << 10;

int gcd (int a, int b) {
	return b ? gcd (b, a % b) : a;
}

int N;
int vec[MAXN];

int main () {
	scanf ("%d", &N);

	int i;
	for (i = 0; i < N; ++i) {
		scanf ("%d", vec + i);
		--vec[i];
	}

	int res = 1;
	int now, x;
	for (i = 0; i < N; ++i) {
		now = i;
		x = 0;
		do {
			now = vec[now];
			++x;
		} while (now != i);
//		printf ("%d ", x);
		res /= gcd (res, x);
		res *= x;
	}

	printf ("%d\n", res);
	return 0;
}
