/*
FROM: acm.timus.ru
PROB: 1028 (Stars)
KEYW: lowest bit index tree
*/

#include <cstdio>

const int MAXC = 1 << 15;
const int MAXN = 1 << 14;

int idt[MAXC];
int lvl[MAXN];

int srch_add (int pos) {
	static int i, res;
	res = 0;
	++pos;
	for (i = pos; i; i &= i - 1)
		res += idt[i];
	for (i = pos; i < MAXC; i += i & -i)
		++idt[i];
	return res;
}

int main () {
	int N;
	scanf ("%d", &N);
	int i;
	int a, b;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", &a, &b);
		++lvl[srch_add (a)];
	}

	for (i = 0; i < N; ++i) printf ("%d\n", lvl[i]);

	return 0;
}
