/*
FROM: acm.timus.ru
PROB: 1044 (Lucky tickets. Easy!)
KEYW: dynamical programming
*/

#include <cstdio>

const int MAXS = 1 << 7;

int N;
int dp[MAXS];

int main () {
	scanf ("%d", &N); N /= 2;

	dp[0] = 1;
	int i, j;
	for (int k = 0; k < N; ++k) {
		for (i = MAXS - 1; i >= 0; --i) {
			if (!dp[i]) continue;
			for (j = 1; j < 10 && i + j < MAXS; ++j)
				dp[i+j] += dp[i];
		}
	}

	int ans = 0;
	for (i = 0; i < MAXS; ++i)
		ans += dp[i] * dp[i];
	printf ("%d\n", ans);

	return 0;
}
