/*
FROM: acm.timus.ru
PROB: 1047 (Simple calculations)
KEYW: mathematics
*/

#include <cstdio>

const int MAXN = 1 << 12;

struct tri {
	double a, b, c;
	tri () {}
	tri (double _a, double _b, double _c) : a (_a), b (_b), c (_c) {}
	tri operator - (const tri &x) const {return tri (a - x.a, b - x.b, c - x.c);}
	tri operator * (double x) const {return tri (a * x, b * x, c * x);}
	tri operator + (double x) const {return tri (a, b, c + x);}
};

int N;
double a0, an1;
double c[MAXN];

int main () {
	scanf ("%d", &N);

	scanf ("%lf %lf", &a0, &an1);
	int i;
	for (i = 1; i <= N; ++i)
		scanf ("%lf", c + i);

	tri f (1, 0, 0), s (0, 1, 0), t;
	for (i = 2; i <= N + 1; ++i) {
		t = s * 2 - f + 2 * c[i-1];
		f = s;
		s = t;
	}

	printf ("%.2lf\n", (an1 - s.a * a0 - s.c) / s.b);

	return 0;
}
