/*
FROM: acm.timus.ru
PROB: 1048 (Superlong sums)
KEYW: add 2 big numbers
*/

#include <cstdio>

const int MAXN = 1 << 20;

int N;
char num1[MAXN], num2[MAXN];

int main () {
	scanf ("%d", &N);

	int i;
	char a, b;
	for (i = N-1; i >= 0; --i) {
		scanf (" %c %c", &a, &b);
		num1[i] = a - '0';
		num2[i] = b;
	}

	for (i = 0; i < N; ++i) {
		num1[i] += num2[i];
		if (num1[i] > '9') {
			num1[i] -= 10;
			++num1[i+1];
		}
	}

	for (i = N-1; i >= 0; --i)
		putchar (num1[i]);
	puts ("");

	return 0;
}
