/*
FROM: acm.timus.ru
PROB: 1061 (Buffer Manager)
KEYW: linear, moving window
*/

#include <cstdio>
#include <cstring>

const int MAXR = 1 << 17;

int N, K;
char regs[MAXR];

int fndK (int sp, int &sum) {
//	printf ("fnd %d\n", sp);
	if (sp == N+1) return -1;
	sum = 0;
	for (int i = 0; i < K; ++i)
		if (regs[i+sp] == '*')
			return fndK (i+sp+1, sum);
		else
			sum += regs[i+sp] - '0';
//	printf ("return sp + K (%d)\n", sum);
	return sp + K;
}

int main () {
	scanf ("%d %d\n", &N, &K);

	char *rp = regs;
	while (gets (rp)) rp += 80;
	rp -= 80;
	rp += strlen (rp);
	*rp++ = '*';

	int csum = 0;
	int cp = 0;
	int ans = 1000000000;
	int sid = 0;//no solution
	for (;;) {
		cp = fndK (cp, csum);
		if (cp == -1) break;
		if (ans > csum) {
			ans = csum;
			sid = cp - K + 1;
		}
		while (regs[cp] != '*') {
			csum += regs[cp] - '0';
			csum -= regs[cp-K] - '0';
			if (ans > csum) {
				ans = csum;
				sid = cp - K + 2;
			}
			++cp;
		}
	}

	printf ("%d\n", sid);

	return 0;
}
