/*
FROM: acm.timus.ru
PROB: 1066 (Garland)
KEYW: mathematics, binary search
*/

#include <cstdio>

const int BSC = 100;

int N;
double A;

double nth (double sec, int id) {
	if (id == 0) return A;
	if (id == 1) return sec;
	return id * sec - (id - 1) * A + (id - 1) * id;
}

double lowest (double sec) {
	int l = 0, r = N-1, m;
	while (l + 1 < r) {
		m = (l + r) / 2;
		if (nth (sec, m) > nth (sec, m+1))
			l = m;
		else
			r = m;
	}
	return nth (sec, r);
}

int main () {
	scanf ("%d %lf", &N, &A);
/*
	double A1;
	double pr1, pr2, n;
	while (scanf ("%lf", &A1) == 1) {
		pr1 = A;
		pr2 = A1;
		
		for (int i = 2; i < N; ++i) {
			n = 2 * pr2 - pr1 + 2;
			printf ("\t%lf\n", n);
			pr1 = pr2;
			pr2 = n;
		}
	}	
*/
	double l = 0, r = A, m;
	for (int k = 0; k < BSC; ++k) {
		m = (l + r) / 2;
		if (lowest (m) < 0)
			l = m;
		else
			r = m;
	}

	printf ("%.2lf\n", nth (l, N-1));

	return 0;
}
