/*
FROM: acm.timus.ru
PROB: 1073 (Square country)
KEYW: dynamical programming
*/

#include <cstdio>
#include <cstring>

const int MAXN = 1 << 16;

int N;
int dp[MAXN];

int main () {
	scanf ("%d", &N);

	memset (dp, 0x7f, sizeof (dp));
	dp[0] = 0;

	int i, j;
	for (j = 1; j * j <= N; ++j) {
		for (i = 0; i + j * j <= N; ++i)
			if (dp[i+j*j] > dp[i] + 1)
				dp[i+j*j] = dp[i] + 1;
	}
	printf ("%d\n", dp[N]);

	return 0;
}
