/*
FROM: acm.timus.ru (Winter 2001 A)
PROB: 1079 (Maximum)
KEYW: linear
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 17;

int row[MAXN];
int max[MAXN];

int main () {
	row[0] = 0; max[0] = 0;
	row[1] = 1; max[1] = 1;
	int i;
	for (i = 2; i < MAXN; ++i) {
		row[i] = row[i/2] + (i & 1 ? row[(i+1)/2] : 0);
		max[i] = std::max (max[i-1], row[i]);
	}

	int N;
	while (scanf ("%d", &N), N)
		printf ("%d\n", max[N]);

	return 0;
}
