/*
FROM: acm.timus.ru
PROB: 1088 (Ilya Murometz)
KEYW: full binary tree, lca (slow)
*/

#include <cstdio>

int D, E, F, H;
unsigned DP, EP;
int main () {
	scanf ("%d %d %d %u %u %d\n", &D, &E, &F, &DP, &EP, &H);

	--DP; --EP;
	DP += 1u << F;
	EP += 1u << F;

	DP >>= D;
	EP >>= E;

	while (D < E) {DP /= 2u; --H; ++D;}
	while (E < D) {EP /= 2u; --H; ++E;}
	while (DP != EP) {
		H -= 2;
		DP /= 2;
		EP /= 2;
	}

	printf ("%s\n", H >= 0 ? "YES" : "NO");

	return 0;
}
