/*
FROM: acm.timus.ru
PROB: 1090 (In the army now)
KEYW: lowest bit index tree
*/

#include <cstdio>
#include <cctype>
#include <cassert>
#include <cstring>

const int MAXN = 10002;

unsigned N, K;
unsigned short idt[MAXN];

inline void add (unsigned short pos) {
	for (; pos <= N; pos += pos & -pos) ++idt[pos];
}

int _crowj;
inline void srch (unsigned short pos) {
	for (; pos; pos &= pos - 1) _crowj += idt[pos];
}

#define FAST_INPUT

int main () {
	scanf ("%u %u\n", &N, &K);

	int br = -1, brj = -1;
	unsigned i, j;
	unsigned short a = 0;
	static char buf[50000] = {1};
	for (i = 0; i < K; ++i) {
		_crowj = 0;
		memset (idt + 1, 0, sizeof (short) * N);
//BEGIN
#ifndef FAST_INPUT
		for (j = 0; j < N; ++j) {
			scanf ("%hu", &a);
			a = N + 1 - a;
//			assert (a >= 1 && a <= N);
			crowj += srch (a);
			add (a);
		}
//END
#else
		gets (buf+1);
		for (j = 1; buf[j-1]; ++j)
			if (isdigit (buf[j])) {
				a *= 10;
				a += buf[j] - '0';
			} else if (a) {
//				printf ("got %hu\n", a);
				a = N + 1 - a;
				srch (a);
				add (a);
				a = 0;
			}
#endif
		if (brj < _crowj) {
			brj = _crowj;
			br = i + 1;
		}
	}

	printf ("%d\n", br);

	return 0;
}
