/*
FROM: acm.timus.ru
PROB: 1095 (Nikifor 3)
KEYW: ad hoc
*/

#include <cstdio>
#include <algorithm>
#include <functional>

const int MAXD = 32;
const int MAXM = 8;

int digs[MAXD], dp;
int mods[MAXM] = {1, 3, 2, 6, 4, 5};

int main () {
	int tc;
	scanf ("%d\n", &tc);
	char line[MAXD];
	int i;
	while (tc--) {
		scanf ("%s", line);
		bool fnd[4] = {0};
		dp = 0;
		int cmod = 0;
		for (i = 0; line[i]; ++i) {
			digs[dp] = line[i] - '0';
			if (digs[dp] <= 4 && digs[dp] >= 1 && !fnd[digs[dp]-1]) {//extract first 1 2 3 4
				fnd[digs[dp]-1] = 1;
			} else {
				cmod += (digs[dp] * mods[dp % 6]) % 7;
				cmod %= 7;
				++dp;
			}
		}
		std::reverse (digs, digs + dp);
		int mv[4] = {1, 2, 3, 4};
		do {
			int nmod = 0;
			for (i = 0; i < 4; ++i)
				nmod += (mv[i] * mods[(dp + i) % 6]) % 7;
			if ((nmod + cmod) % 7 == 0)
				break;
		} while (std::next_permutation (mv, mv + 4));
		std::reverse (mv, mv + 4);
		for (i = 0; i < 4; ++i) printf ("%d", mv[i]);
		for (i = 0; i < dp; ++i) printf ("%d", digs[i]);
		puts ("");
	}

	return 0;
}
