/*
FROM: acm.timus.ru
PROB: 1102
KEYW: string processing
*/

#include <cstdio>
#include <cctype>

const int MAXT = 10001000;

int T;
char text[MAXT];

int strincmp (const char *a, const char *b, int mp) {
//	printf ("%.6s %.6s %d ", a, b, mp);
	while (*a && *b && mp && tolower (*a) == tolower (*b)) {
		++a; ++b;
		--mp;
	}
//	printf ("--> %d\n", mp ? *a - *b : 0);
	return mp ? *a - *b : 0;
}

int main () {
	int tc;
	scanf ("%d\n", &tc);
	
	int i;
	while (tc--) {
		gets (text);
		text[0] = toupper (text[0]);//can start
		for (i = 0; text[i]; ++i) {
			if (islower (text[i])) continue;
			if (strincmp (text + i, "in", 2) == 0) {
				if (text[i+2] == '\0') break;
				text[i+2] = toupper (text[i+2]);
				if (strincmp (text + i + 2, "put", 3) == 0) {
					if (text[i+5] == '\0') break;
					text[i+5] = toupper (text[i+5]);
				}
			}
			if (strincmp (text + i, "puton", 5) == 0) {
				if (text[i+5] == '\0') break;
				text[i+5] = toupper (text[i+5]);
			}
			if (strincmp (text + i, "out", 3) == 0) {
				if (text[i+3] == '\0') break;
				text[i+3] = toupper (text[i+3]);
				if (strincmp (text + i + 3, "put", 3) == 0) {
					if (text[i+6] == '\0') break;
					text[i+6] = toupper (text[i+6]);
				}
			}
			if (strincmp (text + i, "one", 3) == 0) {
				if (text[i+3] == '\0') break;
				text[i+3] = toupper (text[i+3]);
			}
		}
		printf ("%s\n", text[i] ? "YES" : "NO");
	}

	return 0;
}
