#include <cstdio>
//#include <cassert>
#include <vector>

#ifdef ONLINE_JUDGE
void assert (bool a) {
	while (!a);
}
#else
#include <cassert>
#endif
const int MAXN = 1 << 16;
const int LOG = 16;

int N, M;

int lvl[MAXN];
int prev[MAXN][LOG];
int prevw[MAXN][LOG];

std::vector <std::pair <int, int> > gr[MAXN];

void bfs () {
	static int q[MAXN], p3;
	q[p3++] = 0;
	lvl[0] = 0;
	
	for (int i = 0; i < p3; ++i) {
		int a = q[i];
		for (int ii = 1; ii < LOG && prev[a][ii-1] != -1 && prev[prev[a][ii-1]][ii-1] != -1; ++ii) {
			prev[a][ii] = prev[ prev[a][ii-1] ][ii-1];
			prevw[a][ii] = prevw[a][ii-1] + prevw[ prev[a][ii-1] ][ii-1];
		}

		for (size_t i = 0; i < gr[a].size (); ++i) {
			if (lvl[gr[a][i].first] == -1) {
				lvl[gr[a][i].first] = lvl[a] + 1;
				prev[gr[a][i].first][0] = a;
				prevw[gr[a][i].first][0] = gr[a][i].second;
				q[p3++] = gr[a][i].first;
			} else {
				assert (prev[a][0] == gr[a][i].first);
			}
		}
	}
}

/*
int ii;
void dfs (int a) {

}
*/
int __res;
void goto_lvl (int &a, int targ) {
	//this function is RIGHT
	for (int i = LOG-1; i >= 0; --i)
		if (prev[a][i] != -1 && lvl[prev[a][i]] >= targ) {
			__res += prevw[a][i];
			a = prev[a][i];
		}
}

int main () {
	scanf ("%d", &N);

	int i;
	int a, b, c;
	for (i = 1; i < N; ++i) {
		scanf ("%d %d %d", &a, &b, &c);
		gr[a].push_back (std::make_pair (b, c));
		gr[b].push_back (std::make_pair (a, c));
	}

	memset (lvl, -1, sizeof (lvl));
	memset (prev, -1, sizeof (prev));
	lvl[0] = 0;
	bfs ();
	//dfs (0);

/*	for (i = 0; i < N; ++i) {
		printf ("%d ->", i);
		for (int j = 0; j < LOG && prev[i][j] != -1; ++j)
			printf ("\tto %d dst %d\n", prev[i][j], prevw[i][j]);
		puts ("");
	}
*/
	scanf ("%d", &M);
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);

		__res = 0;
		if (lvl[a] < lvl[b]) goto_lvl (b, lvl[a]);
		if (lvl[a] > lvl[b]) goto_lvl (a, lvl[b]);
		if (a == b) goto prnt;
		for (int j = LOG-1; j >= 0; --j) {
			if (prev[a][j] == -1) continue;
			assert (prev[b][j] != -1);
			if (prev[a][j] != prev[b][j]) {
				__res += prevw[a][j] + prevw[b][j];
				a = prev[a][j];
				b = prev[b][j];
			}
		}
		assert (a != b);
		assert (prev[a][0] == prev[b][0]);
		__res += prevw[a][0] + prevw[b][0];
	
		prnt:;
		printf ("%d\n", __res);
	}

	return 0;
}
