#include<cstdio>
#include<map>
#include<algorithm>
#include<vector>
#include<string>

using namespace std;

pair<int, int> names[131072];
char str[131072][16];
pair<int, int> s[1 << 21];

bool cmp(const pair<int, int> &a, const pair<int, int> &b)
{
	if(a.first < b.first) return true;
	else if(a.first == b.first)
	{
		if(strcmp(str[a.second], str[b.second]) < 0)
		{
			return true;
		}
	}
	return false;
}

bool cmp2(const pair<int, int> &a, const pair<int, int> &b)
{
	int t = min(a.second, b.second);
	for(int i = 0; i < t; i++)
	{
		if(str[a.first][i] != str[b.first][i])
		{
			return str[a.first][i] < str[b.first][i];
		}
	}
	return a.second < b.second;
}

int main()
{
	int n, k;
	scanf("%d", &n);
	for(int i = 0; i < n; i++)
	{
		scanf("%s%d", str[i], &k);
		names[i] = make_pair(-k, i);
	}
	sort(names, names + n, cmp);
	int count = 0;
	for(int i = 0; i < n; i++)
	{
		int len = strlen(str[names[i].second]);
		for(int j = 0; j < len; j++)
		{
			s[count++] = make_pair(names[i].second, j + 1);
		}
	}
	stable_sort(s, s + count, cmp2);
	int m;
	scanf("%d", &m);
	for(int i = 0; i < m; i++)
	{
		scanf("%s", str[n++]);
		int len = strlen(str[n - 1]);
		int beg = lower_bound(s, s + count, make_pair(n - 1, len), cmp2) - s;
		int end = upper_bound(s + beg, s + count, make_pair(n - 1, len), cmp2) - s;
		for(int j = beg; j < min(beg + 10, end); j++)
		{
			printf("%s\n", str[s[j].first]);
		}
		if(i + 1 < m) printf("\n");
	}
	return 0;
}
