/*
FROM: acm.timus.ru
PROB: 1544 (Classmates 3)
KEYW: bfs
*/

#include <cstdio>
#include <cstring>
#include <vector>

const int MAXN = 1 << 6;

int N, M;
bool t[MAXN];
std::vector <int> old_gr[MAXN];
int grp[MAXN];
int G;
std::vector <int> gr[MAXN];
bool isin[MAXN][MAXN];
int ref[MAXN];

void dfs (int a, bool tt) {
	grp[a] = G;
	for (size_t i = 0; i < old_gr[a].size (); ++i)
		if (t[old_gr[a][i]] == tt && grp[old_gr[a][i]] == -1)
			dfs (old_gr[a][i], tt);
}

int _d;
int D[MAXN];

void bfs (int s) {
	memset (D, -1, sizeof (D));
	static int q[MAXN], p3;
	q[p3 = 0, p3++] = s;
	D[s] = 0;
	int i;
	_d = 0;
	for (i = 0; i < p3; ++i) {
		_d = D[q[i]];
//		printf ("popped %d %d\n", q[i], D[q[i]]);
		for (size_t j = 0; j < gr[q[i]].size (); ++j)
			if (D[gr[q[i]][j]] == -1) {
				D[gr[q[i]][j]] = D[q[i]] + 1;
				q[p3++] = gr[q[i]][j];
			}
	}
//	printf ("------____%d (%d)\n", s, _d);
}

int main () {
	scanf ("%d %d", &N, &M);

	int i;
	char c;
	for (i = 0; i < N; ++i) {
		scanf (" %c", &c);
		t[i] = c == 'E';
	}

	int a, b;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
		old_gr[a].push_back (b);
		old_gr[b].push_back (a);
	}

	memset (grp, -1, sizeof (grp));
	for (i = 0; i < N; ++i)
		if (grp[i] == -1) {
			dfs (i, t[i]);
			ref[G] = i;~
//			printf ("ref %d %d\n", G, i);
			++G;
		}

	for (i = 0; i < N; ++i)
		for (size_t j = 0; j < old_gr[i].size (); ++j)
			if (grp[i] != grp[old_gr[i][j]]) {
				if (!isin[grp[i]][grp[old_gr[i][j]]]) {
					isin[grp[i]][grp[old_gr[i][j]]] = 1;
					gr[grp[i]].push_back (grp[old_gr[i][j]]);
					gr[grp[old_gr[i][j]]].push_back (grp[i]);
//					printf ("LINK %d %d\n", grp[i], grp[old_gr[i][j]]);
				}
			}

	int md = 1000000, mi = -1;
	for (i = 0; i < G; ++i) {
		bfs (i);
		if (md > _d) {
			md = _d;
			mi = i;
		}
	}

	printf ("%d\n", md);
	for (i = 0; i < md; ++i)
		printf ("%d %c\n", ref[mi] + 1, "EJ"[(t[ref[mi]] + i) & 1]);

	return 0;
}
