#include <cstdio>
#include <algorithm>

using namespace std;

#define N 64

int n, m;
char mas[N][N];
int mini[N][N], maxi[N][N];
int t[N][N];
int c[N][N];
int v[N][N];

int f(int a, int b)
{
	if (!t[a][b])
	{
		t[a][b] = 1;
		if (a == b)
		{
			v[a][b] = (maxi[a][a] != - 1);
		}
		else
		{
			v[a][b] = 100000;
			for (int i = a; i < b; ++ i)
			{
				int x = f(a, i) + f(i + 1, b);
				if (v[a][b] > x)
				{
					v[a][b] = x;
					c[a][b] = i;
				}
			}
			int emin = mini[a][b], emax = maxi[a][b], s = 0, ok = 0;
			for (int i = a; i <= b; ++ i)
				if (emin <= emax && maxi[i][i] == emax && mini[i][i] == emin)
					ok = 1;
			if (ok)
			{
				int o = -1;
				for (int i = a; i <= b; ++ i)
				{
					if (maxi[i][i] == emax && mini[i][i] == emin)
					{
						if (o + 1)
						{
							s += f(o, i - 1);
						}
						o = -1;
					}
					else
					{
						if (o == -1) o = i;
					}
				}
				if (o + 1)
				{
					s += f(o, b);
				}
				if (s + 1 < v[a][b])
				{
					t[a][b] = 2;
					v[a][b] = s + 1;
				}
			}
		}
	}
	return v[a][b];
}

void print(int a, int b)
{
	if (t[a][b] == 1)
	{
		if (a == b)
		{
			if (v[a][b]) printf("%d %d %d %d\n", mini[a][a] + 1, a + 1, maxi[a][a] + 1, a + 1);
		}
		else
		{
			print(a, c[a][b]);
			print(c[a][b] + 1, b);
		}
	}
	else if(t[a][b] == 2)
	{
		int emin = mini[a][b], emax = maxi[a][b];
		int o = -1;
		printf("%d %d %d %d\n", emin + 1, a + 1, emax + 1, b + 1);
		for (int i = a; i <= b; ++ i)
		{
			if (maxi[i][i] == emax && mini[i][i] == emin)
			{
				if (o + 1)
				{
					print(o, i - 1);
				}
				o = -1;
			}
			else
			{
				if (o == -1) o = i;
			}
		}
		if (o + 1)
		{
			print(o, b);
		}
	}
}

int main()
{
	scanf("%d %d", &n, &m);
	for (int i = 0; i < n; ++ i)
		scanf("%s", mas[i]);
	for (int j = 0; j < m; ++ j)
	{
		mini[j][j] = 1000;
		maxi[j][j] = -1;
		for (int i = 0; i < n; ++ i)
			if (mas[i][j] == '1')
			{
				mini[j][j] = min(mini[j][j], i);
				maxi[j][j] = max(maxi[j][j], i);
			}
	}
	for (int i = 0; i < m; ++ i)
	{
		for (int j = i + 1; j < m; ++ j)
		{
			mini[i][j] = max(mini[i][j - 1], mini[j][j]);
			maxi[i][j] = min(maxi[i][j - 1], maxi[j][j]);
		}
	}
	/*for (int i = 0; i < m; ++ i)
	{
		printf("(%d, %d)\n", mini[i][i], maxi[i][i]);
	}*/
	f(0, m - 1);
	printf("%d\n", v[0][m - 1]);
	print(0, m - 1);
	return 0;
}