/*
NAME: Ecological Bin Packing
ID: 102
SITE: acm.uva.es
*/

#include <cstdio>
#include <iostream>
//#include <cstring>

typedef unsigned uint;

char toc (int a) {
	switch (a) {
		case 0: return 'B';
		case 1: return 'G';
		case 2: return 'C';
		default: return -1;	
	}
}

int main () {
	uint a[3][3];
	unsigned long long sum;
//	char out[20];
    
	int i,j,k;
	char A, B, C;
	unsigned long long cs, bs;
	char tmp1[4] = {0};
	char tmp2[4] = {0};
	while (scanf ("%u%u%u %u%u%u %u%u%u", &a[0][0], &a[0][1], &a[0][2],
                                          &a[1][0], &a[1][1], &a[1][2],
                                          &a[2][0], &a[2][1], &a[2][2]) != -1) {
		sum = 0, bs = (unsigned long long)(-1);
		for (i = 0; i < 3; ++i)
			for (j = 0; j < 3; ++j)
				sum += a[i][j];

		for (i = 0; i < 3; ++i)
			for (j = 0; j < 3; ++j)
				for (k = 0; k < 3; ++k) {
					if (i == j || i == k || j == k)
						continue;
					cs = sum - a[0][i] - a[1][j] - a[2][k];
//					printf ("%c%c%c %Ld\n", toc (i), toc (j), toc (k), cs);
					if (cs < bs) {
						bs = cs;
						A = toc(i), B = toc(j), C = toc(k);
//                        sprintf (out, "%c%c%c %uLd", toc(i), toc(k), toc(j), bs);
					} else if (cs == bs) {
						tmp1[0] = A; tmp1[1] = B; tmp1[2] = C;
						tmp2[0] = toc(i); tmp2[1] = toc(j); tmp2[2] = toc(k);
						if (strcmp (tmp1, tmp2) > 0) {
							bs = cs;
							A = toc(i), B = toc(j), C = toc(k);
						}
					}
				}
//        printf ("%s\n", out);
		std::cout << A << B << C << ' ' << bs << '\n';
    }

    return 0;
}

