/*
NAME: Maximum Sum
ID: 108
SITE: acm.uva.es
*/

#include <cstdio>
#include <climits>

const int MAXN = 1 << 7;

int N;
char ma3x[MAXN][MAXN];
short sums[MAXN][MAXN];

int main () {
	scanf ("%d", &N);

	int i, j, k;
	for (i = 0; i < N; ++i) for (j = 0; j < N; ++j) scanf ("%d", (int*)&ma3x[i][j]);

	for (i = 0; i < N; ++i)
		for (j = N-1; j >= 0; --j)
			sums[i][j] = sums[i][j+1] + ma3x[i][j];

	int bsum = INT_MIN;
	int sum;
	for (i = 0; i < N; ++i)
		for (j = i + 1; j <= N; ++j) {
			sum = 0;
			for (k = 0; k < N; ++k) {
				sum += sums[k][i] - sums[k][j];
				bsum >?= sum;
				if (sum < 0) sum = 0;
			}
		}

	printf ("%d\n", bsum);

	return 0;
}
