/*
NAME: Mutant Flatworld Explorers
ID: 118
SITE: acm.uva.es
*/

#include <cstdio>

const int dx[] = {1, 0, -1, 0};
const int dy[] = {0, -1, 0, 1};

int N, M;
bool ma3x[51][51];
char toc[] = {'E', 'S', 'W', 'N'};
int toi (char c) {
	switch (c) {
		case 'E': return 0;
		case 'S': return 1;
		case 'W': return 2;
		case 'N': return 3;
		default: printf ("aaa\n"); return -1000;
	}
}

int main () {
	scanf ("%d %d\n", &N, &M);

	char dirs[8];
	char cc;
	bool flag;
	int dir, x, y;
	int nx, ny;
	while (scanf ("%d %d %s\n", &x, &y, dirs) == 3) {
		dir = toi (*dirs);
		flag = 0;
		while ((cc = getchar ()) != '\n') {
			if (flag) continue;
			switch (cc) {
				case 'F':
						nx = x + dx[dir];
						ny = y + dy[dir];
						if (nx >= 0 && nx <= N && ny >= 0 && ny <= M) {
							x = nx;
							y = ny;
						} else if (!ma3x[x][y]) {
							ma3x[x][y] = 1;
							printf ("%d %d %c LOST\n", x, y, toc[dir]);
							flag = 1;
						}
						break;
				case 'R': dir = dir == 3 ? 0 : dir + 1; break;
				case 'L': dir = dir ? dir - 1 : 3; break;
			}
		}
		if (!flag) printf ("%d %d %c\n", x, y, toc[dir]);
	}
	return 0;
}
