/*
NAME: Greedy Gift Givers
ID: 119
SITE: acm.uva.es
*/

#include <iostream>
#include <vector>
#include <string>
#include <map>

const int MAXN = 1 << 4;

int N;
std::map <std::string, int> ref;
std::vector <std::string> names;
int balance[MAXN];

int main () {
	std::string name;
	int i, j;
	while (std::cin >> N) {
		if (ref.begin () != ref.end ()) std::cout << std::endl;
		ref.clear ();
		names.clear ();
		names.reserve (N);
		for (i = 0; i < N; ++i) balance[i] = 0;
		for (i = 0; i < N; ++i) {
			std::cin >> name;
			names.push_back (name);
			ref[name] = i;
		}
		int cid, n, give;
		for (i = 0; i < N; ++i) {
			std::cin >> name >> give >> n;
			cid = ref[name];
			if (n == 0) continue;
			balance[cid] -= give - (give % n);
			give /= n;
			for (j = 0; j < n; ++j) {
				std::cin >> name;
				balance[ref[name]] += give;
			}
		}
		for (i = 0; i < N; ++i)
			std::cout << names[i] << ' ' << balance[i] << std::endl;
	}

	return 0;
}
