/*
NAME: Following Orders
ID: 124
SITE: acm.uva.es
*/

#include <cstdio>
#include <cstdlib>
#include <cassert>

#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <algorithm>

const int MAXN = 1 << 5;
const int ALPHA = 1 << 5;

int N;
char vec[MAXN];
int ref[ALPHA];
int in[MAXN];
bool used[MAXN];
std::vector <int> com[MAXN];

char buf[MAXN];
void rec (int pos =0) {
	if (pos == N) {puts (buf); return;}
	for (int i = 0; i < N; ++i)
		if (!in[i] && !used[i]) {
			buf[pos] = vec[i];
			used[i] = 1;
			for (unsigned j = 0; j < com[i].size (); ++j)
				--in[com[i][j]];
			rec (pos + 1);
			for (unsigned j = 0; j < com[i].size (); ++j)
				++in[com[i][j]];
			used[i] = 0;
		}
}

int main () {
	std::string line, tmp, tmp2;
	int i =0;
	while (std::getline (std::cin, line), line.size ()) {
		if (i) puts ("");
		std::istringstream _in (line);
		N = 0;
		while (_in >> tmp) {
			assert (tmp.size () == 1);
			vec[N] = tmp[0];
			used[N] = 0;
			com[N].clear ();
			in[N++] = 0;
		}
		std::sort (vec, vec + N);
//		for (i = 0; i < N; ++i) printf ("_%c_", vec[i]); printf ("\n");
		for (i = 0; i < N; ++i) ref[vec[i]-'a'] = i;

		std::getline (std::cin, line);
		std::istringstream _in2 (line);
		while (_in2 >> tmp >> tmp2) {
			assert (tmp.size () == 1 && tmp2.size () == 1);
			++in[ref[tmp2[0] - 'a']];
			com[ref[tmp[0] - 'a']].push_back (ref[tmp2[0] - 'a']);
		}
		buf[N] = 0;
		rec ();
	}

	return 0;
}
