#include <cstdio>

#define EPS 1e-9

int a[1024], b[1024];

int gcd (int a, int b) {
	while(b) {
		int tmp = b;
		b = a % b;
		a = tmp;
	}
	return a;
}

void assert (bool statement) {
	while(!statement) {
	}
}

int main() {
	int n, k;
	while(1) {
		scanf("%d%d", &n, &k);
		if (n == 0 && k == 0) break;
		long long temp = 1;
		for (int i = 0; i < k; i++) {
			scanf("%d%d", &a[i], &b[i]);
			int t = gcd(a[i], b[i]);
			a[i] /= t;
			b[i] /= t;
			temp *= b[i] / gcd(b[i], temp);
		}
		double res = 0, prob = 1;
		long long c = 1;
		for (int i = 1; i * prob > EPS; i++) {
			c *= n;
			if (c == 0) break;
			assert (c);
			double cur = (double)(c % temp) / c;
			c %= temp;
			res += prob * i * (1 - cur);
			prob *= cur;
		}
		printf("%lf\n", res);
	}
	return 0;
}
