#include <cstdio>

#define MOD 100000000
#define MAXN 1024

int c[MAXN][MAXN];

int main() {
	c[0][0] = 1;
	for (int i = 1; i < MAXN; i++) {
		c[i][0] = 1;
		for (int j = 1; j <= i; j++) {
			c[i][j] = (c[i - 1][j - 1] + c[i - 1][j]) % MOD;
		}
	}
	while(1) {
		int n;
		scanf("%d", &n);
		if (n == 0) break;
		int res = 0;
		for (int a = 1; a <= n; a++) {
			for (int b = a; b <= n; b++) {
				if (a * b % n) continue;
				int k = a * b / n;
				int cur = ((long long)c[n][k] * c[n - k][a - k]) % MOD;
				cur = ((long long)cur * c[n - a][b - k]) % MOD;
				res = (res + cur) % MOD;
				if (a != b) res = (res + cur) % MOD;
			}
		}
		printf("%d\n", res);
	}
	return 0;
}
