#include <cstdio>
#include <cstring>
#include <vector>
#include <utility>

#define mp make_pair

using namespace std;
typedef unsigned long long ull;

void bitprnt(unsigned long long num) {
	int i;
	for (i = 63; i > 0 && !(num >> i & 1); --i) putchar('0');
	for (; i >= 0; --i) putchar((num >> i & 1) + '0');
	//puts("");
}

vector<pair<unsigned long long, long long> > xx;

void add_pair(unsigned long long x, long long y) {
	//printf("%llu %lld\n", x, y);
	if (xx.empty())
		xx.push_back(mp(x, y));
	else
		if (xx.back().second < y)
			xx.push_back(mp(x, y));
/*
	for (int i = 0; i < xx.size(); ++i)
		printf("\t%llu %lld\n", xx[i].first, xx[i].second);
*/
}

long long dp[64][2];

long long f(ull num) {
	if (num == 0) return 1;
	memset(dp, 0, sizeof(dp));
	dp[63][0] = 1;
	for (int i = 63; i > 0; --i) {
		int bit = (num >> i) & 1;

		dp[i-1][0] += dp[i][0];
		dp[i-1][1] += dp[i][1];
		if (bit) {
			dp[i-1][1] += dp[i][0];
		} else {
			dp[i-1][0] += dp[i][1];
		}
	}
	return dp[0][0] + (num & 1 ? 0 : dp[0][1]);
}

int main() {
//	memset(res, -1, sizeof(res));
	for (unsigned num = 0; num < 1000000; ++num) {
		add_pair(num, f(num));
	}

	for (int i = 0; i < xx.size(); ++i) {
		bitprnt(xx[i].first);
		printf(" %llu %lld\n", xx[i].first, xx[i].second);
	}

	return 0;
}
