#include <cstdio>
#include <cstring>

const int MAXN = 1 << 7;
const int MAXM = 1 << 13;

struct el {
	int from;
	int to;
	int rd;
	int dst;
	el() {}
	el(int _from, int _to, int _rd, int _dst)
	: from(_from), to(_to), rd(_rd), dst(_dst) {}
};

int N, M;
int balance[MAXN];
int vec[MAXN];
el buf[MAXM * 2];
int bp;
int ans;
int source, sink;

void add_edge(int fr, int to, int rd, int dst) {
	buf[bp] = el(fr, to, rd, dst);
	vec[fr] = bp++;

	buf[bp] = el(to, fr, 0, -dst);
	vec[to] = bp++;
}

int max_flow() {
}

int main() {
	int tc;
	scanf("%d", &tc);

	for (int ctc = 0; ctc < tc; ++ctc) {
		printf("Case #%d: ", ctc + 1);
		scanf("%d %d", &N, &M);

		memset(vec, -1, sizeof(vec));
		memset(balance, 0, sizeof(balance));
		bp = 0;
		ans = 0;
		int targ_flow = 0, flow_size;
		for (int i = 0; i < M; ++i) {
			int u, v, t, q, p;
			scanf("%d %d %d %d %d", &u, &v, &t, &q, &p);
			--u; --v;
			if (p < q) {
				printf("%s\n", "Impossible");
				goto nextc;
			}

			add_edge(u, v, p - q, t);

			balance[u] += p;
			balance[v] -= p;
			ans += p * t;
		}
		source = N;
		sink = source + 1;

		for (int i = 0; i < N; ++i) {
			if (balance[i] > 0) {
				add_edge(source, i, balance[i], 0);
				targ_flow += balance[i];
			} else if (balance[i] < 0) {
				add_edge(i, sink, -balance[i], 0);
				targ_flow -= balance[i];
			}
		}
		flow_size = max_flow();
		if (flow_size != targ_flow)
			printf("Impossible\n");
		else
			printf("%d\n", ans);

		nextc:;
	}

	return 0;
}
