#include <cstdio>
#include <algorithm>
#include <utility>

const int MAX = 1 << 10;

#define MP(A,B) std::make_pair(A,B)

int GP;
std::pair <int, int> good[MAX];

int main () {
	good[GP++] = MP (0, 0);
	int h, m;
	int x, y;
	for (x = 1; x < 10; ++x)
		for (y = 0; y < 10; ++y) {
			//00:0x
			h = 0;
			m = x;
			good[GP++] = MP (h, m);
			//00:xx
			h = 0;
			m = x * 10 + x;
			if (m < 60) good[GP++] = MP (h, m);
			//0x:yx
			h = x;
			m = y * 10 + x;
			if (m < 60) good[GP++] = MP (h, m);
			//xy:yx
			h = x * 10 + y;
			m = y * 10 + x;
			if (h < 24 && m < 60) good[GP++] = MP (h, m);
		}

	std::sort (good, good + GP);
	GP = std::unique (good, good + GP) - good;

	int tc;
	scanf ("%d", &tc);
	while (tc--) {
		scanf ("%d:%d", &h, &m);
		std::pair <int, int> res = good[(std::upper_bound (good, good+GP, MP (h, m)) - good) % GP];
		printf ("%02d:%02d\n", res.first, res.second);
	}
	return 0;
}
