#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 14;

int N, M;
int vec[MAXN];
bool cmp (int a, int b) {
	return 	a % M != b % M ?
				a % M < b % M :
				abs (a % 2) != abs (b % 2) ?
					abs (a % 2) > abs (b % 2) :
					abs (a % 2) == 1 ?
						a > b :
						a < b;
}

int main () {
	while (scanf ("%d %d", &N, &M), N) {
		printf ("%d %d\n", N, M);
		for (int i = 0; i < N; ++i)
			scanf ("%d", vec + i);
		std::sort (vec, vec + N, cmp);
		for (int i = 0; i < N; ++i)
			printf ("%d\n", vec[i]);
	}
	printf ("0 0\n");

	return 0;
}
