#include <cstdio>
#include <cctype>
#include <cstring>
#include <cstdlib>
#include <string>

const int MAXLEN = 1 << 10;

struct el;

union x {
	el *p;
	int a;
};

struct el {
	x m[2][2];
};

bool vec1[MAXLEN * 4];
bool vec2[MAXLEN * 4];
int v1p, v2p;

void to_vec (char r[], bool v[], int &p) {
	int pp = 0;
	int tmp;
	int i, j;
	for (i = 0; r[i]; ++i) {
		if (isdigit (r[i]))
			tmp = r[i] - '0';
		else
			tmp = r[i] - 'A' + 10;

		for (j = 3; j >= 0; --j)
			v[pp++] = (tmp >> j) & 1;
	}

	for (i = 0; !v[i]; ++i);
	p = i + 1;//jump over the first 1
}

void read_input () {
	static char _row1[MAXLEN], _row2[MAXLEN];
	scanf ("%s%s", _row1, _row2);

	if (_row1[0] == '0' && _row2[0] == '0') exit (0);

	to_vec (_row1, vec1, v1p);
	to_vec (_row2, vec2, v2p);
}

x rec (x a, x b) {
	x ret;
	int tmp;
	if (a.a < 2 && b.a < 2) {
		ret.a = a.a && b.a;
		return ret;
	}

	if (a.a < 2) {
		tmp = a.a;
		a.p = new el;
		a.p->m[0][0].a = a.p->m[0][1].a = a.p->m[1][0].a = a.p->m[1][1].a = tmp;
	}

	if (b.a < 2) {
		tmp = b.a;
		b.p = new el;
		b.p->m[0][0].a = b.p->m[0][1].a = b.p->m[1][0].a = b.p->m[1][1].a = tmp;
	}

	ret.p = new el;
	ret.p->m[0][0] = rec (a.p->m[0][0], b.p->m[0][0]);
	ret.p->m[0][1] = rec (a.p->m[0][1], b.p->m[0][1]);
	ret.p->m[1][0] = rec (a.p->m[1][0], b.p->m[1][0]);
	ret.p->m[1][1] = rec (a.p->m[1][1], b.p->m[1][1]);

	return ret;
}

int cc;
x makex (bool *vec) {
	x ret;
	if (vec[cc] == 1) {
		ret.a = vec[cc+1];
		cc += 2;
	} else {
		++cc;
		ret.p = new el;
		ret.p->m[0][0] = makex (vec);
		ret.p->m[0][1] = makex (vec);
		ret.p->m[1][0] = makex (vec);
		ret.p->m[1][1] = makex (vec);
	}

	return ret;
}

void prnt (x a) {
	if (a.a < 2) {printf ("(%d)", a.a); return;}
	printf ("(");
	prnt (a.p->m[0][0]);
	prnt (a.p->m[0][1]);
	prnt (a.p->m[1][0]);
	prnt (a.p->m[1][1]);
	printf (")");
}

int rp = 0;
bool ress[MAXLEN * 4];

void tos (x res) {
	if (res.a < 2) {
		ress[rp++] = 1;
		ress[rp++] = res.a;
	} else {
		ress[rp++] = 0;
		tos (res.p->m[0][0]);
		tos (res.p->m[0][1]);
		tos (res.p->m[1][0]);
		tos (res.p->m[1][1]);
	}
}

int resssp;
char resss[MAXLEN];

char toc (int a) {
	if (a < 10) return a + '0';
	return a + 'A' - 10;
}

void tors () {
	int xx;
	resssp = 0;
	for (int i = rp % 4; i != rp; i += 4) {
		xx = (ress[i] << 3) | (ress[i+1] << 2) | (ress[i+2] << 1) | (ress[i+3]);
		resss[resssp++] = toc (xx);
	}
	resss[resssp] = 0;
}

int main () {
	x x1, x2, res;
	ress[3] = 1;

	for (int tc = 1;; ++tc) {
		read_input ();

		cc = v1p;
		x1 = makex (vec1);

		cc = v2p;
		x2 = makex (vec2);

		res = rec (x1, x2);

		rp = 4;
		tos (res);

		tors ();
		if (tc != 1) printf ("\n");
		printf ("Image %d:\n%s\n", tc, resss);
	}

	return 0;
}
