#include <cstdio>
#include <cctype>
#include <cstring>
#include <cstdlib>
#include <string>

const int MAXLEN = 1 << 10;

bool vec1[MAXLEN * 4];
bool vec2[MAXLEN * 4];
int v1p, v2p;

void to_vec (char r[], bool v[], int &p) {
	int pp = 0;
	int tmp;
	int i, j;
	for (i = 0; r[i]; ++i) {
		if (isdigit (r[i]))
			tmp = r[i] - '0';
		else
			tmp = r[i] - 'A' + 10;

		for (j = 3; j >= 0; --j) {
			v[pp++] = (tmp >> j) & 1;
		}
	}

	for (i = 0; !v[i]; ++i);
	p = i + 1;//jump over the first 1
}

void read_input () {
	static char _row1[MAXLEN], _row2[MAXLEN];
	scanf ("%s%s", _row1, _row2);

	if (std::string (_row1) == "0" && std::string (_row2) == "0") exit (0);

	to_vec (_row1, vec1, v1p);
	to_vec (_row2, vec2, v2p);
}
int rp = 0;
bool ress[MAXLEN * 4];

int p1, p2;

void solve (int _1, int _2) {
//	printf ("solve %d %d -- %d %d\n", p1, p2, _1, _2);
//	getc (stdin);
	if (_1 == -1)
		if (vec1[p1++] == 1) _1 = vec1[p1++];

	if (_2 == -1)
		if (vec2[p2++] == 1) _2 = vec2[p2++];

	if (_1 != -1 && _2 != -1) {
		ress[rp++] = 1;
		ress[rp++] = (_1 && _2);
		return;
	}

	ress[rp++] = 0;
	solve (_1, _2);
	solve (_1, _2);
	solve (_1, _2);
	solve (_1, _2);
}

int resssp;
char resss[MAXLEN];

char toc (int a) {
	if (a < 10) return a + '0';
	return a + 'A' - 10;
}

void tors () {
	int xx;
	resssp = 0;
	for (int i = rp % 4; i < rp; i += 4) {
		xx = (ress[i] << 3) | (ress[i+1] << 2) | (ress[i+2] << 1) | (ress[i+3]);
		resss[resssp++] = toc (xx);
	}

	resss[resssp] = 0;
}

int main () {
	ress[3] = 1;

	for (int tc = 1;; ++tc) {
		read_input ();
		p1 = v1p, p2 = v2p;
		rp = 4;
		solve (-1, -1);

		tors ();
		if (tc != 1) printf ("\n");
		printf ("Image %d:\n%s\n", tc, resss);
	}

	return 0;
}
