#include <cstdio>
#include <algorithm>
#include <utility>

std::pair <int, int> ext_gcd_it (int A, int B) {
	std::pair <int, int> q1 (1, 0), q2 (0, 1), tmp;

//	if (A < B) std::swap (A, B);
	int q;
	while (B) {
		q = A / B;
		tmp = std::make_pair (q1.first - q2.first * q, q1.second - q2.second * q);
		q1 = q2;
		q2 = tmp;
		A %= B;
		std::swap (A, B);
	}

	return q1;
}

std::pair <int, int> ext_gcd_rec (int A, int  B) {
	std::pair <int, int> tmp;
	return B ? (tmp = ext_gcd_rec (B, A % B), std::make_pair (tmp.second, tmp.first - tmp.second * (A / B))) : std::make_pair (1, 0);
}

int main () {
	int A, B;
	scanf ("%d %d", &A, &B);

	std::pair <int, int> res = ext_gcd_rec (A, B);

	printf ("A * (%d) + B * (%d) == gcd (A, B) == %d\n", res.first, res.second, A * res.first + B * res.second);

	return 0;
}
