 #include <stdio.h>
 
#define MAXN 1024
 
int n, SOURCE, SINK;
int lab[MAXN];
int ex[MAXN];
int cap[MAXN][MAXN];
int flow[MAXN][MAXN];
int actives;
int active[MAXN];
int isactive[MAXN];
int grs;
int gr[MAXN];
 
 
int main(void) {
 int i, j, t, v, w, minlab, fl, cnt;
 
 scanf("%d", &n);
 if (n>MAXN) {
  printf("Sorry! N is too large!\n");
  return 1;
 }
 for (i=0; i<n; i++){
  for (j=0; j<n; j++) {
   scanf("%d", &cap[i][j]);
  }
 }
 scanf("%d %d", &SOURCE, &SINK);
 
 for (w=0; w<n; w++) if (cap[SOURCE][w]>0) {
  flow[SOURCE][w]=cap[SOURCE][w];
  flow[w][SOURCE]=-cap[SOURCE][w];
  ex[w]=cap[SOURCE][w];
  if (w != SINK) {
   active[actives]=w;
   actives++;
   isactive[w]=1;
  }
 }
 
 cnt=n-1;
 for (t=0; t!=actives; t++) {
  cnt++;
  if (cnt==n) {
   cnt=0;
   for (i=0; i<n; i++) lab[i]=n*2;
   lab[SINK]=0;
   lab[SOURCE]=n;
   gr[0]=SINK;
   grs=1;
   for (i=0; i<grs; i++) {
    v=gr[i];
    for (j=0; j<n; j++) {
     if (lab[j]==n*2 && flow[j][v]<cap[j][v]) {
      lab[j]=lab[v]+1;
      gr[grs]=j;
      grs++;
     }
    }
   }
   gr[0]=SOURCE;
   grs=1;
   for (i=0; i<grs; i++) {
    v=gr[i];
    for (j=0; j<n; j++) {
     if (lab[j]==n*2 && flow[j][v]<cap[j][v]) {
      lab[j]=lab[v]+1;
      gr[grs]=j;
      grs++;
     }
    }
   }
  }
  if (t==n) t=0;
  v=active[t];
  minlab=3*n;
  for (w=0; w<n; w++) {
   if (lab[v]==lab[w]+1 && flow[v][w]<cap[v][w]) {
    if (w!=SOURCE && w!=SINK) {
     if (!isactive[w]) {
      if (actives==n) actives=0;
      active[actives]=w;
      actives++;
      isactive[w]=1;
     }
    }
    fl=cap[v][w]-flow[v][w];
    if (ex[v]<fl) fl=ex[v];
    flow[v][w]+=fl;
    flow[w][v]-=fl;
    ex[w]+=fl;
    ex[v]-=fl;
    if (ex[v]==0) break;
   } else if (lab[w]<minlab && flow[v][w]<cap[v][w]) minlab=lab[w];
  }
  if (ex[v]>0) {
   lab[v]=minlab+1;
   if (actives==n) actives=0;
   active[actives]=v;
   actives++;
  } else {
   isactive[v]=0;
  }
 }
 
 printf("%d\n", ex[SINK]);
 
 return 0;
}
 