#include <cstdio>
#include <cassert>
#include <cstdlib>
#include <ctime>

int N, M, Q;
int x1, y1, x2, y2;

void gen () {
	x1 = rand () % N;
	x2 = rand () % (N - x1) + 1 + x1;

	y1 = rand () % M;
	y2 = rand () % (M - y1) + 1 + y1;
}

int main (int argc, char *argv[]) {
	assert (argc == 5);
	
	FILE *in = fopen (argv[1], "w");
	sscanf (argv[2], "%d", &N);
	sscanf (argv[3], "%d", &M);
	sscanf (argv[4], "%d", &Q);
	
	assert (in);
	fprintf (in, "%d %d %d\n", N, M, Q);
	
	srand (time (NULL));
	for (int i = 0; i < Q; ++i) {
		int qt = rand () % 2 + 1;
		gen ();
		fprintf (in, "%d %d %d %d %d", qt, x1, y1, x2, y2);
		if (qt == 1) {
			fprintf (in, " %d", rand () % 1000 - 500);
		}
		fputs ("\n", in);
	}

	return 0;
}
