/*
FROM: Balkan Olympiad in Informatics (BOI) 1997 day 1
PROB: factorials
KEYW: log base 10
*/

#include <cstdio>
#include <cmath>

int main () {
	int N;
	scanf ("%d", &N);
	--N;

	double sum = 0;
	static int ans[16], ap = 0;

	int i;
	for (i = 1; ; ++i) {
		sum += log10 (i);
		if ((int)floor (sum) == N)
			ans[ap++] = i;
		if ((int)floor (sum) > N)
			break;
	}

	if (ap == 0) printf ("NO\n");
	else {
		printf ("%d\n", ap);
		for (i = 0; i < ap; ++i)
			printf ("%d\n", ans[i]);
	}

	return 0;
}
