/*
FROM: Balkan Olympiad in Informatics (BOI) 1997
PROB: quadtrees
KEYW: recursion, trees, preorder traversal
*/

#include <cstdio>

const int MAXL = 2048;//1024 * 2 - 1 + terminating zero

char po1[MAXL];
char po2[MAXL];
char res[MAXL];
int i1, i2 , ri;

void adv (char po[], int &i) {
	if (po[i] != 'i') ++i;
	else {
		++i;
		adv (po, i); adv (po, i);
		adv (po, i); adv (po, i);
	}
}

void cpy (char po[], int &i) {
	if (po[i] != 'i') res[ri++] = po[i++];
	else {
		res[ri++] = po[i++];//copy the 'i'
		cpy (po, i); cpy (po, i);
		cpy (po, i); cpy (po, i);
	}
}

void trav () {
	if (po1[i1] == 'w' || po2[i2] == 'w') {
		res[ri++] = 'w';
		adv (po1, i1);
		adv (po2, i2);
	} else if (po1[i1] == 'b') {
		adv (po1, i1);
		cpy (po2, i2);
	} else if (po2[i2] == 'b') {
		cpy (po1, i1);
		adv (po2, i2);
	} else {
		++i1; ++i2;
		res[ri++] = 'i';
		trav (); trav ();
		trav (); trav ();
	}
}

int main () {
	scanf ("%*d\n");//we dont need N
	gets (po1);
	gets (po2);
	trav ();

//	puts (res);
	printf ("%d\n", ri);
}
