/*
FROM: BOOI 4
TASK: fibtree
KEYW: dynamical programming
LANG: C++
*/

#include <cstdio>

const int MAXN = 1 << 9 + 1;
const int MAXK = 1 << 9 + 1;

const int BASE = 1000000000;
int bigN = 20;

struct big {
	int a[20];
	big () {}
//	big () {for (int i = 0; i < bigN; ++i) a[i] = 0;}
	big operator = (int b) {for (int i = 0; i < bigN; ++i) a[i] = 0; a[0] = b; return *this;}
	big operator = (const big &b) {for (int i = 0; i < bigN; ++i) a[i] = b.a[i]; return *this;}
	big operator += (const big &b) {for (int i = 0; i < bigN-1; ++i) {a[i] += b.a[i]; a[i+1] += a[i] / BASE; a[i] %= BASE;} return *this;}
	void prnt () {int i; for (i = bigN-1; i >= 0 && !a[i]; --i); if (i == -1) printf ("0"); else {printf ("%d", a[i]); for (--i; i >= 0; --i) printf ("%09d", a[i]);}}
};

int N, K;
big **opt;

int main () {
	fprintf (stderr, "ex!\n");

	opt = new big *[MAXN];
	for (int i = 0; i < MAXN; ++i)
		opt[i] = new big [MAXN];

	fprintf (stderr, "ex!\n");
	scanf ("%d %d", &N, &K);

	int i, j;
	opt[1][1] = 1;
	for (i = 2; i <= N; ++i) {
		opt[i][1] = 1;
		for (j = 2; j <= i; ++j) {
//			fprintf (stderr, "%d %d", i, j);
			opt[i][j] = opt[i-1][j-1];
//			fprintf (stderr, "!\n");
			opt[i][j] += opt[i-2][j-1];
		}
	}
/*
	for (i = 1; i <= N; ++i) {
		for (j = 1; j <= i; ++j) {
//			printf ("%Ld ", opt[i][j]);
			opt[i][j].prnt (); printf (" ");
		}
		printf ("\n");
	}
*/

	opt[N][K].prnt ();
	printf ("\n");

	return 0;
}
