/*
FROM: Central Europen Olympiad in Informatics (CEOI) 2002 day 2
PROB: dwarfs
KEYW: test generator (random)
*/

#include <cstdio>
#include <cassert>
#include <cstdlib>
#include <ctime>

int N, M;

int main (int argc, char *argv[]) {
	srand (time (0));
	assert (argc == 4);
	FILE *in = fopen (argv[1], "w");
	sscanf (argv[2], "%d", &N);
	sscanf (argv[3], "%d", &M);
	assert (in);

	fprintf (in, "%d\n", N);
	int i;
	for (i = 0; i < N; ++i)
		fprintf (in, "%lf %lf\n", rand () / 1000., rand () / 1000.);

	for (i = 0; i < M; ++i)
		fprintf (in, "%lf %lf %lf %lf\n", rand () / 1000., rand () / 1000., rand () / 1000., rand () / 1000.);
	fclose (in);

	return 0;
}
