#include <cstdio>
#include <cstring>
#include <queue>

using namespace std;

char used[5001][5001], prev[5001][5001], left[1024][5001], right[1024][5001];
short a[5001], b[5001], ans[10002], ac;
int L, M, N;

void input(void)
{
  char buff[10];
  int i, j;
  //freopen("airport.in", "rt", stdin);
  memset(left, 0, sizeof left);
  memset(right, 0, sizeof right);
  scanf("%d\n", &N);
  scanf("%d\n", &L);
  for(i=0; i<L; ++i)
  {
    scanf("%s %hd", buff, &a[i]);
    for(j=0; j<N; ++j)
      left[j][i+1]=left[j][i];
    left[a[i]][i+1]=!left[a[i]][i+1];
  }
  scanf("%d\n", &M);
  for(i=0; i<M; ++i)
  {
    scanf("%s %hd", buff, &b[i]);
    for(j=0; j<N; ++j)
      right[j][i+1]=right[j][i];
    right[b[i]][i+1]=!right[b[i]][i+1];
  }
}

void bfs(void)
{
  char flag=1;
  int i, j;
  queue<pair<short, short> > q;
  memset(used, 0, sizeof used);
  used[0][0]=1;
  q.push(pair<short, short>(0, 0));
  while(!q.empty())
  {
    i=q.front().first;
    j=q.front().second;
    q.pop();
    flag=1;
    if(i==L || j==M)
      continue;
    if(i<L && !right[a[i]][j])
    {
      if(!used[i+1][j])
      {
        used[i+1][j]=1;
        q.push(pair<short, short>(i+1, j));
        prev[i+1][j]=1;
      }
      flag=0;
    }
    if(j<M && !left[b[j]][i])
    {
      if(!used[i][j+1])
      {
        used[i][j+1]=1;
        q.push(pair<short, short>(i, j+1));
        prev[i][j+1]=2;
      }
      flag=0;
    }
    if(flag)
    {
      ac=0;
      while(i||j)
      {
        ans[ac++]=prev[i][j];
        if(prev[i][j]==1)
          --i;
        else
          --j;
      }
      while(ac--)
        printf("%hd", ans[ac]);
      printf("\n");
      flag=-1;
      break;
    }
  }
  if(flag!=-1)
    printf("The performances will always finish.\n");
}

int main(void)
{
  input();
  bfs();
  return 0;
}
