/*
FROM: ROMANIA 2005/2006 ROUND 6 L
PROB: grazing
KEYW: dynamical programming??
*/

#include <cstdio>

const int MAXN = 1 << 3;
const int _infinity = 100;

int N;
int ma3x[MAXN][MAXN];

int sc;

void floid () {
	int i, j, k;
	for (k = 0; k < N; ++k)
		for (i = 0; i < N; ++i)
			for (j = 0; j < N; ++j)
				if (ma3x[i][j] > ma3x[i][k] + ma3x[k][j] - 1)
					ma3x[i][j] = ma3x[i][k] + ma3x[k][j] - 1;
/*
	printf ("**********\n");
	for (i = 0; i < N; ++i) {
		for (j = 0; j < N; ++j)
			printf ("%4d ", ma3x[i][j]);
		printf ("\n");
	}
	printf ("**********\n");
*/
}

void check () {
	int i =0, j =0, k =0;
	for (i = 0; i < N; ++i)
		for (j = i + 1; j < N; ++j)
			for (k = j + 1; k < N; ++k)
				if (ma3x[i][j] == ma3x[i][k] && ma3x[i][j] == ma3x[j][k] && ma3x[i][j] <= N) {
//					printf ("%d %d %d (%d %d %d)\n", i, j, k, ma3x[i][j], ma3x[i][k], ma3x[j][k]);
					return;
				}
	++sc;
}

int main () {
	scanf ("%d", &N);

	int i, ub = N * (N - 1) / 2;
	int ii, jj, tmp;
	for (i = 0; i < (1 << ub); ++i) {
		tmp = i;
		for (ii = 1; ii < N; ++ii)
			for (jj = 0; jj < ii; ++jj) {
				ma3x[ii][jj] = ma3x[jj][ii] = (tmp & 1 ? 2 : _infinity);
				tmp >>= 1;
			}
		for (ii = 0; ii < N; ++ii) ma3x[ii][ii] = 1;
/*
		for (ii = 0; ii < N; ++ii) {
			for (jj = 0; jj < N; ++jj)
				printf ("%4d ", ma3x[ii][jj]);
			printf ("\n");
		}
		printf ("\n");
		*/
		floid ();
		check ();
	}
	printf ("%d\n", sc);

	return 0;
}
