/*
FROM: Campion 2005/2006 round 7 Large
PROB: program
KEYW: dynamical programming
NOTE: N^2
*/

#include <cstdio>
#include <cstring>

const int MAXN = 1 << 9;
const int MOD = 9731;

int N;
char a[MAXN];
int dp[MAXN][MAXN];

int main () {
	gets (a);
	N = strlen (a);

	int i, j;
	for (j = 0; j <= N; ++j) dp[N][j] = 1;//we only need to close those brackets

	for (i = N-1; i >= 0; --i) {
		dp[i][0] = (a[i] == ')' ? 0 : dp[i+1][1]);
		for (j = 1; j <= N; ++j)
			dp[i][j] = (a[i] == ')' ? dp[i+1][j-1] : dp[i+1][j+1] + dp[i][j-1]) % MOD;
	}

	printf ("%d\n", dp[0][0]);

	return 0;
}
