/*
FROM: Champion 2006 round 5 Large
PROB: kerg
KEYW: building a connected graph given the degrees of its nodes
*/

#include <cstdio>
#include <functional>
#include <algorithm>

const int MAXN = 1 << 14;

int K, N;
int vec[MAXN];

int main () {
	FILE *in = fopen ("kreg.in", "r");
	FILE *out = fopen ("kreg.out", "w");
//	FILE *in = stdin;
//	FILE *out = stdout;

	fscanf (in, "%d %d", &K, &N);
	fclose (in);

	int i, j;
	for (i = 0; i < N; ++i) vec[i] = K;
	vec[N] = -1;

	std::pair <int *, int *> bnd;
	int lb, ub;
	for (i = 0; vec[i]; ++i) {
/*		if (vec[i + vec[i]] != vec[i + vec[i] + 1]) {
			for (j = i + 1; j < i + 1 + vec[i]; ++j) {--vec[j]; fprintf (out, "%d %d", i + 1, j + 1);}
			continue;
		}
*/
		bnd = std::equal_range (vec + i + 1, vec + N, vec[i + vec[i]], std::greater <int> ());
		lb = bnd.first - vec;
		ub = bnd.second - vec;
		for (j = i + 1; j != lb; ++j) {
			--vec[j];
			fprintf (out, "%d %d\n", i + 1, j + 1);
		}
		vec[i] -= lb - i - 1;
		for (j = ub - vec[i]; j != ub; ++j) {
			--vec[j];
			fprintf (out, "%d %d\n", i + 1, j + 1);
		}
	}

	fclose (out);

	return 0;
}
