/*
FROM: Champion 2006 round 6 Large
PROB: 2sec
KEYW: dynamical programming
*/

#include <cstdio>

const int MAXN = 1 << 20;

int N;
int vec[MAXN];
int bcmin[MAXN];

int main () {
    FILE *in = fopen ("2sec.in", "r");
    FILE *out = fopen ("2sec.out", "w");
//    FILE *in = stdin;
//    FILE *out = stdout;

    fscanf (in, "%d", &N);
    int i;
    for (i = 0; i < N; ++i)
        fscanf (in, "%d", vec + i);
    fclose (in);
    
    bcmin[0] = vec[0];
    int cmin = vec[0];
    for (i = 1; i < N; ++i) {
        cmin = (cmin <? 0) + vec[i];
        bcmin[i] = bcmin[i-1] <? cmin;
    }

    int cmax = vec[N-1];
    int bcmax = cmax;
    int bdif = bcmax - bcmin[N-2];
//    printf ("%d %d\n", bcmin[N-2], bcmax);
    for (i = N-2; i; --i) {
        cmax = (cmax >? 0) + vec[i];
        bcmax >?= cmax;
//        printf ("%d %d\n", bcmin[i-1], bcmax);
        bdif >?= bcmax - bcmin[i-1];
    }

    fprintf (out, "%d\n", bdif);
    fclose (out);

    return 0;
}
