#include <cstdio>
#include <cstring>
//#include <vector>
#include <algorithm>

const int MAXN = 1 << 7;
const int MAX_CAP = 1 << 10;

int N;
short rd[MAXN][MAXN];
char D[MAXN];
char bD[MAXN];
short ma3x[MAXN][MAXN];
int source, sink;

unsigned vp;
unsigned char vl[MAXN];
//bool used[MAXN];

bool bfs () {
	static int q[MAXN];
	static int p3, i, j;
	p3 = 0;
	memset (D, -1, sizeof (D));
//	memset (used, 0, sizeof (used));
/*	for (i = 0; i < N; ++i) {
		D[i] = -1;
		used[i] = 0;
	}*/
//	used[source] = 1;
	D[sink] = 0;
	q[p3++] = sink;

	for (i = 0; i < p3; ++i) {
//		printf ("pop %d(%d)\n", q[i], D[i]);
		for (j = 0; j < N; ++j) {
			if (rd[j][q[i]] > 0 && D[j] == -1) {
//				printf ("\rpush %d(%d)\n", j, D[q[i]] + 1);
				D[j] = D[q[i]] + 1;
				q[p3++] = j;
			}
		}
	}/*
	for (i = 0; i < N; ++i)
		printf ("%d ", D[i]); printf ("--bfs-\n");*/

	return D[source] != -1;
}

int dfs (int a) {
//	printf ("dfs %d\n", a);
	if (a == sink) {
//		used[sink] = 1;
		return MAX_CAP;
	}

	int tmp;
	for (int i = 0; i < N; ++i) {
		if (D[i] == D[a] - 1 && rd[a][i] > 0) {
//			printf ("\rdfs push %d\n", i);
			vl[vp++] = i;
			if ((tmp = dfs (i))) {D[a] = -5; return tmp * (tmp <= rd[a][i]) + rd[a][i] * (tmp > rd[a][i]);}//fucky minimum
			--vp;
		}
	}
	D[a] = -5;
	return 0;
}

int _sv_d_source;
int dinitz (int _sink) {
	sink = _sink;
	memcpy (rd, ma3x, sizeof (ma3x));

//	printf ("dinitz %d\n", _sink);

	int maxflow = 0, cflow;
	unsigned i;
	int c;
//	vl[0] = source;
	while (bfs ()) {
		_sv_d_source = D[source];
		while (vp = 0, D[source] = _sv_d_source, cflow = dfs (source)) {
			maxflow += cflow;
//			printf ("cflow -- %d\n", cflow);
			c = source;
			for (i = 0; i < vp; ++i) {
//				printf ("%d -> %d\n", c, vl[i]);
				rd[c][vl[i]] -= cflow;
				rd[vl[i]][c] += cflow;
				c = vl[i];
			}
		}
	}
	return maxflow;
}

int main () {
	FILE *in = fopen ("croco.in", "r");
	FILE *out = fopen ("croco.out", "w");
//	FILE *in = stdin;
//	FILE *out = stdout;

	fscanf (in, "%d", &N);
	int i, j;
	int sum = 0;
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j) {
			fscanf (in, "%hd", &ma3x[i][j]);
			sum += ma3x[i][j];
		}
	fclose (in);

	source = 0;
	int tmp;
	int best = dinitz (1), besti = 1;
	memcpy (bD, D, sizeof (D));
	for (i = 2; i < N; ++i)
		if ((tmp = dinitz (i)) < best) {
			best = tmp;
			besti = i;
			memcpy (bD, D, sizeof (D));
		}

//	dinitz (besti);

//	printf ("%d %d\n", best, besti);
/*	for (i = 0; i < N; ++i) {
		for (j = 0; j < N; ++j)
			printf (" %d", rd[i][j]);
		printf ("\n");
	}
*/
/*	for (i = 0; i < N; ++i)
		if (D[i] == -1)
			ans.push_back (i);*/

	fprintf (out, "%d ", sum / 2 - best);
	fprintf (out, "%d\n%d", (int)std::count (bD, bD + N, -1), 1);
	for (i = 1; i < N; ++i) if (bD[i] == -1) fprintf (out, " %d", i + 1); fprintf (out, "\n");

	return 0;
}
