/*
FROM: Campion 2006/2007 round 12 Large
PROB: toys
KEYW: nth_element
*/

#include <cstdio>
#include <algorithm>

typedef long long lld;
const int MAXN = 1 << 21;

int N, L, M;
int S, X, Y, Z, V;
int ftd[MAXN];

int main () {
	freopen ("toys.in", "r", stdin);
	freopen ("toys.out", "w", stdout);

	scanf ("%d %d %d", &N, &L, &M);
	scanf ("%d %d %d %d %d", &S, &X, &Y, &Z, &V);

	long long di = S, ti = 1;
	for (int i = 0; i < N; ++i) {
		//add
//		printf ("add %Ld %Ld\n", di, ti);
		if (ti) {
			++M;
			ftd[i] = di;
		} else {
			ftd[i] = 2ll * L - di;
		}

		//find new
		ti = ((lld)Z * di + (lld)V * (lld)(i + 1)) % 2ll;
		di = ((lld)X * di + (lld)Y * (lld)(i + 1)) % (lld)(L - 1) + 1ll;
	}
	--M;
	
//	for (int i = 0; i < N; ++i) printf ("%d ", ftd[i]); printf ("\n");
//	printf ("%Ld + %dth\n", 2ll * (lld)M * (lld)L / (lld)N, M % N);
	std::nth_element (ftd, ftd + M % N, ftd + N);
	printf ("%Ld\n", (lld)M / (lld)N * 2ll * (lld)L + ftd[M % N]);

	return 0;
}
