/*
KEYW: Ad Hoc Problem
*/
#include <cstdio>
#include <vector>
#include <cctype>
#include <cstdlib>

const int MAXK = 10;
const int MAXN = 1 << MAXK;

int N, K;

bool black[MAXK];
bool active[MAXN];
bool target[MAXN];
std::vector <std::vector <int> > circle;

void input () {
	scanf ("%d %d\n", &N, &K);
	circle.resize (K);

	int tmp = -1;
	int crnt;
	bool ext = 0;

	while (!ext) {
		crnt = getc (stdin);
		if (isdigit (crnt)) {
			if (tmp == -1)
				tmp = crnt - '0';
			else {
				tmp *= 10;
				tmp += crnt - '0';
			}
		} else {
			if (tmp != -1) {
				target[--tmp] = 1;
				tmp = -1;
			}
				ext = (crnt == '\n');
		}
	}

	for (int i = 0; i < K; ++i) {
		ext = 0;
		tmp = -1;
		while (!ext) {
			crnt = getc (stdin);
			if (isdigit (crnt)) {
				if (tmp == -1)
					tmp = crnt - '0';
				else {
					tmp *= 10;
					tmp += crnt - '0';
				}
			} else {
				if (tmp != -1) {
					circle[i].push_back (--tmp);
					tmp = -1;
				}
				ext = (crnt == '\n');
			}
		}
	}

//	for (int i = 0; i < N; ++i) printf ("%d ", target[i]); printf ("\n");
//	for (int i = 0; i < K; ++i) {printf ("%d ->", i); for (int j = 0; j < (int)circle[i].size (); ++j) printf ("%d ", circle[i][j]); printf ("\n");}
}

bool exist_active () {
	int i;
	for (i = 0; i < N && !active[i]; ++i);
	return i != N;
}

bool isgood[MAXK];
bool tmpzone[MAXN];

void set_tmpzone () {
	for (int i = 0; i < N; ++i) tmpzone[i] = target[i];
}

std::vector <int> final;
int crnt[MAXK], cp;

int main () {
	input ();

//	for (int i = 0; i < N; ++i) printf ("%d ", target[i]); printf ("\n");
	int unblacked = K;
	int k, l;
	for (int i = 0; i < N; ++i) active[i] = 1;
	for (int i = 0; i < K; ++i) isgood[i] = 1;
	while (exist_active ()) {
		for (int i = 0; i < K; ++i) {
			if (!isgood[i]) continue;
			for (int j = 0; j < (1 << unblacked); ++j) {
				int jj = j;
				set_tmpzone ();
				cp = 0;//////////new
				for (k = 0; k < K; ++k) {
					if (!isgood[k]) continue;
					if (jj & 1) crnt[cp++] = k;//////////new
					if (jj & 1) for (l = 0; l < (int)circle[k].size (); ++l)
						tmpzone[circle[k][l]] = !tmpzone[circle[k][l]];//invert
					jj >>= 1;
				}

				for (k = 0; k < (int)circle[i].size (); ++k)
					if (active[circle[i][k]] && !tmpzone[circle[i][k]]) break;

				if (k == (int)circle[i].size ()) {//ok
					/////////////new---------BEGIN
					for (k = 0; k < cp; ++k)
						final.push_back (-(crnt[k] + 1));
					final.push_back (i + 1);
					/////////////new---------END
					black[i] = 1;
					isgood[i] = 0;
//					printf ("%d %d\n", i, j);
//					for (k = 0; k < N; ++k) printf ("%d ", tmpzone[k]); printf ("\n");
					--unblacked;
					for (k = 0; k < (int)circle[i].size (); ++k)
						active[circle[i][k]] = 0;

					for (k = 0; k < K; ++k)
						if (isgood[k]) {
							for (l = 0; l < (int)circle[k].size (); ++l)
								if (active[circle[k][l]]) break;
							if (l == (int)circle[k].size ())//not good
								isgood[k] = 0;
						}
					for (k = 0; k < N; ++k)
						target[k] = tmpzone[k];
//					for (k = 0; k < N; ++k) printf ("%d ", active[k]); printf ("\n");
//					for (k = 0; k < K; ++k) printf ("%d ", isgood[k]); printf ("\n");
					goto nxtwhile;
				}
			}
		}
		break;
		nxtwhile:;
	}

//	printf ("%s\n", exist_active () ? "IMPOSSIBLE" : "POSSIBLE");
	////////new----------BEGIN
	if (!exist_active ()) {
		printf ("%d", final.back ());
		for (int i = (int)final.size () - 2; i >= 0; --i)
			printf (" %d", final[i]);
		printf ("\n");
	} else
		printf ("0\n");

	////////new----------END

	return 0;
}
