#include <iostream>
#include <sstream>
#include <string>
#include <stack>
#include <cstdlib>
#include <cstring>

using namespace std;

#define ASSERT(p)  if (!(p)) throw ""

double evalrpn(stack<string> & tks)  {
  ASSERT(!tks.empty());
  double x,y;
  const char * p;  char * q;
  string tk = tks.top();  tks.pop();  p = tk.c_str();
  if (x=strtod(p,&q),*q!=0)  {
    ASSERT(p[1]==0 && strchr("+-*/",*p)!=NULL && tks.size()>=2);
    y = evalrpn(tks);
    x = evalrpn(tks);
    if      (*p=='+')  x += y;
    else if (*p=='-')  x -= y;
    else if (*p=='*')  x *= y;
    else               x /= y;
  }
  return x;
}

int main()  {
  string s;
  while (getline(cin,s))  {
    stack<string> tks;
    istringstream sstr(s);
    string tk;
    while (sstr >> tk)  tks.push(tk);
    if (!tks.empty())
      try  {
        double z = evalrpn(tks);
        ASSERT(tks.empty());
        cout << z << endl;
      }  catch (...)  {cout << "error" << endl;}
  }
  return 0;
}
