#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <sstream>
#include <stack>
#include <string>

#define OPER(B) {double t = stk.top (); stk.pop (); stk.top () B##= t; break;}

using namespace std;

int main () {
	string line, tok;
	stack <double> stk;
	char *strp;
	while (getline (cin, line)) try {
		if (!line.size ()) continue;
		stk = stack<double> ();
		istringstream in (line);
		while (in >> tok) {
			if (tok.size () == 1u && strchr ("+-*/", tok[0])) {
				if (stk.size () < 2) throw string ("Error: operation without needed operands");
				switch (tok[0]) {
					case '+': OPER (+)
					case '-': OPER (-)
					case '*': OPER (*)
					case '/': if (!(stk.top ())) throw string ("Error: divising by zero"); OPER (/)
				}
			} else
				if (stk.push (strtod (tok.c_str (), &strp)), *strp) throw string ("Error: bad number");
		}
		if (stk.size () > 1u) throw string ("Error: stack not empty at the end");
		cout << stk.top () << endl;
	} catch (string &s) {
		cout << s << endl;
	}

	return 0;
}
