/*
TASK: cowq
LANG: C++

FROM: USACO 2003 Dec GREEN
PROB: cowq
KEYW: dynamical programming, decoding

NOTE: DA GO EBA!!
*/

#include <cstdio>
#include <cstring>

#include <algorithm>

const int MAXN = 1 << 5;

int all[MAXN][MAXN];
int up[MAXN][MAXN];
int low[MAXN][MAXN];

int p;

char us[MAXN], ls[MAXN], ls_dp[MAXN];
int ul, ll;

char ans[MAXN];

void dpall () {
	int i, j;
	all[0][0] = 1;
	all[1][0] = 1;
	for (j = 1; j < MAXN; ++j) {
		all[0][j] = 1;
		for (i = 1; i < MAXN; ++i)
			all[i][j] = all[i-1][j-1] + all[i][j-1];
	}
}

void dp (int _dp[MAXN][MAXN], const char *s) {
	int i, j;
	_dp[0][0] = 1;
	_dp[1][0] = (s[0] == '1');
	for (j = 1; j < MAXN; ++j) {
		_dp[0][j] = 1;
		for (i = 1; i < MAXN; ++i)
			_dp[i][j] = (s[j] == '1' ? _dp[i-1][j-1] + all[i][j-1] : _dp[i][j-1]);
	}
}

int f (int i, int j, bool lb, bool ub) {
//	printf ("in f %d %d %d %d -- all %d   low %d    up %d\n", i, j, lb, ub, all[i][j], low[i][j], up[i][j]);
	return (ub ? up[i][j] : all[i][j]) - (lb ? low[i][j] : 0);
}

int main () {
	int i, j;
//	FILE *in = fopen ("cowq.in", "r");
//	fscanf (in, "%s", ls); ll = strlen (ls);
//	fscanf (in, "%s", us); ul = strlen (us);
	gets (ls); ll = strlen (ls);
	gets (us); ul = strlen (us);
//	fclose (in);

	scanf ("%d", &p);
	--p;

	std::reverse (ls, ls + ll);
	std::reverse (us, us + ul);

	for (i = ll; i < MAXN; ++i) ls[i] = '0';
	for (i = ul; i < MAXN; ++i) us[i] = '0';

//	for (i = ll - 1; i >= 0; --i) printf ("%c ", ls[i]); printf ("\n");
//	for (i = ul - 1; i >= 0; --i) printf ("%c ", us[i]); printf ("\n");
//	printf ("\n");

	dpall ();

	for (i = 0; i < ll && ls[i] == '0'; ++i) ls_dp[i] = '1';
	ls_dp[i] = '0';
	for (j = i + 1; j < MAXN; ++j) ls_dp[j] = ls[j];
//	for (i = MAXN-1; i >= 0; --i) printf ("%c ", ls_dp[i]); printf ("\n");
//	printf ("i == %d\n", i);
	if (i != ll) dp (low, ls_dp);

	dp (up, us);
/*
	for (j = 0; j < 5; ++j) {
		for (i = 0; i < 5; ++i)
			printf ("(%d %d)(%d %d %d)  ", i, j, all[i][j], low[i][j], up[i][j]);
		printf ("\n");
	}
*/
//	printf ("p !!! %d\n", p);
	for (i = 0; (p -= f (i, 31, 1, 1)) >= 0; ++i)
		;//printf ("f %d %d %d %d -- %d\n", i, 31, 1, 1, f (i, 31, 1, 1));

//	printf ("p !! %d\n", p);
	p += f (i, 31, 1, 1);
	bool ub = 1, lb = 1;

//	printf ("i == %d, p == %d\n", i, p);

	bool nub;
	for (j = 31; j; --j) {
		if (ub && us[j] == '1') nub = 0; else nub = ub;
//		printf ("p == %d, in %d !%d! -- f (%d, %d, %d, %d) == %d  ", p, i, j, i, j-1, lb, nub, f (i, j-1, lb, nub));

		if (lb && ls[j] == '1') {ans[j] = '1'; --i; if (i == 0) {for (--j; j >= 0; --j) ans[j] = '0'; break;} continue;}
//		if (ub && us[j] == '0') {ans[j] = '0'; continue;}
		if (p < f (i, j-1, lb, nub)) {
//			printf ("-0-(us[j] = %c)\n", us[j]);
//			printf ("!0\n");
			ans[j] = '0';
			//if (ub && us[j] == '1') ub = 0;
			ub = nub;
		} else {
//			printf ("-1- J = %d (ls[j] = %c)\n", j, ls[j]);
//			printf ("!1\n");
			p -= f (i, j-1, lb, nub);
			--i;
			ans[j] = '1';
			if (lb && ls[j] == '0') lb = 0;
//			if (i == 0) printf ("!rfsdjflksd\n");
			if (i == 0) {for (--j; j >= 0; --j) ans[j] = '0'; break;}
		}
	}

	ans[0] = i ? '1' : '0';

	for (i = MAXN-1; i > 0 && ans[i] == '0'; --i);
	for (; i >= 0; --i) printf ("%c", ans[i]); printf ("\n");

	return 0;
}
