/*
TASK:false
LANG:C++

PROB: 3 tegleniq na obiknovenna vezna s 12 moneti, edna fal6iva (po leka ili po tejka), da se nameri fal6ivata i dali e po leka/po tejka
NOTE: Velin's warmup : Theme 2 (optimal guessing, modified binary search)
*/

#include "false.h"

#include <cstdio>
#include <cstdlib>
#include <cassert>

#include <vector>
#include <algorithm>

const int N = 12;

int idx[N];

bool good (char c) {
	return c == '=' || c == '<' || c == '>';
}

std::vector <int> b1, b2;
int ask () {
	static int t1[N], t2[N];
	assert (b1.size () == b2.size ());
//	printf ("%u", b1.size ());
//	for (int i = 0; i < (int)b1.size (); ++i) printf (" %d", idx[b1[i]]);
//	for (int i = 0; i < (int)b2.size (); ++i) printf (" %d", idx[b2[i]]);
//	printf ("\n");
//	fflush (stdout);
	for (int i = 0; i < (int)b1.size (); ++i) t1[i] = idx[b1[i]];
	for (int i = 0; i < (int)b2.size (); ++i) t2[i] = idx[b2[i]];

	char tmp;
//	while (!good (tmp = getchar ()));
	tmp = tegli ((int)b1.size (), t1, t2);
//	printf ("READ !%c!\n", tmp);
	assert (tmp == '=' || tmp == '<' || tmp == '>');
	return tmp == '=' ? 0 : tmp == '<' ? -1 : 1;
}

void doswap () {
	for (int i = 0; i < (int)b1.size (); ++i) std::swap (idx[b1[i]], idx[b2[i]]);
}

void done (int a, char b) {
	answer (a, b);
}

int main () {
	for (int i = 0; i < N; ++i) idx[i] = i + 1;

	b1.clear (); b2.clear ();
	b1.push_back (0); b2.push_back (4);
	b1.push_back (1); b2.push_back (5);
	b1.push_back (2); b2.push_back (6);
	b1.push_back (3); b2.push_back (7);

	int ans = ask (), ans2;
	if (ans) {
		if (ans == 1) doswap ();
//		printf ("write it!\n"); fflush (stdout);
//		assert (0);
		b1.clear (); b2.clear ();
		b1.push_back (2); b2.push_back (3);
		b1.push_back (4); b2.push_back (5);
		b1.push_back (8); b2.push_back (6);
		ans = ask ();
		if (ans == 0) {
			b1.clear (); b2.clear ();
			b1.push_back (0); b2.push_back (1);
			ans = ask ();
			if (ans) {
				done (idx[ans == -1 ? 0 : 1], '<');
//				printf ("%d <\n", idx[ans == -1 ? 0 : 1]);
			} else {
				done (idx[7], '>');
//				printf ("%d >\n", idx[7]);
			}
		} else if (ans == 1) {
			b1.clear (); b2.clear ();
			b1.push_back (3); b2.push_back (8);
			ans = ask ();
			if (ans) {
				done (idx[3], '<');
//				printf ("%d <\n", idx[3]);
			} else {
				done (idx[4], '>');
//				printf ("%d >\n", idx[4]);
			}
		} else {//ans == -1
			b1.clear (); b2.clear ();
			b1.push_back (5); b2.push_back (6);
			ans = ask ();
			switch (ans) {
				case -1: done  (idx[6], '>');
						//printf ("%d >\n", idx[6]);
						break;
				case  0: done (idx[2], '<');
						//printf ("%d <\n", idx[2]);
						break;
				case  1: done (idx[5], '>');
						//printf ("%d >\n", idx[5]);
						break;
			}
		}
	} else {
		b1.clear (); b2.clear ();
		b1.push_back (0); b2.push_back (8);
		b1.push_back (1); b2.push_back (9);
		b1.push_back (2); b2.push_back (10);
		ans = ask ();
		if (ans) {
			b1.clear (); b2.clear ();
			b1.push_back (8); b2.push_back (9);
			ans2 = ask ();
			if (ans2 == 0) {
				done (idx[10], ans == 1 ? '<' : '>');
//				printf ("%d %c\n", idx[10], ans == 1 ? '<' : '>');
			} else if (ans2 == ans) {
				done (idx[9], ans == 1 ? '<' : '>');
//				printf ("%d %c\n", idx[9], ans == 1 ? '<' : '>');
			} else {
				done (idx[8], ans == 1 ? '<' : '>');
//				printf ("%d %c\n", idx[8], ans == 1 ? '<' : '>');
			}
		} else {
			b1.clear (); b2.clear ();
			b1.push_back (0); b2.push_back (11);
			ans = ask ();
			switch (ans) {
				case -1: done (idx[11], '>');
						//printf ("%d >\n", idx[11]);
						break;
				case  0: assert (0);
				case  1: done (idx[11], '<');
						//printf ("%d <\n", idx[11]);
						break;
			}
		}
	}

	return 0;
}
