/*
TASK: laco
LANG: C++

FROM: SPRING 2003 A
PROB: laco
KEYW: mathematics
*/

#include <cstdio>
#include <vector>
#include <utility>

const int MAXN = 3002;
const int MAX = MAXN * MAXN / 2;
const int MAXPROD = MAXN * MAXN;
const int MAXSUM = 2 * MAXN;

const int MARKED = 1 << 29;
const int DEAD = MARKED + 1;

int N, M;

std::vector <bool> good (MAX, 0);
//char good[MAX];

int cp;
short a[MAX], b[MAX];
//int prod[MAX], sum[MAX];

int used_prod[MAXPROD];
int used_sum[MAXSUM];

std::vector <std::pair <short, short> > vec1;
std::vector <std::pair <short, short> > vec2;

void prnt (const std::vector <std::pair <short, short> > &v) {
	for (int i = 0; i < (int)v.size (); ++i) printf ("%d %d\n", v[i].first, v[i].second);
	if (v.empty ()) printf ("0 0\n");
}

int main () {
	scanf ("%d %d", &N, &M);

	int i, j;
	for (i = N; i <= M; ++i)
		for (j = i; j <= M; ++j) {
			a[cp] = i;
			b[cp] = j;
//			prod[cp] = i * j;
//			sum[cp] = i + j;
			++cp;
		}

	for (i = 0; i < MAXPROD; ++i) used_prod[i] = -1;

//1 prod: I dont know the numbers
	for (i = 0; i < cp; ++i)
		if (used_prod[(int)a[i]*b[i]/*prod[i]*/] == -1)
			used_prod[(int)a[i]*b[i]/*prod[i]*/] = i;
		else {
			good[used_prod[(int)a[i]*b[i]/*prod[i]*/]] = 1;//make first one good (may make it good several times - np)
			good[i] = 1;//we are good
		}

//2 sum: I know
	for (i = 0; i < cp; ++i) if (!good[i]) used_sum[a[i]+b[i]/*sum[i]*/] = 1;
	for (i = 0; i < cp; ++i) if (used_sum[a[i]+b[i]/*sum[i]*/]) good[i] = 0;//die (now - 1) muhahaha :)

//3 prod: I know them now
	for (i = 0; i < cp; ++i)
		if (good[i])
 			if (used_prod[(int)a[i]*b[i]/*prod[i]*/] < MARKED)
				used_prod[(int)a[i]*b[i]/*prod[i]*/] = MARKED;
			else
				used_prod[(int)a[i]*b[i]/*prod[i]*/] = DEAD;
	for (i = 0; i < cp; ++i) if (used_prod[(int)a[i]*b[i]/*prod[i]*/] == DEAD) good[i] = 0;//die (now - 2)

	for (i = 0; i < cp; ++i) if (good[i]) vec1.push_back (std::make_pair (a[i], b[i]));

//4 sum: Now I know them too
	for (i = 0; i < cp; ++i)
		if (good[i])
			if (used_sum[a[i]+b[i]/*sum[i]*/] < MARKED)
				used_sum[a[i]+b[i]/*sum[i]*/] = MARKED;
			else
				used_sum[a[i]+b[i]/*sum[i]*/] = DEAD;

	for (i = 0; i < cp; ++i) if (used_sum[a[i]+b[i]/*sum[i]*/] == DEAD) good[i] = 0;//die (now - 3)

	for (i = 0; i < cp; ++i) if (good[i]) vec2.push_back (std::make_pair (a[i], b[i]));

//output

	prnt (vec2);
	printf ("0 0\n");
	prnt (vec1);

	return 0;
}
