/*
TASK: bgame
LANG: C++

FROM: NOI 2005 k4
PROB: bgame
KEYW: 2d staircase nim, game, game sum, sg theory
*/

#include <cstdio>
#include <cassert>
#include <utility>
#include <algorithm>

const int MAXN = 1 << 17;

int N;
std::pair <int, int> data[MAXN];
int x[MAXN], y[MAXN];

int highest_bit (int a) {
	while (a & (a - 1)) a &= a - 1;
	return a;
}

int main () {
	scanf ("%d", &N);

	int i;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", &data[i].first, &data[i].second);
		x[i] = data[i].first;
		y[i] = data[i].second;
	}
	x[N] = 0;
	y[N] = 0;
	std::sort (x, x + N + 1);
	std::sort (y, y + N + 1);

	int sg = 0;
	for (i = N; i > 0; i -= 2) sg ^= (x[i] - x[i-1] - 1) ^ (y[i] - y[i-1] - 1);

	assert (sg);

	int hb_sg = highest_bit (sg);
//	printf ("%d %d\n", sg, hb_sg);

	int D = -1, L;
	for (i = N; i > 0; i -= 2) {
//		printf ("%d -- %d %d  %d %d\n", i, x[i] - x[i-1] - 1, y[i] - y[i-1] - 1, sg ^ (x[i] - x[i-1] - 1), sg ^ (y[i] - y[i-1] - 1));
//		printf ("%d %d\n", (x[i] - x[i-1] - 1) & hb_sg, (y[i] - y[i-1] - 1) & hb_sg);
//		printf ("%d %d\n", x[i] - x[i-1] - 1 - (sg ^ (x[i] - x[i-1] - 1)), y[i] - y[i-1] - 1 - (sg ^ (y[i] - y[i-1] - 1)));
		if ((x[i] - x[i-1] - 1) & hb_sg) {
			D = 1;
			L = x[i] - x[i-1] - 1 - (sg ^ (x[i] - x[i-1] - 1));
			break;
		}
		if ((y[i] - y[i-1] - 1) & hb_sg) {
			D = 2;
			L = y[i] - y[i-1] - 1 - (sg ^ (y[i] - y[i-1] - 1));
			break;
		}
	}

	assert (D != -1);

	int srch = (D == 1 ? x[i] : y[i]);

	for (i = 0; i < N; ++i)
		if (srch == (D == 1 ? data[i].first : data[i].second))
			break;

	printf ("%d %d %d\n", i + 1, D, L);

	return 0;
}
