/*
TASK: nim
LANG: C++

FROM: velin
PROB: nim
KEYW: sum of games
*/

#include "nim.h"

#include <cstdio>

const int MAXN = 1 << 10;

int N;
int vec[MAXN];

int main () {
	scanf ("%d", &N);
	int i, j;
	int sum = 0;
	for (i = 0; i < N; ++i) scanf ("%d", vec + i);
	for (i = 0; i < N; ++i) sum += vec[i];

	int x;
	for (;;) {
		if (!sum) return 0;
		for (i = x = 0; i < N; ++i) x ^= vec[i];
		for (j = 30; !(x & (1 << j)); --j);
		for (i = 0; i < N && !(vec[i] & (1 << j)); ++i);
		take (i + 1, vec[i] - (vec[i] ^ x));
		sum -= vec[i] - (vec[i] ^ x);
		if (!sum) return 0;
		vec[i] ^= x;
		ask (&j, &x);
		vec[j-1] -= x;
		sum -= x;
	}

	return 0;
}
