/*
TASK: coins
LANG: C++

FROM: SPRING 2001 A
PROB: coins
KEYW: constantly improving the situation
*/

#include <cstdio>
#include <cassert>
#include <algorithm>
#include <vector>
#include <utility>

int b[4];
int idx[4];

std::vector <std::pair <int, int> > ans;

void move (int _a, int _b) {
	assert (b[idx[_a]] >= b[idx[_b]]);
	b[idx[_a]] -= b[idx[_b]];
	b[idx[_b]] <<= 1;
	ans.push_back (std::make_pair (idx[_a] + 1, idx[_b] + 1));//printf ("%d %d\n", idx[_a] + 1, idx[_b] + 1);
}

bool cmp (int _a, int _b) {
	return b[_a] < b[_b];
}

int main () {
	scanf ("%d %d %d %*d", b, b + 1, b + 2);
	idx[0] = 0; idx[1] = 1; idx[2] = 2;

//	printf ("!!\n");
	for (;;) {
		std::sort (idx, idx + 3, cmp);
		if (!b[idx[0]]) break;//ready
		if (b[idx[0]] == b[idx[1]]) {
			move (0, 1);
			break;
		} else if (b[idx[1]] == b[idx[2]]) {
			move (1, 2);
			break;
		}
//		printf ("%d %d %d -- %d %d %d\n", idx[0], idx[1], idx[2], b[idx[0]], b[idx[1]], b[idx[2]]); getchar ();
		for (int i = 1, j = b[idx[1]] / b[idx[0]]; j; i *= 2) {
//			printf ("-->%d %d\n", i, j);
			if (j & i) {
				move (1, 0);
				j &= j - 1;
			} else {
				move (2, 0);
			}
		}
	}

	printf ("%u\n", ans.size ());
	for (unsigned i = 0; i < ans.size (); ++i) printf ("%d %d\n", ans[i].first, ans[i].second);

	return 0;
}
