/*
TASK: kmp
NOTE: knut moriss pratt
*/

#include <cstdio>

const int MAXLEN = 1 << 22;//4 000 000

int tlen, plen;
char t[MAXLEN];
char p[MAXLEN];
int fl[MAXLEN];

void pre () {
	fl[0] = fl[1] = 0;
	for (plen = 2; p[plen]; ++plen) {
		for (fl[plen] = fl[plen-1]; fl[plen] && p[fl[plen]] != p[plen-1]; fl[plen] = fl[fl[plen]]);
		if (p[fl[plen]] == p[plen-1]) ++fl[plen];
	}
	for (fl[plen] = fl[plen-1]; fl[plen] && p[fl[plen]] != p[plen-1]; fl[plen] = fl[fl[plen]]);
	if (p[fl[plen]] == p[plen-1]) ++fl[plen];
}

void match () {
	for (int tlen = 0, cp = 0; t[tlen]; ++tlen) {
		for (; cp && p[cp] != t[tlen]; cp = fl[cp]);
		if (p[cp] == t[tlen] && ++cp == plen) {
			cp = fl[plen];
			printf ("%d\n", tlen + 1 - plen);
		}
	}
}

int main () {
	gets (p);
	gets (t);

	pre ();
	match ();

	return 0;
}
