/*
TASK: rk
NOTE: rabin-karp
*/

#include <cstdio>
#include <cstdlib>

#include <vector>

const int MAXLEN = 1 << 22;
const int ALPHA = 128;
const int MOD = 510509;

int tlen, plen;
char t[MAXLEN];
char p[MAXLEN];
int powAP = 1;

int main () {
	gets (p);
	gets (t);

	plen = strlen (p);

	int hashp = 0, chash = 0;
	for (tlen = 0; tlen < plen && t[tlen]; ++tlen) {
		hashp *= ALPHA; hashp += p[tlen]; hashp %= MOD;
		chash *= ALPHA; chash += t[tlen]; chash %= MOD;
		powAP *= ALPHA; powAP %= MOD;
	}

	if (tlen < plen) exit (0);
	if (hashp == chash) printf ("0\n");//the first match
	for (; t[tlen]; ++tlen) {
		chash *= ALPHA; chash += t[tlen]; chash -= (powAP * t[tlen - plen]) % MOD; chash = (chash + MOD) % MOD;
		if (chash == hashp) printf ("%d\n", tlen - plen + 1);
	}

	return 0;
}
