/*
FROM: FALL 2005 A
PROB: digits
KEYW: linear
*/

#include <cstdio>
#include <cctype>
#include <algorithm>

using std::max;

const int MAXR = 1 << 20;

int R, M, K;
int vec[MAXR];

int vec_beg[MAXR];
int vec_end[MAXR];
int vec_end_[MAXR];
int vec_one[MAXR];
int vec_sone[MAXR];

int res[MAXR];

int toi (char c) {
	return isdigit (c) ? c - '0' : c - 'A' + 10;
}

char toc (int a) {
	return a < 10 ? a + '0' : a - 10 + 'A';
}

void solve1 () {
	int i;
	for (i = 0; i < R; ++i) {
		if (vec[i] > M) {
//			printf ("case1 %d %c\n", i, toc(vec[i]));
			vec_beg[i] = 1;
			vec_one[i] = 1;
		} else if (vec[i] < M) {
//			printf ("case2 %d %c\n", i, toc(vec[i]));
			vec_beg[i] = 1;
		} else {//vec[i] == M
//			printf ("case3 %d %c\n", i, toc(vec[i]));
			vec_beg[i] = 1;
			(i ? vec_end[i-1] = 1 : 1);//the second 1 does NOTHING
			++vec_one[0];
		}
	}
}

void solve1_0 () {
	int i;
	for (i = 0; i < R; ++i)
		if (vec[i] > 0) {
			vec_beg[i] = 1;
		} else {
			vec_beg[i] = 1;
			(i ? vec_end[i-1] = 1 : 1);//the second 1 does NOTHING
			++vec_sone[i];
			++vec_one[0];
		}
}

void solve2 () {
	int cs =0;
	int i;
/*
	for (i = 0; i < R; ++i)
		printf ("%d ", vec_beg[i]);
	printf ("\n");

	for (i = 0; i < R; ++i)
		printf ("%d ", vec_end[i]);
	printf ("\n");

	for (i = 0; i < R; ++i)
		printf ("%d ", vec_one[i]);
	printf ("\n");

	for (i = 0; i < R; ++i)
		printf ("%d ", res[i]);
	printf ("\n");
*/
	
	for (i = 0; i < R; ++i) {
		cs += vec_beg[i];
		res[i] += cs * vec[i+1];
//		printf ("%d -> %d * %c (%d)....%d %d\n", i, cs, toc (vec[i+1]), vec[i+1], cs * vec[i+1], res[i]);
		res[i+1] += res[i] / K;
		res[i] %= K;
	}
	for (; res[i] >= K; ++i) {
		res[i+1] += res[i] / K;
		res[i] %= K;
	}
/*
	for (i = 0; i < R + 2; ++i)
		printf ("%d ", res[i]);
	printf ("\n");
*/
/*
	for (; i >= 0; --i)
		printf ("%d(%c)", res[i], toc (res[i]));
	printf ("\n");
*/
	cs =0;
	for (i = R-1; i >= 0; --i) {
		cs += vec_end[i];
		vec_end_[i] = cs;
	}
	
	for (i = 0; i < R; ++i) {
		res[i] += vec_end_[i] * vec[i];
//		printf ("%d -> %d * %d\n", i, vec_end_[i], vec[i]);
		res[i+1] += res[i] / K;
		res[i] %= K;
	}
	for (; res[i] >= K; ++i) {
		res[i+1] += res[i] / K;
		res[i] %= K;
	}
/*
	for (i = 0; i < R + 2; ++i)
		printf ("%d ", res[i]);
	printf ("\n");
*/
	for (i = 0; i < R; ++i) {
		res[i] += vec_one[i];
		res[i+1] += res[i] / K;
		res[i] %= K;
	}
	for (; res[i] >= K; ++i) {
		res[i+1] += res[i] / K;
		res[i] %= K;
	}
/*
	for (i = 0; i < R + 2; ++i)
		printf ("%d ", res[i]);
	printf ("\n");
*/
/*
	for (i = R-1; i >= 0; --i)
		printf ("%d(%c)", res[i], toc (res[i]));
	printf ("\n");
*/
}

void solve2_0 () {
	solve2 ();
/*
	for (int i = 0; i < R; ++i)
		printf ("%d ", vec_sone[i]);
	printf ("\n");
*/
	for (int i = 0; i < MAXR; ++i) {
		res[i] -= vec_sone[i];//printf ("%d -> %d now -> %d\n", i, vec_sone[i], res[i]);
		if (res[i] < 0) {
			--res[i+1];
			res[i] += K;
		}
	}
/*
	for (int i = 0; i < R + 2; ++i)
		printf ("%d ", res[i]);
	printf ("\n");
*/
}

int main () {
	scanf ("%d %d %d\n", &R, &M, &K);
	int i;
	char tmp;
	for (i = 0; i < R; ++i) {
		scanf ("%c", &tmp);
		vec[R-1-i] = toi (tmp);
	}
	
	if (M) {
		solve1 ();
		solve2 ();
	} else {
		solve1_0 ();
		solve2_0 ();
	}
	for (i = MAXR-1; i >= 0 && !res[i]; --i);
//	printf ("start prnt ->%d\n", i);
	for (; i >= 0; --i)
		printf ("%c", toc (res[i]));
	printf ("\n");

	return 0;
}

/*
	for (i = 0; i < R; ++i)
		printf ("%d(%c) ", vec[i], toc (vec[i]));
	printf ("\n");
*/
