/*
FROM: FALL 2005 A
PROB: digits
KEYW: linear
*/

#include <cstdio>
#include <cctype>
#include <algorithm>

const int MAXR = 1 << 3;

int R, M, K;
int targ[MAXR];
int crnt[MAXR];

bool eq () {
	for (int i = 0; i < R; ++i)
		if (targ[i] != crnt[i]) return 0;
	return 1;
}

void incr () {
	for (int i = 0; ++crnt[i] == K; ++i) crnt[i] = 0;
}

int count () {
	int i, cntr =0;
	while (!eq ()) {
		incr ();
		for (i = R - 1; i >= 0 && !crnt[i]; --i);
		for (; i >= 0; --i)
			if (crnt[i] == M)
				++cntr;
	}
	return cntr;
}

char toC (int a) {
	return a < 10 ? a + '0' : a - 10 + 'A';
}

char ret[MAXR];
char * inK (int a) {
//	char ret[MAXR];
	int i;
	for (i = 0; a; ++i) {
		ret[i] = toC(a % K);//printf ("%d", ret[i]);
		a /= K;
	}
	ret[i] = 0;
	std::reverse (ret, ret + i);
	return ret;
}

int main () {
	scanf ("%d %d %d\n", &R, &M, &K);
	
	int i;
	char tmp;
	for (i = 0; i < R; ++i) {
		scanf ("%c", &tmp);
		targ[R-1-i] = (isdigit (tmp) ? tmp - '0' : tmp - 'A' + 10);
	}
	
	printf ("%s\n", inK (count ()));
	
	return 0;
}
