/*
FROM: FALL 2005 C
PROB: hlinks
KEYW: writing
*/

#include <cstdio>
#include <cstring>
#include <cctype>

const int MAXLEN = 1 << 14;
char link[MAXLEN];
int cpos;

bool beg_link =0;
bool could_begin =1;
int ldp;//last dot pos
bool slad;//slash after last dot

int crnt;

void my_flush () {
	for (int i = 0; i < cpos; ++i)
		putc (link[i], stdout);
	cpos = 0;
}

FILE *log;

void link_flush (int sp) {
	link[cpos] = 0;
	fprintf (log, "%d %d %d- *%s*\n", ldp, slad, cpos, link + sp);
	printf ("<a href=\"%s\">%s</a>", link + sp, link + sp);
	cpos = 0;
}

void try_flush () {
	link[cpos] = 0;
	fprintf (log, "*try*%d %d %d- *%s*\n", ldp, slad, cpos, link);

	int i;
	int sp = 0;
	for (i = cpos-1; i >= 0 && link[i] != ':'; --i);
	if (i != -1) {
		if (i > 3) {
			char tmp = link[i + 3];
			link[i + 3] = 0;
			if (strcmp (link + i - 4, "http://"))
				ldp = -1;
			else {
				int tmp2 = cpos;
				cpos = i - 4;
				my_flush ();
				cpos = tmp2;
			}
			link[i + 3] = tmp;
			sp = i - 4;
		} else
			ldp = -1;
	}

	if (ldp != -1 && (slad || (cpos - ldp - 1 >= 2 && cpos - ldp - 1 <= 4)))
		link_flush (sp);
	else
		my_flush ();
}

int main () {
	log = fopen ("log.log", "w");
	while (crnt = getc(stdin), crnt != -1)
		if (!beg_link) {
			if (could_begin) {
				if (isalpha (crnt) || isdigit (crnt)) {
					beg_link = 1;
					ldp = -1;//no point
					slad = 0;
					link[cpos++] = crnt;
				} else {
					putc (crnt, stdout);
					if (crnt == '.' || crnt == '/')
						could_begin = 0;
				}
			} else {
				putc (crnt, stdout);
				if (!isalpha(crnt) && !isdigit (crnt) && crnt != '.' && crnt != '/')	
					could_begin = 1;
			}
		} else {
			if (crnt == ':') {
				link[cpos++] = ':';
			} else if (crnt == '.') {
				link[cpos++] = '.';
				slad = 0;
				if (ldp != -1 && ldp == cpos - 2) {//2 consecutive points
					my_flush ();
					beg_link = 0;
					could_begin = 0;
				}
				ldp = cpos - 1;
			} else if (crnt == '/') {
				link[cpos++] = '/';
				if (ldp != -1)
					slad = 1;
			} else if (isalpha (crnt) || isdigit (crnt)) {
				link[cpos++] = crnt;
			} else {
				try_flush ();
				putc (crnt, stdout);
				beg_link = 0;
				could_begin = 1;
			}
		}

	return 0;
}
