/*
FROM: GCJ (Google Code Jam) Round 2 2008
PROB: B Triangle Areas

LANG: GNU C++ (g++ (GCC) 4.3.1 20080612 (Red Hat 4.3.1-2))
OPT: -lm -O2
*/

#include <cstdio>
#include <cassert>

int A, N, M;

int main() {
	int tc;
	scanf("%d", &tc);

	int x1, y1, x2, y2;
	int da;
	for (int ctc = 1; ctc <= tc; ++ctc) {
		scanf("%d %d %d", &N, &M, &A);

		for (x1 = 1; x1 <= N; ++x1) {
			y2 = (A + x1 - 1) / x1;
			if (y2 > M) continue;
			da = x1 * y2 - A;
			assert(da < x1);
			x2 = da;
			y1 = 1;
			printf("Case #%d: 0 0 %d %d %d %d\n", ctc, x1, y1, x2, y2);
			break;
		}
		if (x1 == N+1)
			printf("Case #%d: IMPOSSIBLE\n", ctc);
	}

	return 0;
}
