/*
FROM: Croatia Final Competition in Informatics 2001 day 2
PROB: fatboy
KEYW: dynamical programming with prev optimizations (2 * dp instead of dp + prev)
*/

#include <cstdio>
#include <cstring>

const int MAXL = 100;
const int MAXB = 4;
const int MSGCNT = 3;

char dp[MAXL][MAXL][MAXL][MAXB][MAXB][MAXB];
char msg[MSGCNT][MAXL + 10];
int len[MSGCNT];

int main () {
	memset (dp, -1, sizeof (dp));

	int i;
	for (i = 0; i < MSGCNT; ++i) {
		gets (msg[i]);
		len[i] = strlen (msg[i]);
//		printf ("%d - %d\n", i, len[i]);
	}

	int i0 = -1, i1 = -1, i2 = -1, b0 = -1, b1 = -1, b2 = -1;
	for (i0 = 0; i0 < MAXB && i0 < len[0]; ++i0)
		for (i1 = 0; i1 < MAXB && i1 < len[1]; ++i1)
			for (i2 = 0; i2 < MAXB && i2 < len[2]; ++i2)
				if (msg[0][i0] == msg[1][i1]
				 && msg[0][i0] == msg[2][i2])
					dp[i0][i1][i2][3-i0][3-i1][3-i2] = 1;


	int ni0, ni1, ni2;
	int bi0 = -1, bi1 = -1, bi2 = -1, bb0 = -1, bb1 = -1, bb2 = -1;
	int ans = 0;
	for (i0 = 0; i0 < len[0]; ++i0)
	for (i1 = 0; i1 < len[1]; ++i1)
	for (i2 = 0; i2 < len[2]; ++i2)
		for (b0 = 0; b0 < MAXB; ++b0)
		for (b1 = 0; b1 < MAXB; ++b1)
		for (b2 = 0; b2 < MAXB; ++b2) {
			if (dp[i0][i1][i2][b0][b1][b2] == -1) continue;
//			printf ("dp %d %d %d  %d %d %d - %d\n", i0, i1, i2, b0, b1, b2, (int)dp[i0][i1][i2][b0][b1][b2]);
			if (ans < dp[i0][i1][i2][b0][b1][b2]) {
				ans = dp[i0][i1][i2][b0][b1][b2];
				bi0 = i0; bi1 = i1; bi2 = i2;
				bb0 = b0; bb1 = b1; bb2 = b2;
			}
			
			for (ni0 = i0 + 1; ni0 <= i0 + b0 + 4 && ni0 < len[0]; ++ni0)
			for (ni1 = i1 + 1; ni1 <= i1 + b1 + 4 && ni1 < len[1]; ++ni1)
			for (ni2 = i2 + 1; ni2 <= i2 + b2 + 4 && ni2 < len[2]; ++ni2) {
				if (msg[0][ni0] != msg[1][ni1]
				 || msg[0][ni0] != msg[2][ni2]) continue;
				
//				printf ("\t%d %d %d -- %d %d %d\n", ni0, ni1, ni2, i0+b0+4-ni0<?3, i1+b1+4-ni1<?3, i2+b2+4-ni2<?3);
				dp[ni0][ni1][ni2][i0+b0+4-ni0<?3][i1+b1+4-ni1<?3][i2+b2+4-ni2<?3] >?= dp[i0][i1][i2][b0][b1][b2] + 1;
			}
		}

	static char ret[MAXL];
	int retp = 0;
	ret[retp++] = msg[0][bi0];
	while (dp[bi0][bi1][bi2][bb0][bb1][bb2] != 1) {
		for (i0 = (bi0 + bb0 - 7) >? 0; i0 <= bi0 + bb0 - 4; ++i0)
		for (i1 = (bi1 + bb1 - 7) >? 0; i1 <= bi1 + bb1 - 4; ++i1)
		for (i2 = (bi2 + bb2 - 7) >? 0; i2 <= bi2 + bb2 - 4; ++i2)
			for (b0 = 0; b0 < MAXB; ++b0)
			for (b1 = 0; b1 < MAXB; ++b1)
			for (b2 = 0; b2 < MAXB; ++b2)
				if (dp[i0][i1][i2][b0][b1][b2] == dp[bi0][bi1][bi2][bb0][bb1][bb2] - 1
				 && bb0 == i0 + b0 + 4 - bi0 <? 3
				 && bb1 == i1 + b1 + 4 - bi1 <? 3
				 && bb2 == i2 + b2 + 4 - bi2 <? 3)
					goto end;
		end:;
		bi0 = i0; bi1 = i1; bi2 = i2;
		bb0 = b0; bb1 = b1; bb2 = b2;	
		ret[retp++] = msg[0][bi0];
	}

	for (i = retp-1; i >= 0; --i) putchar (ret[i]);
	puts ("");

	return 0;
}
