/*
FROM: Croatia Final Competition in Informatics 2002 day 1
PROB: safe
KEYW: linear
*/

#include <cstdio>

const int DC = 10000000;
const int DC2 = DC / 2;

int N;
int hole[DC + 10];

int main () {
	scanf ("%d", &N);

	int i;
	int pos;
	for (i = 0; i < N; ++i) {
		scanf ("%d", &pos);
		++hole[pos-1];
	}
	hole[DC] = hole[0];

	long long ll = 0, rl = 0;
	int lc = 0, rc = 0;

	for (i = 1; i <= DC2; ++i)
		if (hole[i]) {
			rc += hole[i];
			rl += hole[i] * i;
		}

	for (i = DC2; i <= DC; ++i)
		if (hole[i]) {
			lc += hole[i];
			ll += (long long)hole[i] * (DC - i);
		}

	long long ans = (ll + rl) <? ((long long)N * DC2 - ll - rl);
	for (i = 1; i < DC2; ++i) {
		ll += lc;
		rl -= rc;
		if (hole[i+DC2]) {
			ll -= (long long)hole[i+DC2] * DC2; lc -= hole[i+DC2];
			rl += (long long)hole[i+DC2] * DC2; rc += hole[i+DC2];
		}
		if (hole[i]) {
			rc -= hole[i];
			lc += hole[i];
		}
		ans <?= (ll + rl) <? ((long long)N * DC2 - ll - rl);
	}

	printf ("%Ld\n", ans);

	return 0;
}
