/*
FROM: Croatia Final Competition in Informatics 2003 day 1
PROB: list
KEYW: heap, tree reconstruction
*/

#include <cstdio>
#include <queue>

const int MAXN = 1 << 17;

int N;
int row[MAXN];
int count[MAXN];
std::priority_queue <int, std::vector <int>, std::greater <int> > leafs;

int main () {
	scanf ("%d", &N);
	int i;
	for (i = 0; i < N - 1; ++i) {
		scanf ("%d", row + i);
		++count[row[i]];
	}

	for (i = 1; i <= N; ++i)
		if (count[i] == 0)
			leafs.push (i);

	for (i = 0; i < N - 1; ++i) {
		printf ("%d %d\n", row[i], leafs.top ());
		leafs.pop ();
		if (!(--count[row[i]]))
			leafs.push (row[i]);
	}

	return 0;
}
