/*
FROM: Croatia Final Competition in Informatics 2004 day 1
PROB: sifre
KEYW: module, random
*/

#include "sifrelib.h"

#include <cstdio>
#include <cassert>
#include <ctime>
#include <cstdlib>
#include <algorithm>

const int MAXLEN = 1 << 7;
const int ALPHA = 1 << 5;
const int A = 26;

int N;
char tmp[MAXLEN];
char pool[ALPHA];

int main () {
	srand (time (0));
	Init ();

	int i;
	for (i = 0; i < A; ++i) {
		pool[i] = i + 'a';
		tmp[0] = i + 'a';
		int c = Probaj (tmp);
//		printf ("%d -- %d\n", i, c);
		N += c;
	}
	N /= 27;

//	printf ("N == %d\n", N);

	int c1, c2;
	int grc = N, bulk = 0;
	int ret;
	int l = 0;
	for (;;) {
		tmp[l] = 0;
//		printf ("base -- %s, group cound -- %d, bulk == %d\n", tmp, grc, bulk);
		std::random_shuffle (pool, pool + A);
		for (i = 0; i < A; ++i) {
			tmp[l] = pool[i];
			ret = Probaj (tmp);
			c1 = ret - bulk - (l + 1) * grc;
			c2 = grc - c1;
//			printf ("%s -- %d  %d %d\n", tmp, c1, c2, ret);
			if (c1) break;
		}
		if (i == A) {//no break
			tmp[l] = 0;
			puts (tmp);
			assert (grc == 1);//there is only one password and it is in tmp
			tmp[l] = 0;
			Rjesenje (tmp);
		} else {
			bulk += c2 * (l + 1);
			grc = c1;
			++l;
		}
	}

	return 0;
}
