/*
FROM: Croatia 2005 National Junior 1st day
PROB: tomo
KEYW: modulus
*/

#include <cstdi>

const int MAXC = 1 << 20;//because the mod can be 1 000 000

int A, B, C;
bool used[MAXC] = {0};

int main () {
	scanf ("%d %d %d", &A, &B, &C);

	if (A == 0 || B == 0) {
		if (C == 0)
			printf ("1\n");
		else
			printf ("NIKAD\n");

		return 0;
	}
	if (B == 1) {
		if (C == A)
			printf ("1\n");
		else
			printf ("NIKAD\n");
		return 0;
	}

	int MOD = 1;
	while (MOD <= C) MOD *= 10;

	bool f = 0;
	int crnt = A;
	for (int i = 1;; ++i) {
		crnt *= B;
		if (!f && crnt >= MOD) f = 1;
		crnt %= MOD;
		if (crnt == C) {printf ("%d\n", i); return 0;}
		if (f)
			if (used[crnt]) {
				printf ("NIKAD\n");
				return 0;
			} else
				used[crnt] = 1;
	}

	return 0;
}
