/*
FROM: Croatia 2005 National Junior 1st day
PROB: zmija
KEYW: linear
*/

#include <cstdio>
#include <cstdlib>
#include <deque>

const int MAXN = 1 << 7;
const int MAXL = 1 << 14;

int difx [] = {0, 1, 0, -1};
int dify [] = {1, 0, -1, 0};

int N, K, L;

bool apple[MAXN][MAXN];
bool snake[MAXN][MAXN];

int moves[MAXL][2];

void mymod (int &a) {
	a = (a + 4) % 4;
}
/*
void test () {
	system ("clear");
	int i, j;
	for (i = 1; i <= N; ++i) {
		for (j = 1; j <= N; ++j)
			if (apple[i][j] && !snake[i][j])
				printf ("A");
			else if (snake[i][j])
				printf ("S");
			else
				printf (" ");
		printf ("|\n");
	}
	for (i = 0; i <= N; ++i)
		printf ("-");
	printf ("\n");
	for (i = 0; i < 100000000; ++i);
}
*/
int main () {
	scanf ("%d %d\n", &N, &K);

	int i;
	int a, b;
	for (i = 0; i < K; ++i) {
		scanf ("%d %d\n", &a, &b);
		apple[a][b] = 1;
	}

	scanf ("%d\n", &L);

	char d;
	for (i = 0; i < L; ++i) {
		scanf ("%d %c\n", &a, &d);
		moves[i][0] = a;
		moves[i][1] = (d == 'D' ? 1 : -1);
	}
	moves[L][0] = 1000000;

	for (i = 0; i < N+2; ++i)
		snake[0][i] = snake[i][0] = snake[i][N+1] = snake[N+1][i] = 1;

	std::deque <std::pair <int, int> > deq;
	snake[1][1] = 1;

	std::pair <int, int> new_pos;
	int dir = 0;
	int crnt_move = 0;
	deq.push_front (std::make_pair (1, 1));
	for (i = 1;; ++i) {
/*
		for (int k = 0; k < (int)deq.size (); ++k)
			printf ("(%d %d)", deq[k].first, deq[k].second);
		printf ("\n");
*/
//		for (int k = 0; k < 100000000; ++k);
		new_pos = std::make_pair (deq.front ().first + difx[dir], deq.front ().second + dify[dir]);

		if (snake[new_pos.first][new_pos.second] == 1)
			break;
		snake[new_pos.first][new_pos.second] = 1;
		deq.push_front (new_pos);

		if (apple[new_pos.first][new_pos.second]) {
			apple[new_pos.first][new_pos.second] = 0;
		} else {
			snake[deq.back ().first][deq.back ().second] = 0;
			deq.pop_back ();
		}
		//////
		//////
//		test ();
		if (moves[crnt_move][0] == i) {
			dir += moves[crnt_move][1];
			mymod (dir);
//			printf ("new dir == %d(%d)\n", dir, i);

			++crnt_move;
		}
	}

	printf ("%d\n", i);

	return 0;
}
