/*
FROM: Croatia 2005 National Seniors 2nd day
PROB: nagibni
KEYW: dynamical programming, tele
*/

#include <cstdio>
#include <vector>
#include <limits>
#include <utility>
#include <iostream>
#include <algorithm>

using std::make_pair;

const int MAXN = 1 << 12;
const int inf = std::numeric_limits <int> :: min ();

int N;
std::vector <std::vector <std::pair <int, int> > > vec;
int mem[MAXN][3];
bool used[MAXN];

void upd (std::pair <int, int> &a, int val) {
	if (val > a.first) {
		a.second = a.first;
		a.first = val;
	} else if (val > a.second) {
		a.second = val;
	}
}

void rec (int a) {
//	printf ("REC %d\n", a);
	used[a] = 1;
	std::pair <int, int> best (inf, inf);

	int sum = 0;
	int cnt = 0;
	for (int i = 0; i < (int)vec[a].size (); ++i) {
		if (used[vec[a][i].first]) continue;
		rec (vec[a][i].first);

		if (mem[vec[a][i].first][1] == inf && mem[vec[a][i].first][2] == inf) {
			sum += mem[vec[a][i].first][0] + vec[a][i].second;
			++cnt;
		} else {
			if ((mem[vec[a][i].first][1] >? mem[vec[a][i].first][0]) > mem[vec[a][i].first][2]) {
				upd (best, vec[a][i].second);
				sum += (mem[vec[a][i].first][1] >? mem[vec[a][i].first][0]);
			} else {
				if ((mem[vec[a][i].first][1] >? mem[vec[a][i].first][0]) != inf)
					upd (best, (mem[vec[a][i].first][1] >? mem[vec[a][i].first][0]) + vec[a][i].second - mem[vec[a][i].first][2]);
				sum += mem[vec[a][i].first][2];
			}
		}
	}

//	printf ("(%d)%d %d --- %d %d\n", a, sum, cnt, best.first, best.second);
//	std::cout << '(' << a << ')' << sum << ' ' << cnt << " --- " << (best.first == inf ? -9 : best.first) << ' ' << (best.second == inf ? -9 : best.second) << std::endl;

	if (cnt == 2) {
		mem[a][0] = mem[a][1] = inf;
		mem[a][2] = sum;
	} else if (cnt == 1) {
		mem[a][0] = inf;
		mem[a][1] = sum;
		mem[a][2] = (best.first != inf ? sum + best.first : inf);
	} else {//cnt == 0;
		mem[a][0] = sum;
		mem[a][1] = (best.first != inf ? sum + best.first : inf);
		mem[a][2] = (best.first != inf && best.second != inf ? sum + best.first + best.second : inf);
	}

//	printf ("%d %d %d\n", mem[a][0], mem[a][1], mem[a][2]);
//	std::cout << '(' << a << ')'<< (mem[a][0] == inf ? -9 : mem[a][0]) << ' ' << (mem[a][1] == inf ? -9 : mem[a][1]) << ' ' << (mem[a][2] == inf ? -9 : mem[a][2]) << std::endl;
}

int main () {
	scanf ("%d", &N);
	vec.resize (N);

	int i;
	int a, b, d;
	for (i = 0; i < N - 1; ++i) {
		scanf ("%d %d %d" , &a, &b, &d);
		--a; --b;
		vec[a].push_back (make_pair (b, d));
		vec[b].push_back (make_pair (a, d));
	}

	rec (0);
	printf ("%d\n", mem[0][1] >? mem[0][2]);

	return 0;
}
