/*
FROM: Croatia 2005 regional junior
PROB: ispit
KEYW: dfs
*/

#include <cstdio>

const int MAXN = 1 << 10;

int N;
int next[MAXN];
int depth[MAXN];
int prenum[MAXN];
int cycle_beg = -1;

int dfs (int a) {
//	printf ("in dfs %d   %d %d\n", a, depth[a], prenum[a]);
	static int pn = 1;
//	if (depth[a]) return depth[a];
	if (depth[next[a]]) {
//		printf ("depth == %d\n", depth[next[a]] + 1);
		return depth[a] = depth[next[a]] + 1;
	}
	prenum[a] = pn++;
//	printf ("now pn == %d\n", prenum[a]);
	if (prenum[next[a]]) {
//		printf ("make cycle with %d - len %d\n", next[a], prenum[a] - prenum[next[a]] + 1);
		cycle_beg = next[a];
		return depth[a] = prenum[a] - prenum[next[a]] + 1;
	}
	dfs (next[a]);
//	printf ("(%d) cycle beg = %d ", a, cycle_beg);
	if (cycle_beg != -1) depth[a] = depth[next[a]];
	else depth[a] = depth[next[a]] + 1;
	if (cycle_beg == a)
		cycle_beg = -1;
//	printf ("depth == %d\n", depth[a]);
	return depth[a];
}

int main () {
	scanf ("%d", &N);

	int i;
	int tmp;
	for (i = 0; i < N; ++i) {
		scanf ("%d", &tmp);
		next[i] = tmp - 1;
		if (next[i] == i) depth[i] = 1;
	}

	int max =0;
	for (i = 0; i < N; ++i)
		if (!depth[i])
			max >?= dfs (i);

	for (i = 0; i < N && depth[i] != max; ++i);

	printf ("%d\n", i + 1);

	return 0;
}
