/*
FROM: Croatia 2005 regional juniors
PROB: kemija
KEYW: parsing
*/

#include <cstdio>
#include <cctype>
#include <cassert>

const int MAXLEN = 0;
const int ELCNT = 3;

int toidx (char c) {
	switch (c) {
		case 'H': return 0;
		case 'O': return 1;
		case 'C': return 2;
		default: assert (0); return -1;
	}
}

char line[MAXLEN];
int cnt[3][ELCNT];

bool good (int a1, int a2, int a3) {
	return (cnt[0][0] * a1 + cnt[1][0] * a2 == cnt[2][0] * a3 &&
			cnt[0][1] * a1 + cnt[1][1] * a2 == cnt[2][1] * a3 &&
			cnt[0][2] * a1 + cnt[1][2] * a2 == cnt[2][2] * a3);
}

int main () {
	gets (line);

	int i, k;
	int cn;
	for (i = 0, k = 0; k < 3; ++k, ++i) {
		for (; line[i] && line[i] != '+' && line[i] != '='; isdigit (line[++i]) ? ++i : 0) {
//			printf ("%d %c\n", i, line[i]);
			cn = (isdigit (line[i + 1]) ? line[i + 1] - '0' : 1);
			cnt[k][toidx (line[i])] += cn;
		}
	}
/*
	for (i = 0; i < 3; ++i) {
		for (k = 0; k < 3; ++k)
			printf ("%d ", cnt[i][k]);
		printf ("\n");
	}
*/
	int a1, a2, a3;
	int X1, X2, X3 =-1;
	for (a1 = 1; a1 <= 10; ++a1)
		for (a2 = 1; a2 <= 10; ++a2)
			for (a3 = 1; a3 <= 10; ++a3)
				if (good (a1, a2, a3)) {
					X1 = a1;
					X2 = a2;
					X3 = a3;
					goto end;
				}
	end:;
	if (X3 == -1)
		printf ("NEMOGUCE\n");
	else
		printf ("%d %d %d\n", X1, X2, X3);

	return 0;
}
