/*
FROM: Croatia 2006 National Senior day 1
PROB: petice
KEYW: math
*/

#include <cstdio>

const int MAXLEN = 1 << 5;//32

long long N;
int K;
char num[MAXLEN];

int cnt_5 () {
	int res = 0;
	for (int i = 0; i < MAXLEN; ++i) res += num[i] == 5;
	return res;
}

bool inc_1 (int pos) {
	int pr = 0;
	++num[pos];
	pr = num[pos] / 10;
	num[pos] %= 10;
	int i;
	for (i = pos + 1; pr; ++i) {
		++num[i];
		pr = num[i] / 10;
		num[i] %= 10;
	}
	return num[i-1] == 5;
}

void next_5 () {
	int i;
	for (i = 0; num[i] == 5; ++i);
	if (num[i] < 5) num[i] = 5;
	else {
		num[i] = inc_1 (i + 1) ? 0 : 5;
	}
}

int main () {
	scanf ("%Ld %d", &N, &K);

	int p = 0;
	while (N) {
		num[p++] = N % 10;
		N /= 10;
	}

	inc_1 (0);
	while (cnt_5 () < K)
		next_5 ();

	int i;
	for (i = MAXLEN - 1; !num[i]; --i);
	for (; i >= 0; --i) putchar (num[i] + '0');
	puts ("");

	return 0;
}
