/*
FROM: Croatia 2006 National Senior day 1
PROB: pruge
KEYW: coding, simple geometry
*/

#include <cstdio>

int x1, y1;
int x2, y2;
int li, ui;
bool u, d, l, r;

void find_intersect () {
	if (x1 <= y1 && y1 < x2) {
		d = 1;
		li = y1;
	} else if (y1 < x1 && x1 < y2) {
		l = 1;
		li = x1;
	} else return;//no lower intersect -> no intersect at all
	
	if (y1 < x2 && x2 < y2) {
		r = 1;
		ui = x2;
	} else if (x1 < y2 && y2 <= x2) {
		u = 1;
		ui = y2;
	}
//	printf ("%d %d %d %d\n", u, d, l, r);
}

long long rect_up (long long x1, long long y1, long long x2, long long y2) {
//	printf ("ru %Ld %Ld %Ld %Ld  %Ld\n", x1, y1, x2, y2, ((y2 - y1) / 2 + ((y1 & 1) && !(y2 & 1))) * (x2 - x1));
	return ((y2 - y1) / 2 + ((y1 & 1) && !(y2 & 1))) * (x2 - x1);
}

long long rect_down (long long x1, long long y1, long long x2, long long y2) {
//	printf ("rd %Ld %Ld %Ld %Ld  %Ld\n", x1, y1, x2, y2, ((x2 - x1) / 2 + ((x1 & 1) && !(x2 & 1))) * (y2 - y1));
	return ((x2 - x1) / 2 + ((x1 & 1) && !(x2 & 1))) * (y2 - y1);
}

long long sq (long long x, long long y) {
	long long res = 0;
	long long tmp = x & 1 ? 1 : 3;
	for (long long i = (x | 1); i < y; i += 2) {
		res += tmp;
		tmp += 4;
	}
//	printf ("sq %Ld %Ld -- %Ld\n", x, y, res);
	return res;
}

int main () {
	scanf ("%d %d %d %d", &x1, &y1, &x2, &y2);

	find_intersect ();

	if (d && r) {
		printf ("%Ld\n",
			  rect_up (x1, y1, li, ui)
			+ rect_up (x1, ui, x2, y2)
			+ sq (li, ui)
		);
	} else if (d && u) {
		printf ("%Ld\n",
			  rect_up (x1, y1, li, y2)
			+ rect_down (ui, y1, x2, y2)
			+ sq (li, ui)
		);
	} else if (l && r) {
		printf ("%Ld\n",
			  rect_up (x1, ui, x2, y2)
			+ rect_down (x1, y1, x2, li)
			+ sq (li, ui)
		);
	} else if (l && u) {
		printf ("%Ld\n",
			  rect_down (x1, y1, x2, li)
			+ rect_down (ui, li, x2, y2)
			+ sq (li, ui)
		);
	} else if (x1 < y1) {
		printf ("%Ld\n",
			rect_up (x1, y1, x2, y2)
		);
	} else {
		printf ("%Ld\n",
			rect_down (x1, y1, x2, y2)
		);
	}

	return 0;
}
