/*
FROM: Croatia 2006 National Senior day 2
PROB: grad
KEYW: bfs, geometry
*/

#include <cstdio>
#include <cstdlib>
#include <utility>

const int MAXN = 1 << 6;

#define coor first
#define x first
#define y second
#define len second

/*
struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};
*/
int N;
bool ma3x[MAXN][MAXN];
std::pair <std::pair <int, int>, int> cranes[MAXN];
/*int vec[MAXN];
el buf[MAXM];*/

int X, Y;
int K;

int sq (int a) {return a * a;}

bool ins (int cx, int cy, int cr) {
//	printf ("ins %d %d %d -- %d\n", cx, cy, cr, sq (cx - cranes[cr].coor.x) + sq (cy - cranes[cr].coor.y) <= sq (cranes[cr].len));
	return sq (cx - cranes[cr].coor.x) + sq (cy - cranes[cr].coor.y) <= sq (cranes[cr].len);
}

int main () {
	scanf ("%d %d", &X, &Y);
	scanf ("%d", &N);

	int i, j;
	for (i = 0; i < N; ++i)
		scanf ("%d %d %d", &cranes[i].coor.x, &cranes[i].coor.y, &cranes[i].len);
	cranes[N] = std::make_pair (std::make_pair (X / 2, 0), 0);

	for (i = 0; i < N; ++i)
		for (j = i + 1; j <= N; ++j)
			if (
			sq (cranes[i].coor.x - cranes[j].coor.x)
		  + sq (cranes[i].coor.y - cranes[j].coor.y)
			<=
			sq (cranes[i].len + cranes[j].len))
				ma3x[i][j] = ma3x[j][i] = 1;


	static int q[MAXN], p3;
	static bool used[MAXN];

	q[p3++] = N;
	used[N] = 1;
	for (i = 0; i < p3; ++i) {
		int c = q[i];
		for (j = 0; j < N; ++j)
			if (ma3x[c][j] && !used[j]) {
				used[j] = 1;
				q[p3++] = j;
			}
	}
/*
	for (i = 0; i < N; ++i) {
		printf ("(%d)", used[i]);
		for (j = 0; j <= N; ++j)
			printf (" %d", ma3x[i][j]);
		printf ("\n");
	}
*/
	scanf ("%d", &K);
	int cx, cy;
	for (i = 0; i < K; ++i) {
		scanf ("%d %d", &cx, &cy);

		for (j = 0; j < N; ++j)
			if (used[j] && ins (cx, cy, j))
				break;
		printf ("%s\n", j == N ? "NE" : "DA");
	}

	return 0;
}
