/*
FROM: Croatia 2006 Regional
PROB: matches
KEYW: binary operations
*/

#include <cstdio>

const int MAXN = 1 << 14;

int N;
char line[2][MAXN];
bool imp[MAXN][2];

int main () {
	scanf ("%d\n", &N);
	gets (line[0]);
	gets (line[1]);

	int i, k;
	for (k = 0; k < 2; ++k)
		for (i = 1; i < N - 1; ++i)
			if (line[k][i-1] != line[k][i] && line[k][i] != line[k][i+1])
				imp[k][i] = 1;

	int res =0;
	int in = 0;
	for (k = 0; k < 2; ++k) {
		for (i = 0; i < N; ++i) {
			if (imp[k][i] && imp[!k][i]) continue;
			if (line[k][i] == '0' && in) {
				in = 0;
				++res;
			} else if (line[k][i] == '1' && !in)
				in = 1;
		}
		if (in) {
			in = 0;
			++res;
		}
	}
//	printf ("res = %d\n", res);

	in = 0;
	for (i = 1; i < N - 1; ++i)
		if (imp[0][i] && imp[1][i])
			++in;
		else {
			res += (in >> 1) + (in & 1);
			in = 0;
		}

	printf ("%d\n", res);

	return 0;
}
