/*
FROM: Croatia Olympiad in Informatics 2007
PROB: patrik
KEYW: stack
*/

#include <cstdio>

const int MAXN = 1 << 19;

int N;
unsigned stk[MAXN], sp;

int main () {
	scanf ("%d", &N);

	unsigned crnt;
	long long res = 0;
	stk[sp++] = -1;
	for (int i = 0; i < N; ++i) {
		scanf ("%u", &crnt);
		int l = 0, r = sp, m;
		while (l + 1 < r) {
			m = (l + r) / 2;
			if (stk[m] > crnt)
				l = m;
			else
				r = m;
		}
//		printf ("add %d (%d %d)\n", sp - l - (l == 0), l, sp);
		res += sp - l - (l == 0);
		while (sp && stk[sp-1] < crnt) --sp;
		stk[sp++] = crnt;
	}
	printf ("%Ld\n", res);

	return 0;
}
