/*
FROM: COCI (Croatia Open Competition in Informatics) 2006 contest 3
PROB: lista
KEYW: list, longest non-decreasing subsequence
*/

#include <cstdio>
#include <list>
#include <algorithm>

const int MAXN = 1 << 19;

int N, M;
std::list <int> l;
std::list <int>::iterator vec[MAXN];
int fin[MAXN];
int dp[MAXN];
int prev[MAXN];
int shit[MAXN];

inline std::list <int>::iterator nxt (std::list <int>::iterator ii) {
	std::list <int>::iterator ret (ii);
	++ret;
	return ret;
}

int main () {
	scanf ("%d %d\n", &N, &M);

	int i, a, b;
	for (i = N-1; i >= 0; --i) {
		l.push_front (i);
		vec[i] = l.begin ();
	}
/*
	for (std::list <int>::iterator ii = l.begin (); ii != l.end (); ++ii)
		printf (" %d", *ii);
	printf ("\n");
*/

	char m;
	for (i = 0; i < M; ++i) {
		scanf ("%c %d %d\n", &m, &a, &b);
		--a; --b;
		if (m == 'A') {
			l.splice (vec[b], l, vec[a]);
		} else {//m == 'B'
			l.splice (nxt (vec[b]), l, vec[a]);
		}
/*
		printf ("->");
		for (std::list <int>::iterator ii = l.begin (); ii != l.end (); ++ii)
			printf (" %d", *ii + 1);
		printf ("(%c %d %d)\n", m, a + 1, b + 1);
*/
	}
/*
	for (std::list <int>::iterator ii = l.begin (); ii != l.end (); ++ii)
		printf (" %d", *ii + 1);
	printf ("\n");
*/
	int fp = 0;
	for (std::list <int>::iterator ii = l.begin (); ii != l.end (); ++ii)
		fin[fp++] = *ii;

	for (i = 0; i < N + 2; ++i) dp[i] = N + 2;//buffer

	int pos;
	for (i = 0; i < N; ++i) {
		pos = std::lower_bound (dp, dp + N, fin[i]) - dp;
		prev[fin[i]] = pos ? dp[pos-1] : -1;
		dp[pos] = fin[i];
	}

	for (i = N-1; i >= 0 && dp[i] == N + 2; --i);
	int cel = dp[i];
	int rN = i + 1;
	while (i >= 0) {
		shit[i] = cel;
		cel = prev[cel];
		--i;
	}

//	for (i = 0; i < rN; ++i) printf ("%d ", shit[i]); printf ("\n");
	pos = 0;

	printf ("%d\n", N - rN);
	for (i = shit[pos]-1; i >= 0; --i) printf ("A %d %d\n", i + 1, i + 2);
	for (i = shit[pos]+1; i < N; ++i) {
		if (i == shit[pos+1]) {++pos; continue;}
		printf ("B %d %d\n", i + 1, i);
	}

	return 0;
}
