/*
FROM: COCI (Croatia Open Competition in Informatics) 2006 contest 4
PROB: prsteni
KEYW: greatest common divisor
*/

#include <cstdio>

inline int _gcd (int a, int b) {
	return b ? _gcd (b, a % b) : a;
}

inline int gcd (int a, int b) {
	return a > b ? _gcd (a, b) : _gcd (b, a);
}

int main () {
	int N, nom, den, k;
	scanf ("%d", &N);

	scanf ("%d", &nom);
	for (int i = 0; i < N-1; ++i) {
		scanf ("%d", &den);
		k = gcd (nom, den);
		printf ("%d/%d\n", nom / k, den / k);
	}

	return 0;
}
