/*
FROM: COCI (Croatia Open Competition in Informatics) 2007 contest 6
PROB: magija
KEYW: easy
*/

#include <cstdio>

int N, M;
bool ul[64][64];

int main () {
	scanf ("%d %d\n", &N, &M);

	int i, j;
	char tmp;
	for (i = 0; i < N; ++i) {
		for (j = 0; j < M; ++j) {
			scanf ("%c", &tmp);
			ul[i][j] = tmp == '#';
		}
		scanf ("\n");
	}
	int bi, bj;
	scanf ("%d %d", &bi, &bj);
	--bi; --bj;

	for (i = 0; i < 2 * N; ++i) {
		for (j = 0; j < 2 * M; ++j) {
			int wi = i < N ? i : 2 * N - 1 - i;
			int wj = j < M ? j : 2 * M - 1 - j;
			bool wrt = (i == bi && j == bj ? !ul[wi][wj] : ul[wi][wj]);
			putchar (wrt ? '#' : '.');
		}
		putchar ('\n');
	}

	return 0;
}
