#include <cstdio>
#include <cassert>
#include <algorithm>
#include <vector>

int main (int argc, char *argv[]) {
	assert (argc == 3);
	FILE *out = fopen (argv[1], "r");
	FILE *sol = fopen (argv[2], "r");

	assert (out && sol);

	int N1;
	std::vector <int> ids1;
	assert (fscanf (out, "%d", &N1) == 1);

	ids1.resize (N1);
	for (int i = 0; i < N1; ++i)
		assert (fscanf (out, "%d", &ids1[i]) == 1);

	int N2;
	std::vector <int> ids2;
	assert (fscanf (sol, "%d", &N2) == 1);
	ids2.resize (N2);
	for (int i = 0; i < N2; ++i)
		assert (fscanf (sol, "%d", &ids2[i]) == 1);

	assert (N1 == N2);
	std::sort (ids1.begin (), ids1.end ());
	std::sort (ids2.begin (), ids2.end ());
	assert (ids1 == ids2);

	printf ("seems ok!\n");

	return 0;
}
