#include <cstdio>
#include <cstring>

const int MAXN = 1 << 10;

int N;
char str[MAXN];
int fl[MAXN];

void pre_kmp () {
	fl[0] = fl[1] = 0;
	int crnt = 0;
	for (int i = 2; i <= N; ++i) {
//		crnt = fl[i-1];
		while (crnt && str[crnt] != str[i-1])
			crnt = fl[crnt];
		if (str[crnt] == str[i-1]) ++crnt;
		fl[i] = crnt;
	}

	for (int i = 0; i <= N; ++i) printf ("%d ", fl[i]); puts ("");
}

int main () {
	gets (str);
	N = strlen (str);
	pre_kmp ();

	return 0;
}
