/*
FROM: LISH 2007 day 2
PROB: palindrom
KEYW: dynamical programming on string, kmp idea (but precomputed and no actual kmp)
*/

#include <cstdio>
#include <iostream>
#include <algorithm>
#include <string>

const int MAXM = 8;//length of small string (5)

int realN, N, M;
std::string str, rev;
std::string w;

long long dp[2][MAXM][MAXM];
int go1[MAXM][2];
int go2[MAXM][2];

void fnd_go (int go[MAXM][2], const std::string &s) {
	std::string tmp;
	char l;

	int i, j, k;
	for (i = 0; i < M; ++i) {
		for (j = 0; j < 2; ++j) {
			l = j + 'A';
			tmp = s.substr (0, i);
			tmp += l;

			for (k = 0; k < tmp.size (); ++k)
				if (tmp.substr (k, std::string::npos) == s.substr (0, tmp.size () - k))
					break;
			go[i][j] = tmp.size () - k;
//			printf ("%d %c --> %d\n", i, l, go[i][j]);
		}
	}
//	puts ("");
}

long long res = 0;
int c = 1, o = 0;
void try_add (int id1, int id2, char mid) {
	static std::string tmp, tmpx;
	tmp = str.substr (0, id1);
	if (mid) tmp += mid;
	tmpx = rev.substr (0, id2);
	std::reverse (tmpx.begin (), tmpx.end ());
	tmp += tmpx;
//	printf ("%d %d %c (%d) --> %s\t\t", id1, id2, mid, int (mid), tmp.c_str ());
	if (tmp.size () < str.size () || tmp.find (str) == std::string::npos) {
//		printf ("%u\n", str.find (tmp));
		res += dp[o][id1][id2];
//		printf ("YES\n");
	} else {
//		printf ("NO!\n");
	}
}

int main () {
	std::cin >> str; M = str.size (); rev = str; std::reverse (rev.begin (), rev.end ());
	std::cin >> realN; N = realN / 2;

//	std::cout << str << ' ' << rev << std::endl;
	fnd_go (go1, str);
	fnd_go (go2, rev);
/*
	for (int i = 0; i < M; ++i)
		printf ("%d %d\n%d %d\n", go1[i][0], go2[i][0], go1[i][1], go2[i][1]);
*/
	dp[o][0][0] = 1;
	int i, ii, jj;
	for (i = 0; i < N; ++i) {
		memset (dp[c], 0, sizeof (dp) / 2);
		for (ii = 0; ii < M; ++ii)
			for (jj = 0; jj < M; ++jj) {
//				printf ("%d %d %d  %d %d %d  %d\n", i+1, go1[ii][0], go2[jj][0],\
				i, ii, jj, dp[o][ii][jj]);
//				printf ("%d %d %d  %d %d %d  %d\n", i+1, go1[ii][1], go2[jj][1],\
				i, ii, jj, dp[o][ii][jj]);
				dp[c][go1[ii][0]][go2[jj][0]] += dp[o][ii][jj];
				dp[c][go1[ii][1]][go2[jj][1]] += dp[o][ii][jj];
			}
//		printf ("\n");
		o = c;
		c = !c;
	}
/*
	printf ("N == %d\n", N);
	for (ii = 0; ii < M; ++ii)
		for (jj = 0; jj < M; ++jj)
			printf ("%d %d --> %Ld\n", ii, jj, dp[o][ii][jj]);
*/
	for (ii = 0; ii < M; ++ii)
		for (jj = 0; jj < M; ++jj) {
			if (dp[o][ii][jj] == 0) continue;
			if (realN & 1) {
				try_add (ii, jj, 'A');
				try_add (ii, jj, 'B');
			} else {
				try_add (ii, jj, '\0');
			}
		}

//	printf ("%Ld\n", res);
	std::cout << res << std::endl;

	return 0;
}
