#include <cstdio>
#include <cctype>
#include <cassert>
#include <cstring>
#include <string>

int main (int argc, char *argv[]) {
	assert (argc >= 3);
	std::string tn = std::string (argv[1]), fn, nfn, end = std::string (argv[2]);
	for (int i = 3; i < argc; ++i) {
		fn = std::string (argv[i]);
		for (size_t j = 1; j < fn.size (); ++j) {
			if (isdigit (fn[j-1]) && isdigit (fn[j])) {
				nfn = tn + "." + fn[j-1] + fn[j] + "." + end;
				break;
			} else if (isdigit (fn[j-1])) {
				nfn = tn + "." + '0' + fn[j-1] + "." + end;
				break;
			}
		}
		printf ("rename %s -> %s\n", fn.c_str (), nfn.c_str ());
		rename (fn.c_str (), nfn.c_str ());
	}
	
	return 0;
}
