#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 17;

int N, M;
int vec[MAXN];
int idx[MAXN];
int dp[MAXN];

bool cmp (int a, int b) {
	return vec[a] < vec[b];
}

int main () {
	scanf ("%d %d", &N, &M);
	
	int i;
	for (i = 0; i < N; ++i) {
		scanf ("%d", vec + i);
		idx[i] = i;
	}

	std::sort (idx, idx + N, cmp);

	memset (dp, 0x7f, sizeof (dp));//quite big
	dp[0] = -1;
	int crnt;
	for (i = 0; i < M; ++i) {
		scanf ("%d", &crnt);
		int l = -1, r = N, m;
		while (l + 1 < r) {
			m = (l + r) / 2;
			if (vec[idx[m]] < crnt)
				l = m;
			else
				r = m;
		}
		if (vec[idx[r]] != crnt) continue;
		*std::lower_bound (dp, dp + N, idx[r]) = idx[r];
	}

	for (i = 1; dp[i] != 0x7f7f7f7f; ++i);
	printf ("%d\n", i - 1);

	return 0;
}
