#include <cstdio>

const int MAXF = 1 << 10;

int N, F;
int pow[MAXF];
int fact[MAXF];

int vec[MAXF];

int sq (int a) {return a * a;}

int mypow (int base, int pow) {
	if (pow == 0)
		return 1;
	else if (pow & 1)
		return mypow (base, pow - 1) * base;
	else
		return sq (mypow (base, pow / 2));
}

void gen (int pos, bool rev) {
	if (pos == F) {
		int res = 1;
		for (int i = 0; i < F; ++i)
			res *= mypow (fact[i], vec[i]);
		printf (" %d", res);
		return;
	}
//	for (int i = 0; i < pos; ++i) printf ("%d ", vec[i]); printf ("  %d %d\n", pos, rev);
	if (!rev) {
		for (int i = 0; i <= pow[pos]; ++i) {
			vec[pos] = i;
			gen (pos + 1, (pow[pos] + i) & 1);
		}
	} else {
		for (int i = pow[pos]; i >= 0; --i) {
			vec[pos] = i;
			gen (pos + 1, (pow[pos] + i + 1) & 1);
		}
	}
}

int main () {
	scanf ("%d", &N);

	int i;
	for (i = 2; i * i <= N; ++i) {
		if (N % i) continue;
		fact[F] = i;
		do {
			N /= i;
			++pow[F];
		} while (N % i == 0);
		++F;
	}
	if (N != 1)	{
		fact[F] = N;
		pow[F] = 1;
		++F;
	}
/*	for (i = 0; i < F; ++i)
		printf ("%d ^ %d\n", fact[i], pow[i]);*/

	gen (0, 0);
	puts ("");

	return 0;
}
