#include <cstdio>

const int MAXN = 1 << 17;
const long long MAXF = 1000000000000ll;

int N;
long long pos[MAXN];
long long fish[MAXN];

bool can (long long t) {
//	printf ("can %Ld\n", t);
	long long have = 0;
	for (int i = 0; i < N; ++i) {
//		printf ("town %d - %Ld\n", i, have);
		have += fish[i];
		if (have > t + pos[i+1] - pos[i]
		 || have < t)
			have -= t + pos[i+1] - pos[i];
		else
			have = 0;
	}
//	printf ("ret %d\n", have >= 0);
	return have >= 0;
}

int main () {
	scanf ("%d", &N);

	int i;
	for (i = 0; i < N; ++i)
		scanf ("%Ld %Ld", pos + i, fish + i);
	pos[N] = pos[N-1];

	long long l = 0, r = MAXF, m;
	while (l + 1 < r) {
		m = (l + r) / 2;
		if (can (m))
			l = m;
		else
			r = m;
	}

	printf ("%Ld\n", l);
	
	return 0;
}
