/*
FROM: NOI 1998 round 4
PROB: p4
KEYW: mathematics
*/

#include <cstdio>
#include <cassert>

const int MAXN = 1 << 20;
const int MAXPR = 1 << 17;

int pr[MAXPR], prc;
bool era[MAXN];
long long b[MAXPR / 2];
long long c[MAXPR / 2];
int cp;

int main () {
	int i, j;
	for (i = 2; i * i < MAXN; ++i)
		if (!era[i]) {
			pr[prc++] = i;
			for (j = i * i; j < MAXN; j += i) era[j] = 1;
		}

	for (; i < MAXN; ++i)
		if (!era[i]) pr[prc++] = i;

//	printf ("%d\n", prc);
//	for (i = 0; i < prc; ++i) printf ("%d ", pr[i]); printf ("\n");
	long long tmp10 = 10;
	for (i = 0; i < prc; i += 2) {
		if (pr[i] / tmp10)
			tmp10 *= 10;
		b[i >> 1] = (long long)pr[i] * tmp10 + pr[i+1];
	}
//	for (i = 0; i < 20; ++i) printf ("%Ld ", b[i]); printf ("\n");
//	printf ("%Ld\n", b[(prc/2)- 1]);

	for (i = 0; i < (prc >> 1) - 1; ++i) {
		for (j = 0; (long long)pr[j] * pr[j] <= b[i]; ++j) {
//			assert (pr[j]);
			if (!(b[i] % pr[j]))
				goto nxti;
		}
		c[cp++] = b[i];
		if (cp == 150) break;
		nxti:;
	}
//	for (i = 0; i < 150; ++i) printf ("%Ld ", c[i]); printf ("\n");
	int id;
	scanf ("%d", &id);
	printf ("%Ld\n", c[id-1]);

	return 0;
}
