/*
FROM: NOI 2000 round 4 1st day
PROB: equal
KEYW: full exhaustion, backtracking
*/

#include <cstdio>
#include <cstdlib>

#include <algorithm>

const int MAXN = 1 << 7;
const int MAXSUM = 1 << 17;

int N;

int vec[MAXN];
//int opt[MAXN][MAXSUM];

int _cnt[1 << 10];

int allsum;
int inmax;
int grc;
int grsum;

int gr[MAXN][MAXN];
int grs[MAXN];
int gp[MAXN];
/*
bool test (int a) {
	static int i;
	for (i = 0; i < grc && opt[a + 1][grsum - grs[i]]; ++i);
	return i == grc;
}
*/
int fill_with;
bool _try () {
	for (int i = 0; i < grc; ++i) {
		if (grs[i] + (inmax - gp[i]) * fill_with != grsum) return 0;
		for (int j = gp[i]; j < inmax; ++j) gr[i][j] = fill_with;
	}

	return 1;
}

void prnt () {
	if (!_try ()) return;
	printf ("%d\n", grc);
	for (int i = 0; i < grc; ++i) {
		printf ("%d", gr[i][0]);
		for (int j = 1; j < inmax; ++j)
			printf (" %d", gr[i][j]);
		printf ("\n");
	}

	exit (0);
}

void rec (int a) {
//	printf ("\t%d\n", a);
//	prnt (0);
	if (a == N) prnt ();

	for (int i = 0; i < grc; ++i) {
		if (gp[i] == inmax - 1)
			if (grs[i] + vec[a] == grsum) {
				gr[i][gp[i]++] = vec[a];
				grs[i] += vec[a];
				rec (a + 1);
				grs[i] -= vec[a];
				--gp[i];
			} else continue;

		if (gp[i] < inmax - 1 && grs[i] + vec[a] < grsum) {
			gr[i][gp[i]++] = vec[a];
			grs[i] += vec[a];
			rec (a + 1);
			grs[i] -= vec[a];
			--gp[i];
		}
	}
}

int main () {
	int rN;
	scanf ("%d", &rN);
	N = rN;

	int i;// j;
	for (i = 0; i < N; ++i) {
		scanf ("%d", vec + i);
		allsum += vec[i];
		++_cnt[vec[i]];
	}

	int max =0, maxi = -1;
	for (i = 0; i < (1 << 10); ++i) if (max < _cnt[i]) {max = _cnt[i]; maxi = i;}
	for (i = 0; i < N; ++i) if (vec[i] == maxi) vec[i] = 1001;
	std::sort (vec, vec + N);
	for (i = 0; i < N && vec[i] != 1001; ++i);
	N = i;
	fill_with = maxi;
	std::reverse (vec, vec + N);
	for (i = 0; i < N; ++i) printf ("%d ", vec[i]); printf ("\n");
/*
	opt[N-1][vec[N-1]] = 1;
	opt[N-1][0] = 1;
	for (i = N-2; i >= 0; --i) {
		for (j = 0; j < vec[i]; ++j)
			opt[i][j] = opt[i+1][j];
		for (; j < MAXSUM; ++j)
			opt[i][j] = opt[i+1][j] + !!opt[i+1][j - vec[i]];
	}
*/
	for (inmax = 1; inmax < rN; ++inmax)
		if (!(rN % inmax) && !(allsum % (grc = rN / inmax))) {
			grsum = allsum / (rN / inmax);
			rec (0);
		}

	printf ("1\n");
	printf ("%d", vec[0]); for (i = 1; i < N; ++i) printf (" %d", vec[i]); printf ("\n");

	return 0;
}
