/*
FROM: 2002 k3
PROB: toto (encode)
KEYW: coding, combinations
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 6;
const int MAXM = 1 << 4;

int opt[MAXN][MAXM];
int vec[MAXM];

int main () {
	int i, j;
	for (i = 0; i < 6; ++i) scanf ("%d", vec + i); std::sort (vec, vec + 6);

	for (i = 0; i < MAXN; ++i)
		for (j = opt[i][0] = 1; j <= MAXM-1 <? i; ++j)
			opt[i][j] = opt[i-1][j-1] + opt[i-1][j];

	int res = 0;
	for (i = j = 0; i < 6; ++i)
		for (++j; j < vec[i]; ++j)
			res += opt[49-j][5-i];

	for (i = 23; i >= 0; --i) printf ("%d", (res >> i) & 1); puts ("");

	return 0;
}
