/*
FROM: NOI 2002 round 3
PROB: perm
KEYW: dynamical programming
*/

#include <cstdio>

const int MAXN = 1 << 5;
const int MAXK = MAXN;

int N, K;
long long opt[MAXN][MAXK];

int main () {
	scanf ("%d %d", &N, &K);

	opt[1][1] = 1;
	int i, j;
	for (i = 2; i <= N; ++i)
		for (j = 1; j <= i; ++j)
			opt[i][j] = opt[i-1][j-1] + opt[i-1][j] * (i - 1);

	printf ("%Ld\n", opt[N][K]);

	return 0;
}
