/*
FROM: 2003 k1
PROB: club
KEYW: sort, linear
*/

#include <cstdio>
#include <climits>
#include <algorithm>

const int MAXN = 1 << 20;

struct el {
	int time;
	bool out;
	bool operator < (const el &a) const {return time < a.time;}
};

int K, N;
el vec[MAXN*2];

int main () {
	scanf ("%d", &K);

	unsigned a, b;
	while (scanf ("%u %u", &a, &b) == 2) {
		vec[N++] = (el) {a, 0};
		vec[N++] = (el) {a + b, 1};
	}

	std::sort (vec, vec + N);
	vec[N] = (el) {UINT_MAX, 1};

	int in = 0, add = 1, go = 0;
	int res = 0;
	for (int i = 1; i <= N; ++i) {
//		printf ("%d -- %u %d (%d)\n", i, vec[i].time, vec[i].out, in);
		if (vec[i].time != vec[i-1].time) {
//			printf ("here - add %d\n", add);
			if (add && go && in >= K) {++res; /*printf ("yup!\n");*/}
			in += add;
			add = 0; go = 0;
		}
		if (vec[i].out)
			--in, ++go;
		else
			++add;
	}

	printf ("%d\n", res);

	return 0;
}
