/*
FROM: NOI 2003 ROUND 2 A
PROB: frac
KEYW: farey sequence,consequtive generating
*/

#include <cstdio>

int N, K;

struct frac {
	int p, q;
	frac () {}
	frac (int _p, int _q) : p (_p), q (_q) {}
	frac (const frac &a, const frac &b) {p = (a.q + N) / b.q * b.p - a.p; q = (a.q + N) / b.q * b.q - a.q;}
};

int main () {
	scanf ("%d %d", &N, &K);

	frac a1 (0, 1), a2 (1, N), a3;
	if (K == 0) printf ("%d %d\n", a1.p, a1.q);
	else if (K == 1) printf ("%d %d\n", a2.p, a2.q);
	else {
		for (int i = 2; i <= K; ++i) {
			a3 = frac (a1, a2);
			a1 = a2;
			a2 = a3;
		}
		printf ("%d %d\n", a2.p, a2.q);
	}

	return 0;
}
