/*
NAME: Ivan Anev
PROG: cube
LANG: C++
*/

#include <iostream>
#include <cstring>
#include <ctime>

using namespace std;


int rs[3][12] = {
        {8, 5, 0, 4, 11, 9, 1, 3, 10, 6, 2, 7},
        {1, 2, 3, 0, 5, 6, 7, 4, 9, 10, 11, 8},
        {4, 3, 7, 11, 8, 0, 2, 10, 5, 1, 6, 9}
};

class Cube {
private:
        int cs[6], cb[12];
        int ans;
private:
        void gen(int l) {
                int i;

                if (l == 12) {
                        if (check())
                                ans++;
                }
                else {
                        for (i = 0; i < 6; i++)
                                if (cs[i]) {
                                        cb[l] = i;
                                        cs[i]--;
                                        gen(l + 1);
                                        cs[i]++;
                                }
                }
        }
        int check() {
                int r1, r2;
                int nc1[12], nc2[12], nc3[12];

                memcpy(nc1, cb, sizeof(cb));
                for (r1 = 0; r1 < 4; r1++) {
                        rotate(nc2, nc1, 1);
                        memcpy(nc1, nc2, sizeof(nc1));
                        for (r2 = 0; r2 < 4; r2++) {
                                rotate(nc3, nc2, 0);
                                memcpy(nc2, nc3, sizeof(nc2));
                                if (memcmp(cb, nc3, sizeof(cb)) > 0)
                                        return 0;
                        }
                }
                memcpy(nc1, cb, sizeof(cb));
                for (r1 = 0; r1 < 3; r1++) {
                        rotate(nc2, nc1, 2);
                        memcpy(nc1, nc2, sizeof(nc1));
                        if (r1 == 1)
                                continue;
                        for (r2 = 0; r2 < 4; r2++) {
                                rotate(nc3, nc2, 0);
                                memcpy(nc2, nc3, sizeof(nc2));
                                if (memcmp(cb, nc3, sizeof(cb)) > 0)
                                        return 0;
                        }
                }

                return 1;
        }
        void rotate(int nc[], int cb[], int r) {
                int i;

                for (i = 0; i < 12; i++)
                        nc[i] = cb[rs[r][i]];
        }
public:
        void solve() {
                int i, c;

                memset(cs, 0, sizeof(cs));

                for (i = 0; i < 12; i++) {
                        cin >> c;
                        cs[c-1]++;
                }

                ans = 0;

                for (i = 0; cs[i] == 0; i++)
                        ;
                cb[0] = i;
                cs[i]--;
                gen(1);
				printf ("%lf\n", (double)clock () / CLOCKS_PER_SEC);
                cout << ans << '\n';
        }
};

Cube cube;

int main() {
        cube.solve();

        return 0;
}
