/*
FROM: NOI 2004 round 3
PROB: cups
KEYW: combinatorial gray codes (personal edition :) )
*/

#include <cstdio>
#include <vector>
#include <utility>

const int MAXN = 1 << 4;

int N, K;
int in[MAXN];

std::vector <std::pair <int, int> > ans;

void move (int fr, int to) {
	ans.push_back (std::make_pair (fr, to));
	++in[to];
	--in[fr];
	//for (int i = 0; i < N; ++i) printf ("%d ", in[i]); printf ("\n");
}

void f (int, int, int);
void fr (int, int, int);

void f (int n, int s, int bg) {
	if (s == 0 || n == 1) return;

	bool crnt;
	if (s & 1) crnt = 0; else crnt = 1;
//	printf ("f  %d %d %d -- crnt == %d\n", n, s, bg, crnt);
	for (int i = 1; i <= s; ++i) {
		if (!crnt) {
//			printf ("case 11(%d %d %d)\n", n, s, bg);
			move (bg, bg + 1);
			f (n - 1, i, bg + 1);
		} else {
//			printf ("case 12(%d %d %d)\n", n, s, bg);
			move (bg, bg + n - 1);
			fr (n - 1, i, bg + 1);
		}
		crnt = !crnt;
	}
}

void fr (int n, int s, int bg) {
	if (s == 0 || n == 1) return;

	bool crnt;
	if (s & 1) crnt = 1; else crnt = 0;
//	printf ("fr %d %d %d -- crnt == %d\n", n, s, bg, crnt);
	for (int i = 1; i <= s; ++i) {
		if (crnt) {
//			printf ("case 21(%d %d %d)\n", n, s, bg);

			move (bg + n - 1, bg + n - 2);
			fr (n - 1, i, bg);
		} else {
//			printf ("case 22(%d %d %d)\n", n, s, bg);
			move (bg + n - 1, bg);
			f (n - 1, i, bg);
		}

		crnt = !crnt;
	}
}

int main () {
	scanf ("%d %d", &N, &K);
	in[0] = K;
	f (N, K, 0);


	printf ("%u\n", ans.size ()); for (int i = 0; i < (int)ans.size (); ++i) printf ("%d %d\n", ans[i].first + 1, ans[i].second + 1);

	return 0;
}
