/*
FROM: 2005 k2
PROB: base
KEYW: SCC
*/

#include <cstdio>
#include <cassert>

const int MAXN = 1 << 14;
const int MAXM = 1 << 17;

struct el {
	int to;
	int next;
	el () {}
	el (int _to, int _next) : to (_to), next (_next) {}
};

int N, M;
int vec[MAXN];
el buf[MAXM];

el rbuf[MAXM];
int rvec[MAXN];

int pro[MAXN], pp;

int used[MAXN];
bool used2[MAXN];

int stk[MAXN], sp;

void dfs1 (int c) {
	stk[sp++] = c;
/*
	int p;
	while (sp) {
		c = stk[sp - 1];
		p = 0;
		for (int i = vec[c]; i != -1; i = buf[i].next)
			if (!used[buf[i].to]) {
				used[buf[i].to] = 1;
				stk[sp++] = buf[i].to;
				p = 1;
			}
		if (!p) {
			--sp;
			pro[pp++] = c;
		}
	}
*/

	while (sp) {
		c = stk[sp - 1];
		for (; vec[c] != -1 && used[buf[vec[c]].to]; vec[c] = buf[vec[c]].next);
		if (vec[c] == -1) {
			--sp; pro[pp++] = c;
		} else {
			used[buf[vec[c]].to] = 1;
			stk[sp++] = buf[vec[c]].to;
			vec[c] = buf[vec[c]].next;
		}
	}

/*
	for (int i = vec[c]; i != -1; i = buf[i].next)
		if (!used[buf[i].to]) {
			used[buf[i].to] = 1;
!used[buf[vec[c]].to]			dfs1 (buf[i].to);
		}

	pro[pp++] = c;
*/
}

int marked;
void dfs2 (int c) {
	static int grc = 0;
	used[c] = grc;
	stk[sp++] = c;

	while (sp) {
		c = stk[--sp];
		for (int i = rvec[c]; i != -1; i = rbuf[i].next)
			if (used[rbuf[i].to] == -1) {
				++marked;
				used[rbuf[i].to] = grc;
				stk[sp++] = rbuf[i].to;
			} else if (used[rbuf[i].to] == grc)
				++marked;
	}

	++grc;
}

int main () {
	scanf ("%d %d\n", &N, &M);

	int i, a, b;
	for (i = 0; i < N; ++i) vec[i] = rvec[i] = -1;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
		buf[i] = el (b, vec[a]);
		vec[a] = i;

		rbuf[i] = el (a, rvec[b]);
		rvec[b] = i;
	}

	for (i = 0; i < N; ++i) if (!used[i]) used[i] = 1, dfs1 (i);

	for (i = 0; i < N; ++i) used[i] = -1;
	assert (pp == N);
//	for (i = 0; i < pp; ++i) printf ("%d\n", pro[i]); printf ("\n");
	for (i = pp - 1; i >= 0; --i) if (used[pro[i]] == -1) dfs2 (pro[i]);

	printf ("%d\n", M - marked);

	return 0;
}
