#include <stdio.h>
#include <queue>
#include <vector>
using namespace std;

 unsigned _stklen = 33554432;

 struct
  {
   long s1,s2;
  }o[262144];

 typedef
  struct
   {
    long x,y,z;
   } line;

 typedef
  struct
   {
    long x1,y1,x2,y2;
   } un;

 un r[131072];
 un a[131072];
 line b[131072];
 line c[131072];
 long marked[131072];
 long n,cnt;
 line tmp[131072]; 

 template<typename T>
 struct cmp
  {
   bool operator () (const T& a,const T& b) const
    {
     if (a.z<b.z) return false;
     if (a.z>b.z) return true;
     if (a.x<b.x) return false;
     if (a.x>b.x) return true;
     if (a.y<b.y) return false;
     if (a.y>b.y) return true;
     return false;
    }
  };

 template<typename T>
 struct ss
  {
   bool operator () (const T& a,const T& b) const
    {
     if (r[a].x1<r[b].x1) return false;
     if (r[a].x1>r[b].x1) return true;
     if (r[a].y1<r[b].y1) return false;
     if (r[a].y1>r[b].y1) return true;

     if (r[a].x2<r[b].x2) return false;
     if (r[a].x2>r[b].x2) return true;
     if (r[a].y2<r[b].y2) return false;
     if (r[a].y2>r[b].y2) return true;
     return false;
    }
  };  

 priority_queue< line,vector<line>,cmp<line> > heap;
 priority_queue< long,vector<long>,ss<long> > t;

 void solve (line a[],long n,line b[],long m,long x1,long y1,long x2,long y2)
  {
   long p,q,i,j,X,Y,c1,c2,pom;
   for (i=1;i<=n;i++)
    {
     j=i;
     while (a[i].z==a[j].z && j<=n) j++;
     j--;
     if (a[i].x==y1 && a[j].y==y2)
      {
       cnt++;
       r[cnt].x1=r[cnt].x2=a[i].z;
       r[cnt].y1=y1;
       r[cnt].y2=y2;
       goto skip;
      }
     i=j;
    }
//
   for (i=1;i<=m;i++)
    {
     j=i;
     while (b[i].z==b[j].z && j<=m) j++;
     j--;
     if (b[i].x==x1 && b[j].y==x2)
      {
       cnt++;
       r[cnt].y1=r[cnt].y2=b[i].z;
       r[cnt].x1=x1;
       r[cnt].x2=x2;
       goto skip;
      }
    }
   exit (-1);
//
   skip:{};
   X=r[cnt].x2;
   Y=r[cnt].y2;
   p=q=c1=c2=0;
// ver
   memset(marked,0,sizeof(long)*(n+2));
   for (i=1;i<=n;i++)
    if (!(r[cnt].x1<=a[i].z && a[i].z<=r[cnt].x2
    &&    r[cnt].y1<=a[i].x && a[i].y<=r[cnt].y2))
     if (a[i].z<X && a[i].x<Y)
      marked[i]=1;
       else
        marked[i]=2;
   for (i=1;i<=n;i++)
    {
     if (marked[i]==1) a[++p]=a[i];
     if (marked[i]==2) tmp[++c1]=a[i];
    }
   for (i=p+1;i<=p+c1;i++)
    a[i]=tmp[i-p];
// hor
   memset(marked,0,sizeof(long)*(m+2));
   for (i=1;i<=m;i++)
    if (!(r[cnt].y1<=b[i].z && b[i].z<=r[cnt].y2
    &&    r[cnt].x1<=b[i].x && b[i].y<=r[cnt].x2))
     if (b[i].z<Y && b[i].x<X)
      marked[i]=1;
       else
        marked[i]=2;
   for (i=1;i<=m;i++)
    {
     if (marked[i]==1) b[++q]=b[i];
     if (marked[i]==2) tmp[++c2]=b[i];
    }
   for (i=q+1;i<=q+c2;i++)
    b[i]=tmp[i-q];
//
   pom=cnt;
   if (p+q!=0)
    {
     o[pom].s1=cnt+1;
     solve(a,p,b,q,x1,y1,X,Y);
    }
   if (c1+c2!=0)
    {
     o[pom].s2=cnt+1;
     solve(&a[p],c1,&b[q],c2,r[pom].x1,r[pom].y1,x2,y2);
    }
  }

 int main ()
  {
   long X1,Y1,X2,Y2,i,p,q,j;
   line tmp;
   scanf("%ld",&n);
   X1=Y1=1000000;
   X2=Y2=-1000000;
   for (i=1;i<=n;i++)
    {
     scanf("%ld%ld%ld%ld",&a[i].x1,&a[i].y1,&a[i].x2,&a[i].y2);
     if (a[i].x1<X1) X1=a[i].x1;
     if (a[i].x2>X2) X2=a[i].x2;
     if (a[i].y1<Y1) Y1=a[i].y1;
     if (a[i].y2>Y2) Y2=a[i].y2;
    }
   p=q=0;
   for (i=1;i<=n;i++)
    {
     tmp.x=a[i].x1;
     tmp.y=a[i].x2;
     tmp.z=a[i].y1;
     heap.push(tmp);
     tmp.x=a[i].x1;
     tmp.y=a[i].x2;
     tmp.z=a[i].y2;
     heap.push(tmp);     
    }
   while (!heap.empty())
    {
     b[++p]=heap.top();
     heap.pop();
    }
   for (i=1;i<=n;i++)
    {
     tmp.x=a[i].y1;
     tmp.y=a[i].y2;
     tmp.z=a[i].x1;
     heap.push(tmp);
     tmp.x=a[i].y1;
     tmp.y=a[i].y2;
     tmp.z=a[i].x2;
     heap.push(tmp);     
    }
   while (!heap.empty())
    {
     c[++q]=heap.top();
     heap.pop();
    }
// hor
   memset(marked,0,sizeof(marked));
   for (i=1;i<=p;i++)
    if ((i!=0 && b[i].z==b[i-1].z && b[i].x==b[i-1].x) || b[i].z==Y1 || b[i].z==Y2)
     marked[i]=1;
   j=0;
   for (i=1;i<=p;i++)
    if (marked[i]==0)
     b[++j]=b[i];
   p=j;
// ver
   memset(marked,0,sizeof(marked));
   for (i=1;i<=q;i++)
    if ((i!=0 && c[i].z==c[i-1].z && c[i].x==c[i-1].x) || c[i].z==X1 || c[i].z==X2)
     marked[i]=1;
   j=0;
   for (i=1;i<=q;i++)
    if (marked[i]==0)
     c[++j]=c[i];
   q=j;
//
   solve(c,q,b,p,X1,Y1,X2,Y2);
   printf("%ld\n",cnt);
   t.push(1);
   while (!t.empty())
    {
     i=t.top();
     printf("%ld %ld %ld %ld\n",r[i].x1,r[i].y1,r[i].x2,r[i].y2);
     t.pop();
     if (o[i].s1!=0) t.push(o[i].s1);
     if (o[i].s2!=0) t.push(o[i].s2);
    }    
   return 0;
  }
