// The compiler used is Borland C++ Builder

#include <iostream>
#include <fstream>

using namespace std;

int main(int argc, char *argv[])
{  if (argc != 2)
   { cout << "Argument error \n";
     cout << "Usage: mat.checker file_name \n";
     return 0;
   }

   ifstream fout(argv[1]);    // output file
   if(fout.fail())
   { cout << 0 << endl;
     cout << "Cannot open " << argv[1] << endl;
     return 0;
   }

  int A[20][20];
  char s[30];
  int i,j,k,n;
  int p,q,r;

  for(i=0; i<20; i++)
  for(j=0; j<20; j++)
    A[i][j]=2;

  for(i=1; i<=9; i++)
  { s[0]=0;
    fout.getline(s,30);
    if(s==NULL || s[0]==0)
    { cout << 0 << endl;
      cout << "Row " << i << " is missing \n";
      fout.close();
      return 0;
    }

    j=0;
    for(k=0; s[k]>0; k++)
    { if(s[k]=='1')
      { A[i][++j]=1;
        if(j>1 && s[k-1]!=' ')
        { cout << 0 << endl;
          cout << "Wrong format \n";
          cout << "Missing space ";
          cout << "in row " << i << " at position " << k << endl;
          fout.close();
          return 0;
        }
      }
      else if(s[k]=='0')
      { A[i][++j]=0;
        if(j>1 && s[k-1]!=' ')
        { cout << 0 << endl;
          cout << "Wrong format \n";
          cout << "Missing space ";
          cout << "in row " << i << " at position " << k << endl;
          fout.close();
          return 0;
        }
      }
      else if(s[k]==' ')
      { if(k>0 && s[k-1]==' ')
        { cout << 0 << endl;
          cout << "Wrong format \n";
          cout << "Double space ";
          cout << "in row " << i << " at position " << k+1 << endl;
          fout.close();
          return 0;
        }
      }
      else
      { cout << 0 << endl;
        cout << "Wrong character ";
        cout << "in row " << i << " at position " << k+1 << endl;
        fout.close();
        return 0;
      }
      if(j>12)
      { cout << 0 << endl;
        cout << "There is no code with more than 12 columns \n";
        fout.close();
        return 0;
      }
    }
    if(j<3)
    { cout << 0 << endl;
      cout << "Row " << i << " is \"" << s << "\" - too short row \n";
      fout.close();
      return 0;
    }
    if(i==1) n=j;
    else if(n!=j)
    { cout << 0 << endl;
      cout << "Different lengths \n";
      cout << "Length of row 1 is " << n << endl;
      cout << "Length of row " << i << " is " << j << endl;
      fout.close();
      return 0;
    }
  }

  for(p=1; p<=n; p++)
  for(q=1; q<=n; q++)
  for(r=1; r<=n; r++)
  if(p!=q && p!=r && q!=r)
  { for(i=1; i<=9; i++)
      if(A[i][p]==1 && A[i][q]==0 && A[i][r]==0)
        break;
    if(i>9)
    { cout << 0 << endl;
      cout << "Not a code \n";
      cout << "Check columns ";
      cout << p << ", " << q << ", " << r << endl;
      fout.close();
      return 0;
    }
  }

  cout << (n-2)*10 << endl;
  cout << "Correct solution with "<< n << " columns \n";

  fout.close();
  return 0;
}



