/*
TASK: traverse
LANG: C++
*/
//#define generate1

#include<stdio.h>
#include<math.h>
#include<stdlib.h>
#include<sstream>
#include<iostream>
#include<vector>
#include<map>
#include<time.h>
#include<string>
#include<algorithm>
using namespace std;

#define VI vector < int >
#define VS vector < string >
#define pb push_back
#define cs c_str()
#define sz size()
#define ALL(a) (a).begin(),(a).end()
///////////////////////////////////////////
#define in stdin;//fopen("in","r")
FILE*fn;
///////////////////////////////////////////
#define len 32
#define base 1000000000
#define bigtype long long   //should hold  base*base*2
#define lb 9
     
struct L
  {
  int ss[len];
  L(){for(int q1=0;q1<len;q1++)ss[q1]=0;};
  L(bigtype a){for(int q1=len-1;q1>=0;q1--){ss[q1]=a%base;a/=base;};}
  };

L operator+(const L&a,const L&b)
  {L c;
  for(int q1=len-1,c1=0;q1>=0;q1--)
    {c1+=a.ss[q1]+b.ss[q1];
    c.ss[q1]=c1%base;
    c1/=base;}
  return c;}
L operator-(const L&a,const L&b)
  {L c;
  for(int q1=len-1,c1=0,c2=0;q1>=0;q1--)
    {c1=a.ss[q1]-b.ss[q1]-c2;
    c2=0;
    if(c1<0){c1+=base;c2=1;}
    c.ss[q1]=c1;}
  return c;}
L operator*(const L&a,int b)
  {L c;
  bigtype c1=0;
  for(int q1=len-1;q1>=0;q1--)
    {c1+=(bigtype)a.ss[q1]*(bigtype)b;
    c.ss[q1]=(int)(c1%(bigtype)base);
    c1/=(bigtype)base;}
  return c;}
L operator*(int b,const L&a)
  {L c;
  bigtype c1=0;
  for(int q1=len-1;q1>=0;q1--)
    {c1+=(bigtype)a.ss[q1]*(bigtype)b;
    c.ss[q1]=(int)(c1%(bigtype)base);
    c1/=(bigtype)base;}
  return c;}

L operator/(const L&a,int b)
  {L c;
  bigtype c1=0;
  for(int q1=0;q1<len;q1++)
    {c1+=(bigtype)a.ss[q1];
//    printf("%lld\n",c1);
    c.ss[q1]=(int)(  (c1/(bigtype)b)   );
//    printf("%d\n",c.ss[q1]);
    c1=((c1%(bigtype)b) * (bigtype)base);
    //printf("%lld\n",c1);
    }
  return c;}
  
  
int print(const L&a)
  {int q1;
  for(q1=0;q1<len;q1++)if(a.ss[q1])break;
  if(q1==len)q1--;
  printf("%d",a.ss[q1]);
  for(q1++;q1<len;q1++)printf("%0*d",lb,a.ss[q1]);
  return 0;}

L scan(void)
  {char d[len*16];
  int q1,c1,c2,c3,q2;
  L e1;
  fscanf(fn,"%s",d);
  c1=strlen(d);
  for(q1=0;q1<(c1+lb-1)/lb;q1++)
    {c2=0;
    for(q2=lb-1;q2>=0 ;q2--)if(c1-1-q1*lb-q2>=0)
      c2=c2*10+d[c1-1-q1*lb-q2]-48;
    e1.ss[len-1-q1]=c2;}
  return e1;}

int dif(const L&a,const L&b)
  {int q1;
  for(q1=0;q1<len;q1++)if(a.ss[q1]!=b.ss[q1])break;
  if(q1==len)return 0;
  return a.ss[q1]-b.ss[q1];}
int operator<(const L&a,const L&b){int c1=dif(a,b);return c1<0;}
int operator>(const L&a,const L&b){int c1=dif(a,b);return c1>0;}
int operator==(const L&a,const L&b){int c1=dif(a,b);return c1==0;}
int operator!=(const L&a,const L&b){int c1=dif(a,b);return c1!=0;}
int operator<=(const L&a,const L&b){int c1=dif(a,b);return c1<=0;}
int operator>=(const L&a,const L&b){int c1=dif(a,b);return c1>=0;}


/////////////////////////////////////////////
#define type L
#define greater(a,b,c) (c==1?a<b:a>b)
#define mx 513

type pw2[mx];


L randomL(int n,int seed,int all)
  {L e1=pw2[n]-1;
  //print(e1);printf("\n");
  e1=e1/all;
//  print(e1);printf("\n");
  e1=e1*seed;
//  print(e1);printf("\n");
  return e1;}

struct solve1
{
vector < vector < type > > comb;
vector < vector < pair < int , int > > > ss;


type solve(int m,type c)
  {comb.clear();
  ss.clear();
  if(c==0)return 0;
  comb.resize(mx,vector < type > (mx,0));
  int q1,q2,q3;

  for(q1=0;q1<mx;q1++)for(q2=0;q2<=q1;q2++)
    if(q2==0)comb[q1][q2]=1;
    else comb[q1][q2]=comb[q1-1][q2]+comb[q1-1][q2-1];
  
  ss.resize(2);
  
  int dir=0,curs=m;
  type ans=0,cur=c;
  type left,right;
  left=0;
  right=pw2[m];

  while(1)
    {
    if(dir==0)
      {
      
      for(q1=0;q1<ss[0].sz;q1++)
        {ans=ans+comb[ss[0][q1].first][ss[0][q1].second];
        ss[0][q1].second++;}
      
      vector < type > split;
    
      split.pb(left);
    
      for(q1=0;q1<curs;q1++)split.pb((split.back()+right)/2);
      split.erase(split.begin());  
      for(q1=0;q1<split.sz;q1++)if(split[q1]==cur)break;
    
      if(q1!=split.sz)
        {ans=ans+q1;
        break;}
      ans=ans+curs;
        
      for(q1=split.sz-1;q1>=0;q1--)if(cur>split[q1])break;
      
      if(q1!=-1)left=split[q1];
      right=split[q1+1];
      
      for(q2=0;q2<=q1;q2++)
        ss[0].pb(make_pair(curs-q2-1,1));
      
      
      curs=curs-q1-2;
      
      for(q1=0;q1<ss[1].sz;q1++)
        {ans=ans+comb[ss[1][q1].first][ss[1][q1].second];
        ss[1][q1].second++;}
        
      ss[1].pb(make_pair(curs,2));
      }
    else if(dir==1)
      {
      
      for(q1=0;q1<ss[1].sz;q1++)
        {ans=ans+comb[ss[1][q1].first][ss[1][q1].second];
        ss[1][q1].second++;}
      
      vector < type > split;
    
      split.pb(right);
    
      for(q1=0;q1<curs;q1++)split.pb((split.back()+left)/2);
      split.erase(split.begin());  
      for(q1=0;q1<split.sz;q1++)if(split[q1]==cur)break;
    
      if(q1!=split.sz)
        {ans=ans+q1;
        break;}
      ans=ans+curs;
      
      for(q1=split.sz-1;q1>=0;q1--)if(cur<split[q1])break;

      
      left=split[q1+1];
      if(q1!=-1)right=split[q1];
      
      for(q2=0;q2<=q1;q2++)
        ss[1].pb(make_pair(curs-q2-1,1));
      
      
      curs=curs-q1-2;
      
      for(q1=0;q1<ss[0].sz;q1++)
        {ans=ans+comb[ss[0][q1].first][ss[0][q1].second];
        ss[0][q1].second++;}
        
      ss[0].pb(make_pair(curs,2));
      }
    
    dir=1-dir;}
  
  
  return ans+1;}

};


vector < int > order;
vector < int > rev;
vector < vector < int > > cyc;

int dobrute(int a)
  {VI done;
  int q1,q2,c1,c2,c3,dir=0;
  done.resize((1<<a)+1);
  done[0]=1;
  done.back()=1;
  order.pb(0);
  for(q1=0;q1<a;q1++)
    {
    if(dir==0)
      {
      for(q2=0;q2<(1<<a);q2++)if(!done[q2+1])break;
      c1=q2;
      for(q2++;q2<=(1<<a);q2++)
        if(!done[q2])
          {if(q2+q2-c1<=(1<<a))
            if(done[q2+q2-c1])
              {done[q2]=1;
              c1=q2;
              order.pb(q2);}
          }             
        else c1=q2;
      }
    if(dir==1)
      {
      for(q2=(1<<a);q2>0;q2--)if(!done[q2-1])break;
      c1=q2;
      for(q2--;q2>=0;q2--)
        if(!done[q2])
          {if(q2+q2-c1>=0)
            if(done[q2+q2-c1])
              {done[q2]=1;
              c1=q2;
              order.pb(q2);}
          }
        else c1=q2;
      }
      
    dir=1-dir;}
  rev.resize(order.sz);
  for(q1=0;q1<order.sz;q1++)rev[order[q1]]=q1;
  return 0;}

type comb[mx][mx];
type sum[mx][mx];
type sum2[mx][mx];


int ss[2][mx][3];
int br[2],iter[2];
type border[2];

type easy(int m,type c)
  {if(c==0)return 0;
  type c1,c2,ans=0;
  int q1,q2,curs=m,d=0,ok;
  border[0]=0;
  border[1]=pw2[m];
  br[0]=br[1]=iter[0]=iter[1]=0;
  
  while(1)
    {
    iter[d]++;
    
    c1=border[d];
    
    ok=0;
    for(q1=0;q1<curs;q1++)
      {
      c2=(c1+border[1-d])/2;
      if(c==c2){ok=1;break;}
      if(greater(c2,c,d))break;
      c1=c2;
      }
    
    if(ok){ans=ans+q1;break;}
    
    border[1-d]=c2;
    border[d]=c1;
    
    for(q2=0;q2<q1;q2++)
      {ss[d][br[d]][0]=curs-q2-1;
      ss[d][br[d]][1]=1;
      ss[d][br[d]++][2]=iter[d];}
      
    ans=ans+curs;
    curs=curs-q1-1;
    iter[1-d]++;
    
    ss[1-d][br[1-d]][0]=curs;
    ss[1-d][br[1-d]][1]=2;
    ss[1-d][br[1-d]++][2]=iter[1-d];
    
    d=1-d;
    }
  
  for(q1=0;q1<2;q1++)for(q2=0;q2<br[q1];q2++)
    ans=ans 
       +sum[ss[q1][q2][0]][ss[q1][q2][1]+iter[q1]-ss[q1][q2][2]-1]
       -sum[ss[q1][q2][0]][ss[q1][q2][1]-1];
    
  
  return ans+1;}


type hard(int m,type c)
  {if(c==0)return 0;
  type c1,c2,ans=0,c3;
  int q1,q2,d,curs,dir,cur,iter=0;
  border[0]=0;
  border[1]=pw2[m];
  dir=1;
  d=0;
  curs=m;
  
  for(q1=0;;q1++)if(c<comb[m][q1])break;
  else {c=c-comb[m][q1];dir=1-dir;}
  cur=q1-1;
  
  while(1)
    {
    if(iter==cur)break;
   
    if(d==dir)
      {
      c1=border[d];
      
      for(q1=0;q1<curs;q1++)
        {
        c2=(c1+border[1-d])/2;
        if(c<comb[curs-q1-1][cur-iter])break;
        c=c-comb[curs-q1-1][cur-iter];
        c1=c2;
        }
        
      border[d]=c1;
      border[1-d]=c2;
      curs=curs-q1-1;  
      }
    else
      {
      c1=border[d];
      
      for(q1=0;q1<curs-1;q1++)
        {
        c2=(c1+border[1-d])/2;
        c3=sum2[curs-q1-2][cur-iter];
        if(c>=c3)
          {c=c-c3;
          break;}       
        c1=c2;
        }
      
      border[d]=c1;
      border[1-d]=c2;
      curs=curs-q1-1;
      }
    
    d=1-d;
    iter++;}
 
  c1=border[dir];
  for(q1=0;q1<=c;q1++)
    c1=(c1+border[1-dir])/2;
    
  ans=c1;
  return ans;}



int precompute(void)
  {int q1,q2;
  for(q1=0;q1<mx;q1++)for(q2=0;q2<mx;q2++)
    {
    if(q2==0)comb[q1][q2]=1;
    else if(q1==0)comb[q1][q2]=0;
    else comb[q1][q2]=comb[q1-1][q2]+comb[q1-1][q2-1];
    
    if(q2==0)sum[q1][q2]=1;
    else sum[q1][q2]=sum[q1][q2-1]+comb[q1][q2];
    
    if(q1==0)sum2[q1][q2]=comb[q1][q2];
    else sum2[q1][q2]=sum2[q1-1][q2]+comb[q1][q2];
      
    }
  pw2[0]=1;
  for(q1=1;q1<mx;q1++)pw2[q1]=2*pw2[q1-1];
  return 0;}



int findcycles(vector < int > &ss)
  {vector < bool > used;
  used.resize(ss.sz);
  int q1,q2,c1,c2;
  
  for(q1=0;q1<used.sz;q1++)if(!used[q1])
    {
    vector < int > cc;
    cc.pb(q1);
    c1=q1;
    while(ss[c1]!=q1)
      {c1=ss[c1];
      used[c1]=1;
      cc.pb(c1);}
    
    used[q1]=1;
    
    cyc.pb(cc);
    }
  
  return 0;}



type solveit(int b,type a)
  {
  return hard(b,a);
  }


int main()
  {
  precompute();
  #ifndef generate1
  
  fn=in;
  int c,m,q1;
  L e1;
  fscanf(fn,"%d %d",&c,&m);
  
  
//  printf("Gfdgfdg\n");
//  printf("%d %d\n",c,m);
  
  for(q1=0;q1<m;q1++)
    {
    e1=scan();
    
//    print(e1);
    
    print(solveit(c,e1));
    printf("\n");
   
    if(e1>=pw2[c])printf("gfdgfdjngfdgjkffdgfdg\n");    
    
//    if(easy(c,hard(c,e1))!=e1)printf("Gfdgfdgfd\n");
    
    
    }
  
 fclose(fn);
 
 #else
 int c,m,q1,e1;
  scanf("%d %d",&c,&m);
  printf("%d %d\n",c,m);
  
 for(q1=0;q1<m;q1++)
   {
   if(c<=14)printf("%d",rand()%((1<<c)-1)+1);
   else print(randomL(c,q1,m))+12;
   printf("\n");
   }
 #endif
 
 /* int c1=6,q1;
  
  dobrute(c1);
 
 
  solve1 solver;
  
  for(q1=0;q1<(1<<c1);q1++)
    {if(order[q1]!=hard(c1,(type)q1)|| hard(c1,easy(c1,(type)q1))!=q1 || easy(c1,(type)q1)!=rev[q1] || easy(c1,hard(c1,(type)q1))!=q1)
      {
      printf("Gfdgfd\n");
//      printf("%d  -  %d %d\n",q1,order[q1],hard(c1,q1));
      }
    
    if(solver.solve(c1,(type)q1)!=easy(c1,(type)q1))
      {
//      printf("Gffdgffd\n");
      print(solver.solve(c1,(type)q1));
      printf("\n");
      print(easy(c1,(type)q1));
      printf("\n\n");
      }
    }  
 
   
*/
  return 0;} 
  
