/*
FROM: NOI 2006 round 3 day 1
PROB: gen
KEYW: dynamical programming
*/

#include <cstdio>
#include <cstring>

const int MAX = 1 << 7;

int CC;//conversion count
char conv[MAX][3];

int N;//length of original string
unsigned dp[MAX][MAX];//bit masks

int main () {
	static char str[MAX];
	gets (str);
	N = strlen (str);

	int fcc;//first conversion count
	char fconv[2];
	int i, j, k, d;
	scanf ("%d\n", &fcc);
	for (i = 0; i < fcc; ++i) {
		scanf ("%2c\n", fconv);
		for (j = 0; j < N; ++j)
			if (str[j] == fconv[1])
				dp[j][j+1] |= 1 << (fconv[0] - 'A');
	}

	scanf ("%d\n", &CC);
	for (i = 0; i < CC; ++i) {
		scanf ("%3c\n", conv[i]);
		conv[i][0] -= 'A';
		conv[i][1] -= 'A';
		conv[i][2] -= 'A';
	}

	for (d = 2; d <= N; ++d)
		for (i = 0; i + d <= N; ++i)
			for (j = i+1; j < i + d; ++j)
				for (k = 0; k < CC; ++k)
					if ((dp[i][j]   & (1 << conv[k][1]))
					 && (dp[j][i+d] & (1 << conv[k][2]))) {
						dp[i][i+d] |= 1 << conv[k][0];
					}

	for (i = 0; i < 26; ++i)
		if (dp[0][N] & (1 << i))
			putchar (i + 'A');
	if (!dp[0][N]) putchar ('0');
	puts ("");

	return 0;
}
