#include <cstdio>
#include <cstring>

const int MAXN = 1 << 9;
const int MAXS = 200010;

int N;
int prev[MAXS];
int vec[MAXN];

int main () {
	scanf ("%d", &N);
	int i,j;

	for (i = 0; i < N; ++i)
		scanf ("%d", vec + i);

	memset (prev, -1, sizeof (prev));
	prev[0] = -2;
	int lp = 0;
	for (i = 0; i < N; ++i) {
		for (j = lp; j >= 0; --j)
			if (prev[j] != -1 && prev[j+vec[i]] == -1)
				prev[j + vec[i]] = i;
		lp += vec[i];
	}

	for (j = lp / 2; prev[j] == -1; --j);

	static int ans[MAXN], ap;
	for (; j; j -= vec[prev[j]])
		ans[ap++] = prev[j];

	printf ("%d\n%d", ap, ans[ap-1] + 1);
	for (i = ap-2; i >= 0; --i)
		printf (" %d", ans[i] + 1);
	puts ("");

	return 0;
}
