#include <cstdio>
#include <utility>
#include <algorithm>

using std::make_pair;

const int MAXN = 1 << 18;
const int INF = 2000000000;

int N;
std::pair <int, int> vec[MAXN];

int main () {
	scanf ("%d", &N);
	int i;
	for (i = 0; i < N; ++i)
		scanf ("%d %d", &vec[i].first, &vec[i].second);

	std::sort (vec, vec + N);

	int cbeg = -INF, cend = -INF;
	int sum = 0;
	for (i = 0; i < N; ++i) {
		if (vec[i].first > cend) {
			sum += cend - cbeg;
			cbeg = vec[i].first;
			cend = vec[i].second;
		} else
			cend >?= vec[i].second;
	}

	sum += cend - cbeg;
	printf ("%d\n", sum);

	return 0;
}
