/*
FROM: NOI 2007 r1
PROB: expres
KEYW: dynamical programming
NOTE: wrong (author) solution
*/

#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <cstring>

const int MAXN = 128 * 2;
const int MAXL = 256 * 2;
const long long INF = 1ll << 60;

int N;
long long cost[MAXN][MAXN];
long long val[MAXN][MAXN];
int mid[MAXN][MAXN];

int L;
int k[3];
char expr[MAXL];
int digs[MAXN];
int signs[MAXN];

void prnt (int l, int r) {
//	std::system ("PAUSE");
	if (l + 1 == r) {putchar (digs[l] + '0'); return;}
	if (l != 0 || r != N) putchar ('(');
	prnt (l, mid[l][r]);
	putchar ("+-*"[signs[mid[l][r]-1]]);
	prnt (mid[l][r], r);
	if (l != 0 || r != N) putchar (')');
}

int tosign (char a) {
	switch (a) {
		case '+': return 0;
		case '-': return 1;
		case '*': return 2;
		default : assert (("bad input", 0));//there must be a problem with the input
	}
}

int nd (long long a) {//number of digits
	return a ? (int)log10 (llabs (a)) + 1 : 1;
}

void calc_cost_val (int l, int m, int r, long long &ccost, long long &cval) {
	switch (signs[m-1]) {
		case 0: cval = val[l][m] + val[m][r]; ccost = (nd (val[l][m]) + nd (val[m][r])) * k[0] + cost[l][m] + cost[m][r]; return;
		case 1: cval = val[l][m] - val[m][r]; ccost = (nd (val[l][m]) + nd (val[m][r])) * k[1] + cost[l][m] + cost[m][r]; return;
		case 2: cval = val[l][m] * val[m][r]; ccost = (nd (val[l][m]) * nd (val[m][r])) * k[2] + cost[l][m] + cost[m][r]; return;
	}
}

int main () {
	gets (expr); L = strlen (expr); printf ("L == %d\n", L);
	int i, j, d;
	for (i = 0; i < 3; ++i) scanf ("%d", k + i);

	for (i = 0; i < L; i += 2) {
		digs[i/2] = expr[i] - '0';
		printf ("pos %d -- _%c_\n", i, expr[i]);
	}
	for (i = 1; i < L; i += 2) {
		signs[i/2] = tosign (expr[i]);
		printf ("poss %d -- _%c_\n", i, expr[i]);
	}
	N = L/2 + 1;//the number of digits

	for (i = 0; i < N; ++i)
		val[i][i+1] = digs[i];
	long long ccost, cval;
	for (d = 2; d <= N; ++d)
		for (i = 0; i + d <= N; ++i) {//the interval we are calculating is [i, i + d) (digits)
			cost[i][i+d] = INF;
			for (j = i + 1; j < i + d; ++j) {//j shows the position of the sign which will split up the two parts [i,j) and [j;d)
				calc_cost_val (i, j, i+d, ccost, cval);
				if (cost[i][i+d] > ccost) {
					cost[i][i+d] = ccost;
					val[i][i+d] = cval;
					mid[i][i+d] = j;
				}
			}
//			printf ("%d %d -- %d\n", i, i + d, mid[i][i+d]);
			assert (cost[i][i+d] != INF);//make sure we have found an answer
		}

	printf ("%Ld\n", cost[0][N]);
	prnt (0, N);//using mid
	puts ("");

	return 0;
}
