/*
TASK: expres
LANG: C++
*/

#include <cstdio>
#include <ctime>
#include <cassert>
#include <cstdlib>
#include <cmath>
#include <cctype>

#define _RESET_COUNT 1

const int MAXL = 256;
const int MAX = MAXL;

int N;
int k[3];
char expr[MAXL];
int id[255];

long long stk[MAX], stkp;
int sign[MAX], sigp;
int ccost;
int best = 1000000000;

clock_t beg;

int nd (long long a) {
//	printf ("%Ld -- %d\n", a, (int)(log10 (llabs (a))) + 1);
	return a ? (int)(log10 (llabs (a))) + 1 : 1;
}

long long _raw_calc (long long o1, long long o2, int op) {
	switch (op) {
		case 0: ccost += k[0] * (nd (o1) + nd (o2)); return o1 + o2;
		case 1: ccost += k[1] * (nd (o1) + nd (o2)); return o1 - o2;
		case 2: ccost += k[2] * (nd (o1) * nd (o2)); return o1 * o2;
		default: fprintf (stderr, "%d\n", op); assert (0);
	}
}

void petr (int pos) {
//	if ((clock () - beg) * _RESET_COUNT >= CLOCKS_PER_SEC) throw 1;
	if (clock () > 0.97 * CLOCKS_PER_SEC) {printf ("%d\n", best); exit (0);}
//	for (int i = 0; i < stkp; ++i) {printf ("%Ld ", stk[i]); if (i != stkp-1) printf ("%c ", "+-*"[sign[i]]);}
//	puts ("");
//	system ("PAUSE");
	if (pos == N && stkp == 1) {
//		printf ("___%d___\n", ccost);
		best = ccost;
//		throw 1.;
		return;
	}
	long long o1, o2;
	int op, oldcost;
	if (rand () & 1) {
		if (stkp > 1) {
			o1 = stk[stkp-2];
			o2 = stk[stkp-1];
			stkp -= 2;
			op = sign[sigp-1];
			oldcost = ccost;
			--sigp;
			stk[stkp++] = _raw_calc (o1, o2, op);
			if (ccost < best) {
//				printf ("CALC!\n");
				petr (pos);
			}
			--stkp;
			stk[stkp++] = o1;
			stk[stkp++] = o2;
			sign[sigp++] = op;
			ccost = oldcost;
		}
		if (pos != N) {
			sign[sigp++] = expr[pos];
			stk[stkp++] = expr[pos+1];
//		printf ("ADD!\n");
			petr (pos + 2);
			--stkp;
			--sigp;
		}
	} else {
		if (pos != N) {
			sign[sigp++] = expr[pos];
			stk[stkp++] = expr[pos+1];
//		printf ("ADD!\n");
			petr (pos + 2);
			--stkp;
			--sigp;
		}
		if (stkp > 1) {
			o1 = stk[stkp-2];
			o2 = stk[stkp-1];
			stkp -= 2;
			op = sign[sigp-1];
			oldcost = ccost;
			--sigp;
			stk[stkp++] = _raw_calc (o1, o2, op);
			if (ccost < best) {
//				printf ("CALC!\n");
				petr (pos);
			}
			--stkp;
			stk[stkp++] = o1;
			stk[stkp++] = o2;
			sign[sigp++] = op;
			ccost = oldcost;
		}
	}
//	printf ("<<--\n");
}

int main () {
	gets (expr);
	scanf ("%d %d %d", k, k + 1, k + 2);
	expr[0] -= '0';
	int i;
	srand (time (0));
	for (i = 1; expr[i] && !isspace (expr[i]); i += 2) {
		switch (expr[i]) {
			case '+': expr[i] = 0; break;
			case '-': expr[i] = 1; break;
			case '*': expr[i] = 2; break;
		}
		expr[i+1] -= '0';
	}
	N = i;

	for (;;) {
//		try {
			ccost = 0;
			stkp = 0;
			stk[stkp++] = expr[0];
			beg = clock ();
			petr (1);
//		} catch (int) {
//		} catch (double) {
//			break;
//		}
	}
	printf ("%d\n", best);

	return 0;
}
