#include <cstdio>
#include <iostream>
#include <string>
#include <algorithm>

const int MAXN = 1 << 10;

int N;
std::string data[MAXN];
int dp[MAXN];

int main () {
	int i, j;
	std::cin >> N;
	for (i = 0; i < N; ++i)
		std::cin >> data[i];

	std::sort (data, data + N);
	int ans = 0;
	for (i = N-1; i >= 0; --i) {
		dp[i] = 1;
		for (j = i + 1; j < N && std::equal (data[i].begin (), data[i].end (), data[j].begin ()); ++j)
			dp[i] >?= dp[j] + 1;
		ans >?= dp[i];
	}

	std::cout << ans << std::endl;

	return 0;
}
