/*
FROM: SPRING 2001 A
PROB: quire
KEYW: linear
*/

#include <cstdio>
#include <cassert>

int K, P;

int pow4 (int a) {return 1 << (a << 1);}
int pow2 (int a) {return 1 << a;}

int main () {
	scanf ("%d %d", &K, &P);

	--P;
	int x = 0, y = 0, p = P / 2;
	bool xs = P & 1;

	int px, py;
	for (int k = K-1; k >= 0; --k) {
//		printf ("%d -- (%d)%d %d\n", k, xs, x, y);
		px = p / pow4 (k);
		py = p % pow4 (k);
		switch (px) {
			case 0:	p = py;
					x += pow2 (K-1-k);
					break;
			case 1:	p = pow4 (k) - 1 - py;
					xs = !xs;
					y = pow2 (K-1-k) - 1 - y;
					x += pow2 (K-1-k);
					y += pow2 (K-1-k);
					break;
			case 2:	p = py;
					y = pow2 (K-1-k) - 1 - y;
					x = pow2 (K-1-k) - 1 - x;
					y += pow2 (K-1-k);
					break;
			case 3:	p = pow4 (k) - 1 - py;
					xs = !xs;
					x = pow2 (K-1-k) - 1 - x;
					break;
			default:assert (0);
		}
	}

	assert (!p);
	int ys = y & 1;
	if (xs) x = pow2 (K) - 1 - x;
//	printf ("%c%d %c%d\n", xs ? '-' : '\0', x + 1, ys ? '-' : '\0', y + 1);
	if (xs) printf ("-"); printf ("%d ", x + 1);
	if (ys) printf ("-"); printf ("%d\n", y + 1);

	return 0;
}
