#include<fstream.h>
#include<iomanip.h>
#include<stdlib.h>

const int Mmax=12;
const int Nmax=12;
const int ne=20;

int M,N;
int e[Mmax*Nmax+1][ne+1];
int t[Mmax][Nmax];

const int maxd=4;
const int di[maxd]={1,0,-1, 0};
const int dj[maxd]={0,1, 0,-1};

void input1()
{
 int i,j,kn,p,l;

 for(i=0;i<=Mmax*Nmax;i++)
 for(j=0;j<=ne;j++) e[i][j]=0;

 fstream f;
 f.open("enemy.inp",ios::in);
 f >> M >> N >> kn;
// cout << M << ' ' << N << ' ' << kn << endl;

 for(int k=0;k<kn;k++)
  { f >> i >> p;
    e[i][0]=p;
    for(j=1;j<=p;j++) f >> e[i][j];
  }
 f.close();

// symmetrize

for(i=1;i<=M*N;i++)
for(k=1;k<i;k++)
for(l=1;l<=e[k][0];l++)
if(e[k][l]==i)
{
 (e[i][0])++;
 e[i][e[i][0]]=k;
}

// for(i=1;i<=M*N;i++)
// { cout << endl << setw(2) << i << ": ";
//   cout << '(' << e[i][0] << ") ";
//   for(j=1;j<=ne;j++) cout << setw(3) << e[i][j] << ' ';
// }

// cin.get();
}


void input2()
{
 int i,j;

 fstream f;
 f.open("enemy.out",ios::in);

 for(i=0;i<M;i++)
 for(j=0;j<N;j++)
 f >> t[i][j];

 f.close();

// for(i=0;i<N;i++)
// { cout << endl;
//   for(j=0;j<M;j++) cout << t[i][j] << ' ';
// }

// cin.get();

}

int check1(int i, int j)
{
  int p=t[i][j];

  if(e[p][0]>0)
  for(int l=1;l<=e[p][0];l++)
  {
   for(int k=0;k<maxd;k++)
   {
    int i0= i+di[k];
    int j0= j+dj[k];
    if((0<=i0)&&(i0<M)&&(0<=j0)&&(j0<N))
    {
     if(t[i0][j0] != 0)
     if(t[i0][j0]==e[p][l])
     {
      return 0;
     }
    }
  }
  }
  return 1;
}



void check()
{
  for(int i=0;i<M;i++)
  for(int j=0;j<N;j++)
  if(!check1(i,j))
   {cout << i <<','<< j << " is not correct\n"; exit(0);}

  cout << "O.K.!" << endl;
}

void check0()
{
 int i,j,k;
 int p[Mmax*Nmax+1];

  k=1;
  for(i=0;i<M;i++)
  for(j=0;j<N;j++) {p[k]=0; k++;}


  for(i=0;i<M;i++)
  for(j=0;j<N;j++)
  {
    if(t[i][j]<1) {cout << i << ',' << j << " not in a range\n"; exit(0); }
    if(t[i][j]>M*N) {cout << i << ',' << j << " not in a range\n"; exit(0); }
    p[t[i][j]]++;
  }

  k=1;
  for(i=0;i<M;i++)
  for(j=0;j<N;j++)
  {if(p[k] != 1) {cout << k << " is not met just once"; exit(0);}
   k++;
  }
}

main()
{
 input1();
 input2();
 check0();
 check();
 return 0;
}
