#include <fstream.h>
#include <iomanip.h>
#include <stdlib.h>

const int Mmax=11;
const int Nmax=11;
const int ne=21;

int M,N;
int e[Mmax*Nmax+1][ne+1];
int t[Mmax][Nmax];

//const int maxd=8;
//const int di[maxd]={1,1,0,-1,-1,-1, 0, 1};
//const int dj[maxd]={0,1,1, 1, 0,-1,-1,-1};

const int maxd=4;
const int di[maxd]={1,0,-1, 0};
const int dj[maxd]={0,1, 0,-1};


void input()
{
 int i,j,kn,p,l;

 for(i=0;i<=M*N;i++)
 for(j=0;j<=ne;j++) e[i][j]=0;

 fstream f;
 f.open("enemy.inp",ios::in);
 f >> M >> N >> kn;
// cout << M << ' ' << N << ' ' << kn << endl;

 for(int k=0;k<kn;k++)
  { f >> i >> p;
    e[i][0]=p;
    for(j=1;j<=p;j++) f >> e[i][j];
  }
 f.close();

// show:

// for(i=1;i<=M*N;i++)
// { cout << endl << setw(2) << i << ": ";
//   cout << '(' << e[i][0] << ") ";
//   for(j=1;j<=ne;j++) cout << setw(3) << e[i][j] << ' ';
// }

// cin.get();


// symmetrize

for(i=1;i<=M*N;i++)
for(k=1;k<i;k++)
for(l=1;l<=e[k][0];l++)
if(e[k][l]==i)
{
 (e[i][0])++;
 e[i][e[i][0]]=k;
}

// show:

// for(i=1;i<=M*N;i++)
// { cout << endl << setw(2) << i << ": ";
//   cout << '(' << e[i][0] << ") ";
//   for(j=1;j<=ne;j++) cout << setw(3) << e[i][j] << ' ';
// }

// cin.get();
}

void show()
{
 int i,j;

// for(i=0;i<M;i++)
// { cout << endl;
//   for(j=0;j<N;j++) cout << setw(3) << t[i][j];
// }

 fstream f;
 f.open("enemy.out",ios::out);
 for(i=0;i<M;i++)
 {
   for(j=0;j<N;j++) f << t[i][j] << ' ';
   f << endl;
 }

 f.close();
}


int check(int p, int i, int j)
{
//  cout << "check " << p << ' ' << i << ' ' << j << ' ' << e[p][0] << endl;

  if(e[p][0]>0)
  for(int l=1;l<=e[p][0];l++)
  {
//    cout << "l=" << l << endl;
  for(int k=0;k<maxd;k++)
  {
   int i0= i+di[k];
   int j0= j+dj[k];
//   cout << " k=" << k << ' ' << i0 << ' ' << j0 << endl;
   if((0<=i0)&&(i0<M)&&(0<=j0)&&(j0<N))
    {
//     cout << " l=" << l << ' ' << i+di[k] << ' ' << j+dj[k] << endl;

//    cout << "t[i0][j0]=" << t[i0][j0] << ' ' << e[p][l] << endl;
    if(t[i0][j0] != 0)
    if(t[i0][j0]==e[p][l])
     {
//       cout << "return 0\n"; cin.get();
      return 0;
     }
    }
//   cin.get();
  }
  }
  return 1;
}

void put(int p)
{
// cout << p << ' ';
// show();
// cin.get();

 if(p>=M*N+1)
  {
//   cout << "found!\n";
//   cin.get();
   show();
//   cin.get();
   exit(0);
  }

//  cout << "*";

 for(int i=0;i<M;i++)
 for(int j=0;j<N;j++)
 if(t[i][j]==0)
 if(check(p,i,j))
  {
//    cout << i << ' ' << j << ' ' << p << endl;
    t[i][j]=p;
    put(p+1);
    t[i][j]=0;
  }
}

void run()
{
  int i,j;
  for(i=0;i<M;i++)
  for(j=0;j<N;j++) t[i][j]=0;

  put(1);
}

main()
{
 input();
 run();
 cin.get();
 cout << "not found\n";
 cin.get();
 return 0;
}

