/*
FROM: SPRING 2002 A
PROB: ladder
KEYW: dynamical programming
*/

#include <cstdio>

const int MAX = 1 << 10;

inline int max (int a, int b) {return a > b ? a : b;}
inline int max3 (int a, int b, int c) {return max (max (a, b), c);}
inline int min3 (int a, int b, int c) {return a <? b <? c;}

int N, K;
int hb[MAX];
int opt[MAX];

int main () {
	scanf ("%d %*d", &N);

	scanf ("%d", &K);
	int i;
	int a, b;
	for (i = 0; i < K; ++i) {
		scanf ("%d %d", &a, &b);
		--a;
		hb[a] >?= b;
	}

	opt[0] = hb[0];
	opt[1] = max (opt[0], hb[1]);
	opt[2] = max (opt[1], hb[2]);
	for (i = 3; i < N; ++i)
		opt[i] = min3 (opt[i-1] + hb[i], opt[i-2] + max (hb[i-1], hb[i]), opt[i-3] + max3 (hb[i-2], hb[i-1], hb[i]));

	printf ("%d\n", opt[N-1]);
	return 0;
}
