/*
FROM: SPRING 2002 A
PROB: trace
KEYW: full exhaustion, backtracking
*/

#include <cstdio>
#include <cstdlib>
#include <ctime>

const int MAXN = 1 << 7;
const int MAXM = 1 << 8;

int N, M;
int vec[MAXN][MAXM];
int vc[MAXN];

int ref[MAXN];
int row[MAXN];
int best[MAXN], bc = 0;
bool used[MAXN];

int UB = (int)(CLOCKS_PER_SEC * 1.8);

void save (int a, int b) {
	for (int i = a; i < b; ++i)
		best[i-a] = row[i];

	best[b-a] = best[0];
	bc = b - a;
}

void prnt () {
	printf ("%d\n", bc);
//	for (i = 0; i < bc; ++i) printf ("%d %d\n", best[i] + 1, best[i+1] + 1);
	exit (0);
}

void bt (int a, int d) {
//	if (clock () >= UB) prnt ();
	used[a] = 1;
	for (int i = 0; i < vc[a]; ++i)
		if (ref[vec[a][i]] != -1) {
			if (d + 1 - ref[vec[a][i]] > bc)
				save (ref[vec[a][i]], d + 1);
		} else {
			ref[vec[a][i]] = d + 1;
			row[d + 1] = vec[a][i];
			bt (vec[a][i], d + 1);
			ref[vec[a][i]] = -1;
		}
}

int main () {
	scanf ("%d %d", &N, &M);

	int i;
	int a, b;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);
		--a; --b;
		vec[a][vc[a]++] = b;
	}
	for (i = 0; i < MAXN; ++i) ref[i] = -1;
/*
	for (i = 0; i < N; ++i) {
		printf ("%d ->", i);
		for (int j = 0; j < vc[i]; ++j)
			printf (" %d", vec[i][j]);
		printf ("\n");
	}
*/
	for (i = 0; i < N; ++i)
		if (!used[i]) {
			ref[i] = 0;
			row[0] = i;
			bt (i, 0);
			ref[i] = -1;
		}

	prnt ();

	return 0;
}
