/*
FROM: SPRING 2006 A
PROB: wac
KEYW: module, trie, hash_map
*/

#include "module.h"

#include <map>
#include <vector>
#include <string>

const int MAXN = 1 << 20;
const int MAXLEN = 1 << 7;
const int ALPHA = 26;

struct qt {
	int node;
	int index;
	qt () {}
	qt (int _node, int _index) : node (_node), index (_index) {}
};

int nodecntr = 2;//start from 1 (1 is base so the first one next is 2)
std::vector <std::string> words;
std::vector <int> in_node[MAXN];
int nodes[MAXN][ALPHA];

qt go (std::string w, int radd) {
	static int id;
	if (radd) {
		id = words.size ();
		words.push_back (w);
	}

	int i, cnode = 1;
	for (i = 0; i < (int)w.size (); ++i) {
		if (radd) in_node[cnode].push_back (id);
		if (nodes[cnode][w[i] - 'a'])
			cnode = nodes[cnode][w[i] - 'a'];
		else
			cnode = nodes[cnode][w[i] - 'a'] = nodecntr++;
	}

	if (radd) in_node[cnode].push_back (id);
	return qt (cnode, 0);
}

std::map <std::string, qt> hm;

int main () {
	init ();

	char buf[MAXLEN];
	char tmp1[MAXLEN], tmp2[MAXLEN];
	std::map <std::string, qt>::iterator crnt;
	for (;;) {
		getQuery (buf);

		if (buf[0] == 'A') {
			sscanf (buf, "%*s %s", tmp1);
			go (std::string (tmp1), 1);
		} else {
			if (buf[0] == 'F') {
				sscanf (buf, "%*s %s %s", tmp1, tmp2);
				crnt = hm.find (std::string (tmp1));
				if (crnt == hm.end ())
					crnt = hm.insert (std::pair <std::string, qt> (std::string (tmp1), qt ())).first;
				crnt->second = go (std::string (tmp2), 0);
			} else {
				sscanf (buf, "%*s %s", tmp1);
				crnt = hm.find (std::string (tmp1));
				if (crnt->second.index >= (int)in_node[crnt->second.node].size ()) crnt->second.index = 0;
			}
			if (in_node[crnt->second.node].size () == 0)
				answerQuery (".");
			else
				answerQuery (words[in_node[crnt->second.node][crnt->second.index++]].c_str ());
		}
	}

	return 0;
}
