#include <cstdio>
#include <cstdlib>
#include <algorithm>
const int MAX = 1<<20; 
int N;
int idt[MAX],chord[MAX],back[MAX];
int lowest_bit (int a) {return a & -a;}
void add (int i, int val) 
{
	for (; i <= N*2; i += lowest_bit (i))
	{
		idt[i] += val;
    }
}
int _srch (int i) 
{
	int ret = 0;
	
	for (ret = 0; i; i -= lowest_bit (i))
	{
		ret += idt[i];
    }
	return ret;
}
int srch (int l, int r) 
{
	return _srch (r) - _srch (l);
}
int main()
{
    scanf ("%d",&N);
    int i,sum = 0,tmp,tmp1,a,b;
    for(i = 0;i < N;i++)
    {
          scanf("%d %d",&a,&b);
          tmp = (((a > b))?(b):(a));
          tmp1 = (((a > b))?(a):(b));
          chord[tmp] = tmp1;
          back[tmp1] = tmp;
    }
    for (i = 1; i <= N*2;i++)
    {
        if(chord[i])
        {
                  add(i,1);  
        }
        else
        {
            add(back[i],-1);
            sum += srch (back[i],i);
        }
    }
    printf("%d\n",sum);
    return 0;
}
