#include <vector>
#include <string>
#include <algorithm>
#include <cmath>

using namespace std;

struct rec {
	int x1, x2;
	int y1, y2;
};

int N;

rec vec[1 << 6];
int X[1 << 7], Xp;
int Y[1 << 7], Yp;

bool notin (double x, double y) {
	for (int i = 0; i < N; ++i)
		if (vec[i].x1 < x && x < vec[i].x2 && vec[i].y1 < y && y < vec[i].y2) return 0;
	return 1;
}

bool up (double x, double y) {
	for (int i = 0; i < N; ++i)
		if (vec[i].y1 > y && vec[i].x1 < x && x < vec[i].x2) return 1;
	return 0;
}

bool down (double x, double y) {
	for (int i = 0; i < N; ++i)
		if (vec[i].y2 < y && vec[i].x1 < x && x < vec[i].x2) return 1;
	return 0;
}
bool left (double x, double y) {
	for (int i = 0; i < N; ++i)
		if (vec[i].x2 < x && vec[i].y1 < y && y < vec[i].y2) return 1;
	return 0;
}

bool right (double x, double y) {
	for (int i = 0; i < N; ++i)
		if (vec[i].x1 > x && vec[i].y1 < y && y < vec[i].y2) return 1;
	return 0;
}


class OneMorePoint {
	public:
	string interiorPoint (vector <string> vecc) {
		int i, j;
		N = vecc.size ();
		for (i = 0; i < N; ++i) {
/*
			for (j = 0; vecc[i][j] != ' '; ++j) {
				vec[i].x1 *= 10;
				vec[i].x1 += vecc[i][j] - '0';
			}

			for (++j; vecc[i][j] != ' '; ++j) {
				vec[i].y1 *= 10;
				vec[i].y1 += vecc[i][j] - '0';
			}

			for (++j; vecc[i][j] != ' '; ++j) {
				vec[i].x2 *= 10;
				vec[i].x2 += vecc[i][j] - '0';
			}

			for (++j; j < vecc[i].size (); ++j) {
				vec[i].y2 *= 10;
				vec[i].y2 += vecc[i][j] - '0';
			}
*/
			sscanf (vecc[i].c_str (), "%d %d %d %d", &vec[i].x1, &vec[i].y1, &vec[i].x2, &vec[i].y2);
			X[Xp++] = vec[i].x1; X[Xp++] = vec[i].x2;
			Y[Yp++] = vec[i].y1; Y[Yp++] = vec[i].y2;
		}
		sort (X, X + Xp);
		sort (Y, Y + Yp);
		Xp = unique (X, X + Xp) - X;
		Yp = unique (Y, Y + Yp) - Y;
		
		double x, y;
		string syes = "YES";
		string sno = "NO";
		for (i = 0; i < Xp - 1; ++i)
			for (j = 0; j < Yp - 1; ++j) {
				x = (X[i] + X[i+1]) / 2.;
				y = (Y[j] + Y[j+1]) / 2.;
//				printf ("%lf %lf\n", x, y);
				if (notin (x, y) && up (x, y) && down (x, y) && left (x, y) && right (x, y))
					return syes;
			}
		return sno;
	}
};