#include <vector>
#include <string>

using namespace std;
/*
int difx[] = {-1, -1, 1, 1};
int dify[] = {-1, 1, 1, -1};

int nxt[4][2] = { {+3, +1},
		  {+1, -1},
		  {-1, +1},
		  {-3, -1}
		};
*/
bool holesm[1 << 21];//2 000 000
bool holess[1 << 21];//2 000 000

int tom (int a, int b) {
	return a + b;
}

int rows, columns;

int tos (int a, int b) {
	return rows - 1 - a + b;
}

int hol[1 << 6][2];

class BallBouncing {
	public:
	int bounces(int rr, int cc, int startrow, int startcol, vector <string> holes) {
		rows = rr;
		columns = cc;
		int a, b, i;
		for (i = 0; i < holes.size (); ++i) {
			sscanf (holes[i].c_str (), "%d %d", &a, &b);
			hol[i][0] = a;
			hol[i][1] = b;
			holesm[tom (a, b)] = 1;
			holess[tos (a, b)] = 1;
		}
		
		int ccase;
		int r = startrow, c = startcol;
		int hits = 0;
		
		while (r < rows && c < columns) {
			for (i = 0; i < holes.size (); ++i)
				if ((hol[i][0] == r && hol[i][1] == c)) break;
			if (i != holes.size ())
				goto end;
			++r; ++c;
		}
		++hits;
		--r; --c;
		if (r == rows - 1 && c == columns - 1)
			ccase = 3;
		else if (r == rows - 1)
			ccase = 1, ++c;
		else
			ccase = 2, ++r;
		
		for (i = 0; i < (rows + columns) * 2 + 2; ++i) {
//			printf ("%d %d\n", r, c);
			switch (ccase) {
				case 0: case 3:
					if (holess[tos(r, c)]) goto end;
					if (r < c) {
						ccase = 5;
						c -= r + 1;
						r = 0;
						++hits;
					} else if (r > c) {
						ccase = 6;
						r -= c + 1;
						c = 0;
						++hits;
					} else {
						ccase = 4;
						c = r = 0;
						++hits;
					} break;

				case 1: case 6:
					if (holesm[tom (r, c)]) goto end;
					if (r < columns - 1 - c) {
						ccase = 4;
						c += r + 1;
						r = 0;
						++hits;
					} else if (r > columns - 1 - c) {
						ccase = 3;
						r -= columns - 1 - c + 1;
						c = columns - 1;
						++hits;
					} else {
						ccase = 2;
						c = columns - 1;
						r = 0;
						++hits;
					} break;	
	
				case 2: case 5:
					if (holesm[tom(r, c)]) goto end;
					if (rows - 1 - r < c) {
						ccase = 0;
						c -= rows - 1 - r + 1;
						r = rows - 1;
						++hits;
					} else if (rows - 1 - r > c) {
						ccase = 7;
						r += c + 1;
						c = 0;
						++hits;
					} else {
						ccase = 1;
						c = 0;
						r = rows - 1;
						++hits;
					} break;
	
				case 4: case 7:
					if (holess[tos(r, c)]) goto end;
					if (rows - 1 - r < columns - 1 - c) {
						ccase = 1;
						c += rows - 1 - r + 1;
						r = rows - 1;
						++hits;	
					} else if (rows - 1 - r > columns - 1 - c) {
						ccase = 2;
						r += columns - 1 - c + 1;
						c = columns - 1;
						++hits;
					} else {
						ccase = 3;
						c = columns - 1;
						r = rows - 1;
						++hits;
					} break;	
			}
		}
		if (i == ((rows + columns) * 2 + 2)) return -1;
	
		end: return hits;
	}
};