#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

bool kused[36][36];
vector <int> ret;
vector <string> g;
vector <string> w;

int nxt[32][64];

void doprekmp () {
	int i, j, k;
	for (i = 0; i < w.size (); ++i) {
		nxt[i][0] = nxt[i][1] = 0;
		for (j = 2; j < w[i].size (); ++j) {
			k = nxt[i][j-1];
			while (k) {
				if (w[i][k] == w[i][j-1])
					break;
				k = nxt[i][k];
			}
			if (k)
				nxt[i][j] = k+1;
			else
				if (w[i][0] == w[i][j-1])
					nxt[i][j] = 1;
				else
					nxt[i][j] = 0;
		}
	}
/*
	for (i = 0; i < w.size (); ++i) {
		for (j = 0; j < w[i].size (); ++j)
			printf ("%d ", nxt[i][j]);
		printf ("\n");
	}
*/
}

bool kmp (int ww, string &s) {
//	printf ("%d %s\n", ww, s.c_str ());
	int k, i;
	k = 0;
	for (i = 0; i < s.size (); ++i) {
		while (k && w[ww][k] != s[i])
			k = nxt[ww][k];

		if (k || w[ww][0] == s[i])
			++k;
//		printf ("%d -> %d\n", i, k);
		if (k == w[ww].size ()) return 1;
	}

	return 0;
}

void doit (int a, int b) {
	static int cntr =0;
	static int used[36][36] = {{0}};
	++cntr;

//	printf ("haha!\n");

	string crnt;

	int i, j, p;
	for (i = 0, j = 0; used[i][j] != cntr; used[i][j] = cntr, i += a, i %= g.size (), j += b, j %= g[0].size ()) {
		crnt.push_back (g[i][j]);
	}
//	printf ("-%s-\n", crnt.c_str ());

	for (p = 0; p < 51; i += a, i %= g.size (), j += b, j %= g[0].size (), ++p)
		crnt.push_back (g[i][j]);
//	printf ("%s\n", crnt.c_str ());

	for (i = 0; i < w.size (); ++i)
		if (kmp (i, crnt))
			++ret[i];
}

class InfiniteSoup {
	public:
	vector <int> countRays(vector <string> _g, vector <string> words, int k) {
		g = _g;
		w = words;
		for (int i = 0; i < words.size (); ++i) ret.push_back (0);
		int i, j, p, p2;
		doprekmp ();
		for (i = 0; i <= k; ++i)
			for (j = 0; j <= k; ++j) {
				if (kused[i][j] || !(i + j)) continue;
				for (p = 1; i * p <= k && j * p <= k; ++p)
					kused[i * p][j * p] = 1;
				for (p = 0; p * g.size () + i <= k; ++p)
					for (p2 = 0; p2 * g[0].size () + j <= k; ++p2)
						kused[p * g.size () + i][p2 * g[0].size () + j] = 1;
				printf ("%d %d\n", i, j);
				doit (i, j);
			}

		return ret;
	}
};
