#include <cstdio>
#include <string>
#include <vector>

using namespace std;

struct el {
	int to;
	int *c;
	int next;
	el () {}
	el (int _to, int *_c, int _next) : to (_to), c (_c), next (_next) {}
};

vector <vector <int> > vec;

int mymod (int a) {
	a %= 12;
	if (a < 0) return a + 12; else return a;
}

bool good[] = {1, 0, 1, 0, 1, 1, 0, 1, 0, 1, 0, 1};

int go[19][12];

char opt[12][1 << 19];

char F (int a, int set) {
//	printf ("%d %x\n", a, set);
	if (opt[a][set] != -1) return opt[a][set];

	int tmp;
	for (int i = 0; i < vec.size (); ++i)
		if (set & (1 << i) && go[i][a] != -1) {
//			printf ("!");
			if ((tmp = F (go[i][a], set ^ (1 << i))) > opt[a][set])
				opt[a][set] = tmp;
		}

//	printf ("%d %x -> %d\n", a, set, opt[a][set] + 1);
	return (opt[a][set] += 1);
}

class CMajor {
	public:
	int getLongest (vector <string> inp) {
		vec.resize (inp.size ());
		int i, j, k, cnum, csign;
		for (i = 0; i < inp.size (); ++i) {
			cnum = 0;
			csign = 1;
			for (j = 0; j < inp[i].size (); ++j) {
				if (inp[i][j] == ' ') {
					vec[i].push_back (csign ? cnum : -cnum);
					cnum = 0;
					csign = 1;
				} else if (inp[i][j] == '-') {
					csign = 0;
				} else {
					cnum *= 10;
					cnum += inp[i][j] - '0';
				}
			}
			vec[i].push_back (csign ? cnum : -cnum);
		}

		for (i = 0; i < vec.size (); ++i)
			for (j = 0; j < vec[i].size (); ++j)
				vec[i][j] = mymod (vec[i][j]);
/*
		for (i = 0; i < vec.size (); ++i) {
			for (j = 0; j < vec[i].size (); ++j)
				printf ("%d ", vec[i][j]);
			printf ("\n");
		}
*/
		int ccp =0;
		for (i = 0; i < vec.size (); ++i)
			for (j = 0; j < 12; ++j)
				go[i][j] = -1;

		for (i = 0; i < vec.size (); ++i) {
			++ccp;

			for (k = 0; k < 12; ++k) {
				if (!good[k]) continue;
				int crnt = k;
				for (j = 0; j < vec[i].size () && good[crnt = (crnt + vec[i][j]) % 12]; ++j);
				if (j == vec[i].size ()) {
					go[i][k] = crnt;
//					printf ("%d %x -> %d\n", i, k, go[i][k]);
				}
			}
		}
		for (i = 0; i < 12; ++i) {
			if (!good[i]) continue;
			for (j = 0; j < 1 << vec.size (); ++j)
				opt[i][j] = -1;
		}

		int tmp, best =0;
		for (i = 0; i < 12; ++i)
			if (good[i])
				if (best < (tmp = F (i, (1 << vec.size ()) - 1)))
					best = tmp;
		return best;
	}
};