#include <cstdio>
#include <vector>
#include <string>

using namespace std;

const int MAXN = 1 << 6;

int N;

int vec[MAXN][MAXN];
int vecsz[MAXN];

bool used[MAXN][MAXN];
int used_cnt[MAXN];

bool gr[MAXN][MAXN];
int grc[MAXN];
int gr_cnt;
bool gr_can_sz[MAXN][MAXN];
int gr_sz[MAXN][MAXN];
int gr_sz_cnt[MAXN];
//bool ua[MAXN];

void take (int a, int b) {
	if (used[b][a]) return;
	used[b][a] = 1;
	++used_cnt[b];

	for (int i = 0; i < vecsz[a]; ++i)
		take (vec[a][i], b);
}

bool cmp (int a, int b) {
	return used_cnt[a] < used_cnt[b];
}

class GalaxyExpedition {
	public:
	vector <int> possibleValues (vector <string> data) {
		int i, j;
		N = data.size ();
		for (i = 0; i < N; ++i) {
			for (j = 0; j < data[i].size (); ++j)
				if (data[i][j] != ' ') {
					vec[i][vecsz[i]] *= 10;
					vec[i][vecsz[i]] += data[i][j] - '0';
				} else
					++vecsz[i];
			if (data[i].size ()) ++vecsz[i];
		}
		for (i = 0; i < N; ++i) {
			for (j = 0; j < vecsz[i]; ++j)
				printf ("%d ", vec[i][j]);
			printf ("\n");
		}

		for (i = 0; i < N; ++i)
			take (i, i);
		for (i = 0; i < N; ++i) {
			for (j = 0; j < N; ++j)
				printf ("%d ", used[i][j]);
			printf ("\n");
		}

		printf ("*********\n");

		int idx[MAXN];
		for (i = 0; i < N; ++i) idx[i] = i;
		std::sort (idx, idx + N, cmp);

		int k;
		for (i = N-1; i >= 0; --i) {
			printf ("now gr %d (%d)\n", i, idx[i]);

			for (j = 0, k = N; j < gr_cnt; ++j)
				for (k = 0; k < N; ++k)
					if (gr[j][k] && used[idx[i]][k])
						goto xxxx;
			xxxx:;
			printf ("breaked %d %d\n", j, k);
			if (k != N) {
				for (k = 0; k < N; ++k)
					gr[j][k] = (used[idx[i]][k] || gr[j][k]);
				gr_can_sz[j][used_cnt[idx[i]]] = 1;
				printf ("said gr_can_sz  %d %d\n", j, used_cnt[idx[i]]);
			} else {
				printf ("new group!\n");
				j = gr_cnt++;
				for (k = 0; k < N; ++k)
					gr[j][k] = (used[idx[i]][k]);
				gr_can_sz[j][used_cnt[idx[i]]] = 1;
				printf ("said gr_can_sz  %d %d\n", j, used_cnt[idx[i]]);
			}
		}

		for (i = 0; i < gr_cnt; ++i)
			for (j = 0; j <= N; ++j)
				if (gr_can_sz[i][j])
					gr_sz[i][gr_sz_cnt[i]++] = j;

		for (i = 0; i < gr_cnt; ++i) {
			for (j = 0; j < N; ++j)
				printf ("%d ", gr[i][j]);
			printf ("\n");
		}

		for (i = 0; i < gr_cnt; ++i) {
			for (j = 0; j < gr_sz_cnt[i]; ++j)
				printf ("%d ", gr_sz[i][j]);
			printf ("\n");
		}

		bool abs_can[MAXN] = {1};
		for (i = 0; i < gr_cnt; ++i)
			for (j = N; j >= 0; --j)
				for (k = 0; k < gr_sz_cnt[i]; ++k)
					if (abs_can[j])
						abs_can[j + gr_sz[i][k]] = 1;
 		for (i = 1; i <= N; ++i)
 			if (abs_can[i])
 				printf ("%d ", i);
 		printf ("\n");

		vector <int> ret;
		return ret;
	}

};