#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

const int MAXA = 26;
const int _infinity = 1 << 14;
const int MAXLEN = 1 << 14;
int N;
int L[MAXA];

class StickedWords {
	void clear () {
		for (int i = 0; i < MAXA; ++i) {
			D[i] = 1;
			used[i] = 0;
		}
	}

	public:
	int D[MAXA];
	bool used[MAXA];
	string constructLine (vector <string> words, int len) {
		N = words.size ();

		int i, j, k;
		int wl, wb, we;
		for (i = 0; i < MAXA; ++i) {
			clear ();
			used[i] = 1;
			for (j = 0; j <= MAXA; ++j)
				for (k = 0; k < N; ++k) {
					wl = words[k].size () - 1;
					wb = words[k][0] - 'a';
					if (!used[wb]) continue;
					we = words[k][wl] - 'a';
					if (D[we] < D[wb] + wl) {
						D[we] = D[wb] + wl;
						if (j == MAXA) L[i] = _infinity;
						used[we] = 1;
					}
				}
			nexti:;
			if (L[i] != _infinity) {
				L[i] = 1;
				for (j = 0; j < MAXA; ++j)
					L[i] = max (L[i], D[j]);
			}
		}
//		for (i = 0; i < MAXA; ++i) printf ("%c %d\n", i + 'a', L[i]);

		bool can[MAXLEN];
		char A[MAXLEN] = {0};

		std::sort (words.begin (), words.end ());

		for (i = 0; i < N; ++i) {
			wl = words[i].size ();
			wb = words[i][0] - 'a';
			we = words[i][wl - 1] - 'a';
			if (wl + L[we] - 1 >= len) {
				for (j = 0; j < wl && words[i][j] == A[j]; ++j);
				if (j == wl)
					can[j-1] = 1;
				else
					if (!A[j] || A[j] > words[i][j]) {
						for (; j < wl; ++j) {A[j] = words[i][j]; can[j] = 0;}
						can[wl - 1] = 1;
						for (; A[j]; ++j) {A[j] = 0; can[j] = 0;}
					}

			}
		}
		for (i = 1; i < len - 1; ++i) {
			if (!can[i]) continue;
			for (j = 0; j < N; ++j) {
				wl = words[j].size ();
				wb = words[j][0];
				we = words[j][wl - 1] - 'a';
				if (A[i] != wb) continue;
				if (i + wl + L[we] - 1 < len) continue;


				for (k = i; k - i < wl && A[k] == words[j][k-i]; ++k);
				if (k - i == wl) {
					can[k-1] = 1;
					continue;
				}
				if (A[k] && A[k] < words[j][k-i])
					continue;
				for (; k - i < wl; A[k] = words[j][k-i], can[k] = 0, ++k);
				can[k-1] = 1;
				for (; A[k]; ++k) {
					A[k] = 0;
					can[k] = 0;
				}
			}
		}
		for (; !can[i]; ++i);
		A[i + 1] = 0;
//		printf ("**%s**\n", A);

		return string (A);
	}
};