#include <sstream>
#include <fstream>
#include <iostream>
#include <string.h>
#include <algorithm>
#include <stdlib.h>
#include <stdio.h>
#include <numeric>
#include <math.h>
#include <string>
#include <vector>
#include <set>
#include <map>
using namespace std;

size_t dp[1024];

#define B(a) ((a)?(1<<(a)):0)

class mex {
	vector <bool> db;
	public:
	mex () : db () {}
	mex &clear () {
		db.clear ();
		return *this;
	}
	mex &set (size_t idx) {
		if (idx >= db.size ())
			db.resize (idx + 2);
		db[idx] = 1;
		return *this;
	}
	size_t get () const {
		return find (db.begin (), db.end (), bool(0)) - db.begin ();
	}
};


class LittleSquares {
	public:
	string winner(vector <string> M) {
		dp[1] = 1;
		int i, j;
		mex ccode;
		for (i = 2; i < 1024; ++i) {
	//		printf ("i == %x -- ", i);
			ccode.clear ();
			for (j = 0; j < 10; ++j) {
				if (!(i >> j & 1)) continue;

				if (j == 0) {
					//get one small square
					ccode.set (dp[i^1]);
					continue;
				}

				int ii = i ^ B(j);
				if (j == 1) {
					//put a big sqare -> remove only 1
					//put a small square in the big one -> remove 1 and change bit 0
					ccode.set (dp[ii]).set (dp[ii^1]);
					continue;
				}

				//j-1 X
				//put a small square in one end -> change final bit and remain j-1
				ccode.set (dp[ii^B(j-1)^1]);

				//v j-2-v X
				int v, vv;
				for (v = 0; v < j; ++v) {
					vv = j - 2 - v;
					if (vv < 0 || vv < v) break;
					ccode.set (dp[ii^B(v)^B(vv)^1]);
				}

				//k-2
				ccode.set (dp[ii^B(j-2)]);

				//v k-3-v
				for (v = 0; v < j; ++v) {
					vv = j - 3 - v;
					if (vv < 0 || vv < v) break;
					ccode.set (dp[ii^B(v)^B(vv)]);
				}
			}
			dp[i] = ccode.get ();
		}

		for (i = 0; i < 1024; ++i)
			printf ("%x - %zu\n", i, dp[i]);


		int cpos = 0;
		for (i = 0; i + 2 <= (int)M.size (); i += 2) {
			int start = 0;
			for (;;) {
				for (j = start; j + 2 <= (int)M[i].size (); ++j)
					if (M[i][j] != '.' || M[i+1][j] != '.' || M[i][j+1] != '.' || M[i+1][j+1] != '.')
						break;
				if (j != start) {
					printf ("row %d - len %d\n", i, j - start);
					cpos ^= B(j - start);
				}
				start = j + 1;
				if (start + 1 >= (int)M[i].size ()) break;
			}
			cpos ^= count (M[i].begin (), M[i].end (), '.') & 1;
			if (i + 1 < (int)M.size ())
				cpos ^= count (M[i+1].begin (), M[i+1].end (), '.') & 1;
		}

 		printf ("%x\n", cpos);
		return dp[cpos] ? "first" : "second";
	}
};

int main () {
//	ifstream in ("inp");

	vector <string> brd;
	int i, j;
	while (cin.peek () != EOF) {
		string line;
		getline (cin, line);
		brd.push_back (line);
//		for (i = 0; !isspace (line[i]); ++i)
//			brd.back ().push_back (in[i]);
	}

	for (i = 0; i < (int)brd.size (); ++i) {
		for (j = 0; j < (int)brd[i].size (); ++j)
			printf ("%c", brd[i][j]);
		puts ("");
	}

	LittleSquares x;
	printf ("%s\n", x.winner (brd).c_str ());

	return 0;
}
