#include <vector>
#include <string>
#include <utility>

using namespace std;

int memo[101][101][101];

int dfs (int a, int b, int c) {
	if (memo[a][b][c] != 1000000)
		return memo[a][b][c];

	int i;
	if (a == 0 && b == 0) {
		if (c == 0)
			return memo[a][b][c] = 0;

		if (c == 1)
			return memo[a][b][c] = 1;
		else
			return memo[a][b][c] = -2;
	}
	int lose = 1000000000, win = 1000000000;
	//last row
//	int i;
	for (i = a - 1; i >= 0; --i) {
		if (dfs (i, b, c) > 0) {
			printf ("-- %d %d %d   %d (%d %d %d)\n", i, b, c, dfs (i, b, c), a, b, c);
			lose <?= dfs (i, b, c);
		} else
			win <?= dfs (i, b, c);
	}

	//last 2
	for (i = b - 1; i >= 0; --i) {
		if (dfs (i <? a, i, c) > 0) {
			printf ("-- %d %d %d   %d (%d %d %d)\n", i <? a, i, c, dfs (i <? a, i, c), a, b, c);
			lose <?= dfs (i <? a, i, c);
		} else
			win <?= dfs (i <? a, i, c);
	}

	//all

	for (i = c-1; i >= 0; --i) {
		if (dfs (i <? a, i <? b, i) > 0) {
			printf ("-- %d %d %d   %d (%d %d %d)\n", i <? a, i <? b, i, dfs (i <? a, i <? b, i), a, b, c);
			lose <?= dfs (i <? a, i <? b, i);
		} else
			win <?= dfs (i <? a, i <? b, i);
	}
	if (lose != 1000000000) {
		printf ("%d %d %d  %d\n", a, b, c, -(lose + 1));
		return memo[a][b][c] = -(lose + 1);
	} else {
		printf ("%d %d %d  %d\n", a, b, c, (-win + 1));
		return memo[a][b][c] = (-win + 1);
	}
}

class Chomp {
	public:
	int moves(int N) {
		int i, j, k;
		for (i = 0; i < 101; ++i)
			for (j = 0; j < 101; ++j)
				for (k = 0; k < 101; ++k)
					memo[i][j][k] = 1000000;
		return -dfs (N, N, N);
	}
};

int main () {
	Chomp x;

	printf ("%d\n", x.moves (3));

	return 0;
}
