/*
FROM: USACO 2001 FALL GREEN
PROB: plumb
KEYW: dynamical programming
*/

#include <cstdio>
#include <cstring>
#include <limits>

const int MAXD = 1 << 17;
const int MAXN = 1 << 9;
const int _infinity = std::numeric_limits <int>::max ();

struct p {
	int l;
	int c;
};

int D;
int N;
p vec[MAXN];

int opt[MAXD];

int main () {
//	FILE *in = fopen ("plumb.in", "r");
	FILE *in = stdin;
	fscanf (in, "%d %d", &D, &N);

	int i, j;
	for (i = 0; i < N; ++i)
		fscanf (in, "%d %d", &vec[i].l, &vec[i].c);
	fclose (in);

	memset (opt, 0, sizeof (int) * (D + 1));

	opt[0] = _infinity;

	int _min;
	for (i = 0; i < N; ++i)
		for (j = D - vec[i].l; j >= 0; --j)
			if (opt[j] && opt[j + vec[i].l] < (_min = (opt[j] < vec[i].c ? opt[j] : vec[i].c)))
					opt[j + vec[i].l] = _min;

//	FILE *out = fopen ("plumb.out", "w");
	FILE *out = stdout;
	fprintf (out, "%d\n", opt[D]);
	fclose (out);

	return 0;
}
