#include <cstdio>
#include <algorithm>

const int MAXC = 400;

int C;
int vec[MAXC];
int gc;

int brd[MAXC][2];

void input () {
	int tmp[MAXC];

	scanf ("%d", &C);

	int i, j;
	for (i = 0; i < C; ++i) {
		scanf ("%d", vec + i);
		tmp[i] = vec[i];
	}

	std::sort (tmp, tmp + C);
	gc = std::unique (tmp, tmp + C) - tmp;

	for (i = 0; i < C; ++i) {
		for (j = 0; tmp[j] != vec[i]; ++j);
		vec[i] = j;
	}
/*
	for (i = 0; i < C; ++i)
		printf ("%d ", vec[i]);
	printf ("\n");
*/
	for (i = 0; i < C; ++i)
		tmp[i] = vec[i];

	std::sort (tmp, tmp + C);

	brd[0][0] = 0;
	for (i = 1; i < C; ++i)
		if (tmp[i] != tmp[i-1])
			brd[tmp[i-1]][1] = brd[tmp[i]][0] = i;
	brd[gc-1][1] = C;
/*
	for (i = 0; i < gc; ++i)
		printf ("%d %d\n", brd[i][0], brd[i][1]);

*/
}

int ig;
int w[MAXC];

int best = (1 << 31) - 1;//will make 2 overflows :)

int mymod (int a, int b) {
	if (a > b)
		return a - b;
	else
		return a;
}

int main () {
	input ();

	int lb, ub, ii;
	int i, j;
	int sum;
	for (i = 0; i < C; ++i) {
//		printf ("diff = %d\n", i);
	//set initial state
		sum = 0;
		for (j = 0; j < gc; ++j) w[j] = 0;
	//searching for a group that is broken apart :)
		for (j = 0; j < gc; ++j)
			if (brd[j][0] + i < C && brd[j][1] + i > C)
				break;
		if (j == gc)
			ig = -1;
		else {
			ig = j;
			//fill w for the broken group
			for (j = 0; j < brd[ig][1] + i - C; ++j)
				if (vec[j] != ig) {
					++w[ig];
					sum += brd[ig][1] + i - C - j;
				}
			for (j = brd[ig][0] + i; j < C; ++j)
				if (vec[j] != ig)
					sum += j - (brd[ig][0] + i);
		}
	//end of business with broken group

//		printf ("ig = %d, sum = %d, w[ig] = %d\n", ig, sum, (ig == -1 ? -1 : w[ig]));

	//real work part 1
		for (ii = 0; ii < C; ++ii) {
//			printf ("now in place %d with bounds %d %d\n", ii, (brd[vec[ii]][0] + i) % C, mymod (brd[vec[ii]][1] + i, C));
			if (vec[ii] == ig) {
//				printf ("spec!\n");
				if (!(ii < brd[ig][0] + i && ii >= brd[ig][1] + i - C)) continue;//it is in the right place already
				sum += 20;//time for io cow movements :)
				if (w[ig]) {
					--w[ig];
					sum += ii - (brd[ig][1] + i - C);
//					printf ("move place %d with %d (to ub, ig)\n", ii, ii - (brd[ig][1] + i - C));
				} else {
					sum += (brd[ig][0] + i) - ii;
//					printf ("move place %d with %d (to lb, ig)\n", ii, (brd[ig][0] + i) - ii);
				}
			} else {//the element is normal
//				printf ("not spec!\n");
				if (!(ii < (brd[vec[ii]][0] + i) % C || ii >= mymod (brd[vec[ii]][1] + i, C))) continue;//it is in the right place already
				sum += 20;
				if (ii < (brd[vec[ii]][0] + i) % C) {
					++w[vec[ii]];
					sum += (brd[vec[ii]][0] + i) % C - ii;
//					printf ("move place %d with %d (to lb)\n", ii, (brd[vec[ii]][0] + i) % C - ii);
				} else {
					sum += ii - mymod (brd[vec[ii]][1] + i, C);
//					printf ("move place %d with %d (to ub)\n", ii, ii - mymod (brd[vec[ii]][1] + i, C));
				}
			}
		}
	//real work part 2
		for (j = 0; j < gc; ++j) {
			if (j == ig) continue;
			lb = (brd[j][0] + i) % C;
			ub = (brd[j][1] + i) % C;
			for (ii = lb; ii < ub; ++ii) {
				if (vec[ii] != j)
					if (w[j]) {
						--w[j];
						sum += ii - lb;
					} else {
						sum += ub - ii;
					}
			}
		}
	//now try to update best
//		printf ("%d -> %d\n", i, sum);

		best = std::min (sum, best);
	}

	printf ("%d\n", best);

	return 0;
}
