/*
FROM: USACO OPEN 2001 FGREEN
PROB: well
KEYW: dynamical programming
*/

#include <cstdio>
#include <algorithm>

const int MAXG = 1 << 7;//100
const int MAXH = 1 << 5;//30

struct garbage {
	int time;
	int H;
	int E;
	garbage () {}
	garbage (int _time, int _H, int _E) : time (_time), H (_H), E (_E) {}
};

int G, D;

garbage vec[MAXG];
int opt[MAXG][MAXH * MAXG + 10 + 1];

int max (int a, int b) {
	return a > b ? a : b;
}

bool cmp (garbage a, garbage b) {
	return a.time < b.time;
}

int main () {
//	FILE *in = fopen ("well.in", "r");
	FILE *in = stdin;
	fscanf (in, "%d %d", &D, &G);

	int i;
	int maxH = 0;
	for (i = 0; i < G; ++i) {
		fscanf (in, "%d %d %d", &vec[i].time, &vec[i].E, &vec[i].H);
		if (maxH < vec[i].H)
			maxH = vec[i].H;
	}
	vec[G].time = 30 * 1000 + 100;//more than she can survive (muhahaha :) )

	std::sort (vec, vec + G + 1, cmp);

	int j;
	for (i = 0; i < G; ++i)
		for (j = 0; j <= maxH * i; ++j)
			opt[i][j] = -1;

	int survive = 10, survive2 = 10;

	if (vec[0].time > 10)
		goto ext;
	opt[0][0] = 10 - vec[0].time;

	int ntime;
	for (i = 0; i < G; ++i) {
		ntime = vec[i+1].time - vec[i].time;
		for (j = 0; j <= maxH * i; ++j) {
			if (opt[i][j] == -1) continue;

//			printf ("\ttryed %d (crnt %d)\n",vec[i].time + opt[i][j] + vec[i].E, survive);
			if (survive < vec[i].time + opt[i][j] + vec[i].E)
				survive = vec[i].time + opt[i][j] + vec[i].E;

			if (j + vec[i].H >= D) goto ext;

			if (ntime <= opt[i][j])
				if (opt[i + 1][j + vec[i].H] < opt[i][j] - ntime)
					opt[i + 1][j + vec[i].H] = opt[i][j] - ntime;
//					printf ("upgraded %d %d from %d %d with %d(put)\n", i + 1, j + vec[i].H, i, j, opt[i][j] - ntime);

			if (ntime <= opt[i][j] + vec[i].E)
				if (opt[i + 1][j] < opt[i][j] + vec[i].E - ntime)
					opt[i + 1][j] = opt[i][j] + vec[i].E - ntime;
//					printf ("upgraded %d %d from %d %d with %d (eat)\n", i + 1, j, i, j, opt[i][j] + vec[i].E - ntime);
		}
		if (survive2 >= vec[i].time)
			survive2 += vec[i].E;
		else {
			printf ("now dead - %d %d\n", survive, survive2);
			i = G;
			break;
		}
		if (survive != survive2)
			printf ("%d %d\n", survive, survive2);
	}
/*
	if (i == G) {
		survive2 = 10;
		for (j = 0; j < G && vec[j].time <= survive; ++j)
			survive2 += vec[j].E;
	}
*/
	ext:;
//	FILE *out = fopen ("well.out", "w");
	FILE *out = stdout;
	fprintf (out, "%d\n", (i != G ? vec[i].time : survive));
//	fclose (out);

	printf ("%c\n", i == G ? 'S' : 'E');

	return 0;
}
