/*
FROM: USACO 2002 FEBRUARY GREEN
PROB: power
KEYW: recursion, full exhaustion with optimizations
*/

#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>

int targ;
int blen;
int d;

long beg;
long end;

int lb;

void outtime () {
	end = clock ();
	FILE *time = fopen ("time.log", "w");
	fprintf (time, "%lf ", (end - beg) / (double)CLOCKS_PER_SEC);
	fprintf (time, "%d\n", blen - lb);
	fclose (time);
}

void f (int a, int b) {
//	printf ("%d %d %lf, %d\r", a, b, (log2 (targ / (a > b ? a : b))) + d, blen);
	++d;
	if (a == targ) {blen = d--; printf ("%d\n", blen); outtime (); exit (0);}
	if (d >= blen) {--d; return;}
	//a + a
	f (a + a, b);
	f (a + a, a);//no sub 2, 1
	//a + b
	f (a + b, a);//no sub 2, 1
	f (a + b, b);//no sub 2, 1
	//abs (a - b)
	if (a != b && 2 * a != b && d + 1 < blen) {//make 2 steps -> 2 * a, b -> 2 * a - b, 2 * a & 2 * a - b, b
		++d;
		f (abs (2 * a - b), 2 * a);
		f (abs (2 * a - b), b);
		--d;
	}
	--d;
}

int main () {
	scanf ("%d", &targ);
	beg = clock ();
	lb = (int)(floor (log2 (targ)));
	if (1 << lb != targ) blen = ++lb; else {printf ("!!%d\n", lb); outtime (); return 0;}
	for (;; ++blen) {
		f (2, 1);
	}

	return 0;
}
