/*
FROM: USACO 2002 JANUARY GREEN
PROB: stroll
KEYW: dfs
*/

#include <cstdio>

extern unsigned _stklen = 1 << 20;

const int MAXN = 1 << 15;

int N;
int nxt[MAXN];
bool used[MAXN];
int D[MAXN];

int max;

void dfs (int v) {
	static int n = 0;

//	printf ("dfs %d -> %d\n", v, n);
	D[v] = n++;
	if (D[nxt[v]] == -1)
		dfs (nxt[v]);
	else {
		if (!used[nxt[v]] && max < D[v] - D[nxt[v]])
			max = D[v] - D[nxt[v]];
	}
	used[v] = 1;
}

int main () {
//	FILE *in = fopen ("stroll.in", "r");
	FILE *in = stdin;
	fscanf (in, "%d", &N);

	int i;
	for (i = 0; i < N; ++i) {
		fscanf (in, "%d", nxt + i);
		--nxt[i];
	}

	for (i = 0; i < N; ++i) D[i] = -1;
	for (i = 0; i < N; ++i)
		if (!used[i])
			dfs (i);

//	FILE *out = fopen ("stroll.out", "w");
	FILE *out = stdout;
	fprintf (out, "%d\n", max + 1);
	fclose (out);

	return 0;
}
