/*
FROM: USACO 2003 FEBRUARY GREEN
PROB: impster
KEYW: bfs
*/

#include <cstdio>

#define short int

const int MAXALL = 1 << 16;

int B, N;
unsigned short goal;
unsigned short queue[MAXALL];
int used[MAXALL];

void getbin (unsigned short &a) {
	char tmp;
	a = 0;
	for (int i = B - 1; i >= 0; --i) {
		tmp = getc (stdin);
		if (tmp == '1')
			a |= (1 << i);
	}
	getc (stdin);
}

void prntbin (unsigned short a) {
	for (int i = B - 1; i >= 0; --i)
		printf ("%c", !!(a & (1 << i)) + '0');
}

int make_diff (unsigned short a, unsigned short b) {
	unsigned short c = a ^ b;
	int res =0;
//	printf ("(%d %d)%d -- ", a, b, c);
	while (c) {
		++res;
		c &= c - 1;
//		printf ("c == %d\n", c);
	}
//	printf ("%d\n", res);
	return res;
}

int main () {
	scanf ("%d %d\n", &B, &N);

	getbin (goal);

	int i, j;
	for (i = 0; i < N; ++i)
		getbin (queue[i]);

	for (i = 0; i < MAXALL; ++i) used[i] = -1;
/*
	for (i = 0; i < N; ++i)
		used[queue[i]] = 0;
*/
	int p1 = 0, p2 = N, p3 = N, lvl = 1;

	unsigned short tmp;
/*
	for (i = p1; i < p2; ++i)
		for (j = p1; j < p2; ++j) {

			if (used[tmp = queue[i] ^ queue[j]] == -1) {
				used[tmp] = lvl;
				queue[p3++] = tmp;
				printf ("%d -> %d\n", lvl, (int)tmp);
			}
		}

	p1 = p2;
	p2 = p3;
	++lvl;//now is 2
*/
	while (p1 != p2) {
		for (i = 0; i < p2; ++i)
			for (j = p1; j < p2; ++j) {
				if (used[tmp = queue[i] ^ queue[j]] == -1) {
//					printf ("%d -> %d\n", lvl, (int)tmp);
					used[tmp] = lvl;
					queue[p3++] = tmp;
				}
			}
		p1 = p2;
		p2 = p3;
		++lvl;
//		printf ("************\n");
	}

	unsigned short best = queue[0];
	int tmp_diff;
	int diff = make_diff (best, goal);
	for (i = 1; i < p2; ++i)
		if (diff > (tmp_diff = make_diff (queue[i], goal)) || diff == tmp_diff && queue[i] < best) {
			diff = tmp_diff;
			best = queue[i];
		}

	printf ("%d\n", used[best]);
	prntbin (best);
	printf ("\n");

	return 0;
}
