/*
FROM: USACO 2003 MARCH GREEN
PROB: cornfld
KEYW: precompute
*/

#include <cstdio>
#include <algorithm>

using std::min;
using std::max;

const int MAXN = 1 << 8;

typedef unsigned char uchar;

int N, B, K;
int ma3x[MAXN][MAXN];
uchar opt[MAXN][MAXN][MAXN][2];

uchar min4 (uchar a, uchar b, uchar c, uchar d) {
	return min (min (a, b), min (c, d));
}

uchar max4 (uchar a, uchar b, uchar c, uchar d) {
	return max (max (a, b), max (c, d));
}

int main () {
	scanf ("%d %d %d", &N, &B, &K);

	int i, j;
	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j) {
			scanf ("%d", &ma3x[i][j]);
			opt[i][j][1][0] = opt[i][j][1][1] = (uchar)ma3x[i][j];
		}

	int k;
	for (k = 2; k <= B; ++k)
		for (i = k-1; i < N; ++i)
			for (j = k-1; j < N; ++j) {
				opt[i][j][k][0] = min4 (opt[i-1][j-1][k-1][0], opt[i][j-1][k-1][0], opt[i-1][j][k-1][0], opt[i][j][k-1][0]);
				opt[i][j][k][1] = max4 (opt[i-1][j-1][k-1][1], opt[i][j-1][k-1][1], opt[i-1][j][k-1][1], opt[i][j][k-1][1]);
			}

	int a, b;
	for (i = 0; i < K; ++i) {
		scanf ("%d %d", &a, &b);
		printf ("%d\n", opt[a-2+B][b-2+B][B][1] - opt[a-2+B][b-2+B][B][0]);
	}

	return 0;
}
