#include <cstdio>
#include <cmath>
#include <climits>

struct p
{

  int x;
  int y;
};

long long
sq (int a)
{
  return (long long)a * a;
}

int
main ()
{

  FILE *in = fopen ("cowtag.in", "r");
  FILE *out = fopen ("cowtag.out", "w");

  int N;
  fscanf (in, "%d", &N);
  static p A[1000];
  static bool B[1000];
  for (int i = 0; i < N; ++i)
    B[i] = 1;
  for (int i = 0; i < N; ++i)
    fscanf (in, "%d %d", &A[i].x, &A[i].y);
  int br = N;
  for (int i = 0; br > 1; ++i)
    {
      int k = i % N;
      if (B[k])
        {
          long long min = LLONG_MAX;
          int s = 1000;
          for (int j = 0; j < N; ++j)
            {
              if (j == k || !B[j])
                continue;
              long long dist = sq (A[k].x - A[j].x) + sq (A[k].y - A[j].y);
              if (min > dist)
                {
                  min = dist;
                  s = j;
                }
            }
          B[s] = 0;
          br--;
        }
    }
  int m = -1;
  for (int i = 0; i < N; ++i)
    if (B[i])
      m = i + 1;
  fprintf (out, "%d\n", m);
  return 0;
}
