#include <cstdio>
#include <cstring>
#include <algorithm>

const int MAXD = 1 << 10;
const int MAXLEN = 1 << 4;
const int MAXA = 1 << 5;

int B, A, D;
char dict[MAXD][MAXLEN];
int dlen[MAXD];

int trnsl[MAXD][MAXLEN];

int cor[MAXA];

int max = 0;
int corbest[MAXA];

void save (int a) {
	max = a;
	for (int i = 0; i < A; ++i)
		corbest[i] = cor[i];
}

int idx[MAXD];

bool cmp (int a, int b) {
	int i;
	for (i = 0; trnsl[a][i] && trnsl[b][i] && trnsl[a][i] == trnsl[b][i]; ++i);
	return trnsl[a][i] < trnsl[b][i];
}

void doit () {
//	for (int i = 0; i < A; ++i) printf (" %d", cor[i]); printf ("\n");

	int i, j;
	int cnt =1;
	for (i = 0; i < D; ++i) {
		for (j = 0; dict[i][j]; ++j)
			trnsl[i][j] = cor[dict[i][j] - 'A'] + 1;
		trnsl[i][j] = 0;
	}

	for (i = 0; i < D; ++i) idx[i] = i;

	std::sort (idx, idx + D, cmp);

/*
	for (i = 0; i < D; ++i) {
		for (j = 0; trnsl[idx[i]][j]; ++j)
			printf (" %d", trnsl[idx[i]][j]);
		printf ("\n");
	}
	*/
	bool flag =0;
	for (i = 1; i < D; ++i) {
//		printf ("%d -> ", i);
		for (j = 0; trnsl[idx[i]][j] && trnsl[idx[i]][j] == trnsl[idx[i-1]][j]; ++j)// printf ("(%d %d)", trnsl[idx[i-1]][j], trnsl[idx[i]][j]);
		;
//		printf ("j = %d, %d %d\n", j, trnsl[idx[i]][j], trnsl[idx[i-1]][j]);
		if (trnsl[idx[i]][j] || trnsl[idx[i-1]][j]) {++cnt; flag = 0;}
		else if (!flag) {
			flag = 1;
			--cnt;
		}
	}

	if (cnt > max)
		save (cnt);
}

void rec (int pos, int left) {
//	printf ("%d %d\n", pos, left);
	if (pos == -1 || left == -1) {
		for (; pos >= 0; --pos) cor[pos] = 0;
		doit ();
		return;
	}

	cor[pos] = left;
	rec (pos - 1, left - 1);

	if (pos > left) {
		cor[pos] = left + 1;
		rec (pos - 1, left);
	}
}

int main () {
	char filename[100];
	fgets (filename, 100, stdin);
	filename[strlen (filename) - 1] = 0;
	FILE *in = fopen (filename, "r");
//	FILE *out = fopen ("cell.out", "w");
	FILE *out = stdout;
	if (in == 0) printf ("wow!\n");

	int Ntestcase;
	fscanf (in, "%d", &Ntestcase);
	fprintf (out, "#FILE cell %d\n", Ntestcase);

	fscanf (in, "%d %d\n%d\n", &B, &A, &D);

	int i;
	for (i = 0; i < D; ++i) {
		fgets (dict[i], MAXLEN, in);
		dlen[i] = strlen (dict[i]) - 1;
		dict[i][dlen[i]] = 0;
	}
	fclose (in);

	cor[A - 1] = B - 1;
	rec (A - 2, B - 2);

	printf ("%d\n", max);
	printf ("A");
	for (i = 1; i < A; ++i) {
		if (corbest[i] != corbest[i-1]) printf ("\n");
		printf ("%c", i + 'A');
	}
	printf ("\n");

}
