/*
FROM: USACO 2006 FEBRUARY GOLD
ID: iskren81
PROB: trt
LANG: C++
KEYW: dynamical programming
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 11;

int N;
int vec[MAXN];
int *vp1, *vp2;

inline int max (int a, int b) {
	return a > b ? a : b;
}

int main () {
	FILE *in = fopen ("trt.in", "r");
	fscanf (in, "%d", &N);

	int i, j;
	for (i = 0; i < N; ++i)
		fscanf (in, "%d", vec + i);
	fclose (in);

	vp1 = new int [N];
	vp2 = new int [N];
	for (i = 0; i < N; ++i)
		vp1[i] = vec[i] * N;

	for (i = 2; i <= N; ++i) {
		for (j = 0; j + i <= N; ++j)
			vp2[j] = max (	vp1[j]   + vec[j + i - 1] * (N + 1 - i),
							vp1[j+1] + vec[j]		  * (N + 1 - i));
		std::swap (vp1, vp2);
	}

	FILE *out = fopen ("trt.out", "w");
	fprintf (out, "%d\n", vp1[0]);
	fclose (out);

	return 0;
}
