/*
FROM: USACO 2006 MARCH GOLD
PROB: mooo
KEYW: kartezian tree
ID: iskren81
LANG: C++
*/

#include <cstdio>
#include <algorithm>

//extern unsigned _stklen = 2000000;

const int MAXN = 1 << 16;

struct node {
	int num;
	node *left, *right, *up;
	node () {}
	node (int _num, node *_left, node *_right, node *_up) : num (_num), left (_left), right (_right), up (_up) {}
};

int N;

int _seq[MAXN];
int seq[MAXN];
int vol[MAXN];
int idx[MAXN];
int sum[MAXN];

bool cmp (int a, int b) {
	return _seq[a] < _seq[b];
}

void _dfs (node *a) {
	if (!a) return;
	printf ("(");
	_dfs (a->left);
	printf ("%d", a->num);
	_dfs (a->right);
	printf (")");
}

struct el {
	node *a;
	int l;
	int r;
	el () {}
	el (node *_a, int _l, int _r) : a (_a), l (_l), r (_r) {}
};


el stack[MAXN];
void dfs (node *aa, int ll, int rr) {
	int top = 0;

	stack[top++] = el (aa, ll, rr);

	node *a;
	int l, r;
	while (top) {
		--top;
		a = stack[top].a; l = stack[top].l; r = stack[top].r;
		if (!a) continue;
		sum[l] += vol[idx[a->num]];
		sum[r] += vol[idx[a->num]];

		stack[top++] = el (a->left, l, idx[a->num]);
		stack[top++] = el (a->right, idx[a->num], r);
	}

/*
	if (!a) return;
//	printf ("in %d write to %d %d (%d vol %d)\n", a->num, l, r, idx[a->num], vol[idx[a->num]]);
	sum[l] += vol[idx[a->num]];
	sum[r] += vol[idx[a->num]];

	dfs (a->left, l, idx[a->num]);
	dfs (a->right, idx[a->num], r);
*/
}

int main () {
	freopen ("mooo.in", "r", stdin);
	freopen ("mooo.out", "w", stdout);

	scanf ("%d", &N);

	int i;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", _seq + i, vol + i);
		idx[i] = i;
	}

	std::sort (idx, idx + N, cmp);
	for (i = 0; i < N; ++i)
		seq[idx[i]] = i;

//	for (i = 0; i < N; ++i) printf ("%d ", seq[i]); printf ("\n");
	node *head = new node (N + 1, 0, 0, 0);//the biggest of all
	node *crnt = head;
	node *add;
	seq[N] = N;//add a very big at the end
	for (i = 0; i <= N; ++i) {
		while (crnt->num < seq[i]) {
//			printf ("i am %d , he is %d\n", seq[i], crnt->num);
			crnt = crnt->up;
		}
		add = new node (seq[i], crnt->right, 0, crnt);
		crnt->right = add;
		crnt = add;
	}

//	_dfs (head);

	dfs (head->right->left, N + 1, N);

	int max = 0;//if one cow - > 0
	for (i = 0; i < N; ++i)
		if (max < sum[i])
			max = sum[i];

	printf ("%d\n", max);

	return 0;
}
