/*
TASK: tselect
LANG: C++
*/
#include <stdio.h>
#include <vector>
#include <time.h>
#define MAXN 502

using namespace std;

int d[MAXN][MAXN][2];//opt
vector<int> a[MAXN];//graph with "parent->child" edges
int c[MAXN];//c[i] = count of elements in a[i]
int b[MAXN];//milk produced
int g[MAXN];//g[i] = count of cows in the subtree with root i
int n, m;//n is number of cows, m is minimum milk needed to win
FILE *f1, *f2;

inline int max (int a, int b) {
	return (a >= b ? a : b);
}

void solve (int i) {
	int j, k, w, pom;
	g[i] = 1;
	for (j = 0; j < c[i]; j++) {
		solve (a[i][j]);
		g[i] += g[a[i][j]];
	}
	d[i][0][0] = 0;//to take NOTHING ot the tree
	d[i][0][1] = b[i];//to have no relations but to take the root -> b[i] wining
// 0 <-- do NOT take the root
	for (j = 0; j < c[i]; j++) {//za vsqko dete
		pom = a[i][j];//index-a na deteto
		for (k = g[i]; k >= 0; k--)//za vseki broi, po maluk ot ob6iq
			for (w = 0; w <= k; w++)//za vseki broi vruzki ot deteto
				d[i][k][0] = max (d[i][k][0], d[i][k - w][0] + max (d[pom][w][0], d[pom][w][1]));
	}

// 1 <-- DO take the root
	for (j = 0; j < c[i]; j++) {//za vsqko dete
		pom = a[i][j];//index-a ne deteto
		for (k = g[i]; k >= 0; k--)//za vseki broi, po-maluk ot ob6tiq
			for (w = 0; w <= k; w++) {//za vseki broi vruzki ot deteto
				d[i][k][1] = max (d[i][k][1], d[i][k-w][1] + d[pom][w][0]);

				if (k != w)
					d[i][k][1] = max (d[i][k][1], d[i][k-w-1][1] + d[pom][w][1]);
			}
	}
}

int main () {
	int i, pom, j;
	f1 = fopen ("tselect.in", "r");
	f2 = fopen ("tselect.out", "w");
	clock ();
//   n=360;

	fscanf (f1, "%d %d", &n, &m);

	for (i = 0; i < MAXN; i++)
		for (j = 0; j < MAXN; j++)
			d[i][j][0] = d[i][j][1] = -(int)1e9;

	for (i = 1; i <= n; i++) {
		fscanf (f1, "%d %d", &b[i], &pom);
		//b[i]=(int)1e4;
		//pom=i-1;
		a[pom].push_back (i);
		c[pom]++;
	}

	solve (0);
	for (i = n; i >= 0; i--)
		if (d[0][i][0] >= m) break;
	fprintf (f2, "%d\n", i);

	printf ("%lf\n", (double)clock() / (double)CLOCKS_PER_SEC);

	return 0;
}
