/*
FROM: USACO 2006 November Gold
TASK: plank
LANG: C++
ID: iskren81
KEYW: dynamical programming with optimizations on the inner cycle
*/

#include <cstdio>
#include <climits>
#include <cstdlib>
#include <cassert>
#include <algorithm>

const int MAXN = 1024;

short N;
/*
long long dp[MAXN][MAXN];
short prev[MAXN][MAXN];
*/
short data[20000];
short tmp[20000];
/*
long long sum[20000];
*/

bool cmp (short a, short b) {return a > b;}

long long f (int l, int r) {
	if (l + 1 == r) return 0;
	std::sort (data + l, data + r, cmp);

	long long left = 0, right = 0;
	int i;
	int lp = l, rp = r;
	for (i = l; i < r; ++i) {
		if (left < right) {
			left += data[i];
			tmp[lp++] = data[i];
		} else {
			right += data[i];
			tmp[--rp] = data[i];
		}
		sum += data[i];
	}

	for (i = l; i < r; ++i)
		data[i] = tmp[i];

	return f (l, lp) + f (lp, r) + left + right;
}

int main () {
	FILE *in = fopen ("plank.in", "r");
	FILE *out = fopen ("plank.out", "w");
//	FILE *in = stdin;
//	FILE *out = stdout;

	fscanf (in, "%hd", &N);
	register short i, d, k;
	for (i = 0; i < N; ++i)
		fscanf (in, "%hd", data + i);

	fprintf (out, "%Ld\n", f (0, N));
/*	std::sort (data, data + N);

	for (i = 1; i <= N; ++i)
		sum[i] = sum[i-1] + data[i-1];

	if (N >= MAXN) goto unsure;

	for (i = 0; i < N; ++i) {
//		dp[i][i+1] = 0;
		prev[i][i+1] = i;
	}

	for (d = 2; d <= N; ++d)
		for (i = 0; i + d <= N; ++i) {
			dp[i][i+d] = ULLONG_MAX / 2;
			for (k = prev[i][i+d-1]; k <= prev[i+1][i+d]; ++k)
				if (dp[i][i+d] > dp[i][k] + dp[k][i+d]) {
					dp[i][i+d] = dp[i][k] + dp[k][i+d];
					prev[i][i+d] = k;
				}

			dp[i][i+d] += sum[i+d] - sum[i];
		}

	fprintf (out, "%Ld\n", dp[0][N]);

	return 0;
	unsure:
	assert (0);
*/
	return 0;
}
