/*
ID: iskren81
LANG: C++

FROM: USACO 2007 FEBRUARY GOLD
PROB: newbarn
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 14;

int N;
int coor[MAXN][2];
int allX[MAXN], allY[MAXN];

int besti = 1 << 30, ways = 0;
void say (int Xl, int Xr, int Yl, int Yr) {
	static int cnt, ti, i;
//	printf ("%d %d %d %d ---------------\n", Xl, Xr, Yl, Yr);
	for (cnt = ti = i = 0; i < N; ++i) {
		if (coor[i][0] >= Xl && coor[i][0] <= Xr
		 && coor[i][1] >= Yl && coor[i][1] <= Yr)
		 	++cnt;
		ti += abs (Xl - coor[i][0]);
		ti += abs (Yl - coor[i][1]);
//		printf ("\t%d %d\n", abs (Xl - coor[i][0]), abs (Yl - coor[i][1]));
	}

	int tmp = (Xr + 1 - Xl) * (Yr + 1 - Yl) - cnt;
	if (besti > ti && tmp) {
		besti = ti;
		ways = tmp;
//		printf ("%d %d %d %d ---%d\n", Xl, Xr, Yl, Yr, besti);
	} else if (besti == ti) {
		ways += tmp;
//		printf ("%d %d %d %d -- %d (%d)\n", Xl, Xr, Yl, Yr, ti, tmp);
	}
}

int main () {
	freopen ("newbarn.in", "r", stdin);
	freopen ("newbarn.out", "w", stdout);

	scanf ("%d", &N);

	int i;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", coor[i], coor[i] + 1);
		allX[i] = coor[i][0];
		allY[i] = coor[i][1];
	}

	std::sort (allX, allX + N);
	std::sort (allY, allY + N);

	if (N & 1
	 || allX[N/2-1] == allX[N/2]
	 && allY[N/2-1] == allY[N/2]) {
	 	say (allX[N/2]    , allX[N/2]    , allY[N/2]    , allY[N/2]    );
		say (allX[N/2] + 1, allX[N/2] + 1, allY[N/2]    , allY[N/2]    );
		say (allX[N/2] - 1, allX[N/2] - 1, allY[N/2]    , allY[N/2]    );
		say (allX[N/2]    , allX[N/2]    , allY[N/2] + 1, allY[N/2] + 1);
		say (allX[N/2]    , allX[N/2]    , allY[N/2] - 1, allY[N/2] - 1);
	} else
		say (allX[N/2-1], allX[N/2], allY[N/2-1], allY[N/2]);

	printf ("%d %d\n", besti, ways);

	return 0;
}
