/*
ID: iskren81
PROB: lineupg
LANG: C++
*/

#include <cstdio>

const int MAXN = 1 << 16;
const int MAXP = 1 << 4;

int N, Q;
int h[MAXN];
int rmin[MAXN][MAXP], rmax[MAXN][MAXP];

int main () {
	FILE *in = fopen ("lineupg.in", "r");
	FILE *out = fopen ("lineupg.out", "w");
//	FILE *in = stdin;
//	FILE *out = stdout;

	fscanf (in, "%d %d", &N, &Q);

	int i, j, k;
	for (i = 0; i < N; ++i) {
		fscanf (in, "%d", h + i);
		rmin[i][0] = rmax[i][0] = h[i];
	}

	j = 1;
	int j2 = 2;
	for (i = 1; i < MAXP; ++i, j *= 2, j2 *= 2)
		for (k = 0; k + j2 <= N; ++k) {
			rmin[k][i] = rmin[k][i-1] <? rmin[k+j][i-1];
			rmax[k][i] = rmax[k][i-1] >? rmax[k+j][i-1];
		}

	int a, b, x, xx;
	for (i = 0; i < Q; ++i) {
		fscanf (in, "%d %d", &a, &b);
		--a;
		x = 31 - __builtin_clz (b - a);
		xx = 1 << x;
		fprintf (out, "%d\n", (rmax[a][x] >? rmax[b-xx][x]) - (rmin[a][x] <? rmin[b-xx][x]));
	}

	fclose (in);
	fclose (out);

	return 0;
}
