/*
ID: iskren81
PROB: psolve
LANG: C++
*/

#include <cstdio>
#include <cassert>
#include <climits>

const int MAXP = 1 << 9;

int M, P;
int dp[MAXP][MAXP];
int p1[MAXP], p2[MAXP];

int main () {
	FILE *in = fopen ("psolve.in", "r");
	FILE *out = fopen ("psolve.out", "w");
//	FILE *in = stdin;
//	FILE *out = stdout;

	fscanf (in, "%d %d", &M, &P);

	int i, j, k;
	for (i = 0; i < P; ++i)
		fscanf (in, "%d %d", p1 + i, p2 + i);
	fclose (in);

	int pp;//previous payment
	int cp;//current payment
	int np;//next payment
	for (i = P-1; i >= 0; --i)
		for (j = pp = 0; pp <= M;) {
			dp[i][j] = INT_MAX;
//			printf ("___working on %d %d\n", i, j);
			for (k = cp = np = 0; i + k <= P && pp + cp <= M && np <= M; ++k) {
//				if (dp[i+k][k] < dp[i][j]) printf ("\tupd %d %d (%d)\n", i + k, k, dp[i+k][k]);
				dp[i][j] <?= dp[i+k][k];
				cp += p1[i+k];
				np += p2[i+k];
			}
			assert (dp[i][j] != INT_MAX);
			++dp[i][j];
//			printf ("%d %d => %d(pp = %d)\n", i, j, dp[i][j], pp);
			if (++j <= i) pp += p2[i - j]; else break;
		}

	fprintf (out, "%d\n", dp[0][0] + 2);
	fclose (out);

	return 0;
}
