/*
ID: iskren81
TASK: cowturn
LANG: C++

FROM: USACO 2007 March Gold
PROB: cowturn
KEYW: full exhaustion
*/

#include <cstdio>
#include <cstring>

const int MAXN = 5010;

int N;
bool vec[MAXN];
int extr[MAXN];

int main () {
	FILE *in = fopen ("cowturn.in", "r");
	FILE *out = fopen ("cowturn.out", "w");
//	FILE *in = stdin;
//	FILE *out = stdout;

	fscanf (in, "%d\n", &N);

	int i, j;
	int sum = 0;
	char t;
	for (i = 1; i <= N; ++i) {
		fscanf (in, "%c\n", &t);
		vec[i] = t == 'B';
		sum += vec[i];
	}
	fclose (in);

	if (sum == N) {fprintf (out, "%d %d\n", N, 1); return 0;}

	int res = sum, bestk = 1;
	int cnt;
	int N1 = N + 1;
	int extn = 0, cf;
	for (j = 2; j < N; ++j) {
		cf = 0;
		++extn;
		cnt = 0;
//		printf ("j == %d\n", j);
		for (i = 1; i + j <= N1; ++i) {
			cf -= extr[i] == extn;
//			printf ("i, cf %d %d\n", i, cf);
			if ((cf + vec[i]) & 1) {
//				printf ("flip!\n");
				if (++cnt >= res) goto nextj;
				++cf;
				extr[i+j] = extn;
			}
		}
		for (; i <= N; ++i) {
			cf -= extr[i] == extn;
			if ((cf + vec[i]) & 1) {
//				printf ("broken on %d\n", i);
				goto nextj;
			}
		}
//		printf ("cnt, j %d %d\n", cnt, j);
		if (res > cnt) {
			res = cnt;
			bestk = j;
		}

		nextj:;
	}

	fprintf (out, "%d %d\n", bestk, res);

	return 0;
}
