/*
ID: iskren81
TASK: cheappal
LANG: C++

FROM: USACO OPEN 2007 Gold
PROB: cheappal
KEYW: dynamical programming
*/

#include <cstdio>

const int MAXN = 1 << 11;
const int ALPHA = 1 << 5;
const int INF = 1 << 22;

int N, L;
char row[MAXN];
//int dp[MAXN][MAXN];
int _dp1[MAXN], _dp2[MAXN], _dp3[MAXN];
int *dp_old = _dp1, *dp_new = _dp2, *dp_old2 = _dp3;
int cost[ALPHA];

int main () {
	freopen ("cheappal.in", "r", stdin);
	freopen ("cheappal.out", "w", stdout);
	scanf ("%d %d\n", &L, &N);
	gets (row + 1);

	int i, j, d;
	char l;
	int c1, c2;
	for (i = 0; i < ALPHA; ++i) cost[i] = INF;
	for (i = 0; i < L; ++i) {
		scanf ("%c %d %d\n", &l, &c1, &c2);
		cost[l-'a'] = (c1 <? c2);
	}
	for (i = 1; i <= N; ++i) row[i] -= 'a';

//	dp[0][N+1] = 0;
	dp_old[0] = 0;
	for (d = N; d; --d) {
//		dp[0][d] = dp[0][d+1] + cost[row[d]];
		dp_new[0] = dp_old[0] + cost[row[d]];
//		dp[N+1-d][N+1] = dp[N-d][N+1] + cost[row[N+1-d]];
		dp_new[N+1-d] = dp_old[N-d] + cost[row[N+1-d]];
//		printf ("%d %d -- %d\n%d %d -- %d\n", 0, d, dp[0][d], N+1-d, N+1, dp[N+1-d][N+1]);
		for (i = 1; (j = i + d) <= N; ++i) {
//			dp[i][j] = (row[i] == row[j]) ? dp[i-1][j+1] : ((dp[i][j+1] + cost[row[j]]) <? (dp[i-1][j] + cost[row[i]]));
			dp_new[i] = (row[i] == row[j]) ? dp_old2[i-1] : ((dp_old[i] + cost[row[j]]) <? (dp_old[i-1] + cost[row[i]]));
//			printf ("%d %d -- %d\n", i, j, dp[i][j]);
		}
		int *tmp = dp_old2;//the pointer we "miss"
		dp_old2 = dp_old;
		dp_old = dp_new;
		dp_new = tmp;
	}

	int res = (dp_old[0] <? dp_old[N]);
	for (i = 0; i < N; ++i)
		res <?= (dp_old[i] <? dp_old2[i]);
	printf ("%d\n", res);

	return 0;
}
