/*
TASK: cowdrm
LANG: C++
KEYW: back track, brute force
*/

#include <cstdio>
#include <cstring>

const int MAXR = 1 << 7;
const int MAXC = 1 << 7;

const int dx [] = {0, 1, 0, -1};
const int dy [] = {1, 0, -1, 0};

int R, C;
int ma3x[MAXR][MAXC];
bool used[MAXR][MAXC];

char crnt[MAXR * MAXC];
int cp;
bool one_mid;

void input () {
    int i, X;
    scanf ("%d %d", &R, &C);
    scanf ("%d", &X);

    for (i = 0; i < R * C; ++i) {
        X = (X * 22519) % 31123;
        ma3x[i / C][i % C] = X % 10;
    }

    for (i = 0; i < R; ++i) {
        for (int j = 0; j < C; ++j)
            printf ("%d ", ma3x[i][j]);
        printf ("\n");
    }

}

char best[MAXR * MAXC];
char _tmp[MAXR * MAXC];
int bl;

void write (char *ss) {
    int i;
    for (i = cp-1; i >= one_mid; --i) ss[cp-1-i] = crnt[i];
    for (i = 0; i < cp; ++i) ss[i + cp - one_mid] = crnt[i];
    ss[cp * 2 - one_mid] = 0;
}

void upd () {
    crnt[cp] = 0;
//    printf ("UBD %s\n", crnt);
    if (cp * 2 - one_mid > bl) {
        write (best);
        bl = cp * 2 - one_mid;
//        printf ("%s(%d)\n", best, bl);
    } else if (cp * 2 - one_mid == bl) {
        write (_tmp);
        if (strcmp (_tmp, best) > 0) {
            strcpy (best, _tmp);
//            printf ("%s(%d)\n", best, bl);
        }
    }
}

void bt (int x1, int y1, int x2, int y2){
//    printf ("%d %d  %d %d\n", x1, y1, x2, y2);

    if (x1 < 0 || x1 >= R
     || y1 < 0 || y1 >= C) {
//        printf ("OOB\n");
        return;
    }

    if (x1 == x2 && y1 == y2 && cp) {
//        printf ("EQ!\n");
        return;
    }

    if (used[x1][y1] || used[x2][y2]) {
//        printf ("USED!\n");
        return;
    }
    if (ma3x[x1][y1] != ma3x[x2][y2]) {
//        printf ("N EQ!\n");
        return;
    }

    used[x1][y1] = used[x2][y2] = 1;
    crnt[cp++] = ma3x[x1][y1] + '0';
    for (int k1 = 0; k1 < 4; ++k1)
        for (int k2 = 0; k2 < 4; ++k2)
 //           printf ("->(%d %d)", k1, k2),
            bt (x1 + dx[k1], y1 + dy[k1], x2 + dx[k2], y2 + dy[k2]);

    if (ma3x[x1][y1] != 0) upd ();//avoid 0...0

    used[x1][y1] = used[x2][y2] = 0;
    --cp;
}

int main () {
    input ();

    one_mid = 1;
    for (int i = 0; i < R; ++i)
        for (int j = 0; j < C; ++j)
            bt (i, j, i, j);

    one_mid = 0;
    for (int i = 0; i < R - 1; ++i)
        for (int j = 0; j < C - 1; ++j) {
            bt (i, j, i + 1, j);
            bt (i, j, i, j + 1);
        }

    printf ("%s\n", best);

    return 0;
}

