/*
FROM: WINTER 2007 A
PROB: store
KEYW: bfs, tree
*/

#include <cstdio>

const int MAXN = 1 << 14;

int N, C;
int prev[MAXN];
int in[MAXN];
int bcnt[MAXN];

int main () {
	scanf ("%d %d", &N, &C);

	static int q[MAXN], p3;
	int i, j;
	int a;
	for (i = 0; i < N; ++i) {
		scanf ("%d %d", bcnt + i, in + i);
		if (in[i] == 0) q[p3++] = i;
		for (j = 0; j < in[i]; ++j) {
			scanf ("%d", &a);
			prev[--a] = i;
		}
	}

	int res = 0;
	for (i = 0; q[i]; ++i) {
		res += (bcnt[q[i]] / C + !!(bcnt[q[i]] % C)) * 2;
		bcnt[prev[q[i]]] += bcnt[q[i]];
		if (!(--in[prev[q[i]]]))
			q[p3++] = prev[q[i]];
	}

	printf ("%d\n", res % 1000000000);

	return 0;
}
